/* find_symbol.c generated by valac 0.55.1, the Vala compiler
 * generated from find_symbol.vala, do not modify */

/* find_symbol.vala
 *
 * Copyright 2019 Ben Iofel <ben@iofel.me>
 * Copyright 2020 Princeton Ferro <princetonferro@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vala.h>
#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <valagee.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define VLS_TYPE_FIND_SYMBOL (vls_find_symbol_get_type ())
#define VLS_FIND_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_FIND_SYMBOL, VlsFindSymbol))
#define VLS_FIND_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_FIND_SYMBOL, VlsFindSymbolClass))
#define VLS_IS_FIND_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_FIND_SYMBOL))
#define VLS_IS_FIND_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_FIND_SYMBOL))
#define VLS_FIND_SYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_FIND_SYMBOL, VlsFindSymbolClass))

typedef struct _VlsFindSymbol VlsFindSymbol;
typedef struct _VlsFindSymbolClass VlsFindSymbolClass;
typedef struct _VlsFindSymbolPrivate VlsFindSymbolPrivate;

#define LSP_TYPE_POSITION (lsp_position_get_type ())
#define LSP_POSITION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_POSITION, LspPosition))
#define LSP_POSITION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_POSITION, LspPositionClass))
#define LSP_IS_POSITION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_POSITION))
#define LSP_IS_POSITION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_POSITION))
#define LSP_POSITION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_POSITION, LspPositionClass))

typedef struct _LspPosition LspPosition;
typedef struct _LspPositionClass LspPositionClass;
typedef gboolean (*VlsFindSymbolFilter) (ValaCodeNode* needle, ValaCodeNode* hay_node);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _vala_source_reference_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_reference_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define LSP_TYPE_RANGE (lsp_range_get_type ())
#define LSP_RANGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_RANGE, LspRange))
#define LSP_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_RANGE, LspRangeClass))
#define LSP_IS_RANGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_RANGE))
#define LSP_IS_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_RANGE))
#define LSP_RANGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_RANGE, LspRangeClass))

typedef struct _LspRange LspRange;
typedef struct _LspRangeClass LspRangeClass;

struct _VlsFindSymbol {
	ValaCodeVisitor parent_instance;
	VlsFindSymbolPrivate * priv;
	GeeList* result;
};

struct _VlsFindSymbolClass {
	ValaCodeVisitorClass parent_class;
};

struct _VlsFindSymbolPrivate {
	LspPosition* _pos;
	LspPosition* end_pos;
	ValaSourceFile* file;
	gboolean _search_multiline;
	GeeHashSet* seen;
	ValaCodeNode* needle;
	VlsFindSymbolFilter filter;
	gboolean include_declaration;
};

static gint VlsFindSymbol_private_offset;
static gpointer vls_find_symbol_parent_class = NULL;

VALA_EXTERN GType vls_find_symbol_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsFindSymbol, vala_code_visitor_unref)
VALA_EXTERN GType lsp_position_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspPosition, g_object_unref)
static gboolean vls_find_symbol_match (VlsFindSymbol* self,
                                ValaCodeNode* node);
VALA_EXTERN GType lsp_range_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspRange, g_object_unref)
VALA_EXTERN LspRange* lsp_range_new_from_sourceref (ValaSourceReference* sref);
VALA_EXTERN LspRange* lsp_range_construct_from_sourceref (GType object_type,
                                              ValaSourceReference* sref);
VALA_EXTERN gboolean vls_find_symbol_get_search_multiline (VlsFindSymbol* self);
VALA_EXTERN LspPosition* lsp_range_get_start (LspRange* self);
VALA_EXTERN guint lsp_position_get_line (LspPosition* self);
VALA_EXTERN LspPosition* lsp_range_get_end (LspRange* self);
VALA_EXTERN LspPosition* vls_find_symbol_get_pos (VlsFindSymbol* self);
VALA_EXTERN gboolean lsp_range_contains (LspRange* self,
                             LspPosition* pos);
VALA_EXTERN VlsFindSymbol* vls_find_symbol_new (ValaSourceFile* file,
                                    LspPosition* pos,
                                    gboolean search_multiline,
                                    LspPosition* end_pos);
VALA_EXTERN VlsFindSymbol* vls_find_symbol_construct (GType object_type,
                                          ValaSourceFile* file,
                                          LspPosition* pos,
                                          gboolean search_multiline,
                                          LspPosition* end_pos);
static void vls_find_symbol_set_pos (VlsFindSymbol* self,
                              LspPosition* value);
static void vls_find_symbol_set_search_multiline (VlsFindSymbol* self,
                                           gboolean value);
VALA_EXTERN VlsFindSymbol* vls_find_symbol_new_with_filter (ValaSourceFile* file,
                                                ValaCodeNode* needle,
                                                VlsFindSymbolFilter filter_func,
                                                gboolean include_declaration);
VALA_EXTERN VlsFindSymbol* vls_find_symbol_construct_with_filter (GType object_type,
                                                      ValaSourceFile* file,
                                                      ValaCodeNode* needle,
                                                      VlsFindSymbolFilter filter_func,
                                                      gboolean include_declaration);
static void vls_find_symbol_real_visit_source_file (ValaCodeVisitor* base,
                                             ValaSourceFile* file);
static void vls_find_symbol_real_visit_addressof_expression (ValaCodeVisitor* base,
                                                      ValaAddressofExpression* expr);
static void vls_find_symbol_real_visit_array_creation_expression (ValaCodeVisitor* base,
                                                           ValaArrayCreationExpression* expr);
static void vls_find_symbol_real_visit_assignment (ValaCodeVisitor* base,
                                            ValaAssignment* a);
static void vls_find_symbol_real_visit_base_access (ValaCodeVisitor* base,
                                             ValaBaseAccess* expr);
static void vls_find_symbol_real_visit_binary_expression (ValaCodeVisitor* base,
                                                   ValaBinaryExpression* expr);
static void vls_find_symbol_real_visit_block (ValaCodeVisitor* base,
                                       ValaBlock* b);
static void vls_find_symbol_real_visit_boolean_literal (ValaCodeVisitor* base,
                                                 ValaBooleanLiteral* lit);
static void vls_find_symbol_real_visit_break_statement (ValaCodeVisitor* base,
                                                 ValaBreakStatement* stmt);
static void vls_find_symbol_real_visit_cast_expression (ValaCodeVisitor* base,
                                                 ValaCastExpression* expr);
static void vls_find_symbol_real_visit_catch_clause (ValaCodeVisitor* base,
                                              ValaCatchClause* clause);
static void vls_find_symbol_real_visit_character_literal (ValaCodeVisitor* base,
                                                   ValaCharacterLiteral* lit);
static void vls_find_symbol_real_visit_class (ValaCodeVisitor* base,
                                       ValaClass* cl);
static void vls_find_symbol_real_visit_conditional_expression (ValaCodeVisitor* base,
                                                        ValaConditionalExpression* expr);
static void vls_find_symbol_real_visit_constant (ValaCodeVisitor* base,
                                          ValaConstant* c);
static void vls_find_symbol_real_visit_constructor (ValaCodeVisitor* base,
                                             ValaConstructor* c);
static void vls_find_symbol_real_visit_continue_statement (ValaCodeVisitor* base,
                                                    ValaContinueStatement* stmt);
static void vls_find_symbol_real_visit_creation_method (ValaCodeVisitor* base,
                                                 ValaCreationMethod* m);
static void vls_find_symbol_real_visit_data_type (ValaCodeVisitor* base,
                                           ValaDataType* type);
static void vls_find_symbol_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                       ValaDeclarationStatement* stmt);
static void vls_find_symbol_real_visit_delegate (ValaCodeVisitor* base,
                                          ValaDelegate* cb);
static void vls_find_symbol_real_visit_delete_statement (ValaCodeVisitor* base,
                                                  ValaDeleteStatement* stmt);
static void vls_find_symbol_real_visit_destructor (ValaCodeVisitor* base,
                                            ValaDestructor* dtor);
static void vls_find_symbol_real_visit_do_statement (ValaCodeVisitor* base,
                                              ValaDoStatement* stmt);
static void vls_find_symbol_real_visit_element_access (ValaCodeVisitor* base,
                                                ValaElementAccess* expr);
static void vls_find_symbol_real_visit_empty_statement (ValaCodeVisitor* base,
                                                 ValaEmptyStatement* stmt);
static void vls_find_symbol_real_visit_enum (ValaCodeVisitor* base,
                                      ValaEnum* en);
static void vls_find_symbol_real_visit_enum_value (ValaCodeVisitor* base,
                                            ValaEnumValue* ev);
static void vls_find_symbol_real_visit_error_code (ValaCodeVisitor* base,
                                            ValaErrorCode* ecode);
static void vls_find_symbol_real_visit_error_domain (ValaCodeVisitor* base,
                                              ValaErrorDomain* edomain);
static void vls_find_symbol_real_visit_expression (ValaCodeVisitor* base,
                                            ValaExpression* expr);
static void vls_find_symbol_real_visit_expression_statement (ValaCodeVisitor* base,
                                                      ValaExpressionStatement* stmt);
static void vls_find_symbol_real_visit_field (ValaCodeVisitor* base,
                                       ValaField* f);
static void vls_find_symbol_real_visit_for_statement (ValaCodeVisitor* base,
                                               ValaForStatement* stmt);
static void vls_find_symbol_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                   ValaForeachStatement* stmt);
static void vls_find_symbol_real_visit_formal_parameter (ValaCodeVisitor* base,
                                                  ValaParameter* p);
static void vls_find_symbol_real_visit_if_statement (ValaCodeVisitor* base,
                                              ValaIfStatement* stmt);
static void vls_find_symbol_real_visit_initializer_list (ValaCodeVisitor* base,
                                                  ValaInitializerList* list);
static void vls_find_symbol_real_visit_integer_literal (ValaCodeVisitor* base,
                                                 ValaIntegerLiteral* lit);
static void vls_find_symbol_real_visit_interface (ValaCodeVisitor* base,
                                           ValaInterface* iface);
static void vls_find_symbol_real_visit_lambda_expression (ValaCodeVisitor* base,
                                                   ValaLambdaExpression* expr);
static void vls_find_symbol_real_visit_local_variable (ValaCodeVisitor* base,
                                                ValaLocalVariable* local);
static void vls_find_symbol_real_visit_lock_statement (ValaCodeVisitor* base,
                                                ValaLockStatement* stmt);
static void vls_find_symbol_real_visit_loop_statement (ValaCodeVisitor* base,
                                                ValaLoopStatement* stmt);
static void vls_find_symbol_real_visit_member_access (ValaCodeVisitor* base,
                                               ValaMemberAccess* expr);
static void vls_find_symbol_real_visit_method (ValaCodeVisitor* base,
                                        ValaMethod* m);
static void vls_find_symbol_real_visit_method_call (ValaCodeVisitor* base,
                                             ValaMethodCall* expr);
static void vls_find_symbol_real_visit_namespace (ValaCodeVisitor* base,
                                           ValaNamespace* ns);
static void vls_find_symbol_real_visit_null_literal (ValaCodeVisitor* base,
                                              ValaNullLiteral* lit);
static void vls_find_symbol_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                            ValaObjectCreationExpression* expr);
static void vls_find_symbol_real_visit_pointer_indirection (ValaCodeVisitor* base,
                                                     ValaPointerIndirection* expr);
static void vls_find_symbol_real_visit_postfix_expression (ValaCodeVisitor* base,
                                                    ValaPostfixExpression* expr);
static void vls_find_symbol_real_visit_property (ValaCodeVisitor* base,
                                          ValaProperty* prop);
static void vls_find_symbol_real_visit_property_accessor (ValaCodeVisitor* base,
                                                   ValaPropertyAccessor* acc);
static void vls_find_symbol_real_visit_real_literal (ValaCodeVisitor* base,
                                              ValaRealLiteral* lit);
static void vls_find_symbol_real_visit_reference_transfer_expression (ValaCodeVisitor* base,
                                                               ValaReferenceTransferExpression* expr);
static void vls_find_symbol_real_visit_regex_literal (ValaCodeVisitor* base,
                                               ValaRegexLiteral* lit);
static void vls_find_symbol_real_visit_return_statement (ValaCodeVisitor* base,
                                                  ValaReturnStatement* stmt);
static void vls_find_symbol_real_visit_signal (ValaCodeVisitor* base,
                                        ValaSignal* sig);
static void vls_find_symbol_real_visit_sizeof_expression (ValaCodeVisitor* base,
                                                   ValaSizeofExpression* expr);
static void vls_find_symbol_real_visit_slice_expression (ValaCodeVisitor* base,
                                                  ValaSliceExpression* expr);
static void vls_find_symbol_real_visit_string_literal (ValaCodeVisitor* base,
                                                ValaStringLiteral* lit);
static void vls_find_symbol_real_visit_struct (ValaCodeVisitor* base,
                                        ValaStruct* st);
static void vls_find_symbol_real_visit_switch_label (ValaCodeVisitor* base,
                                              ValaSwitchLabel* label);
static void vls_find_symbol_real_visit_switch_section (ValaCodeVisitor* base,
                                                ValaSwitchSection* section);
static void vls_find_symbol_real_visit_switch_statement (ValaCodeVisitor* base,
                                                  ValaSwitchStatement* stmt);
static void vls_find_symbol_real_visit_template (ValaCodeVisitor* base,
                                          ValaTemplate* tmpl);
static void vls_find_symbol_real_visit_throw_statement (ValaCodeVisitor* base,
                                                 ValaThrowStatement* stmt);
static void vls_find_symbol_real_visit_try_statement (ValaCodeVisitor* base,
                                               ValaTryStatement* stmt);
static void vls_find_symbol_real_visit_type_check (ValaCodeVisitor* base,
                                            ValaTypeCheck* expr);
static void vls_find_symbol_real_visit_type_parameter (ValaCodeVisitor* base,
                                                ValaTypeParameter* p);
static void vls_find_symbol_real_visit_typeof_expression (ValaCodeVisitor* base,
                                                   ValaTypeofExpression* expr);
static void vls_find_symbol_real_visit_unary_expression (ValaCodeVisitor* base,
                                                  ValaUnaryExpression* expr);
static void vls_find_symbol_real_visit_unlock_statement (ValaCodeVisitor* base,
                                                  ValaUnlockStatement* stmt);
static void vls_find_symbol_real_visit_using_directive (ValaCodeVisitor* base,
                                                 ValaUsingDirective* ud);
static void vls_find_symbol_real_visit_with_statement (ValaCodeVisitor* base,
                                                ValaWithStatement* stmt);
static void vls_find_symbol_real_visit_yield_statement (ValaCodeVisitor* base,
                                                 ValaYieldStatement* stmt);
static void vls_find_symbol_finalize (ValaCodeVisitor * obj);
static GType vls_find_symbol_get_type_once (void);

static inline gpointer
vls_find_symbol_get_instance_private (VlsFindSymbol* self)
{
	return G_STRUCT_MEMBER_P (self, VlsFindSymbol_private_offset);
}

static gpointer
_vala_source_reference_ref0 (gpointer self)
{
	return self ? vala_source_reference_ref (self) : NULL;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gboolean
vls_find_symbol_match (VlsFindSymbol* self,
                       ValaCodeNode* node)
{
	ValaSourceReference* sr = NULL;
	ValaSourceReference* _tmp0_;
	ValaSourceReference* _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaSourceReference* _tmp4_;
	ValaSourceFile* _tmp5_;
	ValaSourceFile* _tmp6_;
	ValaSourceFile* _tmp7_;
	ValaSourceReference* _tmp8_;
	ValaSourceLocation _tmp9_ = {0};
	ValaSourceLocation _tmp10_;
	ValaSourceReference* _tmp11_;
	ValaSourceLocation _tmp12_ = {0};
	ValaSourceLocation _tmp13_;
	VlsFindSymbolFilter _tmp22_;
	LspRange* range = NULL;
	ValaSourceReference* _tmp32_;
	LspRange* _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp55_ = FALSE;
	LspRange* _tmp56_;
	LspPosition* _tmp57_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	_tmp0_ = vala_code_node_get_source_reference (node);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_source_reference_ref0 (_tmp1_);
	sr = _tmp2_;
	_tmp3_ = sr;
	if (_tmp3_ == NULL) {
		result = FALSE;
		_vala_source_reference_unref0 (sr);
		return result;
	}
	_tmp4_ = sr;
	_tmp5_ = vala_source_reference_get_file (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = self->priv->file;
	if (_tmp6_ != _tmp7_) {
		result = FALSE;
		_vala_source_reference_unref0 (sr);
		return result;
	}
	_tmp8_ = sr;
	vala_source_reference_get_begin (_tmp8_, &_tmp9_);
	_tmp10_ = _tmp9_;
	_tmp11_ = sr;
	vala_source_reference_get_end (_tmp11_, &_tmp12_);
	_tmp13_ = _tmp12_;
	if (_tmp10_.line > _tmp13_.line) {
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		ValaSourceReference* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		_tmp14_ = vala_code_node_get_type_name (node);
		_tmp15_ = _tmp14_;
		_tmp16_ = string_to_string (_tmp15_);
		_tmp17_ = sr;
		_tmp18_ = vala_source_reference_to_string (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = g_strconcat ("wtf vala: ", _tmp16_, ": ", _tmp19_, NULL);
		_tmp21_ = _tmp20_;
		g_warning ("find_symbol.vala:49: %s", _tmp21_);
		_g_free0 (_tmp21_);
		_g_free0 (_tmp19_);
		result = FALSE;
		_vala_source_reference_unref0 (sr);
		return result;
	}
	_tmp22_ = self->priv->filter;
	if (_tmp22_ != NULL) {
		gboolean _tmp23_ = FALSE;
		VlsFindSymbolFilter _tmp30_;
		ValaCodeNode* _tmp31_;
		if (!self->priv->include_declaration) {
			gboolean _tmp24_ = FALSE;
			gboolean _tmp25_ = FALSE;
			ValaCodeNode* _tmp26_;
			_tmp26_ = self->priv->needle;
			if (_tmp26_ == node) {
				ValaCodeNode* _tmp27_;
				_tmp27_ = self->priv->needle;
				_tmp25_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp27_, VALA_TYPE_LOCAL_VARIABLE);
			} else {
				_tmp25_ = FALSE;
			}
			if (_tmp25_) {
				_tmp24_ = TRUE;
			} else {
				ValaCodeNode* _tmp28_;
				ValaCodeNode* _tmp29_;
				_tmp28_ = vala_code_node_get_parent_node (node);
				_tmp29_ = _tmp28_;
				_tmp24_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp29_, VALA_TYPE_DECLARATION_STATEMENT);
			}
			_tmp23_ = _tmp24_;
		} else {
			_tmp23_ = FALSE;
		}
		if (_tmp23_) {
			result = FALSE;
			_vala_source_reference_unref0 (sr);
			return result;
		}
		_tmp30_ = self->priv->filter;
		_tmp31_ = self->priv->needle;
		result = _tmp30_ (_tmp31_, node);
		_vala_source_reference_unref0 (sr);
		return result;
	}
	_tmp32_ = sr;
	_tmp33_ = lsp_range_new_from_sourceref (_tmp32_);
	if (_tmp33_) {
		g_object_set_data ((GObject *) _tmp33_, "vala-creation-function", "Vls.FindSymbol.match");
	}
	range = _tmp33_;
	_tmp34_ = self->priv->_search_multiline;
	if (!_tmp34_) {
		LspRange* _tmp35_;
		LspPosition* _tmp36_;
		LspPosition* _tmp37_;
		guint _tmp38_;
		guint _tmp39_;
		LspRange* _tmp40_;
		LspPosition* _tmp41_;
		LspPosition* _tmp42_;
		guint _tmp43_;
		guint _tmp44_;
		LspRange* _tmp45_;
		LspPosition* _tmp46_;
		LspPosition* _tmp47_;
		guint _tmp48_;
		guint _tmp49_;
		LspPosition* _tmp50_;
		guint _tmp51_;
		guint _tmp52_;
		_tmp35_ = range;
		_tmp36_ = lsp_range_get_start (_tmp35_);
		_tmp37_ = _tmp36_;
		_tmp38_ = lsp_position_get_line (_tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = range;
		_tmp41_ = lsp_range_get_end (_tmp40_);
		_tmp42_ = _tmp41_;
		_tmp43_ = lsp_position_get_line (_tmp42_);
		_tmp44_ = _tmp43_;
		if (_tmp39_ != _tmp44_) {
			result = FALSE;
			_g_object_unref0 (range);
			_vala_source_reference_unref0 (sr);
			return result;
		}
		_tmp45_ = range;
		_tmp46_ = lsp_range_get_start (_tmp45_);
		_tmp47_ = _tmp46_;
		_tmp48_ = lsp_position_get_line (_tmp47_);
		_tmp49_ = _tmp48_;
		_tmp50_ = self->priv->_pos;
		_tmp51_ = lsp_position_get_line (_tmp50_);
		_tmp52_ = _tmp51_;
		if (_tmp49_ != _tmp52_) {
			result = FALSE;
			_g_object_unref0 (range);
			_vala_source_reference_unref0 (sr);
			return result;
		}
	} else {
		gboolean _tmp53_ = FALSE;
		gboolean _tmp54_ = FALSE;
		if (G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_STATEMENT)) {
			_tmp54_ = TRUE;
		} else {
			_tmp54_ = G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_LAMBDA_EXPRESSION);
		}
		if (_tmp54_) {
			_tmp53_ = TRUE;
		} else {
			_tmp53_ = G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_CATCH_CLAUSE);
		}
		if (_tmp53_) {
			result = FALSE;
			_g_object_unref0 (range);
			_vala_source_reference_unref0 (sr);
			return result;
		}
	}
	_tmp56_ = range;
	_tmp57_ = self->priv->_pos;
	if (lsp_range_contains (_tmp56_, _tmp57_)) {
		gboolean _tmp58_ = FALSE;
		LspPosition* _tmp59_;
		_tmp59_ = self->priv->end_pos;
		if (_tmp59_ == NULL) {
			_tmp58_ = TRUE;
		} else {
			LspRange* _tmp60_;
			LspPosition* _tmp61_;
			_tmp60_ = range;
			_tmp61_ = self->priv->end_pos;
			_tmp58_ = lsp_range_contains (_tmp60_, _tmp61_);
		}
		_tmp55_ = _tmp58_;
	} else {
		_tmp55_ = FALSE;
	}
	if (_tmp55_) {
		result = TRUE;
		_g_object_unref0 (range);
		_vala_source_reference_unref0 (sr);
		return result;
	} else {
		result = FALSE;
		_g_object_unref0 (range);
		_vala_source_reference_unref0 (sr);
		return result;
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gpointer
_vala_source_file_ref0 (gpointer self)
{
	return self ? vala_source_file_ref (self) : NULL;
}

VlsFindSymbol*
vls_find_symbol_construct (GType object_type,
                           ValaSourceFile* file,
                           LspPosition* pos,
                           gboolean search_multiline,
                           LspPosition* end_pos)
{
	VlsFindSymbol* self = NULL;
	LspPosition* _tmp0_;
	ValaSourceFile* _tmp1_;
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (pos != NULL, NULL);
	self = (VlsFindSymbol*) vala_code_visitor_construct (object_type);
	vls_find_symbol_set_pos (self, pos);
	_tmp0_ = _g_object_ref0 (end_pos);
	_g_object_unref0 (self->priv->end_pos);
	self->priv->end_pos = _tmp0_;
	_tmp1_ = _vala_source_file_ref0 (file);
	_vala_source_file_unref0 (self->priv->file);
	self->priv->file = _tmp1_;
	vls_find_symbol_set_search_multiline (self, search_multiline);
	vala_code_visitor_visit_source_file ((ValaCodeVisitor*) self, file);
	return self;
}

VlsFindSymbol*
vls_find_symbol_new (ValaSourceFile* file,
                     LspPosition* pos,
                     gboolean search_multiline,
                     LspPosition* end_pos)
{
	return vls_find_symbol_construct (VLS_TYPE_FIND_SYMBOL, file, pos, search_multiline, end_pos);
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

VlsFindSymbol*
vls_find_symbol_construct_with_filter (GType object_type,
                                       ValaSourceFile* file,
                                       ValaCodeNode* needle,
                                       VlsFindSymbolFilter filter_func,
                                       gboolean include_declaration)
{
	VlsFindSymbol* self = NULL;
	ValaSourceFile* _tmp0_;
	ValaCodeNode* _tmp1_;
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (needle != NULL, NULL);
	self = (VlsFindSymbol*) vala_code_visitor_construct (object_type);
	_tmp0_ = _vala_source_file_ref0 (file);
	_vala_source_file_unref0 (self->priv->file);
	self->priv->file = _tmp0_;
	_tmp1_ = _vala_code_node_ref0 (needle);
	_vala_code_node_unref0 (self->priv->needle);
	self->priv->needle = _tmp1_;
	self->priv->filter = filter_func;
	self->priv->include_declaration = include_declaration;
	vala_code_visitor_visit_source_file ((ValaCodeVisitor*) self, file);
	return self;
}

VlsFindSymbol*
vls_find_symbol_new_with_filter (ValaSourceFile* file,
                                 ValaCodeNode* needle,
                                 VlsFindSymbolFilter filter_func,
                                 gboolean include_declaration)
{
	return vls_find_symbol_construct_with_filter (VLS_TYPE_FIND_SYMBOL, file, needle, filter_func, include_declaration);
}

static void
vls_find_symbol_real_visit_source_file (ValaCodeVisitor* base,
                                        ValaSourceFile* file)
{
	VlsFindSymbol * self;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (file != NULL);
	vala_source_file_accept_children (file, (ValaCodeVisitor*) self);
	{
		ValaList* _ud_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _ud_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _ud_index = 0;
		_tmp0_ = vala_source_file_get_current_using_directives (file);
		_tmp1_ = _tmp0_;
		_ud_list = _tmp1_;
		_tmp2_ = _ud_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_ud_size = _tmp4_;
		_ud_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			ValaUsingDirective* ud = NULL;
			ValaList* _tmp7_;
			gpointer _tmp8_;
			ValaUsingDirective* _tmp9_;
			_ud_index = _ud_index + 1;
			_tmp5_ = _ud_index;
			_tmp6_ = _ud_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _ud_list;
			_tmp8_ = vala_list_get (_tmp7_, _ud_index);
			ud = (ValaUsingDirective*) _tmp8_;
			_tmp9_ = ud;
			if (vls_find_symbol_match (self, (ValaCodeNode*) _tmp9_)) {
				GeeList* _tmp10_;
				ValaUsingDirective* _tmp11_;
				_tmp10_ = self->result;
				_tmp11_ = ud;
				gee_collection_add ((GeeCollection*) _tmp10_, (ValaCodeNode*) _tmp11_);
			}
			_vala_code_node_unref0 (ud);
		}
	}
}

static void
vls_find_symbol_real_visit_addressof_expression (ValaCodeVisitor* base,
                                                 ValaAddressofExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_array_creation_expression (ValaCodeVisitor* base,
                                                      ValaArrayCreationExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_assignment (ValaCodeVisitor* base,
                                       ValaAssignment* a)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (a != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) a)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) a);
	if (vls_find_symbol_match (self, (ValaCodeNode*) a)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) a);
	}
	vala_code_node_accept_children ((ValaCodeNode*) a, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_base_access (ValaCodeVisitor* base,
                                        ValaBaseAccess* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_binary_expression (ValaCodeVisitor* base,
                                              ValaBinaryExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_block (ValaCodeVisitor* base,
                                  ValaBlock* b)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (b != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) b)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) b);
	if (vls_find_symbol_match (self, (ValaCodeNode*) b)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) b);
	}
	vala_code_node_accept_children ((ValaCodeNode*) b, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_boolean_literal (ValaCodeVisitor* base,
                                            ValaBooleanLiteral* lit)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_find_symbol_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_break_statement (ValaCodeVisitor* base,
                                            ValaBreakStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_cast_expression (ValaCodeVisitor* base,
                                            ValaCastExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_catch_clause (ValaCodeVisitor* base,
                                         ValaCatchClause* clause)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (clause != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) clause)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) clause);
	if (vls_find_symbol_match (self, (ValaCodeNode*) clause)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) clause);
	}
	vala_code_node_accept_children ((ValaCodeNode*) clause, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_character_literal (ValaCodeVisitor* base,
                                              ValaCharacterLiteral* lit)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_find_symbol_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_class (ValaCodeVisitor* base,
                                  ValaClass* cl)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (cl != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) cl)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) cl);
	if (vls_find_symbol_match (self, (ValaCodeNode*) cl)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) cl);
	}
	vala_code_node_accept_children ((ValaCodeNode*) cl, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_conditional_expression (ValaCodeVisitor* base,
                                                   ValaConditionalExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_constant (ValaCodeVisitor* base,
                                     ValaConstant* c)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (c != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) c)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) c);
	if (vls_find_symbol_match (self, (ValaCodeNode*) c)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) c);
	}
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_constructor (ValaCodeVisitor* base,
                                        ValaConstructor* c)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (c != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) c)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) c);
	if (vls_find_symbol_match (self, (ValaCodeNode*) c)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) c);
	}
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_continue_statement (ValaCodeVisitor* base,
                                               ValaContinueStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_creation_method (ValaCodeVisitor* base,
                                            ValaCreationMethod* m)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (m != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) m)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) m);
	if (vls_find_symbol_match (self, (ValaCodeNode*) m)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) m);
	}
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_data_type (ValaCodeVisitor* base,
                                      ValaDataType* type)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (type != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) type)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) type);
	if (vls_find_symbol_match (self, (ValaCodeNode*) type)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) type);
	}
	vala_code_node_accept_children ((ValaCodeNode*) type, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                  ValaDeclarationStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_delegate (ValaCodeVisitor* base,
                                     ValaDelegate* cb)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (cb != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) cb)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) cb);
	if (vls_find_symbol_match (self, (ValaCodeNode*) cb)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) cb);
	}
	vala_code_node_accept_children ((ValaCodeNode*) cb, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_delete_statement (ValaCodeVisitor* base,
                                             ValaDeleteStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_destructor (ValaCodeVisitor* base,
                                       ValaDestructor* dtor)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (dtor != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) dtor)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) dtor);
	if (vls_find_symbol_match (self, (ValaCodeNode*) dtor)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) dtor);
	}
	vala_code_node_accept_children ((ValaCodeNode*) dtor, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_do_statement (ValaCodeVisitor* base,
                                         ValaDoStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_element_access (ValaCodeVisitor* base,
                                           ValaElementAccess* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_empty_statement (ValaCodeVisitor* base,
                                            ValaEmptyStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_enum (ValaCodeVisitor* base,
                                 ValaEnum* en)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (en != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) en)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) en);
	if (vls_find_symbol_match (self, (ValaCodeNode*) en)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) en);
	}
	vala_code_node_accept_children ((ValaCodeNode*) en, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_enum_value (ValaCodeVisitor* base,
                                       ValaEnumValue* ev)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (ev != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) ev)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) ev);
	if (vls_find_symbol_match (self, (ValaCodeNode*) ev)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) ev);
	}
	vala_code_node_accept_children ((ValaCodeNode*) ev, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_error_code (ValaCodeVisitor* base,
                                       ValaErrorCode* ecode)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (ecode != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) ecode)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) ecode);
	if (vls_find_symbol_match (self, (ValaCodeNode*) ecode)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) ecode);
	}
	vala_code_node_accept_children ((ValaCodeNode*) ecode, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_error_domain (ValaCodeVisitor* base,
                                         ValaErrorDomain* edomain)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (edomain != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) edomain)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) edomain);
	if (vls_find_symbol_match (self, (ValaCodeNode*) edomain)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) edomain);
	}
	vala_code_node_accept_children ((ValaCodeNode*) edomain, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_expression (ValaCodeVisitor* base,
                                       ValaExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_expression_statement (ValaCodeVisitor* base,
                                                 ValaExpressionStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_field (ValaCodeVisitor* base,
                                  ValaField* f)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (f != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) f)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) f);
	if (vls_find_symbol_match (self, (ValaCodeNode*) f)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) f);
	}
	vala_code_node_accept_children ((ValaCodeNode*) f, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_for_statement (ValaCodeVisitor* base,
                                          ValaForStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_foreach_statement (ValaCodeVisitor* base,
                                              ValaForeachStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_formal_parameter (ValaCodeVisitor* base,
                                             ValaParameter* p)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (p != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) p)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) p);
	if (vls_find_symbol_match (self, (ValaCodeNode*) p)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) p);
	}
	vala_code_node_accept_children ((ValaCodeNode*) p, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_if_statement (ValaCodeVisitor* base,
                                         ValaIfStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_initializer_list (ValaCodeVisitor* base,
                                             ValaInitializerList* list)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (list != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) list)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) list);
	if (vls_find_symbol_match (self, (ValaCodeNode*) list)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) list);
	}
	vala_code_node_accept_children ((ValaCodeNode*) list, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_integer_literal (ValaCodeVisitor* base,
                                            ValaIntegerLiteral* lit)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_find_symbol_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_interface (ValaCodeVisitor* base,
                                      ValaInterface* iface)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (iface != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) iface)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) iface);
	if (vls_find_symbol_match (self, (ValaCodeNode*) iface)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) iface);
	}
	vala_code_node_accept_children ((ValaCodeNode*) iface, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_lambda_expression (ValaCodeVisitor* base,
                                              ValaLambdaExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_local_variable (ValaCodeVisitor* base,
                                           ValaLocalVariable* local)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (local != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) local)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) local);
	if (vls_find_symbol_match (self, (ValaCodeNode*) local)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) local);
	}
	vala_code_node_accept_children ((ValaCodeNode*) local, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_lock_statement (ValaCodeVisitor* base,
                                           ValaLockStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_loop_statement (ValaCodeVisitor* base,
                                           ValaLoopStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_member_access (ValaCodeVisitor* base,
                                          ValaMemberAccess* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_method (ValaCodeVisitor* base,
                                   ValaMethod* m)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (m != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) m)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) m);
	if (vls_find_symbol_match (self, (ValaCodeNode*) m)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) m);
	}
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_method_call (ValaCodeVisitor* base,
                                        ValaMethodCall* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_namespace (ValaCodeVisitor* base,
                                      ValaNamespace* ns)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (ns != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) ns)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) ns);
	if (vls_find_symbol_match (self, (ValaCodeNode*) ns)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) ns);
	}
	vala_code_node_accept_children ((ValaCodeNode*) ns, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_null_literal (ValaCodeVisitor* base,
                                         ValaNullLiteral* lit)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_find_symbol_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                       ValaObjectCreationExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_pointer_indirection (ValaCodeVisitor* base,
                                                ValaPointerIndirection* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_postfix_expression (ValaCodeVisitor* base,
                                               ValaPostfixExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_property (ValaCodeVisitor* base,
                                     ValaProperty* prop)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (prop != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) prop)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) prop);
	if (vls_find_symbol_match (self, (ValaCodeNode*) prop)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) prop);
	}
	vala_code_node_accept_children ((ValaCodeNode*) prop, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_property_accessor (ValaCodeVisitor* base,
                                              ValaPropertyAccessor* acc)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (acc != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) acc)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) acc);
	if (vls_find_symbol_match (self, (ValaCodeNode*) acc)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) acc);
	}
	vala_code_node_accept_children ((ValaCodeNode*) acc, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_real_literal (ValaCodeVisitor* base,
                                         ValaRealLiteral* lit)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_find_symbol_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_reference_transfer_expression (ValaCodeVisitor* base,
                                                          ValaReferenceTransferExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_regex_literal (ValaCodeVisitor* base,
                                          ValaRegexLiteral* lit)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_find_symbol_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_return_statement (ValaCodeVisitor* base,
                                             ValaReturnStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_signal (ValaCodeVisitor* base,
                                   ValaSignal* sig)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (sig != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) sig)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) sig);
	if (vls_find_symbol_match (self, (ValaCodeNode*) sig)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) sig);
	}
	vala_code_node_accept_children ((ValaCodeNode*) sig, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_sizeof_expression (ValaCodeVisitor* base,
                                              ValaSizeofExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_slice_expression (ValaCodeVisitor* base,
                                             ValaSliceExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_string_literal (ValaCodeVisitor* base,
                                           ValaStringLiteral* lit)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_find_symbol_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_struct (ValaCodeVisitor* base,
                                   ValaStruct* st)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (st != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) st)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) st);
	if (vls_find_symbol_match (self, (ValaCodeNode*) st)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) st);
	}
	vala_code_node_accept_children ((ValaCodeNode*) st, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_switch_label (ValaCodeVisitor* base,
                                         ValaSwitchLabel* label)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (label != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) label)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) label);
	if (vls_find_symbol_match (self, (ValaCodeNode*) label)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) label);
	}
	vala_code_node_accept_children ((ValaCodeNode*) label, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_switch_section (ValaCodeVisitor* base,
                                           ValaSwitchSection* section)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (section != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) section)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) section);
	if (vls_find_symbol_match (self, (ValaCodeNode*) section)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) section);
	}
	vala_code_node_accept_children ((ValaCodeNode*) section, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_switch_statement (ValaCodeVisitor* base,
                                             ValaSwitchStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_template (ValaCodeVisitor* base,
                                     ValaTemplate* tmpl)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (tmpl != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) tmpl)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) tmpl);
	if (vls_find_symbol_match (self, (ValaCodeNode*) tmpl)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) tmpl);
	}
	vala_code_node_accept_children ((ValaCodeNode*) tmpl, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_throw_statement (ValaCodeVisitor* base,
                                            ValaThrowStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_try_statement (ValaCodeVisitor* base,
                                          ValaTryStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_type_check (ValaCodeVisitor* base,
                                       ValaTypeCheck* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_type_parameter (ValaCodeVisitor* base,
                                           ValaTypeParameter* p)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (p != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) p)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) p);
	if (vls_find_symbol_match (self, (ValaCodeNode*) p)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) p);
	}
	vala_code_node_accept_children ((ValaCodeNode*) p, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_typeof_expression (ValaCodeVisitor* base,
                                              ValaTypeofExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_unary_expression (ValaCodeVisitor* base,
                                             ValaUnaryExpression* expr)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_find_symbol_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_unlock_statement (ValaCodeVisitor* base,
                                             ValaUnlockStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_using_directive (ValaCodeVisitor* base,
                                            ValaUsingDirective* ud)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (ud != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) ud)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) ud);
	if (vls_find_symbol_match (self, (ValaCodeNode*) ud)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) ud);
	}
	vala_code_node_accept_children ((ValaCodeNode*) ud, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_with_statement (ValaCodeVisitor* base,
                                           ValaWithStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_find_symbol_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp2_;
		_tmp2_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp2_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_find_symbol_real_visit_yield_statement (ValaCodeVisitor* base,
                                            ValaYieldStatement* stmt)
{
	VlsFindSymbol * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsFindSymbol*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

LspPosition*
vls_find_symbol_get_pos (VlsFindSymbol* self)
{
	LspPosition* result;
	LspPosition* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_pos;
	result = _tmp0_;
	return result;
}

static void
vls_find_symbol_set_pos (VlsFindSymbol* self,
                         LspPosition* value)
{
	LspPosition* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_pos);
	self->priv->_pos = _tmp0_;
}

gboolean
vls_find_symbol_get_search_multiline (VlsFindSymbol* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_search_multiline;
	return result;
}

static void
vls_find_symbol_set_search_multiline (VlsFindSymbol* self,
                                      gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_search_multiline = value;
}

static void
vls_find_symbol_class_init (VlsFindSymbolClass * klass,
                            gpointer klass_data)
{
	vls_find_symbol_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeVisitorClass *) klass)->finalize = vls_find_symbol_finalize;
	g_type_class_adjust_private_offset (klass, &VlsFindSymbol_private_offset);
	((ValaCodeVisitorClass *) klass)->visit_source_file = (void (*) (ValaCodeVisitor*, ValaSourceFile*)) vls_find_symbol_real_visit_source_file;
	((ValaCodeVisitorClass *) klass)->visit_addressof_expression = (void (*) (ValaCodeVisitor*, ValaAddressofExpression*)) vls_find_symbol_real_visit_addressof_expression;
	((ValaCodeVisitorClass *) klass)->visit_array_creation_expression = (void (*) (ValaCodeVisitor*, ValaArrayCreationExpression*)) vls_find_symbol_real_visit_array_creation_expression;
	((ValaCodeVisitorClass *) klass)->visit_assignment = (void (*) (ValaCodeVisitor*, ValaAssignment*)) vls_find_symbol_real_visit_assignment;
	((ValaCodeVisitorClass *) klass)->visit_base_access = (void (*) (ValaCodeVisitor*, ValaBaseAccess*)) vls_find_symbol_real_visit_base_access;
	((ValaCodeVisitorClass *) klass)->visit_binary_expression = (void (*) (ValaCodeVisitor*, ValaBinaryExpression*)) vls_find_symbol_real_visit_binary_expression;
	((ValaCodeVisitorClass *) klass)->visit_block = (void (*) (ValaCodeVisitor*, ValaBlock*)) vls_find_symbol_real_visit_block;
	((ValaCodeVisitorClass *) klass)->visit_boolean_literal = (void (*) (ValaCodeVisitor*, ValaBooleanLiteral*)) vls_find_symbol_real_visit_boolean_literal;
	((ValaCodeVisitorClass *) klass)->visit_break_statement = (void (*) (ValaCodeVisitor*, ValaBreakStatement*)) vls_find_symbol_real_visit_break_statement;
	((ValaCodeVisitorClass *) klass)->visit_cast_expression = (void (*) (ValaCodeVisitor*, ValaCastExpression*)) vls_find_symbol_real_visit_cast_expression;
	((ValaCodeVisitorClass *) klass)->visit_catch_clause = (void (*) (ValaCodeVisitor*, ValaCatchClause*)) vls_find_symbol_real_visit_catch_clause;
	((ValaCodeVisitorClass *) klass)->visit_character_literal = (void (*) (ValaCodeVisitor*, ValaCharacterLiteral*)) vls_find_symbol_real_visit_character_literal;
	((ValaCodeVisitorClass *) klass)->visit_class = (void (*) (ValaCodeVisitor*, ValaClass*)) vls_find_symbol_real_visit_class;
	((ValaCodeVisitorClass *) klass)->visit_conditional_expression = (void (*) (ValaCodeVisitor*, ValaConditionalExpression*)) vls_find_symbol_real_visit_conditional_expression;
	((ValaCodeVisitorClass *) klass)->visit_constant = (void (*) (ValaCodeVisitor*, ValaConstant*)) vls_find_symbol_real_visit_constant;
	((ValaCodeVisitorClass *) klass)->visit_constructor = (void (*) (ValaCodeVisitor*, ValaConstructor*)) vls_find_symbol_real_visit_constructor;
	((ValaCodeVisitorClass *) klass)->visit_continue_statement = (void (*) (ValaCodeVisitor*, ValaContinueStatement*)) vls_find_symbol_real_visit_continue_statement;
	((ValaCodeVisitorClass *) klass)->visit_creation_method = (void (*) (ValaCodeVisitor*, ValaCreationMethod*)) vls_find_symbol_real_visit_creation_method;
	((ValaCodeVisitorClass *) klass)->visit_data_type = (void (*) (ValaCodeVisitor*, ValaDataType*)) vls_find_symbol_real_visit_data_type;
	((ValaCodeVisitorClass *) klass)->visit_declaration_statement = (void (*) (ValaCodeVisitor*, ValaDeclarationStatement*)) vls_find_symbol_real_visit_declaration_statement;
	((ValaCodeVisitorClass *) klass)->visit_delegate = (void (*) (ValaCodeVisitor*, ValaDelegate*)) vls_find_symbol_real_visit_delegate;
	((ValaCodeVisitorClass *) klass)->visit_delete_statement = (void (*) (ValaCodeVisitor*, ValaDeleteStatement*)) vls_find_symbol_real_visit_delete_statement;
	((ValaCodeVisitorClass *) klass)->visit_destructor = (void (*) (ValaCodeVisitor*, ValaDestructor*)) vls_find_symbol_real_visit_destructor;
	((ValaCodeVisitorClass *) klass)->visit_do_statement = (void (*) (ValaCodeVisitor*, ValaDoStatement*)) vls_find_symbol_real_visit_do_statement;
	((ValaCodeVisitorClass *) klass)->visit_element_access = (void (*) (ValaCodeVisitor*, ValaElementAccess*)) vls_find_symbol_real_visit_element_access;
	((ValaCodeVisitorClass *) klass)->visit_empty_statement = (void (*) (ValaCodeVisitor*, ValaEmptyStatement*)) vls_find_symbol_real_visit_empty_statement;
	((ValaCodeVisitorClass *) klass)->visit_enum = (void (*) (ValaCodeVisitor*, ValaEnum*)) vls_find_symbol_real_visit_enum;
	((ValaCodeVisitorClass *) klass)->visit_enum_value = (void (*) (ValaCodeVisitor*, ValaEnumValue*)) vls_find_symbol_real_visit_enum_value;
	((ValaCodeVisitorClass *) klass)->visit_error_code = (void (*) (ValaCodeVisitor*, ValaErrorCode*)) vls_find_symbol_real_visit_error_code;
	((ValaCodeVisitorClass *) klass)->visit_error_domain = (void (*) (ValaCodeVisitor*, ValaErrorDomain*)) vls_find_symbol_real_visit_error_domain;
	((ValaCodeVisitorClass *) klass)->visit_expression = (void (*) (ValaCodeVisitor*, ValaExpression*)) vls_find_symbol_real_visit_expression;
	((ValaCodeVisitorClass *) klass)->visit_expression_statement = (void (*) (ValaCodeVisitor*, ValaExpressionStatement*)) vls_find_symbol_real_visit_expression_statement;
	((ValaCodeVisitorClass *) klass)->visit_field = (void (*) (ValaCodeVisitor*, ValaField*)) vls_find_symbol_real_visit_field;
	((ValaCodeVisitorClass *) klass)->visit_for_statement = (void (*) (ValaCodeVisitor*, ValaForStatement*)) vls_find_symbol_real_visit_for_statement;
	((ValaCodeVisitorClass *) klass)->visit_foreach_statement = (void (*) (ValaCodeVisitor*, ValaForeachStatement*)) vls_find_symbol_real_visit_foreach_statement;
	((ValaCodeVisitorClass *) klass)->visit_formal_parameter = (void (*) (ValaCodeVisitor*, ValaParameter*)) vls_find_symbol_real_visit_formal_parameter;
	((ValaCodeVisitorClass *) klass)->visit_if_statement = (void (*) (ValaCodeVisitor*, ValaIfStatement*)) vls_find_symbol_real_visit_if_statement;
	((ValaCodeVisitorClass *) klass)->visit_initializer_list = (void (*) (ValaCodeVisitor*, ValaInitializerList*)) vls_find_symbol_real_visit_initializer_list;
	((ValaCodeVisitorClass *) klass)->visit_integer_literal = (void (*) (ValaCodeVisitor*, ValaIntegerLiteral*)) vls_find_symbol_real_visit_integer_literal;
	((ValaCodeVisitorClass *) klass)->visit_interface = (void (*) (ValaCodeVisitor*, ValaInterface*)) vls_find_symbol_real_visit_interface;
	((ValaCodeVisitorClass *) klass)->visit_lambda_expression = (void (*) (ValaCodeVisitor*, ValaLambdaExpression*)) vls_find_symbol_real_visit_lambda_expression;
	((ValaCodeVisitorClass *) klass)->visit_local_variable = (void (*) (ValaCodeVisitor*, ValaLocalVariable*)) vls_find_symbol_real_visit_local_variable;
	((ValaCodeVisitorClass *) klass)->visit_lock_statement = (void (*) (ValaCodeVisitor*, ValaLockStatement*)) vls_find_symbol_real_visit_lock_statement;
	((ValaCodeVisitorClass *) klass)->visit_loop_statement = (void (*) (ValaCodeVisitor*, ValaLoopStatement*)) vls_find_symbol_real_visit_loop_statement;
	((ValaCodeVisitorClass *) klass)->visit_member_access = (void (*) (ValaCodeVisitor*, ValaMemberAccess*)) vls_find_symbol_real_visit_member_access;
	((ValaCodeVisitorClass *) klass)->visit_method = (void (*) (ValaCodeVisitor*, ValaMethod*)) vls_find_symbol_real_visit_method;
	((ValaCodeVisitorClass *) klass)->visit_method_call = (void (*) (ValaCodeVisitor*, ValaMethodCall*)) vls_find_symbol_real_visit_method_call;
	((ValaCodeVisitorClass *) klass)->visit_namespace = (void (*) (ValaCodeVisitor*, ValaNamespace*)) vls_find_symbol_real_visit_namespace;
	((ValaCodeVisitorClass *) klass)->visit_null_literal = (void (*) (ValaCodeVisitor*, ValaNullLiteral*)) vls_find_symbol_real_visit_null_literal;
	((ValaCodeVisitorClass *) klass)->visit_object_creation_expression = (void (*) (ValaCodeVisitor*, ValaObjectCreationExpression*)) vls_find_symbol_real_visit_object_creation_expression;
	((ValaCodeVisitorClass *) klass)->visit_pointer_indirection = (void (*) (ValaCodeVisitor*, ValaPointerIndirection*)) vls_find_symbol_real_visit_pointer_indirection;
	((ValaCodeVisitorClass *) klass)->visit_postfix_expression = (void (*) (ValaCodeVisitor*, ValaPostfixExpression*)) vls_find_symbol_real_visit_postfix_expression;
	((ValaCodeVisitorClass *) klass)->visit_property = (void (*) (ValaCodeVisitor*, ValaProperty*)) vls_find_symbol_real_visit_property;
	((ValaCodeVisitorClass *) klass)->visit_property_accessor = (void (*) (ValaCodeVisitor*, ValaPropertyAccessor*)) vls_find_symbol_real_visit_property_accessor;
	((ValaCodeVisitorClass *) klass)->visit_real_literal = (void (*) (ValaCodeVisitor*, ValaRealLiteral*)) vls_find_symbol_real_visit_real_literal;
	((ValaCodeVisitorClass *) klass)->visit_reference_transfer_expression = (void (*) (ValaCodeVisitor*, ValaReferenceTransferExpression*)) vls_find_symbol_real_visit_reference_transfer_expression;
	((ValaCodeVisitorClass *) klass)->visit_regex_literal = (void (*) (ValaCodeVisitor*, ValaRegexLiteral*)) vls_find_symbol_real_visit_regex_literal;
	((ValaCodeVisitorClass *) klass)->visit_return_statement = (void (*) (ValaCodeVisitor*, ValaReturnStatement*)) vls_find_symbol_real_visit_return_statement;
	((ValaCodeVisitorClass *) klass)->visit_signal = (void (*) (ValaCodeVisitor*, ValaSignal*)) vls_find_symbol_real_visit_signal;
	((ValaCodeVisitorClass *) klass)->visit_sizeof_expression = (void (*) (ValaCodeVisitor*, ValaSizeofExpression*)) vls_find_symbol_real_visit_sizeof_expression;
	((ValaCodeVisitorClass *) klass)->visit_slice_expression = (void (*) (ValaCodeVisitor*, ValaSliceExpression*)) vls_find_symbol_real_visit_slice_expression;
	((ValaCodeVisitorClass *) klass)->visit_string_literal = (void (*) (ValaCodeVisitor*, ValaStringLiteral*)) vls_find_symbol_real_visit_string_literal;
	((ValaCodeVisitorClass *) klass)->visit_struct = (void (*) (ValaCodeVisitor*, ValaStruct*)) vls_find_symbol_real_visit_struct;
	((ValaCodeVisitorClass *) klass)->visit_switch_label = (void (*) (ValaCodeVisitor*, ValaSwitchLabel*)) vls_find_symbol_real_visit_switch_label;
	((ValaCodeVisitorClass *) klass)->visit_switch_section = (void (*) (ValaCodeVisitor*, ValaSwitchSection*)) vls_find_symbol_real_visit_switch_section;
	((ValaCodeVisitorClass *) klass)->visit_switch_statement = (void (*) (ValaCodeVisitor*, ValaSwitchStatement*)) vls_find_symbol_real_visit_switch_statement;
	((ValaCodeVisitorClass *) klass)->visit_template = (void (*) (ValaCodeVisitor*, ValaTemplate*)) vls_find_symbol_real_visit_template;
	((ValaCodeVisitorClass *) klass)->visit_throw_statement = (void (*) (ValaCodeVisitor*, ValaThrowStatement*)) vls_find_symbol_real_visit_throw_statement;
	((ValaCodeVisitorClass *) klass)->visit_try_statement = (void (*) (ValaCodeVisitor*, ValaTryStatement*)) vls_find_symbol_real_visit_try_statement;
	((ValaCodeVisitorClass *) klass)->visit_type_check = (void (*) (ValaCodeVisitor*, ValaTypeCheck*)) vls_find_symbol_real_visit_type_check;
	((ValaCodeVisitorClass *) klass)->visit_type_parameter = (void (*) (ValaCodeVisitor*, ValaTypeParameter*)) vls_find_symbol_real_visit_type_parameter;
	((ValaCodeVisitorClass *) klass)->visit_typeof_expression = (void (*) (ValaCodeVisitor*, ValaTypeofExpression*)) vls_find_symbol_real_visit_typeof_expression;
	((ValaCodeVisitorClass *) klass)->visit_unary_expression = (void (*) (ValaCodeVisitor*, ValaUnaryExpression*)) vls_find_symbol_real_visit_unary_expression;
	((ValaCodeVisitorClass *) klass)->visit_unlock_statement = (void (*) (ValaCodeVisitor*, ValaUnlockStatement*)) vls_find_symbol_real_visit_unlock_statement;
	((ValaCodeVisitorClass *) klass)->visit_using_directive = (void (*) (ValaCodeVisitor*, ValaUsingDirective*)) vls_find_symbol_real_visit_using_directive;
	((ValaCodeVisitorClass *) klass)->visit_with_statement = (void (*) (ValaCodeVisitor*, ValaWithStatement*)) vls_find_symbol_real_visit_with_statement;
	((ValaCodeVisitorClass *) klass)->visit_yield_statement = (void (*) (ValaCodeVisitor*, ValaYieldStatement*)) vls_find_symbol_real_visit_yield_statement;
}

static void
vls_find_symbol_instance_init (VlsFindSymbol * self,
                               gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeHashSet* _tmp1_;
	self->priv = vls_find_symbol_get_instance_private (self);
	_tmp0_ = gee_array_list_new (VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL);
	if (_tmp0_) {
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
	}
	self->result = (GeeList*) _tmp0_;
	_tmp1_ = gee_hash_set_new (VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp1_) {
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "");
	}
	self->priv->seen = _tmp1_;
	self->priv->include_declaration = TRUE;
}

static void
vls_find_symbol_finalize (ValaCodeVisitor * obj)
{
	VlsFindSymbol * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VLS_TYPE_FIND_SYMBOL, VlsFindSymbol);
	_g_object_unref0 (self->priv->_pos);
	_g_object_unref0 (self->priv->end_pos);
	_vala_source_file_unref0 (self->priv->file);
	_g_object_unref0 (self->result);
	_g_object_unref0 (self->priv->seen);
	_vala_code_node_unref0 (self->priv->needle);
	VALA_CODE_VISITOR_CLASS (vls_find_symbol_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
vls_find_symbol_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VlsFindSymbolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vls_find_symbol_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VlsFindSymbol), 0, (GInstanceInitFunc) vls_find_symbol_instance_init, NULL };
	GType vls_find_symbol_type_id;
	vls_find_symbol_type_id = g_type_register_static (VALA_TYPE_CODE_VISITOR, "VlsFindSymbol", &g_define_type_info, 0);
	VlsFindSymbol_private_offset = g_type_add_instance_private (vls_find_symbol_type_id, sizeof (VlsFindSymbolPrivate));
	return vls_find_symbol_type_id;
}

GType
vls_find_symbol_get_type (void)
{
	static gsize vls_find_symbol_type_id__once = 0;
	if (g_once_init_enter (&vls_find_symbol_type_id__once)) {
		GType vls_find_symbol_type_id;
		vls_find_symbol_type_id = vls_find_symbol_get_type_once ();
		g_once_init_leave (&vls_find_symbol_type_id__once, vls_find_symbol_type_id);
	}
	return vls_find_symbol_type_id__once;
}

