/* buildtask.c generated by valac 0.55.1, the Vala compiler
 * generated from buildtask.vala, do not modify */

/* buildtask.vala
 *
 * Copyright 2020 Princeton Ferro <princetonferro@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define VLS_TYPE_BUILD_TARGET (vls_build_target_get_type ())
#define VLS_BUILD_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_BUILD_TARGET, VlsBuildTarget))
#define VLS_BUILD_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_BUILD_TARGET, VlsBuildTargetClass))
#define VLS_IS_BUILD_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_BUILD_TARGET))
#define VLS_IS_BUILD_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_BUILD_TARGET))
#define VLS_BUILD_TARGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_BUILD_TARGET, VlsBuildTargetClass))

typedef struct _VlsBuildTarget VlsBuildTarget;
typedef struct _VlsBuildTargetClass VlsBuildTargetClass;
typedef struct _VlsBuildTargetPrivate VlsBuildTargetPrivate;

#define VLS_TYPE_BUILD_TASK (vls_build_task_get_type ())
#define VLS_BUILD_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_BUILD_TASK, VlsBuildTask))
#define VLS_BUILD_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_BUILD_TASK, VlsBuildTaskClass))
#define VLS_IS_BUILD_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_BUILD_TASK))
#define VLS_IS_BUILD_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_BUILD_TASK))
#define VLS_BUILD_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_BUILD_TASK, VlsBuildTaskClass))

typedef struct _VlsBuildTask VlsBuildTask;
typedef struct _VlsBuildTaskClass VlsBuildTaskClass;
typedef struct _VlsBuildTaskPrivate VlsBuildTaskPrivate;
enum  {
	VLS_BUILD_TASK_0_PROPERTY,
	VLS_BUILD_TASK_USED_FILES_PROPERTY,
	VLS_BUILD_TASK_CANDIDATE_INPUTS_PROPERTY,
	VLS_BUILD_TASK_NUM_PROPERTIES
};
static GParamSpec* vls_build_task_properties[VLS_BUILD_TASK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))

struct _VlsBuildTarget {
	GObject parent_instance;
	VlsBuildTargetPrivate * priv;
};

struct _VlsBuildTargetClass {
	GObjectClass parent_class;
	void (*build_if_stale) (VlsBuildTarget* self, GCancellable* cancellable, GError** error);
};

struct _VlsBuildTask {
	VlsBuildTarget parent_instance;
	VlsBuildTaskPrivate * priv;
};

struct _VlsBuildTaskClass {
	VlsBuildTargetClass parent_class;
};

struct _VlsBuildTaskPrivate {
	gchar** arguments;
	gint arguments_length1;
	gint _arguments_size_;
	gchar* exe_name;
	gchar* build_dir;
	GSubprocessLauncher* launcher;
	GeeArrayList* _used_files;
	GeeArrayList* _candidate_inputs;
};

typedef enum  {
	VLS_PROJECT_ERROR_VERSION_UNSUPPORTED,
	VLS_PROJECT_ERROR_INTROSPECTION,
	VLS_PROJECT_ERROR_CONFIGURATION,
	VLS_PROJECT_ERROR_TASK_FAILED,
	VLS_PROJECT_ERROR_NOT_FOUND
} VlsProjectError;
#define VLS_PROJECT_ERROR vls_project_error_quark ()

static gint VlsBuildTask_private_offset;
static gpointer vls_build_task_parent_class = NULL;

VALA_EXTERN GType vls_build_target_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsBuildTarget, g_object_unref)
VALA_EXTERN GType vls_build_task_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsBuildTask, g_object_unref)
VALA_EXTERN void vls_build_target_build_if_stale (VlsBuildTarget* self,
                                      GCancellable* cancellable,
                                      GError** error);
VALA_EXTERN VlsBuildTask* vls_build_task_new (const gchar* build_dir,
                                  const gchar* output_dir,
                                  const gchar* name,
                                  const gchar* id,
                                  gint no,
                                  gchar** compiler,
                                  gint compiler_length1,
                                  gchar** args,
                                  gint args_length1,
                                  gchar** sources,
                                  gint sources_length1,
                                  gchar** generated_sources,
                                  gint generated_sources_length1,
                                  gchar** target_output_files,
                                  gint target_output_files_length1,
                                  const gchar* language,
                                  GError** error);
VALA_EXTERN VlsBuildTask* vls_build_task_construct (GType object_type,
                                        const gchar* build_dir,
                                        const gchar* output_dir,
                                        const gchar* name,
                                        const gchar* id,
                                        gint no,
                                        gchar** compiler,
                                        gint compiler_length1,
                                        gchar** args,
                                        gint args_length1,
                                        gchar** sources,
                                        gint sources_length1,
                                        gchar** generated_sources,
                                        gint generated_sources_length1,
                                        gchar** target_output_files,
                                        gint target_output_files_length1,
                                        const gchar* language,
                                        GError** error);
VALA_EXTERN VlsBuildTarget* vls_build_target_construct (GType object_type,
                                            const gchar* output_dir,
                                            const gchar* name,
                                            const gchar* id,
                                            gint no);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gboolean vls_util_arg_is_vala_file (const gchar* arg);
VALA_EXTERN GeeArrayList* vls_build_task_get_used_files (VlsBuildTask* self);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add7 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN GeeArrayList* vls_build_target_get_input (VlsBuildTarget* self);
static void _vala_array_add8 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gint vls_util_iterate_valac_args (gchar** args,
                                  gint args_length1,
                                  gchar** flag_name,
                                  gchar** arg_value,
                                  gint last_arg_index);
VALA_EXTERN GeeArrayList* vls_build_target_get_output (VlsBuildTarget* self);
VALA_EXTERN GQuark vls_project_error_quark (void);
static gchar* _______lambda17_ (VlsBuildTask* self,
                         GFile* f);
static gpointer ________lambda17__gee_map_func (gpointer g,
                                         gpointer self);
static gchar* _______lambda18_ (VlsBuildTask* self,
                         gchar* rightacc,
                         gchar* elem);
static gpointer ________lambda18__gee_fold_func (gpointer g,
                                          gpointer a,
                                          gpointer self);
static void _vala_array_add9 (GFile** * array,
                       gint* length,
                       gint* size,
                       GFile* value);
VALA_EXTERN GFile** vls_util_discover_gresources_xml_input_files (const gchar* gresources_xml,
                                                      GFile** source_dirs,
                                                      gint source_dirs_length1,
                                                      gint* result_length1,
                                                      GError** error);
VALA_EXTERN GeeArrayList* vls_build_task_get_candidate_inputs (VlsBuildTask* self);
static void vls_build_task_real_build_if_stale (VlsBuildTarget* base,
                                         GCancellable* cancellable,
                                         GError** error);
VALA_EXTERN const gchar* vls_build_target_get_id (VlsBuildTarget* self);
VALA_EXTERN GDateTime* vls_build_target_get_last_updated (VlsBuildTarget* self);
VALA_EXTERN void vls_build_target_set_last_updated (VlsBuildTarget* self,
                                        GDateTime* value);
static void vls_build_task_set_used_files (VlsBuildTask* self,
                                    GeeArrayList* value);
static void vls_build_task_set_candidate_inputs (VlsBuildTask* self,
                                          GeeArrayList* value);
static void vls_build_task_finalize (GObject * obj);
static GType vls_build_task_get_type_once (void);
static void _vala_vls_build_task_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_vls_build_task_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
vls_build_task_get_instance_private (VlsBuildTask* self)
{
	return G_STRUCT_MEMBER_P (self, VlsBuildTask_private_offset);
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add7 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add8 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

static gchar*
_______lambda17_ (VlsBuildTask* self,
                  GFile* f)
{
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (f != NULL, NULL);
	_tmp0_ = g_file_get_path (f);
	result = _tmp0_;
	_g_object_unref0 (f);
	return result;
}

static gpointer
________lambda17__gee_map_func (gpointer g,
                                gpointer self)
{
	gpointer result;
	result = _______lambda17_ ((VlsBuildTask*) self, (GFile*) g);
	return result;
}

static gchar*
_______lambda18_ (VlsBuildTask* self,
                  gchar* rightacc,
                  gchar* elem)
{
	gchar* _tmp0_ = NULL;
	gchar* result;
	g_return_val_if_fail (rightacc != NULL, NULL);
	g_return_val_if_fail (elem != NULL, NULL);
	if (g_strcmp0 (elem, "") != 0) {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = string_to_string (elem);
		_tmp2_ = string_to_string (rightacc);
		_tmp3_ = g_strconcat (_tmp1_, ", ", _tmp2_, NULL);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
	} else {
		gchar* _tmp4_;
		_tmp4_ = g_strdup (rightacc);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	}
	result = _tmp0_;
	_g_free0 (rightacc);
	_g_free0 (elem);
	return result;
}

static gpointer
________lambda18__gee_fold_func (gpointer g,
                                 gpointer a,
                                 gpointer self)
{
	gpointer result;
	result = _______lambda18_ ((VlsBuildTask*) self, (gchar*) g, (gchar*) a);
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_vala_array_add9 (GFile** * array,
                  gint* length,
                  gint* size,
                  GFile* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GFile*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

VlsBuildTask*
vls_build_task_construct (GType object_type,
                          const gchar* build_dir,
                          const gchar* output_dir,
                          const gchar* name,
                          const gchar* id,
                          gint no,
                          gchar** compiler,
                          gint compiler_length1,
                          gchar** args,
                          gint args_length1,
                          gchar** sources,
                          gint sources_length1,
                          gchar** generated_sources,
                          gint generated_sources_length1,
                          gchar** target_output_files,
                          gint target_output_files_length1,
                          const gchar* language,
                          GError** error)
{
	VlsBuildTask * self = NULL;
	gchar* _tmp0_;
	GSubprocessLauncher* _tmp1_;
	GSubprocessLauncher* _tmp2_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	gchar* _tmp51_ = NULL;
	gchar* cmd_basename = NULL;
	gchar* _tmp54_;
	const gchar* _tmp55_;
	gboolean _tmp88_ = FALSE;
	gboolean _tmp89_ = FALSE;
	const gchar* _tmp90_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (build_dir != NULL, NULL);
	g_return_val_if_fail (output_dir != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	g_return_val_if_fail (language != NULL, NULL);
	self = (VlsBuildTask*) vls_build_target_construct (object_type, output_dir, name, id, no);
	_tmp0_ = g_strdup (build_dir);
	_g_free0 (self->priv->build_dir);
	self->priv->build_dir = _tmp0_;
	_tmp1_ = g_subprocess_launcher_new (G_SUBPROCESS_FLAGS_STDOUT_PIPE);
	if (_tmp1_) {
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "Vls.BuildTask.new");
	}
	_g_object_unref0 (self->priv->launcher);
	self->priv->launcher = _tmp1_;
	_tmp2_ = self->priv->launcher;
	g_subprocess_launcher_set_cwd (_tmp2_, build_dir);
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
		arg_collection = compiler;
		arg_collection_length1 = compiler_length1;
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
			gchar* _tmp3_;
			gchar* arg = NULL;
			_tmp3_ = g_strdup (arg_collection[arg_it]);
			arg = _tmp3_;
			{
				gchar** _tmp4_;
				gint _tmp4__length1;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				_tmp4_ = self->priv->arguments;
				_tmp4__length1 = self->priv->arguments_length1;
				if (_tmp4__length1 > 0) {
					const gchar* _tmp5_;
					gchar* _tmp6_;
					_tmp5_ = self->priv->exe_name;
					_tmp6_ = g_strconcat (_tmp5_, " ", NULL);
					_g_free0 (self->priv->exe_name);
					self->priv->exe_name = _tmp6_;
				}
				_tmp7_ = self->priv->exe_name;
				_tmp8_ = arg;
				_tmp9_ = g_strconcat (_tmp7_, _tmp8_, NULL);
				_g_free0 (self->priv->exe_name);
				self->priv->exe_name = _tmp9_;
				_tmp10_ = arg;
				_tmp11_ = g_strdup (_tmp10_);
				_vala_array_add4 (&self->priv->arguments, &self->priv->arguments_length1, &self->priv->_arguments_size_, _tmp11_);
				_g_free0 (arg);
			}
		}
	}
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
		arg_collection = args;
		arg_collection_length1 = args_length1;
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
			gchar* _tmp12_;
			gchar* arg = NULL;
			_tmp12_ = g_strdup (arg_collection[arg_it]);
			arg = _tmp12_;
			{
				gchar** _tmp13_;
				gint _tmp13__length1;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				_tmp13_ = self->priv->arguments;
				_tmp13__length1 = self->priv->arguments_length1;
				if (_tmp13__length1 > 0) {
					const gchar* _tmp14_;
					gchar* _tmp15_;
					_tmp14_ = self->priv->exe_name;
					_tmp15_ = g_strconcat (_tmp14_, " ", NULL);
					_g_free0 (self->priv->exe_name);
					self->priv->exe_name = _tmp15_;
				}
				_tmp16_ = self->priv->exe_name;
				_tmp17_ = arg;
				_tmp18_ = g_strconcat (_tmp16_, _tmp17_, NULL);
				_g_free0 (self->priv->exe_name);
				self->priv->exe_name = _tmp18_;
				_tmp19_ = arg;
				_tmp20_ = g_strdup (_tmp19_);
				_vala_array_add5 (&self->priv->arguments, &self->priv->arguments_length1, &self->priv->_arguments_size_, _tmp20_);
				_g_free0 (arg);
			}
		}
	}
	_tmp21_ = self->priv->arguments;
	_tmp21__length1 = self->priv->arguments_length1;
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
		arg_collection = _tmp21_;
		arg_collection_length1 = _tmp21__length1;
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
			gchar* _tmp22_;
			gchar* arg = NULL;
			_tmp22_ = g_strdup (arg_collection[arg_it]);
			arg = _tmp22_;
			{
				const gchar* _tmp23_;
				_tmp23_ = arg;
				if (vls_util_arg_is_vala_file (_tmp23_)) {
					GFile* file = NULL;
					const gchar* _tmp24_;
					GFile* _tmp25_;
					GeeArrayList* _tmp26_;
					GFile* _tmp27_;
					_tmp24_ = arg;
					_tmp25_ = g_file_new_for_commandline_arg_and_cwd (_tmp24_, output_dir);
					file = _tmp25_;
					_tmp26_ = self->priv->_used_files;
					_tmp27_ = file;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
					_g_object_unref0 (file);
				}
				_g_free0 (arg);
			}
		}
	}
	if (g_strcmp0 (language, "c") == 0) {
		gchar* _tmp28_;
		_tmp28_ = g_strdup ("-fdiagnostics-color=never");
		_vala_array_add6 (&self->priv->arguments, &self->priv->arguments_length1, &self->priv->_arguments_size_, _tmp28_);
	}
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
		arg_collection = sources;
		arg_collection_length1 = sources_length1;
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
			gchar* _tmp29_;
			gchar* arg = NULL;
			_tmp29_ = g_strdup (arg_collection[arg_it]);
			arg = _tmp29_;
			{
				GeeArrayList* _tmp38_;
				GeeArrayList* _tmp39_;
				const gchar* _tmp40_;
				GFile* _tmp41_;
				GFile* _tmp42_;
				if (g_strcmp0 (language, "c") == 0) {
					gchar** _tmp30_;
					gint _tmp30__length1;
					const gchar* _tmp33_;
					const gchar* _tmp34_;
					gchar* _tmp35_;
					const gchar* _tmp36_;
					gchar* _tmp37_;
					_tmp30_ = self->priv->arguments;
					_tmp30__length1 = self->priv->arguments_length1;
					if (_tmp30__length1 > 0) {
						const gchar* _tmp31_;
						gchar* _tmp32_;
						_tmp31_ = self->priv->exe_name;
						_tmp32_ = g_strconcat (_tmp31_, " ", NULL);
						_g_free0 (self->priv->exe_name);
						self->priv->exe_name = _tmp32_;
					}
					_tmp33_ = self->priv->exe_name;
					_tmp34_ = arg;
					_tmp35_ = g_strconcat (_tmp33_, _tmp34_, NULL);
					_g_free0 (self->priv->exe_name);
					self->priv->exe_name = _tmp35_;
					_tmp36_ = arg;
					_tmp37_ = g_strdup (_tmp36_);
					_vala_array_add7 (&self->priv->arguments, &self->priv->arguments_length1, &self->priv->_arguments_size_, _tmp37_);
				}
				_tmp38_ = vls_build_target_get_input ((VlsBuildTarget*) self);
				_tmp39_ = _tmp38_;
				_tmp40_ = arg;
				_tmp41_ = g_file_new_for_commandline_arg_and_cwd (_tmp40_, output_dir);
				_tmp42_ = _tmp41_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp39_, _tmp42_);
				_g_object_unref0 (_tmp42_);
				_g_free0 (arg);
			}
		}
	}
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
		arg_collection = generated_sources;
		arg_collection_length1 = generated_sources_length1;
		for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
			gchar* _tmp43_;
			gchar* arg = NULL;
			_tmp43_ = g_strdup (arg_collection[arg_it]);
			arg = _tmp43_;
			{
				const gchar* _tmp44_;
				gchar* _tmp45_;
				GeeArrayList* _tmp46_;
				GeeArrayList* _tmp47_;
				const gchar* _tmp48_;
				GFile* _tmp49_;
				GFile* _tmp50_;
				_tmp44_ = arg;
				_tmp45_ = g_strdup (_tmp44_);
				_vala_array_add8 (&self->priv->arguments, &self->priv->arguments_length1, &self->priv->_arguments_size_, _tmp45_);
				_tmp46_ = vls_build_target_get_input ((VlsBuildTarget*) self);
				_tmp47_ = _tmp46_;
				_tmp48_ = arg;
				_tmp49_ = g_file_new_for_commandline_arg_and_cwd (_tmp48_, output_dir);
				_tmp50_ = _tmp49_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp47_, _tmp50_);
				_g_object_unref0 (_tmp50_);
				_g_free0 (arg);
			}
		}
	}
	if (compiler_length1 > 0) {
		const gchar* _tmp52_;
		gchar* _tmp53_;
		_tmp52_ = compiler[0];
		_tmp53_ = g_path_get_basename (_tmp52_);
		_g_free0 (_tmp51_);
		_tmp51_ = _tmp53_;
	} else {
		_g_free0 (_tmp51_);
		_tmp51_ = NULL;
	}
	_tmp54_ = g_strdup (_tmp51_);
	cmd_basename = _tmp54_;
	_tmp55_ = cmd_basename;
	if (g_strcmp0 (_tmp55_, "vapigen") == 0) {
		gchar* library_name = NULL;
		gchar* directory = NULL;
		gchar* flag_name = NULL;
		gchar* arg_value = NULL;
		const gchar* _tmp68_;
		library_name = NULL;
		directory = NULL;
		{
			gint arg_i = 0;
			arg_i = -1;
			{
				gboolean _tmp56_ = FALSE;
				_tmp56_ = TRUE;
				while (TRUE) {
					gchar** _tmp57_;
					gint _tmp57__length1;
					gchar* _tmp58_ = NULL;
					gchar* _tmp59_ = NULL;
					gint _tmp60_;
					gchar** _tmp61_;
					gint _tmp61__length1;
					const gchar* _tmp62_;
					if (!_tmp56_) {
					}
					_tmp56_ = FALSE;
					_tmp57_ = self->priv->arguments;
					_tmp57__length1 = self->priv->arguments_length1;
					_tmp60_ = vls_util_iterate_valac_args (_tmp57_, (gint) _tmp57__length1, &_tmp58_, &_tmp59_, arg_i);
					_g_free0 (flag_name);
					flag_name = _tmp58_;
					_g_free0 (arg_value);
					arg_value = _tmp59_;
					arg_i = _tmp60_;
					_tmp61_ = self->priv->arguments;
					_tmp61__length1 = self->priv->arguments_length1;
					if (!(arg_i < _tmp61__length1)) {
						break;
					}
					_tmp62_ = flag_name;
					if (g_strcmp0 (_tmp62_, "directory") == 0) {
						const gchar* _tmp63_;
						gchar* _tmp64_;
						_tmp63_ = arg_value;
						_tmp64_ = g_strdup (_tmp63_);
						_g_free0 (directory);
						directory = _tmp64_;
					} else {
						const gchar* _tmp65_;
						_tmp65_ = flag_name;
						if (g_strcmp0 (_tmp65_, "library") == 0) {
							const gchar* _tmp66_;
							gchar* _tmp67_;
							_tmp66_ = arg_value;
							_tmp67_ = g_strdup (_tmp66_);
							_g_free0 (library_name);
							library_name = _tmp67_;
						}
					}
				}
			}
		}
		_tmp68_ = library_name;
		if (_tmp68_ != NULL) {
			const gchar* _tmp69_;
			GeeArrayList* _tmp71_;
			GeeArrayList* _tmp72_;
			const gchar* _tmp73_;
			const gchar* _tmp74_;
			gchar* _tmp75_;
			gchar* _tmp76_;
			const gchar* _tmp77_;
			GFile* _tmp78_;
			GFile* _tmp79_;
			_tmp69_ = directory;
			if (_tmp69_ == NULL) {
				gchar* _tmp70_;
				g_warning ("buildtask.vala:115: BuildTask(%s): no --directory for vapigen, assumin" \
"g %s", id, output_dir);
				_tmp70_ = g_strdup (output_dir);
				_g_free0 (directory);
				directory = _tmp70_;
			}
			_tmp71_ = vls_build_target_get_output ((VlsBuildTarget*) self);
			_tmp72_ = _tmp71_;
			_tmp73_ = library_name;
			_tmp74_ = string_to_string (_tmp73_);
			_tmp75_ = g_strconcat (_tmp74_, ".vapi", NULL);
			_tmp76_ = _tmp75_;
			_tmp77_ = directory;
			_tmp78_ = g_file_new_for_commandline_arg_and_cwd (_tmp76_, _tmp77_);
			_tmp79_ = _tmp78_;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp72_, _tmp79_);
			_g_object_unref0 (_tmp79_);
			_g_free0 (_tmp76_);
		}
		_g_free0 (arg_value);
		_g_free0 (flag_name);
		_g_free0 (directory);
		_g_free0 (library_name);
	} else {
		{
			gchar** output_filename_collection = NULL;
			gint output_filename_collection_length1 = 0;
			gint _output_filename_collection_size_ = 0;
			gint output_filename_it = 0;
			output_filename_collection = target_output_files;
			output_filename_collection_length1 = target_output_files_length1;
			for (output_filename_it = 0; output_filename_it < output_filename_collection_length1; output_filename_it = output_filename_it + 1) {
				gchar* _tmp80_;
				gchar* output_filename = NULL;
				_tmp80_ = g_strdup (output_filename_collection[output_filename_it]);
				output_filename = _tmp80_;
				{
					const gchar* _tmp81_;
					_tmp81_ = output_filename;
					if (_tmp81_ != NULL) {
						GeeArrayList* _tmp82_;
						GeeArrayList* _tmp83_;
						const gchar* _tmp84_;
						GFile* _tmp85_;
						GFile* _tmp86_;
						const gchar* _tmp87_;
						_tmp82_ = vls_build_target_get_output ((VlsBuildTarget*) self);
						_tmp83_ = _tmp82_;
						_tmp84_ = output_filename;
						_tmp85_ = g_file_new_for_commandline_arg_and_cwd (_tmp84_, output_dir);
						_tmp86_ = _tmp85_;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp83_, _tmp86_);
						_g_object_unref0 (_tmp86_);
						_tmp87_ = output_filename;
						g_debug ("buildtask.vala:125: BuildTask(%s): outputs %s", id, _tmp87_);
					}
					_g_free0 (output_filename);
				}
			}
		}
	}
	_tmp90_ = cmd_basename;
	if (g_strcmp0 (_tmp90_, "glib-mkenums") == 0) {
		_tmp89_ = TRUE;
	} else {
		const gchar* _tmp91_;
		_tmp91_ = cmd_basename;
		_tmp89_ = g_strcmp0 (_tmp91_, "g-ir-scanner") == 0;
	}
	if (_tmp89_) {
		_tmp88_ = TRUE;
	} else {
		const gchar* _tmp92_;
		_tmp92_ = cmd_basename;
		_tmp88_ = g_strcmp0 (_tmp92_, "glib-compile-resources") == 0;
	}
	if (_tmp88_) {
		GFile* output_file = NULL;
		const gchar* _tmp115_;
		if (target_output_files_length1 >= 1) {
			const gchar* _tmp93_;
			GFile* _tmp94_;
			gboolean _tmp95_ = FALSE;
			const gchar* _tmp96_;
			_tmp93_ = target_output_files[0];
			_tmp94_ = g_file_new_for_path (_tmp93_);
			_g_object_unref0 (output_file);
			output_file = _tmp94_;
			_tmp96_ = cmd_basename;
			if (g_strcmp0 (_tmp96_, "glib-mkenums") == 0) {
				const gchar* _tmp97_;
				_tmp97_ = target_output_files[0];
				_tmp95_ = g_str_has_suffix (_tmp97_, ".c");
			} else {
				_tmp95_ = FALSE;
			}
			if (_tmp95_) {
				GeeArrayList* _tmp98_;
				GeeArrayList* _tmp99_;
				const gchar* _tmp100_;
				const gchar* _tmp101_;
				gint _tmp102_;
				gint _tmp103_;
				gchar* _tmp104_;
				gchar* _tmp105_;
				gchar* _tmp106_;
				gchar* _tmp107_;
				GFile* _tmp108_;
				GFile* _tmp109_;
				_tmp98_ = vls_build_target_get_input ((VlsBuildTarget*) self);
				_tmp99_ = _tmp98_;
				_tmp100_ = target_output_files[0];
				_tmp101_ = target_output_files[0];
				_tmp102_ = strlen (_tmp101_);
				_tmp103_ = _tmp102_;
				_tmp104_ = string_substring (_tmp100_, (glong) 0, (glong) (_tmp103_ - 2));
				_tmp105_ = _tmp104_;
				_tmp106_ = g_strconcat (_tmp105_, ".h", NULL);
				_tmp107_ = _tmp106_;
				_tmp108_ = g_file_new_for_path (_tmp107_);
				_tmp109_ = _tmp108_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp99_, _tmp109_);
				_g_object_unref0 (_tmp109_);
				_g_free0 (_tmp107_);
				_g_free0 (_tmp105_);
			}
		} else {
			const gchar* _tmp110_;
			gchar* _tmp111_;
			gchar* _tmp112_;
			GError* _tmp113_;
			GError* _tmp114_;
			_tmp110_ = string_to_string (id);
			_tmp111_ = g_strconcat ("BuildTask(", _tmp110_, ") expected at least one output file for target", NULL);
			_tmp112_ = _tmp111_;
			_tmp113_ = g_error_new_literal (VLS_PROJECT_ERROR, VLS_PROJECT_ERROR_INTROSPECTION, _tmp112_);
			_tmp114_ = _tmp113_;
			_g_free0 (_tmp112_);
			_inner_error0_ = _tmp114_;
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (output_file);
			_g_free0 (cmd_basename);
			_g_free0 (_tmp51_);
			_g_object_unref0 (self);
			return NULL;
		}
		_tmp115_ = cmd_basename;
		if (g_strcmp0 (_tmp115_, "g-ir-scanner") == 0) {
			gchar* last_arg = NULL;
			gchar* gir_library_name = NULL;
			GFile* gir_library_dir = NULL;
			GFile* _tmp116_;
			GFile* _tmp117_;
			gchar** _tmp118_;
			gint _tmp118__length1;
			const gchar* _tmp125_;
			last_arg = NULL;
			gir_library_name = NULL;
			_tmp116_ = output_file;
			_tmp117_ = g_file_get_parent (_tmp116_);
			gir_library_dir = _tmp117_;
			_tmp118_ = self->priv->arguments;
			_tmp118__length1 = self->priv->arguments_length1;
			{
				gchar** arg_collection = NULL;
				gint arg_collection_length1 = 0;
				gint _arg_collection_size_ = 0;
				gint arg_it = 0;
				arg_collection = _tmp118_;
				arg_collection_length1 = _tmp118__length1;
				for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
					gchar* _tmp119_;
					gchar* arg = NULL;
					_tmp119_ = g_strdup (arg_collection[arg_it]);
					arg = _tmp119_;
					{
						const gchar* _tmp120_;
						const gchar* _tmp123_;
						gchar* _tmp124_;
						_tmp120_ = last_arg;
						if (g_strcmp0 (_tmp120_, "--library") == 0) {
							const gchar* _tmp121_;
							gchar* _tmp122_;
							_tmp121_ = arg;
							_tmp122_ = g_strdup (_tmp121_);
							_g_free0 (gir_library_name);
							gir_library_name = _tmp122_;
						}
						_tmp123_ = arg;
						_tmp124_ = g_strdup (_tmp123_);
						_g_free0 (last_arg);
						last_arg = _tmp124_;
						_g_free0 (arg);
					}
				}
			}
			_tmp125_ = gir_library_name;
			if (_tmp125_ != NULL) {
				GFile* _tmp126_;
				_tmp126_ = gir_library_dir;
				if (_tmp126_ != NULL) {
					GeeArrayList* tried = NULL;
					GeeArrayList* _tmp127_;
					gboolean success = FALSE;
					GFile* library_file = NULL;
					gchar* _tmp128_;
					gchar* _tmp129_;
					gchar** _tmp130_;
					_tmp127_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
					if (_tmp127_) {
						g_object_set_data ((GObject *) _tmp127_, "vala-creation-function", "Vls.BuildTask.new");
					}
					tried = _tmp127_;
					success = FALSE;
					library_file = NULL;
					_tmp128_ = g_strdup ("so");
					_tmp129_ = g_strdup ("dll");
					_tmp130_ = g_new0 (gchar*, 2 + 1);
					_tmp130_[0] = _tmp128_;
					_tmp130_[1] = _tmp129_;
					{
						gchar** shlib_suffix_collection = NULL;
						gint shlib_suffix_collection_length1 = 0;
						gint _shlib_suffix_collection_size_ = 0;
						gint shlib_suffix_it = 0;
						shlib_suffix_collection = _tmp130_;
						shlib_suffix_collection_length1 = 2;
						for (shlib_suffix_it = 0; shlib_suffix_it < shlib_suffix_collection_length1; shlib_suffix_it = shlib_suffix_it + 1) {
							gchar* _tmp131_;
							gchar* shlib_suffix = NULL;
							_tmp131_ = g_strdup (shlib_suffix_collection[shlib_suffix_it]);
							shlib_suffix = _tmp131_;
							{
								GFile* _tmp132_;
								const gchar* _tmp133_;
								const gchar* _tmp134_;
								const gchar* _tmp135_;
								const gchar* _tmp136_;
								gchar* _tmp137_;
								gchar* _tmp138_;
								GFile* _tmp139_;
								GFile* _tmp140_;
								GFile* libdir = NULL;
								GFile* _tmp147_;
								const gchar* _tmp148_;
								const gchar* _tmp149_;
								const gchar* _tmp150_;
								const gchar* _tmp151_;
								gchar* _tmp152_;
								gchar* _tmp153_;
								GFile* _tmp154_;
								GFile* _tmp155_;
								GFile* _tmp156_;
								GeeArrayList* _tmp163_;
								GFile* _tmp164_;
								_tmp132_ = gir_library_dir;
								_tmp133_ = gir_library_name;
								_tmp134_ = string_to_string (_tmp133_);
								_tmp135_ = shlib_suffix;
								_tmp136_ = string_to_string (_tmp135_);
								_tmp137_ = g_strconcat ("lib", _tmp134_, ".", _tmp136_, NULL);
								_tmp138_ = _tmp137_;
								_tmp139_ = g_file_get_child (_tmp132_, _tmp138_);
								_g_object_unref0 (library_file);
								library_file = _tmp139_;
								_g_free0 (_tmp138_);
								_tmp140_ = library_file;
								if (g_file_query_exists (_tmp140_, NULL)) {
									GeeArrayList* _tmp141_;
									GeeArrayList* _tmp142_;
									GFile* _tmp143_;
									GFile* _tmp144_;
									gchar* _tmp145_;
									gchar* _tmp146_;
									_tmp141_ = vls_build_target_get_input ((VlsBuildTarget*) self);
									_tmp142_ = _tmp141_;
									_tmp143_ = library_file;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp142_, _tmp143_);
									_tmp144_ = library_file;
									_tmp145_ = g_file_get_path (_tmp144_);
									_tmp146_ = _tmp145_;
									g_debug ("buildtask.vala:166: BuildTask(%s) found input %s", id, _tmp146_);
									_g_free0 (_tmp146_);
									success = TRUE;
									_g_free0 (shlib_suffix);
									break;
								}
								_tmp147_ = gir_library_dir;
								_tmp148_ = gir_library_name;
								_tmp149_ = string_to_string (_tmp148_);
								_tmp150_ = shlib_suffix;
								_tmp151_ = string_to_string (_tmp150_);
								_tmp152_ = g_strconcat ("lib", _tmp149_, ".", _tmp151_, ".p", NULL);
								_tmp153_ = _tmp152_;
								_tmp154_ = g_file_get_child (_tmp147_, _tmp153_);
								_tmp155_ = _tmp154_;
								_g_free0 (_tmp153_);
								libdir = _tmp155_;
								_tmp156_ = libdir;
								if (g_file_query_exists (_tmp156_, NULL)) {
									GeeArrayList* _tmp157_;
									GeeArrayList* _tmp158_;
									GFile* _tmp159_;
									GFile* _tmp160_;
									gchar* _tmp161_;
									gchar* _tmp162_;
									_tmp157_ = vls_build_target_get_input ((VlsBuildTarget*) self);
									_tmp158_ = _tmp157_;
									_tmp159_ = library_file;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp158_, _tmp159_);
									_tmp160_ = library_file;
									_tmp161_ = g_file_get_path (_tmp160_);
									_tmp162_ = _tmp161_;
									g_debug ("buildtask.vala:176: BuildTask(%s) found input %s", id, _tmp162_);
									_g_free0 (_tmp162_);
									success = TRUE;
									_g_object_unref0 (libdir);
									_g_free0 (shlib_suffix);
									break;
								}
								_tmp163_ = tried;
								_tmp164_ = library_file;
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp163_, _tmp164_);
								_g_object_unref0 (libdir);
								_g_free0 (shlib_suffix);
							}
						}
						shlib_suffix_collection = (_vala_array_free (shlib_suffix_collection, shlib_suffix_collection_length1, (GDestroyNotify) g_free), NULL);
					}
					if (!success) {
						GeeArrayList* _tmp165_;
						GeeIterator* _tmp166_;
						GeeIterator* _tmp167_;
						gchar* _tmp168_;
						gpointer _tmp169_;
						gchar* _tmp170_;
						_tmp165_ = tried;
						_tmp166_ = gee_traversable_map ((GeeTraversable*) _tmp165_, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ________lambda17__gee_map_func, self);
						_tmp167_ = _tmp166_;
						_tmp168_ = g_strdup ("");
						_tmp169_ = gee_traversable_fold ((GeeTraversable*) _tmp167_, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ________lambda18__gee_fold_func, self, _tmp168_);
						_tmp170_ = (gchar*) _tmp169_;
						g_warning ("buildtask.vala:184: BuildTask(%s) failed to determine g-ir-scanner inp" \
"ut because all options don't exist (tried %s)", id, _tmp170_);
						_g_free0 (_tmp170_);
						_g_object_unref0 (_tmp167_);
					} else {
						GFile* real_file = NULL;
						GFile* _tmp171_;
						GFile* _tmp172_;
						_tmp171_ = library_file;
						_tmp172_ = _g_object_ref0 (_tmp171_);
						real_file = _tmp172_;
						{
							GFileInfo* info = NULL;
							GFile* _tmp173_;
							GFileInfo* _tmp174_;
							gboolean _tmp184_ = FALSE;
							gboolean _tmp185_ = FALSE;
							GFileInfo* _tmp186_;
							_tmp173_ = real_file;
							_tmp174_ = g_file_query_info (_tmp173_, "standard::*", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
							info = _tmp174_;
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								goto __catch0_g_error;
							}
							while (TRUE) {
								GFileInfo* _tmp175_;
								GFile* _tmp176_;
								GFileInfo* _tmp177_;
								const gchar* _tmp178_;
								GFile* _tmp179_;
								_tmp175_ = info;
								if (!g_file_info_get_is_symlink (_tmp175_)) {
									break;
								}
								_tmp176_ = gir_library_dir;
								_tmp177_ = info;
								_tmp178_ = g_file_info_get_symlink_target (_tmp177_);
								_tmp179_ = g_file_get_child (_tmp176_, _tmp178_);
								_g_object_unref0 (real_file);
								real_file = _tmp179_;
								{
									GFileInfo* _tmp180_ = NULL;
									GFile* _tmp181_;
									GFileInfo* _tmp182_;
									GFileInfo* _tmp183_;
									_tmp181_ = real_file;
									_tmp182_ = g_file_query_info (_tmp181_, "standard::*", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
									_tmp180_ = _tmp182_;
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										goto __catch1_g_error;
									}
									_tmp183_ = _tmp180_;
									_tmp180_ = NULL;
									_g_object_unref0 (info);
									info = _tmp183_;
									_g_object_unref0 (_tmp180_);
								}
								goto __finally1;
								__catch1_g_error:
								{
									g_clear_error (&_inner_error0_);
									_g_object_unref0 (info);
									info = NULL;
									break;
								}
								__finally1:
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
									_g_object_unref0 (info);
									goto __catch0_g_error;
								}
							}
							_tmp186_ = info;
							if (_tmp186_ == NULL) {
								_tmp185_ = TRUE;
							} else {
								GFileInfo* _tmp187_;
								_tmp187_ = info;
								_tmp185_ = !g_file_info_get_is_symlink (_tmp187_);
							}
							if (_tmp185_) {
								GFile* _tmp188_;
								GFile* _tmp189_;
								_tmp188_ = real_file;
								_tmp189_ = library_file;
								_tmp184_ = _tmp188_ != _tmp189_;
							} else {
								_tmp184_ = FALSE;
							}
							if (_tmp184_) {
								GeeArrayList* _tmp190_;
								GeeArrayList* _tmp191_;
								GFile* _tmp192_;
								GFile* _tmp193_;
								gchar* _tmp194_;
								gchar* _tmp195_;
								_tmp190_ = vls_build_target_get_input ((VlsBuildTarget*) self);
								_tmp191_ = _tmp190_;
								_tmp192_ = real_file;
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp191_, _tmp192_);
								_tmp193_ = real_file;
								_tmp194_ = g_file_get_path (_tmp193_);
								_tmp195_ = _tmp194_;
								g_debug ("buildtask.vala:210: BuildTask(%s): found input from symlink - %s", id, _tmp195_);
								_g_free0 (_tmp195_);
							}
							_g_object_unref0 (info);
						}
						goto __finally0;
						__catch0_g_error:
						{
							g_clear_error (&_inner_error0_);
						}
						__finally0:
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							g_propagate_error (error, _inner_error0_);
							_g_object_unref0 (real_file);
							_g_object_unref0 (library_file);
							_g_object_unref0 (tried);
							_g_object_unref0 (gir_library_dir);
							_g_free0 (gir_library_name);
							_g_free0 (last_arg);
							_g_object_unref0 (output_file);
							_g_free0 (cmd_basename);
							_g_free0 (_tmp51_);
							_g_object_unref0 (self);
							return NULL;
						}
						_g_object_unref0 (real_file);
					}
					_g_object_unref0 (library_file);
					_g_object_unref0 (tried);
				} else {
					g_warning ("buildtask.vala:218: BuildTask(%s): could not get directory for .gir fi" \
"le", id);
				}
			} else {
				g_warning ("buildtask.vala:221: BuildTask(%s): could not get library for g-ir-scan" \
"ner task", id);
			}
			_g_object_unref0 (gir_library_dir);
			_g_free0 (gir_library_name);
			_g_free0 (last_arg);
		} else {
			const gchar* _tmp196_;
			_tmp196_ = cmd_basename;
			if (g_strcmp0 (_tmp196_, "glib-compile-resources") == 0) {
				GFile** source_dirs = NULL;
				GFile** _tmp197_;
				gint source_dirs_length1;
				gint _source_dirs_size_;
				gchar* last_arg = NULL;
				gchar** _tmp198_;
				gint _tmp198__length1;
				_tmp197_ = g_new0 (GFile*, 0 + 1);
				source_dirs = _tmp197_;
				source_dirs_length1 = 0;
				_source_dirs_size_ = source_dirs_length1;
				last_arg = NULL;
				_tmp198_ = self->priv->arguments;
				_tmp198__length1 = self->priv->arguments_length1;
				{
					gchar** arg_collection = NULL;
					gint arg_collection_length1 = 0;
					gint _arg_collection_size_ = 0;
					gint arg_it = 0;
					arg_collection = _tmp198_;
					arg_collection_length1 = _tmp198__length1;
					for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
						gchar* _tmp199_;
						gchar* arg = NULL;
						_tmp199_ = g_strdup (arg_collection[arg_it]);
						arg = _tmp199_;
						{
							const gchar* _tmp200_;
							const gchar* _tmp203_;
							gchar* _tmp204_;
							_tmp200_ = last_arg;
							if (g_strcmp0 (_tmp200_, "--sourcedir") == 0) {
								const gchar* _tmp201_;
								GFile* _tmp202_;
								_tmp201_ = arg;
								_tmp202_ = g_file_new_for_commandline_arg_and_cwd (_tmp201_, output_dir);
								_vala_array_add9 (&source_dirs, &source_dirs_length1, &_source_dirs_size_, _tmp202_);
							}
							_tmp203_ = arg;
							_tmp204_ = g_strdup (_tmp203_);
							_g_free0 (last_arg);
							last_arg = _tmp204_;
							_g_free0 (arg);
						}
					}
				}
				{
					GeeArrayList* _input_file_list = NULL;
					GeeArrayList* _tmp205_;
					GeeArrayList* _tmp206_;
					gint _input_file_size = 0;
					GeeArrayList* _tmp207_;
					gint _tmp208_;
					gint _tmp209_;
					gint _input_file_index = 0;
					_tmp205_ = vls_build_target_get_input ((VlsBuildTarget*) self);
					_tmp206_ = _tmp205_;
					_input_file_list = _tmp206_;
					_tmp207_ = _input_file_list;
					_tmp208_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp207_);
					_tmp209_ = _tmp208_;
					_input_file_size = _tmp209_;
					_input_file_index = -1;
					while (TRUE) {
						gint _tmp210_;
						gint _tmp211_;
						GFile* input_file = NULL;
						GeeArrayList* _tmp212_;
						gpointer _tmp213_;
						GFile* _tmp214_;
						gchar* _tmp215_;
						gchar* _tmp216_;
						gboolean _tmp217_;
						gchar* gresources_xml = NULL;
						GFile* _tmp218_;
						gchar* _tmp219_;
						gchar* _tmp220_;
						gchar* _tmp221_ = NULL;
						GFile** potential_gresources = NULL;
						const gchar* _tmp222_;
						GFile** _tmp223_;
						gint _tmp223__length1;
						gint _tmp224_ = 0;
						GFile** _tmp225_;
						gint potential_gresources_length1;
						gint _potential_gresources_size_;
						GeeArrayList* _tmp226_;
						GFile** _tmp227_;
						gint _tmp227__length1;
						GeeArrayList* _tmp228_;
						GFile** _tmp229_;
						gint _tmp229__length1;
						_input_file_index = _input_file_index + 1;
						_tmp210_ = _input_file_index;
						_tmp211_ = _input_file_size;
						if (!(_tmp210_ < _tmp211_)) {
							break;
						}
						_tmp212_ = _input_file_list;
						_tmp213_ = gee_abstract_list_get ((GeeAbstractList*) _tmp212_, _input_file_index);
						input_file = (GFile*) _tmp213_;
						_tmp214_ = input_file;
						_tmp215_ = g_file_get_path (_tmp214_);
						_tmp216_ = _tmp215_;
						_tmp217_ = !g_str_has_suffix (_tmp216_, ".gresources.xml");
						_g_free0 (_tmp216_);
						if (_tmp217_) {
							_g_object_unref0 (input_file);
							break;
						}
						_tmp218_ = input_file;
						_tmp219_ = g_file_get_path (_tmp218_);
						_tmp220_ = _tmp219_;
						g_file_get_contents (_tmp220_, &_tmp221_, NULL, &_inner_error0_);
						_g_free0 (gresources_xml);
						gresources_xml = _tmp221_;
						_g_free0 (_tmp220_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							g_propagate_error (error, _inner_error0_);
							_g_free0 (gresources_xml);
							_g_object_unref0 (input_file);
							_g_free0 (last_arg);
							source_dirs = (_vala_array_free (source_dirs, source_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
							_g_object_unref0 (output_file);
							_g_free0 (cmd_basename);
							_g_free0 (_tmp51_);
							_g_object_unref0 (self);
							return NULL;
						}
						_tmp222_ = gresources_xml;
						_tmp223_ = source_dirs;
						_tmp223__length1 = source_dirs_length1;
						_tmp225_ = vls_util_discover_gresources_xml_input_files (_tmp222_, _tmp223_, (gint) _tmp223__length1, &_tmp224_, &_inner_error0_);
						potential_gresources = _tmp225_;
						potential_gresources_length1 = _tmp224_;
						_potential_gresources_size_ = potential_gresources_length1;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							g_propagate_error (error, _inner_error0_);
							_g_free0 (gresources_xml);
							_g_object_unref0 (input_file);
							_g_free0 (last_arg);
							source_dirs = (_vala_array_free (source_dirs, source_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
							_g_object_unref0 (output_file);
							_g_free0 (cmd_basename);
							_g_free0 (_tmp51_);
							_g_object_unref0 (self);
							return NULL;
						}
						_tmp226_ = self->priv->_candidate_inputs;
						_tmp227_ = potential_gresources;
						_tmp227__length1 = potential_gresources_length1;
						gee_collection_add_all_array ((GeeCollection*) _tmp226_, _tmp227_, (gint) _tmp227__length1);
						_tmp228_ = self->priv->_used_files;
						_tmp229_ = potential_gresources;
						_tmp229__length1 = potential_gresources_length1;
						gee_collection_add_all_array ((GeeCollection*) _tmp228_, _tmp229_, (gint) _tmp229__length1);
						potential_gresources = (_vala_array_free (potential_gresources, potential_gresources_length1, (GDestroyNotify) g_object_unref), NULL);
						_g_free0 (gresources_xml);
						_g_object_unref0 (input_file);
					}
				}
				_g_free0 (last_arg);
				source_dirs = (_vala_array_free (source_dirs, source_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
			}
		}
		_g_object_unref0 (output_file);
	}
	_g_free0 (cmd_basename);
	_g_free0 (_tmp51_);
	return self;
}

VlsBuildTask*
vls_build_task_new (const gchar* build_dir,
                    const gchar* output_dir,
                    const gchar* name,
                    const gchar* id,
                    gint no,
                    gchar** compiler,
                    gint compiler_length1,
                    gchar** args,
                    gint args_length1,
                    gchar** sources,
                    gint sources_length1,
                    gchar** generated_sources,
                    gint generated_sources_length1,
                    gchar** target_output_files,
                    gint target_output_files_length1,
                    const gchar* language,
                    GError** error)
{
	return vls_build_task_construct (VLS_TYPE_BUILD_TASK, build_dir, output_dir, name, id, no, compiler, compiler_length1, args, args_length1, sources, sources_length1, generated_sources, generated_sources_length1, target_output_files, target_output_files_length1, language, error);
}

static void
vls_build_task_real_build_if_stale (VlsBuildTarget* base,
                                    GCancellable* cancellable,
                                    GError** error)
{
	VlsBuildTask * self;
	gboolean _tmp0_ = FALSE;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GSubprocess* process = NULL;
	GSubprocessLauncher* _tmp31_;
	gchar** _tmp32_;
	gint _tmp32__length1;
	GSubprocess* _tmp33_;
	GSubprocess* _tmp34_;
	GError* _inner_error0_ = NULL;
	self = (VlsBuildTask*) base;
	_tmp1_ = vls_build_target_get_input ((VlsBuildTarget*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = gee_collection_get_is_empty ((GeeCollection*) _tmp2_);
	_tmp4_ = _tmp3_;
	if (!_tmp4_) {
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp5_ = vls_build_target_get_output ((VlsBuildTarget*) self);
		_tmp6_ = _tmp5_;
		_tmp7_ = gee_collection_get_is_empty ((GeeCollection*) _tmp6_);
		_tmp8_ = _tmp7_;
		_tmp0_ = !_tmp8_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gboolean inputs_modified_after = FALSE;
		inputs_modified_after = FALSE;
		{
			GeeArrayList* _file_list = NULL;
			GeeArrayList* _tmp9_;
			GeeArrayList* _tmp10_;
			gint _file_size = 0;
			GeeArrayList* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _file_index = 0;
			_tmp9_ = vls_build_target_get_input ((VlsBuildTarget*) self);
			_tmp10_ = _tmp9_;
			_file_list = _tmp10_;
			_tmp11_ = _file_list;
			_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
			_tmp13_ = _tmp12_;
			_file_size = _tmp13_;
			_file_index = -1;
			while (TRUE) {
				gint _tmp14_;
				gint _tmp15_;
				GFile* file = NULL;
				GeeArrayList* _tmp16_;
				gpointer _tmp17_;
				GFileInfo* info = NULL;
				GFile* _tmp18_;
				GFileInfo* _tmp19_;
				GDateTime* file_last_modified = NULL;
				GFileInfo* _tmp20_;
				GDateTime* _tmp21_;
				GDateTime* _tmp22_;
				_file_index = _file_index + 1;
				_tmp14_ = _file_index;
				_tmp15_ = _file_size;
				if (!(_tmp14_ < _tmp15_)) {
					break;
				}
				_tmp16_ = _file_list;
				_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _file_index);
				file = (GFile*) _tmp17_;
				_tmp18_ = file;
				_tmp19_ = g_file_query_info (_tmp18_, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NONE, cancellable, &_inner_error0_);
				info = _tmp19_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					g_propagate_error (error, _inner_error0_);
					_g_object_unref0 (file);
					return;
				}
				_tmp20_ = info;
				_tmp21_ = g_file_info_get_modification_date_time (_tmp20_);
				_g_date_time_unref0 (file_last_modified);
				file_last_modified = _tmp21_;
				_tmp22_ = file_last_modified;
				if (_tmp22_ == NULL) {
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					GFile* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
					_tmp23_ = vls_build_target_get_id ((VlsBuildTarget*) self);
					_tmp24_ = _tmp23_;
					_tmp25_ = file;
					_tmp26_ = g_file_get_path (_tmp25_);
					_tmp27_ = _tmp26_;
					g_warning ("buildtask.vala:262: BuildTask(%s) could not get last modified time of " \
"%s", _tmp24_, _tmp27_);
					_g_free0 (_tmp27_);
				} else {
					GDateTime* _tmp28_;
					GDateTime* _tmp29_;
					GDateTime* _tmp30_;
					_tmp28_ = file_last_modified;
					_tmp29_ = vls_build_target_get_last_updated ((VlsBuildTarget*) self);
					_tmp30_ = _tmp29_;
					if (g_date_time_compare (_tmp28_, _tmp30_) > 0) {
						inputs_modified_after = TRUE;
						_g_date_time_unref0 (file_last_modified);
						_g_object_unref0 (info);
						_g_object_unref0 (file);
						break;
					}
				}
				_g_date_time_unref0 (file_last_modified);
				_g_object_unref0 (info);
				_g_object_unref0 (file);
			}
		}
		if (!inputs_modified_after) {
			return;
		}
	}
	_tmp31_ = self->priv->launcher;
	_tmp32_ = self->priv->arguments;
	_tmp32__length1 = self->priv->arguments_length1;
	_tmp33_ = g_subprocess_launcher_spawnv (_tmp31_, _tmp32_, &_inner_error0_);
	process = _tmp33_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return;
	}
	_tmp34_ = process;
	g_subprocess_wait (_tmp34_, cancellable, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (process);
		return;
	}
	if (g_cancellable_is_cancelled (cancellable)) {
		GSubprocess* _tmp35_;
		_tmp35_ = process;
		g_subprocess_force_exit (_tmp35_);
		g_cancellable_set_error_if_cancelled (cancellable, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (process);
			return;
		}
	} else {
		GSubprocess* _tmp36_;
		_tmp36_ = process;
		if (!g_subprocess_get_successful (_tmp36_)) {
			gchar* failed_msg = NULL;
			gchar* _tmp37_;
			GSubprocess* _tmp38_;
			const gchar* _tmp58_;
			_tmp37_ = g_strdup ("");
			failed_msg = _tmp37_;
			_tmp38_ = process;
			if (g_subprocess_get_if_exited (_tmp38_)) {
				const gchar* _tmp39_;
				const gchar* _tmp40_;
				const gchar* _tmp41_;
				const gchar* _tmp42_;
				const gchar* _tmp43_;
				GSubprocess* _tmp44_;
				gchar* _tmp45_;
				gchar* _tmp46_;
				const gchar* _tmp47_;
				const gchar* _tmp48_;
				gchar* _tmp49_;
				_tmp39_ = vls_build_target_get_id ((VlsBuildTarget*) self);
				_tmp40_ = _tmp39_;
				_tmp41_ = string_to_string (_tmp40_);
				_tmp42_ = self->priv->exe_name;
				_tmp43_ = string_to_string (_tmp42_);
				_tmp44_ = process;
				_tmp45_ = g_strdup_printf ("%i", g_subprocess_get_exit_status (_tmp44_));
				_tmp46_ = _tmp45_;
				_tmp47_ = self->priv->build_dir;
				_tmp48_ = string_to_string (_tmp47_);
				_tmp49_ = g_strconcat ("BuildTask(", _tmp41_, ") `", _tmp43_, "' returned with status ", _tmp46_, " (launched from ", _tmp48_, ")", NULL);
				_g_free0 (failed_msg);
				failed_msg = _tmp49_;
				_g_free0 (_tmp46_);
			} else {
				const gchar* _tmp50_;
				const gchar* _tmp51_;
				const gchar* _tmp52_;
				const gchar* _tmp53_;
				const gchar* _tmp54_;
				const gchar* _tmp55_;
				const gchar* _tmp56_;
				gchar* _tmp57_;
				_tmp50_ = vls_build_target_get_id ((VlsBuildTarget*) self);
				_tmp51_ = _tmp50_;
				_tmp52_ = string_to_string (_tmp51_);
				_tmp53_ = self->priv->exe_name;
				_tmp54_ = string_to_string (_tmp53_);
				_tmp55_ = self->priv->build_dir;
				_tmp56_ = string_to_string (_tmp55_);
				_tmp57_ = g_strconcat ("BuildTask(", _tmp52_, ") `", _tmp54_, "' terminated (launched from ", _tmp56_, ")", NULL);
				_g_free0 (failed_msg);
				failed_msg = _tmp57_;
			}
			_tmp58_ = failed_msg;
			g_warning ("buildtask.vala:292: %s", _tmp58_);
			_g_free0 (failed_msg);
		} else {
			gboolean _tmp59_ = FALSE;
			GeeArrayList* _tmp60_;
			GeeArrayList* _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
			GTimeZone* _tmp79_;
			GTimeZone* _tmp80_;
			GDateTime* _tmp81_;
			GDateTime* _tmp82_;
			_tmp60_ = vls_build_target_get_output ((VlsBuildTarget*) self);
			_tmp61_ = _tmp60_;
			_tmp62_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp61_);
			_tmp63_ = _tmp62_;
			if (_tmp63_ == 1) {
				GeeArrayList* _tmp64_;
				GeeArrayList* _tmp65_;
				gpointer _tmp66_;
				GFile* _tmp67_;
				_tmp64_ = vls_build_target_get_output ((VlsBuildTarget*) self);
				_tmp65_ = _tmp64_;
				_tmp66_ = gee_abstract_list_get ((GeeAbstractList*) _tmp65_, 0);
				_tmp67_ = (GFile*) _tmp66_;
				_tmp59_ = !g_file_query_exists (_tmp67_, cancellable);
				_g_object_unref0 (_tmp67_);
			} else {
				_tmp59_ = FALSE;
			}
			if (_tmp59_) {
				GFile* output_file = NULL;
				GeeArrayList* _tmp68_;
				GeeArrayList* _tmp69_;
				gpointer _tmp70_;
				GInputStream* process_output_istream = NULL;
				GSubprocess* _tmp71_;
				GInputStream* _tmp72_;
				GInputStream* _tmp73_;
				GInputStream* _tmp74_;
				_tmp68_ = vls_build_target_get_output ((VlsBuildTarget*) self);
				_tmp69_ = _tmp68_;
				_tmp70_ = gee_abstract_list_get ((GeeAbstractList*) _tmp69_, 0);
				output_file = (GFile*) _tmp70_;
				_tmp71_ = process;
				_tmp72_ = g_subprocess_get_stdout_pipe (_tmp71_);
				_tmp73_ = _g_object_ref0 (_tmp72_);
				process_output_istream = _tmp73_;
				_tmp74_ = process_output_istream;
				if (_tmp74_ != NULL) {
					GFileOutputStream* outfile_ostream = NULL;
					GFile* _tmp75_;
					GFileOutputStream* _tmp76_;
					GFileOutputStream* _tmp77_;
					GInputStream* _tmp78_;
					_tmp75_ = output_file;
					_tmp76_ = g_file_replace (_tmp75_, NULL, FALSE, G_FILE_CREATE_NONE, cancellable, &_inner_error0_);
					outfile_ostream = _tmp76_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						g_propagate_error (error, _inner_error0_);
						_g_object_unref0 (process_output_istream);
						_g_object_unref0 (output_file);
						_g_object_unref0 (process);
						return;
					}
					_tmp77_ = outfile_ostream;
					_tmp78_ = process_output_istream;
					g_output_stream_splice ((GOutputStream*) _tmp77_, _tmp78_, G_OUTPUT_STREAM_SPLICE_NONE, cancellable, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						g_propagate_error (error, _inner_error0_);
						_g_object_unref0 (outfile_ostream);
						_g_object_unref0 (process_output_istream);
						_g_object_unref0 (output_file);
						_g_object_unref0 (process);
						return;
					}
					_g_object_unref0 (outfile_ostream);
				}
				_g_object_unref0 (process_output_istream);
				_g_object_unref0 (output_file);
			}
			_tmp79_ = g_time_zone_new_local ();
			_tmp80_ = _tmp79_;
			_tmp81_ = g_date_time_new_now (_tmp80_);
			_tmp82_ = _tmp81_;
			vls_build_target_set_last_updated ((VlsBuildTarget*) self, _tmp82_);
			_g_date_time_unref0 (_tmp82_);
			_g_time_zone_unref0 (_tmp80_);
		}
	}
	_g_object_unref0 (process);
}

GeeArrayList*
vls_build_task_get_used_files (VlsBuildTask* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_used_files;
	result = _tmp0_;
	return result;
}

static void
vls_build_task_set_used_files (VlsBuildTask* self,
                               GeeArrayList* value)
{
	GeeArrayList* old_value;
	g_return_if_fail (self != NULL);
	old_value = vls_build_task_get_used_files (self);
	if (old_value != value) {
		GeeArrayList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_used_files);
		self->priv->_used_files = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, vls_build_task_properties[VLS_BUILD_TASK_USED_FILES_PROPERTY]);
	}
}

GeeArrayList*
vls_build_task_get_candidate_inputs (VlsBuildTask* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_candidate_inputs;
	result = _tmp0_;
	return result;
}

static void
vls_build_task_set_candidate_inputs (VlsBuildTask* self,
                                     GeeArrayList* value)
{
	GeeArrayList* old_value;
	g_return_if_fail (self != NULL);
	old_value = vls_build_task_get_candidate_inputs (self);
	if (old_value != value) {
		GeeArrayList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_candidate_inputs);
		self->priv->_candidate_inputs = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, vls_build_task_properties[VLS_BUILD_TASK_CANDIDATE_INPUTS_PROPERTY]);
	}
}

static void
vls_build_task_class_init (VlsBuildTaskClass * klass,
                           gpointer klass_data)
{
	vls_build_task_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &VlsBuildTask_private_offset);
	((VlsBuildTargetClass *) klass)->build_if_stale = (void (*) (VlsBuildTarget*, GCancellable*, GError**)) vls_build_task_real_build_if_stale;
	G_OBJECT_CLASS (klass)->get_property = _vala_vls_build_task_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_vls_build_task_set_property;
	G_OBJECT_CLASS (klass)->finalize = vls_build_task_finalize;
	/**
	     * Because a built task could be any command, we don't know whether the files
	     * that appear in the arg list are inputs or outputs initially.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VLS_BUILD_TASK_USED_FILES_PROPERTY, vls_build_task_properties[VLS_BUILD_TASK_USED_FILES_PROPERTY] = g_param_spec_object ("used-files", "used-files", "used-files", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	     * Candidate inputs are files that _may_ be inputs (and only inputs) to
	     * this task but that we cannot determine yet. They may not exist now, but
	     * they are expected to exist at the time this target is built.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VLS_BUILD_TASK_CANDIDATE_INPUTS_PROPERTY, vls_build_task_properties[VLS_BUILD_TASK_CANDIDATE_INPUTS_PROPERTY] = g_param_spec_object ("candidate-inputs", "candidate-inputs", "candidate-inputs", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
vls_build_task_instance_init (VlsBuildTask * self,
                              gpointer klass)
{
	gchar** _tmp0_;
	gchar* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	self->priv = vls_build_task_get_instance_private (self);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	self->priv->arguments = _tmp0_;
	self->priv->arguments_length1 = 0;
	self->priv->_arguments_size_ = self->priv->arguments_length1;
	_tmp1_ = g_strdup ("");
	self->priv->exe_name = _tmp1_;
	_tmp2_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp2_) {
		g_object_set_data ((GObject *) _tmp2_, "vala-creation-function", "");
	}
	self->priv->_used_files = _tmp2_;
	_tmp3_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp3_) {
		g_object_set_data ((GObject *) _tmp3_, "vala-creation-function", "");
	}
	self->priv->_candidate_inputs = _tmp3_;
}

static void
vls_build_task_finalize (GObject * obj)
{
	VlsBuildTask * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VLS_TYPE_BUILD_TASK, VlsBuildTask);
	self->priv->arguments = (_vala_array_free (self->priv->arguments, self->priv->arguments_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (self->priv->exe_name);
	_g_free0 (self->priv->build_dir);
	_g_object_unref0 (self->priv->launcher);
	_g_object_unref0 (self->priv->_used_files);
	_g_object_unref0 (self->priv->_candidate_inputs);
	G_OBJECT_CLASS (vls_build_task_parent_class)->finalize (obj);
}

/**
 * Represents a build target when it is an arbitrary command.
 */
 G_GNUC_NO_INLINE static GType
vls_build_task_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VlsBuildTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vls_build_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VlsBuildTask), 0, (GInstanceInitFunc) vls_build_task_instance_init, NULL };
	GType vls_build_task_type_id;
	vls_build_task_type_id = g_type_register_static (VLS_TYPE_BUILD_TARGET, "VlsBuildTask", &g_define_type_info, 0);
	VlsBuildTask_private_offset = g_type_add_instance_private (vls_build_task_type_id, sizeof (VlsBuildTaskPrivate));
	return vls_build_task_type_id;
}

GType
vls_build_task_get_type (void)
{
	static gsize vls_build_task_type_id__once = 0;
	if (g_once_init_enter (&vls_build_task_type_id__once)) {
		GType vls_build_task_type_id;
		vls_build_task_type_id = vls_build_task_get_type_once ();
		g_once_init_leave (&vls_build_task_type_id__once, vls_build_task_type_id);
	}
	return vls_build_task_type_id__once;
}

static void
_vala_vls_build_task_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	VlsBuildTask * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VLS_TYPE_BUILD_TASK, VlsBuildTask);
	switch (property_id) {
		case VLS_BUILD_TASK_USED_FILES_PROPERTY:
		g_value_set_object (value, vls_build_task_get_used_files (self));
		break;
		case VLS_BUILD_TASK_CANDIDATE_INPUTS_PROPERTY:
		g_value_set_object (value, vls_build_task_get_candidate_inputs (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_vls_build_task_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	VlsBuildTask * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VLS_TYPE_BUILD_TASK, VlsBuildTask);
	switch (property_id) {
		case VLS_BUILD_TASK_USED_FILES_PROPERTY:
		vls_build_task_set_used_files (self, g_value_get_object (value));
		break;
		case VLS_BUILD_TASK_CANDIDATE_INPUTS_PROPERTY:
		vls_build_task_set_candidate_inputs (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

