/* server.c generated by valac 0.55.1, the Vala compiler
 * generated from server.vala, do not modify */

/* server.vala
 *
 * Copyright 2017-2019 Ben Iofel <ben@iofel.me>
 * Copyright 2017-2020 Princeton Ferro <princetonferro@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <jsonrpc-glib.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gio/gio.h>
#include <unistd.h>
#include <gio/gunixinputstream.h>
#include <gio/gunixoutputstream.h>
#include <glib-unix.h>
#include <stdarg.h>
#include <vala.h>
#include <valagee.h>
#include <json-glib/json-glib.h>
#include <signal.h>
#include <stdio.h>

#define VLS_SERVER_check_update_context_period_ms ((guint) 100)
#define VLS_SERVER_update_context_delay_inc_us ((gint64) (500 * 1000))
#define VLS_SERVER_update_context_delay_max_us ((gint64) (1000 * 1000))
#define VLS_SERVER_wait_for_context_update_delay_ms ((guint) 200)
#define CONFIG_PROJECT_VERSION "0.48.4"
#define CONFIG_PROJECT_BUGSITE "https://github.com/Prince781/vala-language-server/issues"
#define CONFIG_PROJECT_NAME "vala-language-server"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define VLS_TYPE_SERVER (vls_server_get_type ())
#define VLS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_SERVER, VlsServer))
#define VLS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_SERVER, VlsServerClass))
#define VLS_IS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_SERVER))
#define VLS_IS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_SERVER))
#define VLS_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_SERVER, VlsServerClass))

typedef struct _VlsServer VlsServer;
typedef struct _VlsServerClass VlsServerClass;
typedef struct _VlsServerPrivate VlsServerPrivate;
typedef void (*VlsServerNotificationHandler) (VlsServer* _self_, JsonrpcClient* client, GVariant* params);
typedef void (*VlsServerCallHandler) (VlsServer* _self_, JsonrpcServer* server, JsonrpcClient* client, const gchar* method, GVariant* id, GVariant* params);

#define LSP_TYPE_INITIALIZE_PARAMS (lsp_initialize_params_get_type ())
#define LSP_INITIALIZE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParams))
#define LSP_INITIALIZE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParamsClass))
#define LSP_IS_INITIALIZE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_INITIALIZE_PARAMS))
#define LSP_IS_INITIALIZE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_INITIALIZE_PARAMS))
#define LSP_INITIALIZE_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParamsClass))

typedef struct _LspInitializeParams LspInitializeParams;
typedef struct _LspInitializeParamsClass LspInitializeParamsClass;

#define VLS_TYPE_GIR_DOCUMENTATION (vls_gir_documentation_get_type ())
#define VLS_GIR_DOCUMENTATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_GIR_DOCUMENTATION, VlsGirDocumentation))
#define VLS_GIR_DOCUMENTATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_GIR_DOCUMENTATION, VlsGirDocumentationClass))
#define VLS_IS_GIR_DOCUMENTATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_GIR_DOCUMENTATION))
#define VLS_IS_GIR_DOCUMENTATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_GIR_DOCUMENTATION))
#define VLS_GIR_DOCUMENTATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_GIR_DOCUMENTATION, VlsGirDocumentationClass))

typedef struct _VlsGirDocumentation VlsGirDocumentation;
typedef struct _VlsGirDocumentationClass VlsGirDocumentationClass;

#define VLS_TYPE_REQUEST (vls_request_get_type ())
#define VLS_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_REQUEST, VlsRequest))
#define VLS_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_REQUEST, VlsRequestClass))
#define VLS_IS_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_REQUEST))
#define VLS_IS_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_REQUEST))
#define VLS_REQUEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_REQUEST, VlsRequestClass))

typedef struct _VlsRequest VlsRequest;
typedef struct _VlsRequestClass VlsRequestClass;

#define VLS_TYPE_PROJECT (vls_project_get_type ())
#define VLS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_PROJECT, VlsProject))
#define VLS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_PROJECT, VlsProjectClass))
#define VLS_IS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_PROJECT))
#define VLS_IS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_PROJECT))
#define VLS_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_PROJECT, VlsProjectClass))

typedef struct _VlsProject VlsProject;
typedef struct _VlsProjectClass VlsProjectClass;

#define VLS_TYPE_DEFAULT_PROJECT (vls_default_project_get_type ())
#define VLS_DEFAULT_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_DEFAULT_PROJECT, VlsDefaultProject))
#define VLS_DEFAULT_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_DEFAULT_PROJECT, VlsDefaultProjectClass))
#define VLS_IS_DEFAULT_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_DEFAULT_PROJECT))
#define VLS_IS_DEFAULT_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_DEFAULT_PROJECT))
#define VLS_DEFAULT_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_DEFAULT_PROJECT, VlsDefaultProjectClass))

typedef struct _VlsDefaultProject VlsDefaultProject;
typedef struct _VlsDefaultProjectClass VlsDefaultProjectClass;
enum  {
	VLS_SERVER_0_PROPERTY,
	VLS_SERVER_NUM_PROPERTIES
};
static GParamSpec* vls_server_properties[VLS_SERVER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _vls_gir_documentation_unref0(var) ((var == NULL) ? NULL : (var = (vls_gir_documentation_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
typedef enum  {
	LSP_MESSAGE_TYPE_Error = 1,
	LSP_MESSAGE_TYPE_Warning = 2,
	LSP_MESSAGE_TYPE_Info = 3,
	LSP_MESSAGE_TYPE_Log = 4
} LspMessageType;

#define LSP_TYPE_MESSAGE_TYPE (lsp_message_type_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	LSP_TEXT_DOCUMENT_SYNC_KIND_Unset = -1,
	LSP_TEXT_DOCUMENT_SYNC_KIND_None = 0,
	LSP_TEXT_DOCUMENT_SYNC_KIND_Full = 1,
	LSP_TEXT_DOCUMENT_SYNC_KIND_Incremental = 2
} LspTextDocumentSyncKind;

#define LSP_TYPE_TEXT_DOCUMENT_SYNC_KIND (lsp_text_document_sync_kind_get_type ())

#define VLS_TYPE_MESON_PROJECT (vls_meson_project_get_type ())
#define VLS_MESON_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_MESON_PROJECT, VlsMesonProject))
#define VLS_MESON_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_MESON_PROJECT, VlsMesonProjectClass))
#define VLS_IS_MESON_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_MESON_PROJECT))
#define VLS_IS_MESON_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_MESON_PROJECT))
#define VLS_MESON_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_MESON_PROJECT, VlsMesonProjectClass))

typedef struct _VlsMesonProject VlsMesonProject;
typedef struct _VlsMesonProjectClass VlsMesonProjectClass;

#define VLS_TYPE_CC_PROJECT (vls_cc_project_get_type ())
#define VLS_CC_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_CC_PROJECT, VlsCcProject))
#define VLS_CC_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_CC_PROJECT, VlsCcProjectClass))
#define VLS_IS_CC_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_CC_PROJECT))
#define VLS_IS_CC_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_CC_PROJECT))
#define VLS_CC_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_CC_PROJECT, VlsCcProjectClass))

typedef struct _VlsCcProject VlsCcProject;
typedef struct _VlsCcProjectClass VlsCcProjectClass;

#define VLS_TYPE_BUILD_TARGET (vls_build_target_get_type ())
#define VLS_BUILD_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_BUILD_TARGET, VlsBuildTarget))
#define VLS_BUILD_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_BUILD_TARGET, VlsBuildTargetClass))
#define VLS_IS_BUILD_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_BUILD_TARGET))
#define VLS_IS_BUILD_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_BUILD_TARGET))
#define VLS_BUILD_TARGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_BUILD_TARGET, VlsBuildTargetClass))

typedef struct _VlsBuildTarget VlsBuildTarget;
typedef struct _VlsBuildTargetClass VlsBuildTargetClass;

#define VLS_TYPE_COMPILATION (vls_compilation_get_type ())
#define VLS_COMPILATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_COMPILATION, VlsCompilation))
#define VLS_COMPILATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_COMPILATION, VlsCompilationClass))
#define VLS_IS_COMPILATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_COMPILATION))
#define VLS_IS_COMPILATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_COMPILATION))
#define VLS_COMPILATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_COMPILATION, VlsCompilationClass))

typedef struct _VlsCompilation VlsCompilation;
typedef struct _VlsCompilationClass VlsCompilationClass;

#define VLS_TYPE_PAIR (vls_pair_get_type ())
#define VLS_PAIR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_PAIR, VlsPair))
#define VLS_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_PAIR, VlsPairClass))
#define VLS_IS_PAIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_PAIR))
#define VLS_IS_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_PAIR))
#define VLS_PAIR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_PAIR, VlsPairClass))

typedef struct _VlsPair VlsPair;
typedef struct _VlsPairClass VlsPairClass;
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))

#define VLS_TYPE_TEXT_DOCUMENT (vls_text_document_get_type ())
#define VLS_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument))
#define VLS_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocumentClass))
#define VLS_IS_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_TEXT_DOCUMENT))
#define VLS_IS_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_TEXT_DOCUMENT))
#define VLS_TEXT_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocumentClass))

typedef struct _VlsTextDocument VlsTextDocument;
typedef struct _VlsTextDocumentClass VlsTextDocumentClass;

#define LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT (lsp_text_document_content_change_event_get_type ())
#define LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEvent))
#define LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEventClass))
#define LSP_IS_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT))
#define LSP_IS_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT))
#define LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEventClass))

typedef struct _LspTextDocumentContentChangeEvent LspTextDocumentContentChangeEvent;
typedef struct _LspTextDocumentContentChangeEventClass LspTextDocumentContentChangeEventClass;

#define LSP_TYPE_RANGE (lsp_range_get_type ())
#define LSP_RANGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_RANGE, LspRange))
#define LSP_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_RANGE, LspRangeClass))
#define LSP_IS_RANGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_RANGE))
#define LSP_IS_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_RANGE))
#define LSP_RANGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_RANGE, LspRangeClass))

typedef struct _LspRange LspRange;
typedef struct _LspRangeClass LspRangeClass;

#define LSP_TYPE_POSITION (lsp_position_get_type ())
#define LSP_POSITION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_POSITION, LspPosition))
#define LSP_POSITION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_POSITION, LspPositionClass))
#define LSP_IS_POSITION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_POSITION))
#define LSP_IS_POSITION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_POSITION))
#define LSP_POSITION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_POSITION, LspPositionClass))

typedef struct _LspPosition LspPosition;
typedef struct _LspPositionClass LspPositionClass;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
typedef void (*VlsServerOnContextUpdatedFunc) (gboolean request_cancelled, gpointer user_data);
typedef struct _Block24Data Block24Data;
typedef struct _Block25Data Block25Data;
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))

#define VLS_TYPE_REPORTER (vls_reporter_get_type ())
#define VLS_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_REPORTER, VlsReporter))
#define VLS_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_REPORTER, VlsReporterClass))
#define VLS_IS_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_REPORTER))
#define VLS_IS_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_REPORTER))
#define VLS_REPORTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_REPORTER, VlsReporterClass))

typedef struct _VlsReporter VlsReporter;
typedef struct _VlsReporterClass VlsReporterClass;
typedef struct _VlsReporterPrivate VlsReporterPrivate;

#define VLS_TYPE_SOURCE_MESSAGE (vls_source_message_get_type ())
#define VLS_SOURCE_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_SOURCE_MESSAGE, VlsSourceMessage))
#define VLS_SOURCE_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_SOURCE_MESSAGE, VlsSourceMessageClass))
#define VLS_IS_SOURCE_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_SOURCE_MESSAGE))
#define VLS_IS_SOURCE_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_SOURCE_MESSAGE))
#define VLS_SOURCE_MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_SOURCE_MESSAGE, VlsSourceMessageClass))

typedef struct _VlsSourceMessage VlsSourceMessage;
typedef struct _VlsSourceMessageClass VlsSourceMessageClass;
typedef struct _VlsSourceMessagePrivate VlsSourceMessagePrivate;
typedef enum  {
	LSP_DIAGNOSTIC_SEVERITY_Unset = 0,
	LSP_DIAGNOSTIC_SEVERITY_Error = 1,
	LSP_DIAGNOSTIC_SEVERITY_Warning = 2,
	LSP_DIAGNOSTIC_SEVERITY_Information = 3,
	LSP_DIAGNOSTIC_SEVERITY_Hint = 4
} LspDiagnosticSeverity;

#define LSP_TYPE_DIAGNOSTIC_SEVERITY (lsp_diagnostic_severity_get_type ())

#define LSP_TYPE_DIAGNOSTIC (lsp_diagnostic_get_type ())
#define LSP_DIAGNOSTIC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DIAGNOSTIC, LspDiagnostic))
#define LSP_DIAGNOSTIC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DIAGNOSTIC, LspDiagnosticClass))
#define LSP_IS_DIAGNOSTIC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DIAGNOSTIC))
#define LSP_IS_DIAGNOSTIC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DIAGNOSTIC))
#define LSP_DIAGNOSTIC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DIAGNOSTIC, LspDiagnosticClass))

typedef struct _LspDiagnostic LspDiagnostic;
typedef struct _LspDiagnosticClass LspDiagnosticClass;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

#define VLS_TYPE_FIND_SYMBOL (vls_find_symbol_get_type ())
#define VLS_FIND_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_FIND_SYMBOL, VlsFindSymbol))
#define VLS_FIND_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_FIND_SYMBOL, VlsFindSymbolClass))
#define VLS_IS_FIND_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_FIND_SYMBOL))
#define VLS_IS_FIND_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_FIND_SYMBOL))
#define VLS_FIND_SYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_FIND_SYMBOL, VlsFindSymbolClass))

typedef struct _VlsFindSymbol VlsFindSymbol;
typedef struct _VlsFindSymbolClass VlsFindSymbolClass;
typedef struct _VlsFindSymbolPrivate VlsFindSymbolPrivate;
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))

#define LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS (lsp_text_document_position_params_get_type ())
#define LSP_TEXT_DOCUMENT_POSITION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParams))
#define LSP_TEXT_DOCUMENT_POSITION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParamsClass))
#define LSP_IS_TEXT_DOCUMENT_POSITION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS))
#define LSP_IS_TEXT_DOCUMENT_POSITION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS))
#define LSP_TEXT_DOCUMENT_POSITION_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParamsClass))

typedef struct _LspTextDocumentPositionParams LspTextDocumentPositionParams;
typedef struct _LspTextDocumentPositionParamsClass LspTextDocumentPositionParamsClass;
typedef struct _Block26Data Block26Data;

#define LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER (lsp_text_document_identifier_get_type ())
#define LSP_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifier))
#define LSP_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifierClass))
#define LSP_IS_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_IS_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_TEXT_DOCUMENT_IDENTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifierClass))

typedef struct _LspTextDocumentIdentifier LspTextDocumentIdentifier;
typedef struct _LspTextDocumentIdentifierClass LspTextDocumentIdentifierClass;
#define _vala_code_visitor_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_visitor_unref (var), NULL)))

#define LSP_TYPE_LOCATION (lsp_location_get_type ())
#define LSP_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_LOCATION, LspLocation))
#define LSP_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_LOCATION, LspLocationClass))
#define LSP_IS_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_LOCATION))
#define LSP_IS_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_LOCATION))
#define LSP_LOCATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_LOCATION, LspLocationClass))

typedef struct _LspLocation LspLocation;
typedef struct _LspLocationClass LspLocationClass;
typedef struct _Block27Data Block27Data;

#define VLS_TYPE_SYMBOL_ENUMERATOR (vls_symbol_enumerator_get_type ())
#define VLS_SYMBOL_ENUMERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_SYMBOL_ENUMERATOR, VlsSymbolEnumerator))
#define VLS_SYMBOL_ENUMERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_SYMBOL_ENUMERATOR, VlsSymbolEnumeratorClass))
#define VLS_IS_SYMBOL_ENUMERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_SYMBOL_ENUMERATOR))
#define VLS_IS_SYMBOL_ENUMERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_SYMBOL_ENUMERATOR))
#define VLS_SYMBOL_ENUMERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_SYMBOL_ENUMERATOR, VlsSymbolEnumeratorClass))

typedef struct _VlsSymbolEnumerator VlsSymbolEnumerator;
typedef struct _VlsSymbolEnumeratorClass VlsSymbolEnumeratorClass;

#define VLS_TYPE_CODE_ANALYZER (vls_code_analyzer_get_type ())
#define VLS_CODE_ANALYZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_CODE_ANALYZER, VlsCodeAnalyzer))
#define VLS_IS_CODE_ANALYZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_CODE_ANALYZER))
#define VLS_CODE_ANALYZER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VLS_TYPE_CODE_ANALYZER, VlsCodeAnalyzerIface))

typedef struct _VlsCodeAnalyzer VlsCodeAnalyzer;
typedef struct _VlsCodeAnalyzerIface VlsCodeAnalyzerIface;

#define LSP_TYPE_CLIENT_CAPABILITIES (lsp_client_capabilities_get_type ())
#define LSP_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilities))
#define LSP_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilitiesClass))
#define LSP_IS_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CLIENT_CAPABILITIES))
#define LSP_IS_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CLIENT_CAPABILITIES))
#define LSP_CLIENT_CAPABILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilitiesClass))

typedef struct _LspClientCapabilities LspClientCapabilities;
typedef struct _LspClientCapabilitiesClass LspClientCapabilitiesClass;

#define LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES (lsp_text_document_client_capabilities_get_type ())
#define LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilities))
#define LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilitiesClass))
#define LSP_IS_TEXT_DOCUMENT_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES))
#define LSP_IS_TEXT_DOCUMENT_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES))
#define LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilitiesClass))

typedef struct _LspTextDocumentClientCapabilities LspTextDocumentClientCapabilities;
typedef struct _LspTextDocumentClientCapabilitiesClass LspTextDocumentClientCapabilitiesClass;

#define LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES (lsp_document_symbol_capabilities_get_type ())
#define LSP_DOCUMENT_SYMBOL_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilities))
#define LSP_DOCUMENT_SYMBOL_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilitiesClass))
#define LSP_IS_DOCUMENT_SYMBOL_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES))
#define LSP_IS_DOCUMENT_SYMBOL_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES))
#define LSP_DOCUMENT_SYMBOL_CAPABILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilitiesClass))

typedef struct _LspDocumentSymbolCapabilities LspDocumentSymbolCapabilities;
typedef struct _LspDocumentSymbolCapabilitiesClass LspDocumentSymbolCapabilitiesClass;

#define LSP_TYPE_DOCUMENT_SYMBOL (lsp_document_symbol_get_type ())
#define LSP_DOCUMENT_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbol))
#define LSP_DOCUMENT_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbolClass))
#define LSP_IS_DOCUMENT_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_SYMBOL))
#define LSP_IS_DOCUMENT_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_SYMBOL))
#define LSP_DOCUMENT_SYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbolClass))

typedef struct _LspDocumentSymbol LspDocumentSymbol;
typedef struct _LspDocumentSymbolClass LspDocumentSymbolClass;

#define LSP_TYPE_SYMBOL_INFORMATION (lsp_symbol_information_get_type ())
#define LSP_SYMBOL_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformation))
#define LSP_SYMBOL_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformationClass))
#define LSP_IS_SYMBOL_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_SYMBOL_INFORMATION))
#define LSP_IS_SYMBOL_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_SYMBOL_INFORMATION))
#define LSP_SYMBOL_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformationClass))

typedef struct _LspSymbolInformation LspSymbolInformation;
typedef struct _LspSymbolInformationClass LspSymbolInformationClass;

#define VLS_TYPE_DOC_COMMENT (vls_doc_comment_get_type ())
#define VLS_DOC_COMMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_DOC_COMMENT, VlsDocComment))
#define VLS_DOC_COMMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_DOC_COMMENT, VlsDocCommentClass))
#define VLS_IS_DOC_COMMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_DOC_COMMENT))
#define VLS_IS_DOC_COMMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_DOC_COMMENT))
#define VLS_DOC_COMMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_DOC_COMMENT, VlsDocCommentClass))

typedef struct _VlsDocComment VlsDocComment;
typedef struct _VlsDocCommentClass VlsDocCommentClass;
#define _vala_comment_unref0(var) ((var == NULL) ? NULL : (var = (vala_comment_unref (var), NULL)))
#define _vls_doc_comment_unref0(var) ((var == NULL) ? NULL : (var = (vls_doc_comment_unref (var), NULL)))

#define LSP_TYPE_COMPLETION_PARAMS (lsp_completion_params_get_type ())
#define LSP_COMPLETION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_COMPLETION_PARAMS, LspCompletionParams))
#define LSP_COMPLETION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_COMPLETION_PARAMS, LspCompletionParamsClass))
#define LSP_IS_COMPLETION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_COMPLETION_PARAMS))
#define LSP_IS_COMPLETION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_COMPLETION_PARAMS))
#define LSP_COMPLETION_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_COMPLETION_PARAMS, LspCompletionParamsClass))

typedef struct _LspCompletionParams LspCompletionParams;
typedef struct _LspCompletionParamsClass LspCompletionParamsClass;

#define LSP_TYPE_COMPLETION_CONTEXT (lsp_completion_context_get_type ())
#define LSP_COMPLETION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContext))
#define LSP_COMPLETION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContextClass))
#define LSP_IS_COMPLETION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_COMPLETION_CONTEXT))
#define LSP_IS_COMPLETION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_COMPLETION_CONTEXT))
#define LSP_COMPLETION_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContextClass))

typedef struct _LspCompletionContext LspCompletionContext;
typedef struct _LspCompletionContextClass LspCompletionContextClass;
typedef struct _Block28Data Block28Data;

#define VLS_TYPE_FIND_SCOPE (vls_find_scope_get_type ())
#define VLS_FIND_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_FIND_SCOPE, VlsFindScope))
#define VLS_FIND_SCOPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_FIND_SCOPE, VlsFindScopeClass))
#define VLS_IS_FIND_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_FIND_SCOPE))
#define VLS_IS_FIND_SCOPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_FIND_SCOPE))
#define VLS_FIND_SCOPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_FIND_SCOPE, VlsFindScopeClass))

typedef struct _VlsFindScope VlsFindScope;
typedef struct _VlsFindScopeClass VlsFindScopeClass;
#define _vala_scope_unref0(var) ((var == NULL) ? NULL : (var = (vala_scope_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))

#define LSP_TYPE_HOVER (lsp_hover_get_type ())
#define LSP_HOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_HOVER, LspHover))
#define LSP_HOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_HOVER, LspHoverClass))
#define LSP_IS_HOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_HOVER))
#define LSP_IS_HOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_HOVER))
#define LSP_HOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_HOVER, LspHoverClass))

typedef struct _LspHover LspHover;
typedef struct _LspHoverClass LspHoverClass;

#define LSP_TYPE_MARKED_STRING (lsp_marked_string_get_type ())
#define LSP_MARKED_STRING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_MARKED_STRING, LspMarkedString))
#define LSP_MARKED_STRING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_MARKED_STRING, LspMarkedStringClass))
#define LSP_IS_MARKED_STRING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_MARKED_STRING))
#define LSP_IS_MARKED_STRING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_MARKED_STRING))
#define LSP_MARKED_STRING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_MARKED_STRING, LspMarkedStringClass))

typedef struct _LspMarkedString LspMarkedString;
typedef struct _LspMarkedStringClass LspMarkedStringClass;
typedef enum  {
	LSP_DOCUMENT_HIGHLIGHT_KIND_Text = 1,
	LSP_DOCUMENT_HIGHLIGHT_KIND_Read = 2,
	LSP_DOCUMENT_HIGHLIGHT_KIND_Write = 3
} LspDocumentHighlightKind;

#define LSP_TYPE_DOCUMENT_HIGHLIGHT_KIND (lsp_document_highlight_kind_get_type ())
typedef struct _Block29Data Block29Data;

#define LSP_TYPE_REFERENCE_PARAMS (lsp_reference_params_get_type ())
#define LSP_REFERENCE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_REFERENCE_PARAMS, LspReferenceParams))
#define LSP_REFERENCE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_REFERENCE_PARAMS, LspReferenceParamsClass))
#define LSP_IS_REFERENCE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_REFERENCE_PARAMS))
#define LSP_IS_REFERENCE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_REFERENCE_PARAMS))
#define LSP_REFERENCE_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_REFERENCE_PARAMS, LspReferenceParamsClass))

typedef struct _LspReferenceParams LspReferenceParams;
typedef struct _LspReferenceParamsClass LspReferenceParamsClass;

#define LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT (lsp_reference_params_reference_context_get_type ())
#define LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContext))
#define LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContextClass))
#define LSP_REFERENCE_PARAMS_IS_REFERENCE_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT))
#define LSP_REFERENCE_PARAMS_IS_REFERENCE_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT))
#define LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContextClass))

typedef struct _LspReferenceParamsReferenceContext LspReferenceParamsReferenceContext;
typedef struct _LspReferenceParamsReferenceContextClass LspReferenceParamsReferenceContextClass;

#define LSP_TYPE_DOCUMENT_HIGHLIGHT (lsp_document_highlight_get_type ())
#define LSP_DOCUMENT_HIGHLIGHT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlight))
#define LSP_DOCUMENT_HIGHLIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlightClass))
#define LSP_IS_DOCUMENT_HIGHLIGHT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_HIGHLIGHT))
#define LSP_IS_DOCUMENT_HIGHLIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_HIGHLIGHT))
#define LSP_DOCUMENT_HIGHLIGHT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlightClass))

typedef struct _LspDocumentHighlight LspDocumentHighlight;
typedef struct _LspDocumentHighlightClass LspDocumentHighlightClass;
typedef struct _Block30Data Block30Data;
typedef gboolean (*VlsFindSymbolFilter) (ValaCodeNode* needle, ValaCodeNode* hay_node);
typedef struct _Block31Data Block31Data;
typedef struct _Block32Data Block32Data;
typedef struct _Block33Data Block33Data;

#define LSP_TYPE_TEXT_EDIT (lsp_text_edit_get_type ())
#define LSP_TEXT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_EDIT, LspTextEdit))
#define LSP_TEXT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_EDIT, LspTextEditClass))
#define LSP_IS_TEXT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_EDIT))
#define LSP_IS_TEXT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_EDIT))
#define LSP_TEXT_EDIT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_EDIT, LspTextEditClass))

typedef struct _LspTextEdit LspTextEdit;
typedef struct _LspTextEditClass LspTextEditClass;

#define LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER (lsp_versioned_text_document_identifier_get_type ())
#define LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifier))
#define LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifierClass))
#define LSP_IS_VERSIONED_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_IS_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifierClass))

typedef struct _LspVersionedTextDocumentIdentifier LspVersionedTextDocumentIdentifier;
typedef struct _LspVersionedTextDocumentIdentifierClass LspVersionedTextDocumentIdentifierClass;

#define LSP_TYPE_TEXT_DOCUMENT_EDIT (lsp_text_document_edit_get_type ())
#define LSP_TEXT_DOCUMENT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEdit))
#define LSP_TEXT_DOCUMENT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEditClass))
#define LSP_IS_TEXT_DOCUMENT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_EDIT))
#define LSP_IS_TEXT_DOCUMENT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_EDIT))
#define LSP_TEXT_DOCUMENT_EDIT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEditClass))

typedef struct _LspTextDocumentEdit LspTextDocumentEdit;
typedef struct _LspTextDocumentEditClass LspTextDocumentEditClass;
typedef struct _Block34Data Block34Data;
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _VlsServer {
	GObject parent_instance;
	VlsServerPrivate * priv;
};

struct _VlsServerClass {
	GObjectClass parent_class;
};

struct _VlsServerPrivate {
	JsonrpcServer* server;
	GMainLoop* loop;
	GHashTable* notif_handlers;
	GHashTable* call_handlers;
	LspInitializeParams* init_params;
	VlsGirDocumentation* documentation;
	GeeHashSet* pending_requests;
	gboolean shutting_down;
	guint* g_sources;
	gint g_sources_length1;
	gint _g_sources_size_;
	gulong client_closed_event_id;
	GHashTable* projects;
	VlsDefaultProject* default_project;
	GeeHashSet* discarded_files;
	GeeHashSet* open_files;
	JsonrpcClient* update_context_client;
	gint64 update_context_requests;
	gint64 update_context_time_us;
};

typedef enum  {
	VLS_PROJECT_ERROR_VERSION_UNSUPPORTED,
	VLS_PROJECT_ERROR_INTROSPECTION,
	VLS_PROJECT_ERROR_CONFIGURATION,
	VLS_PROJECT_ERROR_TASK_FAILED,
	VLS_PROJECT_ERROR_NOT_FOUND
} VlsProjectError;
#define VLS_PROJECT_ERROR vls_project_error_quark ()
struct _Block24Data {
	int _ref_count_;
	VlsServer* self;
	VlsRequest* req;
	VlsServerOnContextUpdatedFunc on_context_updated_func;
	gpointer on_context_updated_func_target;
	GDestroyNotify on_context_updated_func_target_destroy_notify;
};

struct _Block25Data {
	int _ref_count_;
	VlsServer* self;
	JsonArray* diags_without_source;
	GeeHashMap* doc_diags;
	VlsCompilation* target;
};

struct _VlsReporter {
	ValaReport parent_instance;
	VlsReporterPrivate * priv;
	GPtrArray* messages;
};

struct _VlsReporterClass {
	ValaReportClass parent_class;
};

struct _VlsSourceMessage {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VlsSourceMessagePrivate * priv;
	ValaSourceReference* loc;
	gchar* message;
	LspDiagnosticSeverity severity;
};

struct _VlsSourceMessageClass {
	GTypeClass parent_class;
	void (*finalize) (VlsSourceMessage *self);
};

struct _VlsFindSymbol {
	ValaCodeVisitor parent_instance;
	VlsFindSymbolPrivate * priv;
	GeeList* result;
};

struct _VlsFindSymbolClass {
	ValaCodeVisitorClass parent_class;
};

struct _Block26Data {
	int _ref_count_;
	VlsServer* self;
	LspTextDocumentPositionParams* p;
	GeeArrayList* results;
	VlsProject* selected_project;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block27Data {
	int _ref_count_;
	VlsServer* self;
	LspTextDocumentPositionParams* p;
	GeeArrayList* results;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _VlsCodeAnalyzerIface {
	GTypeInterface parent_iface;
	GDateTime* (*get_last_updated) (VlsCodeAnalyzer* self);
	void (*set_last_updated) (VlsCodeAnalyzer* self, GDateTime* value);
};

struct _Block28Data {
	int _ref_count_;
	VlsServer* self;
	GeeArrayList* results;
	VlsProject* selected_project;
	LspPosition* pos;
	JsonrpcClient* client;
	GVariant* id;
};

struct _Block29Data {
	int _ref_count_;
	VlsServer* self;
	GeeArrayList* results;
	VlsProject* selected_project;
	LspPosition* pos;
	gboolean is_highlight;
	gboolean include_declaration;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block30Data {
	int _ref_count_;
	VlsServer* self;
	GeeArrayList* results;
	VlsProject* selected_project;
	LspPosition* pos;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block31Data {
	int _ref_count_;
	VlsServer* self;
	gchar* query;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block32Data {
	int _ref_count_;
	Block31Data * _data31_;
	JsonArray* json_array;
};

struct _Block33Data {
	int _ref_count_;
	VlsServer* self;
	gchar* new_name;
	GeeArrayList* results;
	VlsProject* selected_project;
	LspPosition* pos;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block34Data {
	int _ref_count_;
	VlsServer* self;
	GeeArrayList* results;
	VlsProject* selected_project;
	LspPosition* pos;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

static gint VlsServer_private_offset;
static gpointer vls_server_parent_class = NULL;
static gboolean vls_server_received_signal;
static gboolean vls_server_received_signal = FALSE;
VALA_EXTERN GCancellable* vls_server_cancellable;
GCancellable* vls_server_cancellable = NULL;
VALA_EXTERN gboolean opt_version;
gboolean opt_version = FALSE;

VALA_EXTERN GType vls_server_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsServer, g_object_unref)
VALA_EXTERN GType lsp_initialize_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspInitializeParams, g_object_unref)
VALA_EXTERN gpointer vls_gir_documentation_ref (gpointer instance);
VALA_EXTERN void vls_gir_documentation_unref (gpointer instance);
VALA_EXTERN GParamSpec* vls_param_spec_gir_documentation (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
VALA_EXTERN void vls_value_set_gir_documentation (GValue* value,
                                      gpointer v_object);
VALA_EXTERN void vls_value_take_gir_documentation (GValue* value,
                                       gpointer v_object);
VALA_EXTERN gpointer vls_value_get_gir_documentation (const GValue* value);
VALA_EXTERN GType vls_gir_documentation_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsGirDocumentation, vls_gir_documentation_unref)
VALA_EXTERN GType vls_request_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsRequest, g_object_unref)
VALA_EXTERN GType vls_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsProject, g_object_unref)
VALA_EXTERN GType vls_default_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsDefaultProject, g_object_unref)
VALA_EXTERN VlsServer* vls_server_new (GMainLoop* loop);
VALA_EXTERN VlsServer* vls_server_construct (GType object_type,
                                 GMainLoop* loop);
static gboolean __lambda23_ (VlsServer* self);
static void vls_server_shutdown_real (VlsServer* self);
static gboolean ___lambda23__gsource_func (gpointer self);
static void _vala_array_add12 (guint* * array,
                        gint* length,
                        gint* size,
                        guint value);
static void __lambda24_ (VlsServer* self,
                  JsonrpcClient* client);
static void ___lambda24__jsonrpc_server_client_closed (JsonrpcServer* _sender,
                                                JsonrpcClient* client,
                                                gpointer self);
static void _g_free0_ (gpointer var);
VALA_EXTERN guint vls_request_hash (VlsRequest* req);
static guint _vls_request_hash_gee_hash_data_func (gconstpointer v,
                                            gpointer self);
VALA_EXTERN gboolean vls_request_equal (VlsRequest* reqA,
                            VlsRequest* reqB);
static gboolean _vls_request_equal_gee_equal_data_func (gconstpointer a,
                                                 gconstpointer b,
                                                 gpointer self);
static void __lambda25_ (VlsServer* self,
                  JsonrpcClient* client,
                  const gchar* method,
                  GVariant* params);
static void ___lambda25__jsonrpc_server_notification (JsonrpcServer* _sender,
                                               JsonrpcClient* client,
                                               const gchar* method,
                                               GVariant* params,
                                               gpointer self);
static gboolean __lambda26_ (VlsServer* self,
                      JsonrpcClient* client,
                      const gchar* method,
                      GVariant* id,
                      GVariant* params);
static gboolean ___lambda26__jsonrpc_server_handle_call (JsonrpcServer* _sender,
                                                  JsonrpcClient* client,
                                                  const gchar* method,
                                                  GVariant* id,
                                                  GVariant* params,
                                                  gpointer self);
static void _g_object_unref0_ (gpointer var);
static void vls_server_initialize (VlsServer* self,
                            JsonrpcServer* _self_,
                            JsonrpcClient* client,
                            const gchar* method,
                            GVariant* id,
                            GVariant* params);
static void _vls_server_initialize_vls_server_call_handler (VlsServer* _self_,
                                                     JsonrpcServer* server,
                                                     JsonrpcClient* client,
                                                     const gchar* method,
                                                     GVariant* id,
                                                     GVariant* params);
static void vls_server_shutdown (VlsServer* self,
                          JsonrpcServer* _self_,
                          JsonrpcClient* client,
                          const gchar* method,
                          GVariant* id,
                          GVariant* params);
static void _vls_server_shutdown_vls_server_call_handler (VlsServer* _self_,
                                                   JsonrpcServer* server,
                                                   JsonrpcClient* client,
                                                   const gchar* method,
                                                   GVariant* id,
                                                   GVariant* params);
static void vls_server_exit (VlsServer* self,
                      JsonrpcClient* client,
                      GVariant* params);
static void _vls_server_exit_vls_server_notification_handler (VlsServer* _self_,
                                                       JsonrpcClient* client,
                                                       GVariant* params);
static void vls_server_textDocumentDefinition (VlsServer* self,
                                        JsonrpcServer* _self_,
                                        JsonrpcClient* client,
                                        const gchar* method,
                                        GVariant* id,
                                        GVariant* params);
static void _vls_server_textDocumentDefinition_vls_server_call_handler (VlsServer* _self_,
                                                                 JsonrpcServer* server,
                                                                 JsonrpcClient* client,
                                                                 const gchar* method,
                                                                 GVariant* id,
                                                                 GVariant* params);
static void vls_server_textDocumentDidOpen (VlsServer* self,
                                     JsonrpcClient* client,
                                     GVariant* params);
static void _vls_server_textDocumentDidOpen_vls_server_notification_handler (VlsServer* _self_,
                                                                      JsonrpcClient* client,
                                                                      GVariant* params);
static void vls_server_textDocumentDidSave (VlsServer* self,
                                     JsonrpcClient* client,
                                     GVariant* params);
static void _vls_server_textDocumentDidSave_vls_server_notification_handler (VlsServer* _self_,
                                                                      JsonrpcClient* client,
                                                                      GVariant* params);
static void vls_server_textDocumentDidClose (VlsServer* self,
                                      JsonrpcClient* client,
                                      GVariant* params);
static void _vls_server_textDocumentDidClose_vls_server_notification_handler (VlsServer* _self_,
                                                                       JsonrpcClient* client,
                                                                       GVariant* params);
static void vls_server_textDocumentDidChange (VlsServer* self,
                                       JsonrpcClient* client,
                                       GVariant* params);
static void _vls_server_textDocumentDidChange_vls_server_notification_handler (VlsServer* _self_,
                                                                        JsonrpcClient* client,
                                                                        GVariant* params);
static void vls_server_textDocumentDocumentSymbol (VlsServer* self,
                                            JsonrpcServer* _self_,
                                            JsonrpcClient* client,
                                            const gchar* method,
                                            GVariant* id,
                                            GVariant* params);
static void _vls_server_textDocumentDocumentSymbol_vls_server_call_handler (VlsServer* _self_,
                                                                     JsonrpcServer* server,
                                                                     JsonrpcClient* client,
                                                                     const gchar* method,
                                                                     GVariant* id,
                                                                     GVariant* params);
static void vls_server_textDocumentCompletion (VlsServer* self,
                                        JsonrpcServer* _self_,
                                        JsonrpcClient* client,
                                        const gchar* method,
                                        GVariant* id,
                                        GVariant* params);
static void _vls_server_textDocumentCompletion_vls_server_call_handler (VlsServer* _self_,
                                                                 JsonrpcServer* server,
                                                                 JsonrpcClient* client,
                                                                 const gchar* method,
                                                                 GVariant* id,
                                                                 GVariant* params);
static void vls_server_textDocumentSignatureHelp (VlsServer* self,
                                           JsonrpcServer* _self_,
                                           JsonrpcClient* client,
                                           const gchar* method,
                                           GVariant* id,
                                           GVariant* params);
static void _vls_server_textDocumentSignatureHelp_vls_server_call_handler (VlsServer* _self_,
                                                                    JsonrpcServer* server,
                                                                    JsonrpcClient* client,
                                                                    const gchar* method,
                                                                    GVariant* id,
                                                                    GVariant* params);
static void vls_server_textDocumentHover (VlsServer* self,
                                   JsonrpcServer* _self_,
                                   JsonrpcClient* client,
                                   const gchar* method,
                                   GVariant* id,
                                   GVariant* params);
static void _vls_server_textDocumentHover_vls_server_call_handler (VlsServer* _self_,
                                                            JsonrpcServer* server,
                                                            JsonrpcClient* client,
                                                            const gchar* method,
                                                            GVariant* id,
                                                            GVariant* params);
static void vls_server_textDocumentReferences (VlsServer* self,
                                        JsonrpcServer* _self_,
                                        JsonrpcClient* client,
                                        const gchar* method,
                                        GVariant* id,
                                        GVariant* params);
static void _vls_server_textDocumentReferences_vls_server_call_handler (VlsServer* _self_,
                                                                 JsonrpcServer* server,
                                                                 JsonrpcClient* client,
                                                                 const gchar* method,
                                                                 GVariant* id,
                                                                 GVariant* params);
static void vls_server_textDocumentImplementation (VlsServer* self,
                                            JsonrpcServer* _self_,
                                            JsonrpcClient* client,
                                            const gchar* method,
                                            GVariant* id,
                                            GVariant* params);
static void _vls_server_textDocumentImplementation_vls_server_call_handler (VlsServer* _self_,
                                                                     JsonrpcServer* server,
                                                                     JsonrpcClient* client,
                                                                     const gchar* method,
                                                                     GVariant* id,
                                                                     GVariant* params);
static void vls_server_handle_workspace_symbol_request (VlsServer* self,
                                                 JsonrpcServer* _self_,
                                                 JsonrpcClient* client,
                                                 const gchar* method,
                                                 GVariant* id,
                                                 GVariant* params);
static void _vls_server_handle_workspace_symbol_request_vls_server_call_handler (VlsServer* _self_,
                                                                          JsonrpcServer* server,
                                                                          JsonrpcClient* client,
                                                                          const gchar* method,
                                                                          GVariant* id,
                                                                          GVariant* params);
static void vls_server_textDocumentRename (VlsServer* self,
                                    JsonrpcServer* _self_,
                                    JsonrpcClient* client,
                                    const gchar* method,
                                    GVariant* id,
                                    GVariant* params);
static void _vls_server_textDocumentRename_vls_server_call_handler (VlsServer* _self_,
                                                             JsonrpcServer* server,
                                                             JsonrpcClient* client,
                                                             const gchar* method,
                                                             GVariant* id,
                                                             GVariant* params);
static void vls_server_textDocumentPrepareRename (VlsServer* self,
                                           JsonrpcServer* _self_,
                                           JsonrpcClient* client,
                                           const gchar* method,
                                           GVariant* id,
                                           GVariant* params);
static void _vls_server_textDocumentPrepareRename_vls_server_call_handler (VlsServer* _self_,
                                                                    JsonrpcServer* server,
                                                                    JsonrpcClient* client,
                                                                    const gchar* method,
                                                                    GVariant* id,
                                                                    GVariant* params);
static void vls_server_handle_code_lens_request (VlsServer* self,
                                          JsonrpcServer* _self_,
                                          JsonrpcClient* client,
                                          const gchar* method,
                                          GVariant* id,
                                          GVariant* params);
static void _vls_server_handle_code_lens_request_vls_server_call_handler (VlsServer* _self_,
                                                                   JsonrpcServer* server,
                                                                   JsonrpcClient* client,
                                                                   const gchar* method,
                                                                   GVariant* id,
                                                                   GVariant* params);
static void vls_server_cancelRequest (VlsServer* self,
                               JsonrpcClient* client,
                               GVariant* params);
static void _vls_server_cancelRequest_vls_server_notification_handler (VlsServer* _self_,
                                                                JsonrpcClient* client,
                                                                GVariant* params);
VALA_EXTERN GVariant* vls_server_buildDict (VlsServer* self,
                                ...);
VALA_EXTERN GType lsp_message_type_get_type (void) G_GNUC_CONST ;
static void vls_server_showMessage (VlsServer* self,
                             JsonrpcClient* client,
                             const gchar* message,
                             LspMessageType type);
VALA_EXTERN gpointer vls_util_parse_variant (GType t_type,
                                 GBoxedCopyFunc t_dup_func,
                                 GDestroyNotify t_destroy_func,
                                 GVariant* variant);
VALA_EXTERN const gchar* lsp_initialize_params_get_rootUri (LspInitializeParams* self);
VALA_EXTERN const gchar* lsp_initialize_params_get_rootPath (LspInitializeParams* self);
VALA_EXTERN gchar* vls_util_realpath (const gchar* name,
                          const gchar* cwd);
VALA_EXTERN GType lsp_text_document_sync_kind_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GeeArrayList* vls_util_find_files (GFile* dir,
                                   GRegex* basename_pattern,
                                   guint max_depth,
                                   GCancellable* cancellable,
                                   GeeArrayList* found,
                                   GError** error);
VALA_EXTERN GType vls_meson_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsMesonProject, g_object_unref)
VALA_EXTERN VlsMesonProject* vls_meson_project_new (const gchar* root_path,
                                        GCancellable* cancellable,
                                        GError** error);
VALA_EXTERN VlsMesonProject* vls_meson_project_construct (GType object_type,
                                              const gchar* root_path,
                                              GCancellable* cancellable,
                                              GError** error);
VALA_EXTERN GQuark vls_project_error_quark (void);
VALA_EXTERN GType vls_cc_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsCcProject, g_object_unref)
VALA_EXTERN VlsCcProject* vls_cc_project_new (const gchar* root_path,
                                  const gchar* cc_location,
                                  GCancellable* cancellable,
                                  GError** error);
VALA_EXTERN VlsCcProject* vls_cc_project_construct (GType object_type,
                                        const gchar* root_path,
                                        const gchar* cc_location,
                                        GCancellable* cancellable,
                                        GError** error);
VALA_EXTERN VlsDefaultProject* vls_default_project_new (const gchar* root_path);
VALA_EXTERN VlsDefaultProject* vls_default_project_construct (GType object_type,
                                                  const gchar* root_path);
VALA_EXTERN void vls_project_build_if_stale (VlsProject* self,
                                 GCancellable* cancellable,
                                 GError** error);
VALA_EXTERN GType vls_build_target_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsBuildTarget, g_object_unref)
VALA_EXTERN GType vls_compilation_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsCompilation, g_object_unref)
VALA_EXTERN GeeArrayList* vls_project_get_compilations (VlsProject* self);
static void vls_server_publishDiagnostics (VlsServer* self,
                                    VlsProject* project,
                                    VlsCompilation* target,
                                    JsonrpcClient* client);
VALA_EXTERN guint vls_util_file_hash (GFile* file);
static guint _vls_util_file_hash_gee_hash_data_func (gconstpointer v,
                                              gpointer self);
VALA_EXTERN gboolean vls_util_file_equal (GFile* file1,
                              GFile* file2);
static gboolean _vls_util_file_equal_gee_equal_data_func (gconstpointer a,
                                                   gconstpointer b,
                                                   gpointer self);
VALA_EXTERN GeeCollection* vls_project_get_packages (VlsProject* self);
VALA_EXTERN GeeCollection* vls_project_get_custom_gir_dirs (VlsProject* self);
VALA_EXTERN VlsGirDocumentation* vls_gir_documentation_new (GeeCollection* vala_packages,
                                                GeeCollection* custom_gir_dirs);
VALA_EXTERN VlsGirDocumentation* vls_gir_documentation_construct (GType object_type,
                                                      GeeCollection* vala_packages,
                                                      GeeCollection* custom_gir_dirs);
static gboolean __lambda38_ (VlsServer* self);
static void vls_server_check_update_context (VlsServer* self);
static gboolean ___lambda38__gsource_func (gpointer self);
static void _vala_array_add13 (guint* * array,
                        gint* length,
                        gint* size,
                        guint value);
static void vls_server_project_changed_event (VlsServer* self);
static void _vls_server_project_changed_event_vls_project_changed (VlsProject* _sender,
                                                            gpointer self);
static void vls_server_request_context_update (VlsServer* self,
                                        JsonrpcClient* client);
VALA_EXTERN VlsRequest* vls_request_new (GVariant* id,
                             const gchar* method);
VALA_EXTERN VlsRequest* vls_request_construct (GType object_type,
                                   GVariant* id,
                                   const gchar* method);
VALA_EXTERN void vls_server_reply_null (GVariant* id,
                            JsonrpcClient* client,
                            const gchar* method);
static gchar* _variant_get1 (GVariant* value);
static gchar* _variant_get2 (GVariant* value);
static gchar* _variant_get3 (GVariant* value);
VALA_EXTERN GType vls_pair_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsPair, g_object_unref)
VALA_EXTERN GeeArrayList* vls_project_open (VlsProject* self,
                                const gchar* escaped_uri,
                                const gchar* content,
                                GCancellable* cancellable,
                                GError** error);
VALA_EXTERN void vls_gir_documentation_add_package_from_source_file (VlsGirDocumentation* self,
                                                         ValaSourceFile* vapi_pkg);
VALA_EXTERN gconstpointer vls_pair_get_first (VlsPair* self);
VALA_EXTERN GType vls_text_document_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsTextDocument, vala_source_file_unref)
VALA_EXTERN void vls_text_document_set_last_saved_content (VlsTextDocument* self,
                                               const gchar* value);
static gchar* _variant_get4 (GVariant* value);
static VlsProject** _vala_array_dup12 (VlsProject** self,
                                gssize length);
static void _vala_array_add14 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN GeeArrayList* vls_project_lookup_compile_input_source_file (VlsProject* self,
                                                            const gchar* escaped_uri);
VALA_EXTERN gint vls_text_document_get_last_saved_version (VlsTextDocument* self);
static gchar* _variant_get5 (GVariant* value);
static VlsProject** _vala_array_dup13 (VlsProject** self,
                                gssize length);
static void _vala_array_add15 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN gboolean vls_project_close (VlsProject* self,
                            const gchar* escaped_uri,
                            GError** error);
static gchar* _variant_get6 (GVariant* value);
static gint64 _variant_get7 (GVariant* value);
static VlsProject** _vala_array_dup14 (VlsProject** self,
                                gssize length);
static void _vala_array_add16 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN gint vls_text_document_get_version (VlsTextDocument* self);
VALA_EXTERN GType lsp_text_document_content_change_event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentContentChangeEvent, g_object_unref)
VALA_EXTERN GType lsp_range_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspRange, g_object_unref)
VALA_EXTERN LspRange* lsp_text_document_content_change_event_get_range (LspTextDocumentContentChangeEvent* self);
VALA_EXTERN const gchar* lsp_text_document_content_change_event_get_text (LspTextDocumentContentChangeEvent* self);
VALA_EXTERN GType lsp_position_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspPosition, g_object_unref)
VALA_EXTERN LspPosition* lsp_range_get_start (LspRange* self);
VALA_EXTERN LspPosition* lsp_range_get_end (LspRange* self);
VALA_EXTERN gsize vls_util_get_string_pos (const gchar* str,
                               guint lineno,
                               guint charno);
VALA_EXTERN guint lsp_position_get_line (LspPosition* self);
VALA_EXTERN guint lsp_position_get_character (LspPosition* self);
VALA_EXTERN void vls_text_document_set_last_updated (VlsTextDocument* self,
                                         GDateTime* value);
VALA_EXTERN void vls_text_document_set_version (VlsTextDocument* self,
                                    gint value);
static VlsProject** _vala_array_dup15 (VlsProject** self,
                                gssize length);
static void _vala_array_add17 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN gboolean vls_project_reconfigure_if_stale (VlsProject* self,
                                           GCancellable* cancellable,
                                           GError** error);
VALA_EXTERN GeeCollection* vls_compilation_get_project_files (VlsCompilation* self);
static gchar* _________lambda39_ (VlsServer* self,
                           ValaSourceFile* f);
static gpointer __________lambda39__gee_map_func (gpointer g,
                                           gpointer self);
VALA_EXTERN ValaCodeContext* vls_compilation_get_code_context (VlsCompilation* self);
VALA_EXTERN gconstpointer vls_pair_get_second (VlsPair* self);
VALA_EXTERN void vls_gir_documentation_rebuild_if_stale (VlsGirDocumentation* self);
VALA_EXTERN void vls_server_wait_for_context_update (VlsServer* self,
                                         GVariant* id,
                                         VlsServerOnContextUpdatedFunc on_context_updated_func,
                                         gpointer on_context_updated_func_target,
                                         GDestroyNotify on_context_updated_func_target_destroy_notify);
VALA_EXTERN gchar* vls_request_to_string (VlsRequest* self);
static void vls_server_wait_for_context_update_aux (VlsServer* self,
                                             VlsRequest* req,
                                             VlsServerOnContextUpdatedFunc on_context_updated_func,
                                             gpointer on_context_updated_func_target,
                                             GDestroyNotify on_context_updated_func_target_destroy_notify);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static gboolean ___lambda40_ (Block24Data* _data24_);
static gboolean ____lambda40__gsource_func (gpointer self);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
VALA_EXTERN const gchar* vls_build_target_get_id (VlsBuildTarget* self);
VALA_EXTERN GType vls_reporter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsReporter, vala_report_unref)
VALA_EXTERN VlsReporter* vls_compilation_get_reporter (VlsCompilation* self);
VALA_EXTERN gpointer vls_source_message_ref (gpointer instance);
VALA_EXTERN void vls_source_message_unref (gpointer instance);
VALA_EXTERN GParamSpec* vls_param_spec_source_message (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void vls_value_set_source_message (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void vls_value_take_source_message (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer vls_value_get_source_message (const GValue* value);
VALA_EXTERN GType vls_source_message_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsSourceMessage, vls_source_message_unref)
static void __lambda37_ (Block25Data* _data25_,
                  VlsSourceMessage* err);
VALA_EXTERN GType lsp_diagnostic_severity_get_type (void) G_GNUC_CONST ;
VALA_EXTERN LspPosition* lsp_position_new (void);
VALA_EXTERN LspPosition* lsp_position_construct (GType object_type);
VALA_EXTERN void lsp_position_set_line (LspPosition* self,
                            guint value);
VALA_EXTERN void lsp_position_set_character (LspPosition* self,
                                 guint value);
VALA_EXTERN LspRange* lsp_range_new (void);
VALA_EXTERN LspRange* lsp_range_construct (GType object_type);
VALA_EXTERN void lsp_range_set_start (LspRange* self,
                          LspPosition* value);
VALA_EXTERN void lsp_range_set_end (LspRange* self,
                        LspPosition* value);
VALA_EXTERN GType lsp_diagnostic_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDiagnostic, g_object_unref)
VALA_EXTERN LspDiagnostic* lsp_diagnostic_new (void);
VALA_EXTERN LspDiagnostic* lsp_diagnostic_construct (GType object_type);
VALA_EXTERN void lsp_diagnostic_set_range (LspDiagnostic* self,
                               LspRange* value);
VALA_EXTERN void lsp_diagnostic_set_severity (LspDiagnostic* self,
                                  LspDiagnosticSeverity value);
VALA_EXTERN void lsp_diagnostic_set_message (LspDiagnostic* self,
                                 const gchar* value);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void _vala_JsonNode_free (JsonNode* self);
static void ___lambda37__gfunc (gconstpointer data,
                         gpointer self);
VALA_EXTERN const gchar* vls_project_get_root_path (VlsProject* self);
VALA_EXTERN GType vls_find_symbol_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsFindSymbol, vala_code_visitor_unref)
VALA_EXTERN ValaCodeNode* vls_server_get_best (VlsFindSymbol* fs,
                                   ValaSourceFile* file);
VALA_EXTERN LspPosition* lsp_position_new_from_libvala (ValaSourceLocation* sloc);
VALA_EXTERN LspPosition* lsp_position_construct_from_libvala (GType object_type,
                                                  ValaSourceLocation* sloc);
VALA_EXTERN GType lsp_text_document_position_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentPositionParams, g_object_unref)
static Block26Data* block26_data_ref (Block26Data* _data26_);
static void block26_data_unref (void * _userdata_);
VALA_EXTERN GType lsp_text_document_identifier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentIdentifier, g_object_unref)
VALA_EXTERN LspTextDocumentIdentifier* lsp_text_document_position_params_get_textDocument (LspTextDocumentPositionParams* self);
VALA_EXTERN const gchar* lsp_text_document_identifier_get_uri (LspTextDocumentIdentifier* self);
static void __lambda41_ (Block26Data* _data26_,
                  gboolean request_cancelled);
VALA_EXTERN LspPosition* lsp_text_document_position_params_get_position (LspTextDocumentPositionParams* self);
VALA_EXTERN VlsFindSymbol* vls_find_symbol_new (ValaSourceFile* file,
                                    LspPosition* pos,
                                    gboolean search_multiline,
                                    LspPosition* end_pos);
VALA_EXTERN VlsFindSymbol* vls_find_symbol_construct (GType object_type,
                                          ValaSourceFile* file,
                                          LspPosition* pos,
                                          gboolean search_multiline,
                                          LspPosition* end_pos);
VALA_EXTERN ValaSymbol* vls_symbol_references_get_symbol_data_type_refers_to (ValaDataType* data_type);
VALA_EXTERN ValaSymbol* vls_symbol_references_find_real_symbol (VlsProject* project,
                                                    ValaSymbol* symbol);
VALA_EXTERN GType lsp_location_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspLocation, g_object_unref)
VALA_EXTERN LspLocation* lsp_location_new_from_sourceref (ValaSourceReference* sref);
VALA_EXTERN LspLocation* lsp_location_construct_from_sourceref (GType object_type,
                                                    ValaSourceReference* sref);
VALA_EXTERN const gchar* lsp_location_get_uri (LspLocation* self);
VALA_EXTERN GVariant* vls_util_object_to_variant (GObject* object,
                                      GError** error);
static void ___lambda41__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
static void __lambda42_ (Block27Data* _data27_,
                  gboolean request_cancelled);
VALA_EXTERN GType vls_symbol_enumerator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsSymbolEnumerator, vala_code_visitor_unref)
VALA_EXTERN GType vls_code_analyzer_get_type (void) G_GNUC_CONST ;
VALA_EXTERN VlsCodeAnalyzer* vls_compilation_get_analysis_for_file (VlsCompilation* self,
                                                        GType t_type,
                                                        GBoxedCopyFunc t_dup_func,
                                                        GDestroyNotify t_destroy_func,
                                                        ValaSourceFile* source);
VALA_EXTERN GType lsp_client_capabilities_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspClientCapabilities, g_object_unref)
VALA_EXTERN LspClientCapabilities* lsp_initialize_params_get_capabilities (LspInitializeParams* self);
VALA_EXTERN GType lsp_text_document_client_capabilities_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentClientCapabilities, g_object_unref)
VALA_EXTERN LspTextDocumentClientCapabilities* lsp_client_capabilities_get_textDocument (LspClientCapabilities* self);
VALA_EXTERN GType lsp_document_symbol_capabilities_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentSymbolCapabilities, g_object_unref)
VALA_EXTERN LspDocumentSymbolCapabilities* lsp_text_document_client_capabilities_get_documentSymbol (LspTextDocumentClientCapabilities* self);
VALA_EXTERN gboolean lsp_document_symbol_capabilities_get_hierarchicalDocumentSymbolSupport (LspDocumentSymbolCapabilities* self);
VALA_EXTERN GType lsp_document_symbol_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentSymbol, g_object_unref)
VALA_EXTERN GeeIterator* vls_symbol_enumerator_iterator (VlsSymbolEnumerator* self);
VALA_EXTERN GType lsp_symbol_information_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspSymbolInformation, g_object_unref)
VALA_EXTERN GeeIterable* vls_symbol_enumerator_flattened (VlsSymbolEnumerator* self);
static void ___lambda42__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
VALA_EXTERN gpointer vls_doc_comment_ref (gpointer instance);
VALA_EXTERN void vls_doc_comment_unref (gpointer instance);
VALA_EXTERN GParamSpec* vls_param_spec_doc_comment (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void vls_value_set_doc_comment (GValue* value,
                                gpointer v_object);
VALA_EXTERN void vls_value_take_doc_comment (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer vls_value_get_doc_comment (const GValue* value);
VALA_EXTERN GType vls_doc_comment_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsDocComment, vls_doc_comment_unref)
VALA_EXTERN VlsDocComment* vls_server_get_symbol_documentation (VlsServer* self,
                                                    VlsProject* project,
                                                    ValaSymbol* sym);
VALA_EXTERN ValaSymbol* vls_gir_documentation_find_gir_symbol (VlsGirDocumentation* self,
                                                   ValaSymbol* sym);
VALA_EXTERN VlsDocComment* vls_doc_comment_new_from_gir_comment (ValaComment* comment,
                                                     VlsGirDocumentation* documentation,
                                                     VlsCompilation* compilation,
                                                     GError** error);
VALA_EXTERN VlsDocComment* vls_doc_comment_construct_from_gir_comment (GType object_type,
                                                           ValaComment* comment,
                                                           VlsGirDocumentation* documentation,
                                                           VlsCompilation* compilation,
                                                           GError** error);
VALA_EXTERN VlsDocComment* vls_doc_comment_new_from_valadoc_comment (ValaComment* comment,
                                                         ValaSymbol* symbol,
                                                         VlsCompilation* compilation,
                                                         GError** error);
VALA_EXTERN VlsDocComment* vls_doc_comment_construct_from_valadoc_comment (GType object_type,
                                                               ValaComment* comment,
                                                               ValaSymbol* symbol,
                                                               VlsCompilation* compilation,
                                                               GError** error);
VALA_EXTERN GeeHashMap* vls_doc_comment_get_parameters (VlsDocComment* self);
VALA_EXTERN VlsDocComment* vls_doc_comment_new (const gchar* markdown_doc);
VALA_EXTERN VlsDocComment* vls_doc_comment_construct (GType object_type,
                                          const gchar* markdown_doc);
VALA_EXTERN GType lsp_completion_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCompletionParams, g_object_unref)
VALA_EXTERN GType lsp_completion_context_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCompletionContext, g_object_unref)
VALA_EXTERN void vls_completion_engine_begin_response (VlsServer* lang_serv,
                                           VlsProject* project,
                                           JsonrpcClient* client,
                                           GVariant* id,
                                           const gchar* method,
                                           ValaSourceFile* doc,
                                           VlsCompilation* compilation,
                                           LspPosition* pos,
                                           LspCompletionContext* completion_context);
VALA_EXTERN LspCompletionContext* lsp_completion_params_get_context (LspCompletionParams* self);
VALA_EXTERN void vls_signature_help_engine_begin_response (VlsServer* lang_serv,
                                               VlsProject* project,
                                               JsonrpcClient* client,
                                               GVariant* id,
                                               const gchar* method,
                                               ValaSourceFile* doc,
                                               VlsCompilation* compilation,
                                               LspPosition* pos);
static Block28Data* block28_data_ref (Block28Data* _data28_);
static void block28_data_unref (void * _userdata_);
static void __lambda53_ (Block28Data* _data28_,
                  gboolean request_cancelled);
VALA_EXTERN VlsFindScope* vls_find_scope_new (ValaSourceFile* file,
                                  LspPosition* pos,
                                  gboolean before_context_update);
VALA_EXTERN VlsFindScope* vls_find_scope_construct (GType object_type,
                                        ValaSourceFile* file,
                                        LspPosition* pos,
                                        gboolean before_context_update);
VALA_EXTERN GType vls_find_scope_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsFindScope, vala_code_visitor_unref)
VALA_EXTERN ValaSymbol* vls_find_scope_get_best_block (VlsFindScope* self);
VALA_EXTERN GType lsp_hover_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspHover, g_object_unref)
VALA_EXTERN LspHover* lsp_hover_new (void);
VALA_EXTERN LspHover* lsp_hover_construct (GType object_type);
VALA_EXTERN LspRange* vls_symbol_references_get_replacement_range (ValaCodeNode* code_node,
                                                       ValaSymbol* symbol);
VALA_EXTERN gboolean lsp_range_contains (LspRange* self,
                             LspPosition* pos);
VALA_EXTERN GeeCollection* vls_symbol_references_get_visible_components_of_code_node (ValaCodeNode* code_node);
VALA_EXTERN void lsp_hover_set_range (LspHover* self,
                          LspRange* value);
VALA_EXTERN LspRange* lsp_range_new_from_sourceref (ValaSourceReference* sref);
VALA_EXTERN LspRange* lsp_range_construct_from_sourceref (GType object_type,
                                              ValaSourceReference* sref);
VALA_EXTERN gchar* vls_code_help_get_symbol_representation (ValaDataType* data_type,
                                                ValaSymbol* sym,
                                                ValaScope* scope,
                                                gboolean allow_show_parent_member,
                                                ValaList* method_type_arguments,
                                                const gchar* override_name,
                                                gboolean show_initializers,
                                                gboolean is_parent_symbol,
                                                ValaList* ellipsis_overrides,
                                                gboolean show_parameter_direction);
VALA_EXTERN GType lsp_marked_string_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspMarkedString, g_object_unref)
VALA_EXTERN GeeList* lsp_hover_get_contents (LspHover* self);
VALA_EXTERN LspMarkedString* lsp_marked_string_new (void);
VALA_EXTERN LspMarkedString* lsp_marked_string_construct (GType object_type);
VALA_EXTERN void lsp_marked_string_set_language (LspMarkedString* self,
                                     const gchar* value);
VALA_EXTERN void lsp_marked_string_set_value (LspMarkedString* self,
                                  const gchar* value);
VALA_EXTERN const gchar* vls_doc_comment_get_body (VlsDocComment* self);
static void ___lambda53__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
VALA_EXTERN GType lsp_document_highlight_kind_get_type (void) G_GNUC_CONST ;
static LspDocumentHighlightKind vls_server_determine_node_highlight_kind (VlsServer* self,
                                                                   ValaCodeNode* node);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
VALA_EXTERN GType lsp_reference_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspReferenceParams, g_object_unref)
VALA_EXTERN GType lsp_reference_params_reference_context_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspReferenceParamsReferenceContext, g_object_unref)
VALA_EXTERN LspReferenceParamsReferenceContext* lsp_reference_params_get_context (LspReferenceParams* self);
VALA_EXTERN gboolean lsp_reference_params_reference_context_get_includeDeclaration (LspReferenceParamsReferenceContext* self);
static void __lambda54_ (Block29Data* _data29_,
                  gboolean request_cancelled);
VALA_EXTERN void vls_symbol_references_list_in_file (ValaSourceFile* file,
                                         ValaSymbol* symbol,
                                         gboolean include_declaration,
                                         GeeHashMap* references);
VALA_EXTERN GeeArrayList* vls_build_target_get_output (VlsBuildTarget* self);
VALA_EXTERN GeeCollection* vls_symbol_references_get_compilations_using_symbol (VlsProject* project,
                                                                    ValaSymbol* symbol);
VALA_EXTERN GType lsp_document_highlight_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentHighlight, g_object_unref)
VALA_EXTERN LspDocumentHighlight* lsp_document_highlight_new (void);
VALA_EXTERN LspDocumentHighlight* lsp_document_highlight_construct (GType object_type);
VALA_EXTERN void lsp_document_highlight_set_range (LspDocumentHighlight* self,
                                       LspRange* value);
VALA_EXTERN void lsp_document_highlight_set_kind (LspDocumentHighlight* self,
                                      LspDocumentHighlightKind value);
VALA_EXTERN LspLocation* lsp_location_new (const gchar* filename,
                               LspRange* range);
VALA_EXTERN LspLocation* lsp_location_construct (GType object_type,
                                     const gchar* filename,
                                     LspRange* range);
static void ___lambda54__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
static void __lambda59_ (Block30Data* _data30_,
                  gboolean request_cancelled);
static gboolean _______lambda60_ (ValaCodeNode* needle,
                           ValaCodeNode* node);
static gboolean ________lambda60__vls_find_symbol_filter (ValaCodeNode* needle,
                                                   ValaCodeNode* hay_node);
VALA_EXTERN VlsFindSymbol* vls_find_symbol_new_with_filter (ValaSourceFile* file,
                                                ValaCodeNode* needle,
                                                VlsFindSymbolFilter filter_func,
                                                gboolean include_declaration);
VALA_EXTERN VlsFindSymbol* vls_find_symbol_construct_with_filter (GType object_type,
                                                      ValaSourceFile* file,
                                                      ValaCodeNode* needle,
                                                      VlsFindSymbolFilter filter_func,
                                                      gboolean include_declaration);
static gboolean ________lambda61_ (ValaCodeNode* needle,
                            ValaCodeNode* node);
static gboolean _________lambda61__vls_find_symbol_filter (ValaCodeNode* needle,
                                                    ValaCodeNode* hay_node);
static gboolean ________lambda62_ (ValaCodeNode* needle,
                            ValaCodeNode* node);
static gboolean _________lambda62__vls_find_symbol_filter (ValaCodeNode* needle,
                                                    ValaCodeNode* hay_node);
static void ___lambda59__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
static gchar* _variant_get8 (GVariant* value);
static void __lambda63_ (Block31Data* _data31_,
                  gboolean request_cancelled);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
static VlsProject** _vala_array_dup16 (VlsProject** self,
                                gssize length);
static void _vala_array_add18 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN GeeIterable* vls_project_get_project_source_files (VlsProject* self);
static gboolean _______lambda64_ (Block32Data* _data32_,
                           LspSymbolInformation* dsym);
VALA_EXTERN const gchar* lsp_symbol_information_get_name (LspSymbolInformation* self);
static gboolean ________lambda64__gee_predicate (gconstpointer g,
                                          gpointer self);
static gboolean _______lambda65_ (Block32Data* _data32_,
                           LspSymbolInformation* dsym);
static gboolean ________lambda65__gee_forall_func (gpointer g,
                                            gpointer self);
static void ___lambda63__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static Block33Data* block33_data_ref (Block33Data* _data33_);
static void block33_data_unref (void * _userdata_);
static gchar* _variant_get9 (GVariant* value);
static void __lambda66_ (Block33Data* _data33_,
                  gboolean request_cancelled);
VALA_EXTERN void vls_symbol_references_list_implementations_of_virtual_symbol (ValaSourceFile* file,
                                                                   ValaSymbol* symbol,
                                                                   GeeHashMap* references);
VALA_EXTERN GType lsp_text_edit_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextEdit, g_object_unref)
VALA_EXTERN gchar* vls_code_help_get_expression_representation (ValaCodeNode* expr);
VALA_EXTERN LspTextEdit* lsp_text_edit_new (void);
VALA_EXTERN LspTextEdit* lsp_text_edit_construct (GType object_type);
VALA_EXTERN void lsp_text_edit_set_range (LspTextEdit* self,
                              LspRange* value);
VALA_EXTERN void lsp_text_edit_set_newText (LspTextEdit* self,
                                const gchar* value);
VALA_EXTERN GType lsp_versioned_text_document_identifier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspVersionedTextDocumentIdentifier, g_object_unref)
VALA_EXTERN LspVersionedTextDocumentIdentifier* lsp_versioned_text_document_identifier_new (void);
VALA_EXTERN LspVersionedTextDocumentIdentifier* lsp_versioned_text_document_identifier_construct (GType object_type);
VALA_EXTERN void lsp_versioned_text_document_identifier_set_version (LspVersionedTextDocumentIdentifier* self,
                                                         gint value);
VALA_EXTERN void lsp_text_document_identifier_set_uri (LspTextDocumentIdentifier* self,
                                           const gchar* value);
VALA_EXTERN GType lsp_text_document_edit_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentEdit, g_object_unref)
VALA_EXTERN LspTextDocumentEdit* lsp_text_document_edit_new (void);
VALA_EXTERN LspTextDocumentEdit* lsp_text_document_edit_construct (GType object_type);
VALA_EXTERN void lsp_text_document_edit_set_textDocument (LspTextDocumentEdit* self,
                                              LspVersionedTextDocumentIdentifier* value);
VALA_EXTERN void lsp_text_document_edit_set_edits (LspTextDocumentEdit* self,
                                       GeeArrayList* value);
static void ___lambda66__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static Block34Data* block34_data_ref (Block34Data* _data34_);
static void block34_data_unref (void * _userdata_);
static void __lambda68_ (Block34Data* _data34_,
                  gboolean request_cancelled);
static void ___lambda68__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static gchar* _variant_get10 (GVariant* value);
VALA_EXTERN void vls_code_lens_engine_begin_response (VlsServer* lang_serv,
                                          VlsProject* project,
                                          JsonrpcClient* client,
                                          GVariant* id,
                                          const gchar* method,
                                          ValaSourceFile* doc,
                                          VlsCompilation* compilation);
static void _vls_server___lambda69_ (void);
static void __vls_server___lambda69__gsignal_handler_func (gint signum);
static void _vls_server___lambda70_ (void);
static void __vls_server___lambda70__gsignal_handler_func (gint signum);
static void vls_server_finalize (GObject * obj);
static GType vls_server_get_type_once (void);
static gint _vala_main (gchar** args,
                 gint args_length1);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static GRegex* _tmp_regex_0 = NULL;
static GRegex* _tmp_regex_1 = NULL;
const GOptionEntry entries[2] = {{"version", 'V', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, &opt_version, "Print the version and commit info", NULL}, {0}};

static inline gpointer
vls_server_get_instance_private (VlsServer* self)
{
	return G_STRUCT_MEMBER_P (self, VlsServer_private_offset);
}

static gpointer
_g_main_loop_ref0 (gpointer self)
{
	return self ? g_main_loop_ref (self) : NULL;
}

static gboolean
__lambda23_ (VlsServer* self)
{
	gboolean result;
	if (vls_server_received_signal) {
		vls_server_shutdown_real (self);
		result = G_SOURCE_REMOVE;
		return result;
	}
	result = !self->priv->shutting_down;
	return result;
}

static gboolean
___lambda23__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda23_ ((VlsServer*) self);
	return result;
}

static void
_vala_array_add12 (guint* * array,
                   gint* length,
                   gint* size,
                   guint value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (guint, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
__lambda24_ (VlsServer* self,
             JsonrpcClient* client)
{
	g_return_if_fail (client != NULL);
	vls_server_shutdown_real (self);
}

static void
___lambda24__jsonrpc_server_client_closed (JsonrpcServer* _sender,
                                           JsonrpcClient* client,
                                           gpointer self)
{
	__lambda24_ ((VlsServer*) self, client);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static guint
_vls_request_hash_gee_hash_data_func (gconstpointer v,
                                      gpointer self)
{
	guint result;
	result = vls_request_hash ((VlsRequest*) v);
	return result;
}

static gboolean
_vls_request_equal_gee_equal_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self)
{
	gboolean result;
	result = vls_request_equal ((VlsRequest*) a, (VlsRequest*) b);
	return result;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
__lambda25_ (VlsServer* self,
             JsonrpcClient* client,
             const gchar* method,
             GVariant* params)
{
	GHashTable* _tmp0_;
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = self->priv->notif_handlers;
	if (g_hash_table_contains (_tmp0_, method)) {
		GHashTable* _tmp1_;
		gconstpointer _tmp2_;
		_tmp1_ = self->priv->notif_handlers;
		_tmp2_ = g_hash_table_lookup (_tmp1_, method);
		((VlsServerNotificationHandler) _tmp2_) (self, client, params);
	} else {
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp3_ = string_to_string (method);
		_tmp4_ = g_strconcat ("no notification handler for ", _tmp3_, NULL);
		_tmp5_ = _tmp4_;
		g_warning ("server.vala:147: %s", _tmp5_);
		_g_free0 (_tmp5_);
	}
}

static void
___lambda25__jsonrpc_server_notification (JsonrpcServer* _sender,
                                          JsonrpcClient* client,
                                          const gchar* method,
                                          GVariant* params,
                                          gpointer self)
{
	__lambda25_ ((VlsServer*) self, client, method, params);
}

static gboolean
__lambda26_ (VlsServer* self,
             JsonrpcClient* client,
             const gchar* method,
             GVariant* id,
             GVariant* params)
{
	GHashTable* _tmp0_;
	gboolean result;
	g_return_val_if_fail (client != NULL, FALSE);
	g_return_val_if_fail (method != NULL, FALSE);
	g_return_val_if_fail (id != NULL, FALSE);
	g_return_val_if_fail (params != NULL, FALSE);
	_tmp0_ = self->priv->call_handlers;
	if (g_hash_table_contains (_tmp0_, method)) {
		GHashTable* _tmp1_;
		gconstpointer _tmp2_;
		JsonrpcServer* _tmp3_;
		_tmp1_ = self->priv->call_handlers;
		_tmp2_ = g_hash_table_lookup (_tmp1_, method);
		_tmp3_ = self->priv->server;
		((VlsServerCallHandler) _tmp2_) (self, _tmp3_, client, method, id, params);
		result = TRUE;
		return result;
	} else {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = string_to_string (method);
		_tmp5_ = g_strconcat ("no call handler for ", _tmp4_, NULL);
		_tmp6_ = _tmp5_;
		g_warning ("server.vala:156: %s", _tmp6_);
		_g_free0 (_tmp6_);
		result = FALSE;
		return result;
	}
}

static gboolean
___lambda26__jsonrpc_server_handle_call (JsonrpcServer* _sender,
                                         JsonrpcClient* client,
                                         const gchar* method,
                                         GVariant* id,
                                         GVariant* params,
                                         gpointer self)
{
	gboolean result;
	result = __lambda26_ ((VlsServer*) self, client, method, id, params);
	return result;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static void
_vls_server_initialize_vls_server_call_handler (VlsServer* _self_,
                                                JsonrpcServer* server,
                                                JsonrpcClient* client,
                                                const gchar* method,
                                                GVariant* id,
                                                GVariant* params)
{
	vls_server_initialize (_self_, server, client, method, id, params);
}

static void
_vls_server_shutdown_vls_server_call_handler (VlsServer* _self_,
                                              JsonrpcServer* server,
                                              JsonrpcClient* client,
                                              const gchar* method,
                                              GVariant* id,
                                              GVariant* params)
{
	vls_server_shutdown (_self_, server, client, method, id, params);
}

static void
_vls_server_exit_vls_server_notification_handler (VlsServer* _self_,
                                                  JsonrpcClient* client,
                                                  GVariant* params)
{
	vls_server_exit (_self_, client, params);
}

static void
_vls_server_textDocumentDefinition_vls_server_call_handler (VlsServer* _self_,
                                                            JsonrpcServer* server,
                                                            JsonrpcClient* client,
                                                            const gchar* method,
                                                            GVariant* id,
                                                            GVariant* params)
{
	vls_server_textDocumentDefinition (_self_, server, client, method, id, params);
}

static void
_vls_server_textDocumentDidOpen_vls_server_notification_handler (VlsServer* _self_,
                                                                 JsonrpcClient* client,
                                                                 GVariant* params)
{
	vls_server_textDocumentDidOpen (_self_, client, params);
}

static void
_vls_server_textDocumentDidSave_vls_server_notification_handler (VlsServer* _self_,
                                                                 JsonrpcClient* client,
                                                                 GVariant* params)
{
	vls_server_textDocumentDidSave (_self_, client, params);
}

static void
_vls_server_textDocumentDidClose_vls_server_notification_handler (VlsServer* _self_,
                                                                  JsonrpcClient* client,
                                                                  GVariant* params)
{
	vls_server_textDocumentDidClose (_self_, client, params);
}

static void
_vls_server_textDocumentDidChange_vls_server_notification_handler (VlsServer* _self_,
                                                                   JsonrpcClient* client,
                                                                   GVariant* params)
{
	vls_server_textDocumentDidChange (_self_, client, params);
}

static void
_vls_server_textDocumentDocumentSymbol_vls_server_call_handler (VlsServer* _self_,
                                                                JsonrpcServer* server,
                                                                JsonrpcClient* client,
                                                                const gchar* method,
                                                                GVariant* id,
                                                                GVariant* params)
{
	vls_server_textDocumentDocumentSymbol (_self_, server, client, method, id, params);
}

static void
_vls_server_textDocumentCompletion_vls_server_call_handler (VlsServer* _self_,
                                                            JsonrpcServer* server,
                                                            JsonrpcClient* client,
                                                            const gchar* method,
                                                            GVariant* id,
                                                            GVariant* params)
{
	vls_server_textDocumentCompletion (_self_, server, client, method, id, params);
}

static void
_vls_server_textDocumentSignatureHelp_vls_server_call_handler (VlsServer* _self_,
                                                               JsonrpcServer* server,
                                                               JsonrpcClient* client,
                                                               const gchar* method,
                                                               GVariant* id,
                                                               GVariant* params)
{
	vls_server_textDocumentSignatureHelp (_self_, server, client, method, id, params);
}

static void
_vls_server_textDocumentHover_vls_server_call_handler (VlsServer* _self_,
                                                       JsonrpcServer* server,
                                                       JsonrpcClient* client,
                                                       const gchar* method,
                                                       GVariant* id,
                                                       GVariant* params)
{
	vls_server_textDocumentHover (_self_, server, client, method, id, params);
}

static void
_vls_server_textDocumentReferences_vls_server_call_handler (VlsServer* _self_,
                                                            JsonrpcServer* server,
                                                            JsonrpcClient* client,
                                                            const gchar* method,
                                                            GVariant* id,
                                                            GVariant* params)
{
	vls_server_textDocumentReferences (_self_, server, client, method, id, params);
}

static void
_vls_server_textDocumentImplementation_vls_server_call_handler (VlsServer* _self_,
                                                                JsonrpcServer* server,
                                                                JsonrpcClient* client,
                                                                const gchar* method,
                                                                GVariant* id,
                                                                GVariant* params)
{
	vls_server_textDocumentImplementation (_self_, server, client, method, id, params);
}

static void
_vls_server_handle_workspace_symbol_request_vls_server_call_handler (VlsServer* _self_,
                                                                     JsonrpcServer* server,
                                                                     JsonrpcClient* client,
                                                                     const gchar* method,
                                                                     GVariant* id,
                                                                     GVariant* params)
{
	vls_server_handle_workspace_symbol_request (_self_, server, client, method, id, params);
}

static void
_vls_server_textDocumentRename_vls_server_call_handler (VlsServer* _self_,
                                                        JsonrpcServer* server,
                                                        JsonrpcClient* client,
                                                        const gchar* method,
                                                        GVariant* id,
                                                        GVariant* params)
{
	vls_server_textDocumentRename (_self_, server, client, method, id, params);
}

static void
_vls_server_textDocumentPrepareRename_vls_server_call_handler (VlsServer* _self_,
                                                               JsonrpcServer* server,
                                                               JsonrpcClient* client,
                                                               const gchar* method,
                                                               GVariant* id,
                                                               GVariant* params)
{
	vls_server_textDocumentPrepareRename (_self_, server, client, method, id, params);
}

static void
_vls_server_handle_code_lens_request_vls_server_call_handler (VlsServer* _self_,
                                                              JsonrpcServer* server,
                                                              JsonrpcClient* client,
                                                              const gchar* method,
                                                              GVariant* id,
                                                              GVariant* params)
{
	vls_server_handle_code_lens_request (_self_, server, client, method, id, params);
}

static void
_vls_server_cancelRequest_vls_server_notification_handler (VlsServer* _self_,
                                                           JsonrpcClient* client,
                                                           GVariant* params)
{
	vls_server_cancelRequest (_self_, client, params);
}

VlsServer*
vls_server_construct (GType object_type,
                      GMainLoop* loop)
{
	VlsServer * self = NULL;
	GMainLoop* _tmp0_;
	JsonrpcServer* _tmp1_;
	gint new_stdout_fd = 0;
	GUnixInputStream* input_stream = NULL;
	GUnixInputStream* _tmp2_;
	GUnixOutputStream* output_stream = NULL;
	GUnixOutputStream* _tmp3_;
	JsonrpcServer* _tmp7_;
	GUnixInputStream* _tmp8_;
	GUnixOutputStream* _tmp9_;
	GSimpleIOStream* _tmp10_;
	GSimpleIOStream* _tmp11_;
	JsonrpcServer* _tmp12_;
	gulong _tmp13_;
	GHashFunc _tmp14_;
	GEqualFunc _tmp15_;
	GHashTable* _tmp16_;
	GHashFunc _tmp17_;
	GEqualFunc _tmp18_;
	GHashTable* _tmp19_;
	GeeHashSet* _tmp20_;
	JsonrpcServer* _tmp21_;
	JsonrpcServer* _tmp22_;
	GHashFunc _tmp23_;
	GEqualFunc _tmp24_;
	GHashTable* _tmp25_;
	GHashTable* _tmp26_;
	gchar* _tmp27_;
	GHashTable* _tmp28_;
	gchar* _tmp29_;
	GHashTable* _tmp30_;
	gchar* _tmp31_;
	GHashTable* _tmp32_;
	gchar* _tmp33_;
	GHashTable* _tmp34_;
	gchar* _tmp35_;
	GHashTable* _tmp36_;
	gchar* _tmp37_;
	GHashTable* _tmp38_;
	gchar* _tmp39_;
	GHashTable* _tmp40_;
	gchar* _tmp41_;
	GHashTable* _tmp42_;
	gchar* _tmp43_;
	GHashTable* _tmp44_;
	gchar* _tmp45_;
	GHashTable* _tmp46_;
	gchar* _tmp47_;
	GHashTable* _tmp48_;
	gchar* _tmp49_;
	GHashTable* _tmp50_;
	gchar* _tmp51_;
	GHashTable* _tmp52_;
	gchar* _tmp53_;
	GHashTable* _tmp54_;
	gchar* _tmp55_;
	GHashTable* _tmp56_;
	gchar* _tmp57_;
	GHashTable* _tmp58_;
	gchar* _tmp59_;
	GHashTable* _tmp60_;
	gchar* _tmp61_;
	GHashTable* _tmp62_;
	gchar* _tmp63_;
	GHashTable* _tmp64_;
	gchar* _tmp65_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (loop != NULL, NULL);
	self = (VlsServer*) g_object_new (object_type, NULL);
	_tmp0_ = _g_main_loop_ref0 (loop);
	_g_main_loop_unref0 (self->priv->loop);
	self->priv->loop = _tmp0_;
	_tmp1_ = jsonrpc_server_new ();
	if (_tmp1_) {
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "Vls.Server.new");
	}
	_g_object_unref0 (self->priv->server);
	self->priv->server = _tmp1_;
	new_stdout_fd = dup (STDOUT_FILENO);
	close (STDOUT_FILENO);
	dup2 (STDERR_FILENO, STDOUT_FILENO);
	_tmp2_ = (GUnixInputStream*) g_unix_input_stream_new (STDIN_FILENO, FALSE);
	if (_tmp2_) {
		g_object_set_data ((GObject *) _tmp2_, "vala-creation-function", "Vls.Server.new");
	}
	input_stream = _tmp2_;
	_tmp3_ = (GUnixOutputStream*) g_unix_output_stream_new (new_stdout_fd, FALSE);
	if (_tmp3_) {
		g_object_set_data ((GObject *) _tmp3_, "vala-creation-function", "Vls.Server.new");
	}
	output_stream = _tmp3_;
	{
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		_tmp5_ = g_unix_set_fd_nonblocking (STDIN_FILENO, TRUE, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		if (!_tmp5_) {
			_tmp4_ = TRUE;
		} else {
			gboolean _tmp6_ = FALSE;
			_tmp6_ = g_unix_set_fd_nonblocking (new_stdout_fd, TRUE, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp4_ = !_tmp6_;
		}
		if (_tmp4_) {
			g_error ("server.vala:112: could not set pipes to nonblocking.\n");
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		g_debug ("server.vala:114: failed to set FDs to nonblocking");
		g_main_loop_quit (loop);
		_g_object_unref0 (output_stream);
		_g_object_unref0 (input_stream);
		return self;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (output_stream);
		_g_object_unref0 (input_stream);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_vala_array_add12 (&self->priv->g_sources, &self->priv->g_sources_length1, &self->priv->_g_sources_size_, g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) (1 * 1000), ___lambda23__gsource_func, g_object_ref (self), g_object_unref));
	_tmp7_ = self->priv->server;
	_tmp8_ = input_stream;
	_tmp9_ = output_stream;
	_tmp10_ = (GSimpleIOStream*) g_simple_io_stream_new ((GInputStream*) _tmp8_, (GOutputStream*) _tmp9_);
	if (_tmp10_) {
		g_object_set_data ((GObject *) _tmp10_, "vala-creation-function", "Vls.Server.new");
	}
	_tmp11_ = _tmp10_;
	jsonrpc_server_accept_io_stream (_tmp7_, (GIOStream*) _tmp11_);
	_g_object_unref0 (_tmp11_);
	_tmp12_ = self->priv->server;
	_tmp13_ = g_signal_connect_object (_tmp12_, "client-closed", (GCallback) ___lambda24__jsonrpc_server_client_closed, self, 0);
	self->priv->client_closed_event_id = _tmp13_;
	_tmp14_ = g_str_hash;
	_tmp15_ = g_str_equal;
	_tmp16_ = g_hash_table_new_full (_tmp14_, _tmp15_, _g_free0_, NULL);
	_g_hash_table_unref0 (self->priv->notif_handlers);
	self->priv->notif_handlers = _tmp16_;
	_tmp17_ = g_str_hash;
	_tmp18_ = g_str_equal;
	_tmp19_ = g_hash_table_new_full (_tmp17_, _tmp18_, _g_free0_, NULL);
	_g_hash_table_unref0 (self->priv->call_handlers);
	self->priv->call_handlers = _tmp19_;
	_tmp20_ = gee_hash_set_new (VLS_TYPE_REQUEST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_request_hash_gee_hash_data_func, NULL, NULL, _vls_request_equal_gee_equal_data_func, NULL, NULL);
	if (_tmp20_) {
		g_object_set_data ((GObject *) _tmp20_, "vala-creation-function", "Vls.Server.new");
	}
	_g_object_unref0 (self->priv->pending_requests);
	self->priv->pending_requests = _tmp20_;
	_tmp21_ = self->priv->server;
	g_signal_connect_object (_tmp21_, "notification", (GCallback) ___lambda25__jsonrpc_server_notification, self, 0);
	_tmp22_ = self->priv->server;
	g_signal_connect_object (_tmp22_, "handle-call", (GCallback) ___lambda26__jsonrpc_server_handle_call, self, 0);
	_tmp23_ = g_direct_hash;
	_tmp24_ = g_direct_equal;
	_tmp25_ = g_hash_table_new_full (_tmp23_, _tmp24_, _g_object_unref0_, NULL);
	_g_hash_table_unref0 (self->priv->projects);
	self->priv->projects = _tmp25_;
	_tmp26_ = self->priv->call_handlers;
	_tmp27_ = g_strdup ("initialize");
	g_hash_table_insert (_tmp26_, _tmp27_, _vls_server_initialize_vls_server_call_handler);
	_tmp28_ = self->priv->call_handlers;
	_tmp29_ = g_strdup ("shutdown");
	g_hash_table_insert (_tmp28_, _tmp29_, _vls_server_shutdown_vls_server_call_handler);
	_tmp30_ = self->priv->notif_handlers;
	_tmp31_ = g_strdup ("exit");
	g_hash_table_insert (_tmp30_, _tmp31_, _vls_server_exit_vls_server_notification_handler);
	_tmp32_ = self->priv->call_handlers;
	_tmp33_ = g_strdup ("textDocument/definition");
	g_hash_table_insert (_tmp32_, _tmp33_, _vls_server_textDocumentDefinition_vls_server_call_handler);
	_tmp34_ = self->priv->notif_handlers;
	_tmp35_ = g_strdup ("textDocument/didOpen");
	g_hash_table_insert (_tmp34_, _tmp35_, _vls_server_textDocumentDidOpen_vls_server_notification_handler);
	_tmp36_ = self->priv->notif_handlers;
	_tmp37_ = g_strdup ("textDocument/didSave");
	g_hash_table_insert (_tmp36_, _tmp37_, _vls_server_textDocumentDidSave_vls_server_notification_handler);
	_tmp38_ = self->priv->notif_handlers;
	_tmp39_ = g_strdup ("textDocument/didClose");
	g_hash_table_insert (_tmp38_, _tmp39_, _vls_server_textDocumentDidClose_vls_server_notification_handler);
	_tmp40_ = self->priv->notif_handlers;
	_tmp41_ = g_strdup ("textDocument/didChange");
	g_hash_table_insert (_tmp40_, _tmp41_, _vls_server_textDocumentDidChange_vls_server_notification_handler);
	_tmp42_ = self->priv->call_handlers;
	_tmp43_ = g_strdup ("textDocument/documentSymbol");
	g_hash_table_insert (_tmp42_, _tmp43_, _vls_server_textDocumentDocumentSymbol_vls_server_call_handler);
	_tmp44_ = self->priv->call_handlers;
	_tmp45_ = g_strdup ("textDocument/completion");
	g_hash_table_insert (_tmp44_, _tmp45_, _vls_server_textDocumentCompletion_vls_server_call_handler);
	_tmp46_ = self->priv->call_handlers;
	_tmp47_ = g_strdup ("textDocument/signatureHelp");
	g_hash_table_insert (_tmp46_, _tmp47_, _vls_server_textDocumentSignatureHelp_vls_server_call_handler);
	_tmp48_ = self->priv->call_handlers;
	_tmp49_ = g_strdup ("textDocument/hover");
	g_hash_table_insert (_tmp48_, _tmp49_, _vls_server_textDocumentHover_vls_server_call_handler);
	_tmp50_ = self->priv->call_handlers;
	_tmp51_ = g_strdup ("textDocument/references");
	g_hash_table_insert (_tmp50_, _tmp51_, _vls_server_textDocumentReferences_vls_server_call_handler);
	_tmp52_ = self->priv->call_handlers;
	_tmp53_ = g_strdup ("textDocument/documentHighlight");
	g_hash_table_insert (_tmp52_, _tmp53_, _vls_server_textDocumentReferences_vls_server_call_handler);
	_tmp54_ = self->priv->call_handlers;
	_tmp55_ = g_strdup ("textDocument/implementation");
	g_hash_table_insert (_tmp54_, _tmp55_, _vls_server_textDocumentImplementation_vls_server_call_handler);
	_tmp56_ = self->priv->call_handlers;
	_tmp57_ = g_strdup ("workspace/symbol");
	g_hash_table_insert (_tmp56_, _tmp57_, _vls_server_handle_workspace_symbol_request_vls_server_call_handler);
	_tmp58_ = self->priv->call_handlers;
	_tmp59_ = g_strdup ("textDocument/rename");
	g_hash_table_insert (_tmp58_, _tmp59_, _vls_server_textDocumentRename_vls_server_call_handler);
	_tmp60_ = self->priv->call_handlers;
	_tmp61_ = g_strdup ("textDocument/prepareRename");
	g_hash_table_insert (_tmp60_, _tmp61_, _vls_server_textDocumentPrepareRename_vls_server_call_handler);
	_tmp62_ = self->priv->call_handlers;
	_tmp63_ = g_strdup ("textDocument/codeLens");
	g_hash_table_insert (_tmp62_, _tmp63_, _vls_server_handle_code_lens_request_vls_server_call_handler);
	_tmp64_ = self->priv->notif_handlers;
	_tmp65_ = g_strdup ("$/cancelRequest");
	g_hash_table_insert (_tmp64_, _tmp65_, _vls_server_cancelRequest_vls_server_notification_handler);
	g_debug ("server.vala:185: Finished constructing");
	_g_object_unref0 (output_stream);
	_g_object_unref0 (input_stream);
	return self;
}

VlsServer*
vls_server_new (GMainLoop* loop)
{
	return vls_server_construct (VLS_TYPE_SERVER, loop);
}

static gpointer
_g_variant_ref0 (gpointer self)
{
	return self ? g_variant_ref (self) : NULL;
}

GVariant*
vls_server_buildDict (VlsServer* self,
                      ...)
{
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* _tmp3_;
	va_list l = {0};
	GVariantBuilder* _tmp12_;
	GVariant* _tmp13_;
	GVariant* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_variant_type_new ("a{sv}");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_builder_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	builder = _tmp3_;
	va_start (l, self);
	while (TRUE) {
		gchar* key = NULL;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		GVariant* val = NULL;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
		GVariantBuilder* _tmp9_;
		const gchar* _tmp10_;
		GVariant* _tmp11_;
		_tmp4_ = va_arg (l, gchar*);
		_tmp5_ = g_strdup (_tmp4_);
		key = _tmp5_;
		_tmp6_ = key;
		if (_tmp6_ == NULL) {
			_g_free0 (key);
			break;
		}
		_tmp7_ = va_arg (l, GVariant*);
		_tmp8_ = _g_variant_ref0 (_tmp7_);
		val = _tmp8_;
		_tmp9_ = builder;
		_tmp10_ = key;
		_tmp11_ = val;
		g_variant_builder_add (_tmp9_, "{sv}", _tmp10_, _tmp11_, NULL);
		_g_variant_unref0 (val);
		_g_free0 (key);
	}
	_tmp12_ = builder;
	_tmp13_ = g_variant_builder_end (_tmp12_);
	g_variant_ref_sink (_tmp13_);
	result = _tmp13_;
	va_end (l);
	_g_variant_builder_unref0 (builder);
	return result;
}

static void
vls_server_showMessage (VlsServer* self,
                        JsonrpcClient* client,
                        const gchar* message,
                        LspMessageType type)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (message != NULL);
	if (type == LSP_MESSAGE_TYPE_Error) {
		g_warning ("server.vala:205: %s", message);
	}
	{
		GVariant* _tmp0_;
		GVariant* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		GCancellable* _tmp6_;
		_tmp0_ = g_variant_new_int16 ((gint16) type);
		g_variant_ref_sink (_tmp0_);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_variant_new_string (message);
		g_variant_ref_sink (_tmp2_);
		_tmp3_ = _tmp2_;
		_tmp4_ = vls_server_buildDict (self, "type", _tmp1_, "message", _tmp3_, NULL);
		_tmp5_ = _tmp4_;
		_tmp6_ = vls_server_cancellable;
		jsonrpc_client_send_notification (client, "window/showMessage", _tmp5_, _tmp6_, &_inner_error0_);
		_g_variant_unref0 (_tmp5_);
		_g_variant_unref0 (_tmp3_);
		_g_variant_unref0 (_tmp1_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		_tmp9_ = string_to_string (_tmp8_);
		_tmp10_ = g_strconcat ("showMessage: failed to notify client: ", _tmp9_, NULL);
		_tmp11_ = _tmp10_;
		g_debug ("server.vala:212: %s", _tmp11_);
		_g_free0 (_tmp11_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static inline GRegex*
_thread_safe_regex_init (GRegex** re,
                         const gchar * pattern,
                         GRegexCompileFlags compile_flags)
{
	if (g_once_init_enter ((gsize*) re)) {
		GRegex* val = g_regex_new (pattern, compile_flags, 0, NULL);
		g_once_init_leave ((gsize*) re, (gsize) val);
	}
	return *re;
}

static guint
_vls_util_file_hash_gee_hash_data_func (gconstpointer v,
                                        gpointer self)
{
	guint result;
	result = vls_util_file_hash ((GFile*) v);
	return result;
}

static gboolean
_vls_util_file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self)
{
	gboolean result;
	result = vls_util_file_equal ((GFile*) a, (GFile*) b);
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
__lambda38_ (VlsServer* self)
{
	gboolean result;
	vls_server_check_update_context (self);
	result = !self->priv->shutting_down;
	return result;
}

static gboolean
___lambda38__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda38_ ((VlsServer*) self);
	return result;
}

static void
_vala_array_add13 (guint* * array,
                   gint* length,
                   gint* size,
                   guint value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (guint, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
_vls_server_project_changed_event_vls_project_changed (VlsProject* _sender,
                                                       gpointer self)
{
	vls_server_project_changed_event ((VlsServer*) self);
}

static void
vls_server_initialize (VlsServer* self,
                       JsonrpcServer* _self_,
                       JsonrpcClient* client,
                       const gchar* method,
                       GVariant* id,
                       GVariant* params)
{
	gpointer _tmp0_;
	GFile* root_dir = NULL;
	LspInitializeParams* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp18_;
	gchar* root_path = NULL;
	GFile* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GFile* meson_file = NULL;
	GFile* _tmp84_;
	GFile* _tmp85_;
	GeeArrayList* cc_files = NULL;
	GeeArrayList* _tmp86_;
	GeeArrayList* new_projects = NULL;
	GeeArrayList* _tmp96_;
	VlsProject* backend_project = NULL;
	GFile* _tmp97_;
	GCancellable* _tmp98_;
	gboolean _tmp110_ = FALSE;
	VlsProject* _tmp111_;
	VlsProject* _tmp138_;
	const gchar* _tmp149_;
	VlsDefaultProject* _tmp150_;
	GeeHashSet* packages = NULL;
	GeeHashSet* _tmp176_;
	GeeHashSet* custom_gir_dirs = NULL;
	GeeHashSet* _tmp177_;
	GeeHashSet* _tmp194_;
	GeeHashSet* _tmp195_;
	VlsGirDocumentation* _tmp196_;
	JsonrpcClient* _tmp197_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_INITIALIZE_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	_g_object_unref0 (self->priv->init_params);
	self->priv->init_params = (LspInitializeParams*) _tmp0_;
	_tmp1_ = self->priv->init_params;
	_tmp2_ = lsp_initialize_params_get_rootUri (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NULL) {
		LspInitializeParams* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		GFile* _tmp7_;
		_tmp4_ = self->priv->init_params;
		_tmp5_ = lsp_initialize_params_get_rootUri (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_file_new_for_uri (_tmp6_);
		_g_object_unref0 (root_dir);
		root_dir = _tmp7_;
	} else {
		LspInitializeParams* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		_tmp8_ = self->priv->init_params;
		_tmp9_ = lsp_initialize_params_get_rootPath (_tmp8_);
		_tmp10_ = _tmp9_;
		if (_tmp10_ != NULL) {
			LspInitializeParams* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			GFile* _tmp14_;
			_tmp11_ = self->priv->init_params;
			_tmp12_ = lsp_initialize_params_get_rootPath (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = g_file_new_for_path (_tmp13_);
			_g_object_unref0 (root_dir);
			root_dir = _tmp14_;
		} else {
			gchar* _tmp15_;
			gchar* _tmp16_;
			GFile* _tmp17_;
			_tmp15_ = g_get_current_dir ();
			_tmp16_ = _tmp15_;
			_tmp17_ = g_file_new_for_path (_tmp16_);
			_g_object_unref0 (root_dir);
			root_dir = _tmp17_;
			_g_free0 (_tmp16_);
		}
	}
	_tmp18_ = root_dir;
	if (!g_file_is_native (_tmp18_)) {
		vls_server_showMessage (self, client, "Non-native files not supported", LSP_MESSAGE_TYPE_Error);
		g_error ("server.vala:228: Non-native files not supported");
	}
	_tmp19_ = root_dir;
	_tmp20_ = g_file_get_path (_tmp19_);
	_tmp21_ = (gchar*) _tmp20_;
	_tmp22_ = vls_util_realpath (_tmp21_, NULL);
	_tmp23_ = _tmp22_;
	_g_free0 (_tmp21_);
	root_path = _tmp23_;
	_tmp24_ = root_path;
	_tmp25_ = string_to_string (_tmp24_);
	_tmp26_ = g_strconcat ("[initialize] root path is ", _tmp25_, NULL);
	_tmp27_ = _tmp26_;
	g_debug ("server.vala:231: %s", _tmp27_);
	_g_free0 (_tmp27_);
	{
		GVariant* _tmp28_;
		GVariant* _tmp29_;
		GVariant* _tmp30_;
		GVariant* _tmp31_;
		GVariant* _tmp32_;
		GVariant* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar** _tmp36_;
		gchar** _tmp37_;
		gint _tmp37__length1;
		GVariant* _tmp38_;
		GVariant* _tmp39_;
		GVariant* _tmp40_;
		GVariant* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar** _tmp45_;
		gchar** _tmp46_;
		gint _tmp46__length1;
		GVariant* _tmp47_;
		GVariant* _tmp48_;
		GVariant* _tmp49_;
		GVariant* _tmp50_;
		GVariant* _tmp51_;
		GVariant* _tmp52_;
		GVariant* _tmp53_;
		GVariant* _tmp54_;
		GVariant* _tmp55_;
		GVariant* _tmp56_;
		GVariant* _tmp57_;
		GVariant* _tmp58_;
		GVariant* _tmp59_;
		GVariant* _tmp60_;
		GVariant* _tmp61_;
		GVariant* _tmp62_;
		GVariant* _tmp63_;
		GVariant* _tmp64_;
		GVariant* _tmp65_;
		GVariant* _tmp66_;
		GVariant* _tmp67_;
		GVariant* _tmp68_;
		GVariant* _tmp69_;
		GVariant* _tmp70_;
		GVariant* _tmp71_;
		GVariant* _tmp72_;
		GVariant* _tmp73_;
		GVariant* _tmp74_;
		GVariant* _tmp75_;
		GVariant* _tmp76_;
		GVariant* _tmp77_;
		GVariant* _tmp78_;
		GCancellable* _tmp79_;
		_tmp28_ = g_variant_new_int16 ((gint16) LSP_TEXT_DOCUMENT_SYNC_KIND_Incremental);
		g_variant_ref_sink (_tmp28_);
		_tmp29_ = _tmp28_;
		_tmp30_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp30_);
		_tmp31_ = _tmp30_;
		_tmp32_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp32_);
		_tmp33_ = _tmp32_;
		_tmp34_ = g_strdup (".");
		_tmp35_ = g_strdup (">");
		_tmp36_ = g_new0 (gchar*, 2 + 1);
		_tmp36_[0] = _tmp34_;
		_tmp36_[1] = _tmp35_;
		_tmp37_ = _tmp36_;
		_tmp37__length1 = 2;
		_tmp38_ = g_variant_new_strv (_tmp37_, 2);
		g_variant_ref_sink (_tmp38_);
		_tmp39_ = _tmp38_;
		_tmp40_ = vls_server_buildDict (self, "triggerCharacters", _tmp39_, NULL);
		_tmp41_ = _tmp40_;
		_tmp42_ = g_strdup ("(");
		_tmp43_ = g_strdup ("[");
		_tmp44_ = g_strdup (",");
		_tmp45_ = g_new0 (gchar*, 3 + 1);
		_tmp45_[0] = _tmp42_;
		_tmp45_[1] = _tmp43_;
		_tmp45_[2] = _tmp44_;
		_tmp46_ = _tmp45_;
		_tmp46__length1 = 3;
		_tmp47_ = g_variant_new_strv (_tmp46_, 3);
		g_variant_ref_sink (_tmp47_);
		_tmp48_ = _tmp47_;
		_tmp49_ = vls_server_buildDict (self, "triggerCharacters", _tmp48_, NULL);
		_tmp50_ = _tmp49_;
		_tmp51_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp51_);
		_tmp52_ = _tmp51_;
		_tmp53_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp53_);
		_tmp54_ = _tmp53_;
		_tmp55_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp55_);
		_tmp56_ = _tmp55_;
		_tmp57_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp57_);
		_tmp58_ = _tmp57_;
		_tmp59_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp59_);
		_tmp60_ = _tmp59_;
		_tmp61_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp61_);
		_tmp62_ = _tmp61_;
		_tmp63_ = vls_server_buildDict (self, "prepareProvider", _tmp62_, NULL);
		_tmp64_ = _tmp63_;
		_tmp65_ = g_variant_new_boolean (FALSE);
		g_variant_ref_sink (_tmp65_);
		_tmp66_ = _tmp65_;
		_tmp67_ = vls_server_buildDict (self, "resolveProvider", _tmp66_, NULL);
		_tmp68_ = _tmp67_;
		_tmp69_ = vls_server_buildDict (self, "textDocumentSync", _tmp29_, "definitionProvider", _tmp31_, "documentSymbolProvider", _tmp33_, "completionProvider", _tmp41_, "signatureHelpProvider", _tmp50_, "hoverProvider", _tmp52_, "referencesProvider", _tmp54_, "documentHighlightProvider", _tmp56_, "implementationProvider", _tmp58_, "workspaceSymbolProvider", _tmp60_, "renameProvider", _tmp64_, "codeLensProvider", _tmp68_, NULL);
		_tmp70_ = _tmp69_;
		_tmp71_ = g_variant_new_string ("Vala Language Server");
		g_variant_ref_sink (_tmp71_);
		_tmp72_ = _tmp71_;
		_tmp73_ = g_variant_new_string (CONFIG_PROJECT_VERSION);
		g_variant_ref_sink (_tmp73_);
		_tmp74_ = _tmp73_;
		_tmp75_ = vls_server_buildDict (self, "name", _tmp72_, "version", _tmp74_, NULL);
		_tmp76_ = _tmp75_;
		_tmp77_ = vls_server_buildDict (self, "capabilities", _tmp70_, "serverInfo", _tmp76_, NULL);
		_tmp78_ = _tmp77_;
		_tmp79_ = vls_server_cancellable;
		jsonrpc_client_reply (client, id, _tmp78_, _tmp79_, &_inner_error0_);
		_g_variant_unref0 (_tmp78_);
		_g_variant_unref0 (_tmp76_);
		_g_variant_unref0 (_tmp74_);
		_g_variant_unref0 (_tmp72_);
		_g_variant_unref0 (_tmp70_);
		_g_variant_unref0 (_tmp68_);
		_g_variant_unref0 (_tmp66_);
		_g_variant_unref0 (_tmp64_);
		_g_variant_unref0 (_tmp62_);
		_g_variant_unref0 (_tmp60_);
		_g_variant_unref0 (_tmp58_);
		_g_variant_unref0 (_tmp56_);
		_g_variant_unref0 (_tmp54_);
		_g_variant_unref0 (_tmp52_);
		_g_variant_unref0 (_tmp50_);
		_g_variant_unref0 (_tmp48_);
		_tmp46_ = (_vala_array_free (_tmp46_, _tmp46__length1, (GDestroyNotify) g_free), NULL);
		_g_variant_unref0 (_tmp41_);
		_g_variant_unref0 (_tmp39_);
		_tmp37_ = (_vala_array_free (_tmp37_, _tmp37__length1, (GDestroyNotify) g_free), NULL);
		_g_variant_unref0 (_tmp33_);
		_g_variant_unref0 (_tmp31_);
		_g_variant_unref0 (_tmp29_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp80_;
		const gchar* _tmp81_;
		gchar* _tmp82_;
		gchar* _tmp83_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp80_ = e->message;
		_tmp81_ = string_to_string (_tmp80_);
		_tmp82_ = g_strconcat ("[initialize] failed to reply to client: ", _tmp81_, NULL);
		_tmp83_ = _tmp82_;
		g_error ("server.vala:260: %s", _tmp83_);
		_g_free0 (_tmp83_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (root_path);
		_g_object_unref0 (root_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp84_ = root_dir;
	_tmp85_ = g_file_get_child (_tmp84_, "meson.build");
	meson_file = _tmp85_;
	_tmp86_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp86_) {
		g_object_set_data ((GObject *) _tmp86_, "vala-creation-function", "Vls.Server.initialize");
	}
	cc_files = _tmp86_;
	{
		GeeArrayList* _tmp87_ = NULL;
		GFile* _tmp88_;
		GeeArrayList* _tmp89_;
		GeeArrayList* _tmp90_;
		GeeArrayList* _tmp91_;
		GeeArrayList* _tmp92_;
		GeeArrayList* _tmp93_;
		_tmp88_ = root_dir;
		_tmp89_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
		if (_tmp89_) {
			g_object_set_data ((GObject *) _tmp89_, "vala-creation-function", "Vls.Server.initialize");
		}
		_tmp90_ = _tmp89_;
		_tmp91_ = vls_util_find_files (_tmp88_, _thread_safe_regex_init (&_tmp_regex_0, "compile_commands\\.json", 0), (guint) 2, NULL, _tmp90_, &_inner_error0_);
		_tmp92_ = _tmp91_;
		_g_object_unref0 (_tmp90_);
		_tmp87_ = _tmp92_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
		_tmp93_ = _tmp87_;
		_tmp87_ = NULL;
		_g_object_unref0 (cc_files);
		cc_files = _tmp93_;
		_g_object_unref0 (_tmp87_);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp94_;
		const gchar* _tmp95_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp94_ = e;
		_tmp95_ = _tmp94_->message;
		g_warning ("server.vala:268: could not enumerate root dir - %s", _tmp95_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (cc_files);
		_g_object_unref0 (meson_file);
		_g_free0 (root_path);
		_g_object_unref0 (root_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp96_ = gee_array_list_new (VLS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp96_) {
		g_object_set_data ((GObject *) _tmp96_, "vala-creation-function", "Vls.Server.initialize");
	}
	new_projects = _tmp96_;
	backend_project = NULL;
	_tmp97_ = meson_file;
	_tmp98_ = vls_server_cancellable;
	if (g_file_query_exists (_tmp97_, _tmp98_)) {
		{
			VlsMesonProject* _tmp99_ = NULL;
			const gchar* _tmp100_;
			GCancellable* _tmp101_;
			VlsMesonProject* _tmp102_;
			VlsMesonProject* _tmp103_;
			_tmp100_ = root_path;
			_tmp101_ = vls_server_cancellable;
			_tmp102_ = vls_meson_project_new (_tmp100_, _tmp101_, &_inner_error0_);
			if (_tmp102_) {
				g_object_set_data ((GObject *) _tmp102_, "vala-creation-function", "Vls.Server.initialize");
			}
			_tmp99_ = _tmp102_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch2_g_error;
			}
			_tmp103_ = _tmp99_;
			_tmp99_ = NULL;
			_g_object_unref0 (backend_project);
			backend_project = (VlsProject*) _tmp103_;
			_g_object_unref0 (_tmp99_);
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			GError* _tmp104_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp104_ = e;
			if (!g_error_matches (_tmp104_, VLS_PROJECT_ERROR, VLS_PROJECT_ERROR_VERSION_UNSUPPORTED)) {
				GError* _tmp105_;
				const gchar* _tmp106_;
				const gchar* _tmp107_;
				gchar* _tmp108_;
				gchar* _tmp109_;
				_tmp105_ = e;
				_tmp106_ = _tmp105_->message;
				_tmp107_ = string_to_string (_tmp106_);
				_tmp108_ = g_strconcat ("Failed to initialize Meson project - ", _tmp107_, NULL);
				_tmp109_ = _tmp108_;
				vls_server_showMessage (self, client, _tmp109_, LSP_MESSAGE_TYPE_Error);
				_g_free0 (_tmp109_);
			}
			_g_error_free0 (e);
		}
		__finally2:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (backend_project);
			_g_object_unref0 (new_projects);
			_g_object_unref0 (cc_files);
			_g_object_unref0 (meson_file);
			_g_free0 (root_path);
			_g_object_unref0 (root_dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp111_ = backend_project;
	if (_tmp111_ == NULL) {
		GeeArrayList* _tmp112_;
		gboolean _tmp113_;
		gboolean _tmp114_;
		_tmp112_ = cc_files;
		_tmp113_ = gee_collection_get_is_empty ((GeeCollection*) _tmp112_);
		_tmp114_ = _tmp113_;
		_tmp110_ = !_tmp114_;
	} else {
		_tmp110_ = FALSE;
	}
	if (_tmp110_) {
		{
			GeeArrayList* _cc_file_list = NULL;
			GeeArrayList* _tmp115_;
			gint _cc_file_size = 0;
			GeeArrayList* _tmp116_;
			gint _tmp117_;
			gint _tmp118_;
			gint _cc_file_index = 0;
			_tmp115_ = cc_files;
			_cc_file_list = _tmp115_;
			_tmp116_ = _cc_file_list;
			_tmp117_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp116_);
			_tmp118_ = _tmp117_;
			_cc_file_size = _tmp118_;
			_cc_file_index = -1;
			while (TRUE) {
				gint _tmp119_;
				gint _tmp120_;
				GFile* cc_file = NULL;
				GeeArrayList* _tmp121_;
				gpointer _tmp122_;
				gchar* cc_file_path = NULL;
				GFile* _tmp123_;
				gchar* _tmp124_;
				gchar* _tmp125_;
				gchar* _tmp126_;
				gchar* _tmp127_;
				_cc_file_index = _cc_file_index + 1;
				_tmp119_ = _cc_file_index;
				_tmp120_ = _cc_file_size;
				if (!(_tmp119_ < _tmp120_)) {
					break;
				}
				_tmp121_ = _cc_file_list;
				_tmp122_ = gee_abstract_list_get ((GeeAbstractList*) _tmp121_, _cc_file_index);
				cc_file = (GFile*) _tmp122_;
				_tmp123_ = cc_file;
				_tmp124_ = g_file_get_path (_tmp123_);
				_tmp125_ = _tmp124_;
				_tmp126_ = vls_util_realpath (_tmp125_, NULL);
				_tmp127_ = _tmp126_;
				_g_free0 (_tmp125_);
				cc_file_path = _tmp127_;
				{
					VlsCcProject* _tmp128_ = NULL;
					const gchar* _tmp129_;
					const gchar* _tmp130_;
					GCancellable* _tmp131_;
					VlsCcProject* _tmp132_;
					VlsCcProject* _tmp133_;
					const gchar* _tmp134_;
					_tmp129_ = root_path;
					_tmp130_ = cc_file_path;
					_tmp131_ = vls_server_cancellable;
					_tmp132_ = vls_cc_project_new (_tmp129_, _tmp130_, _tmp131_, &_inner_error0_);
					if (_tmp132_) {
						g_object_set_data ((GObject *) _tmp132_, "vala-creation-function", "Vls.Server.initialize");
					}
					_tmp128_ = _tmp132_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch3_g_error;
					}
					_tmp133_ = _tmp128_;
					_tmp128_ = NULL;
					_g_object_unref0 (backend_project);
					backend_project = (VlsProject*) _tmp133_;
					_tmp134_ = cc_file_path;
					g_debug ("server.vala:290: [initialize] initialized CcProject with %s", _tmp134_);
					_g_object_unref0 (_tmp128_);
					_g_free0 (cc_file_path);
					_g_object_unref0 (cc_file);
					break;
				}
				goto __finally3;
				__catch3_g_error:
				{
					GError* e = NULL;
					const gchar* _tmp135_;
					GError* _tmp136_;
					const gchar* _tmp137_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp135_ = cc_file_path;
					_tmp136_ = e;
					_tmp137_ = _tmp136_->message;
					g_debug ("server.vala:293: [initialize] CcProject failed with %s - %s", _tmp135_, _tmp137_);
					_g_error_free0 (e);
					_g_free0 (cc_file_path);
					_g_object_unref0 (cc_file);
					continue;
				}
				__finally3:
				_g_free0 (cc_file_path);
				_g_object_unref0 (cc_file);
				_g_object_unref0 (backend_project);
				_g_object_unref0 (new_projects);
				_g_object_unref0 (cc_files);
				_g_object_unref0 (meson_file);
				_g_free0 (root_path);
				_g_object_unref0 (root_dir);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	_tmp138_ = backend_project;
	if (_tmp138_ == NULL) {
		GFile* cmake_file = NULL;
		GFile* _tmp139_;
		GFile* _tmp140_;
		GFile* autogen_sh = NULL;
		GFile* _tmp141_;
		GFile* _tmp142_;
		GFile* _tmp143_;
		GCancellable* _tmp144_;
		GFile* _tmp145_;
		GCancellable* _tmp146_;
		_tmp139_ = root_dir;
		_tmp140_ = g_file_get_child (_tmp139_, "CMakeLists.txt");
		cmake_file = _tmp140_;
		_tmp141_ = root_dir;
		_tmp142_ = g_file_get_child (_tmp141_, "autogen.sh");
		autogen_sh = _tmp142_;
		_tmp143_ = cmake_file;
		_tmp144_ = vls_server_cancellable;
		if (g_file_query_exists (_tmp143_, _tmp144_)) {
			vls_server_showMessage (self, client, "CMake build system is not currently supported. Only Meson is. See http" \
"s://github.com/benwaffle/vala-language-server/issues/73", LSP_MESSAGE_TYPE_Warning);
		}
		_tmp145_ = autogen_sh;
		_tmp146_ = vls_server_cancellable;
		if (g_file_query_exists (_tmp145_, _tmp146_)) {
			vls_server_showMessage (self, client, "Autotools build system is not currently supported. Consider switching " \
"to Meson.", LSP_MESSAGE_TYPE_Warning);
		}
		_g_object_unref0 (autogen_sh);
		_g_object_unref0 (cmake_file);
	} else {
		GeeArrayList* _tmp147_;
		VlsProject* _tmp148_;
		_tmp147_ = new_projects;
		_tmp148_ = backend_project;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp147_, _tmp148_);
	}
	_tmp149_ = root_path;
	_tmp150_ = vls_default_project_new (_tmp149_);
	if (_tmp150_) {
		g_object_set_data ((GObject *) _tmp150_, "vala-creation-function", "Vls.Server.initialize");
	}
	_g_object_unref0 (self->priv->default_project);
	self->priv->default_project = _tmp150_;
	{
		GeeArrayList* _project_list = NULL;
		GeeArrayList* _tmp151_;
		gint _project_size = 0;
		GeeArrayList* _tmp152_;
		gint _tmp153_;
		gint _tmp154_;
		gint _project_index = 0;
		_tmp151_ = new_projects;
		_project_list = _tmp151_;
		_tmp152_ = _project_list;
		_tmp153_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp152_);
		_tmp154_ = _tmp153_;
		_project_size = _tmp154_;
		_project_index = -1;
		while (TRUE) {
			gint _tmp155_;
			gint _tmp156_;
			VlsProject* project = NULL;
			GeeArrayList* _tmp157_;
			gpointer _tmp158_;
			_project_index = _project_index + 1;
			_tmp155_ = _project_index;
			_tmp156_ = _project_size;
			if (!(_tmp155_ < _tmp156_)) {
				break;
			}
			_tmp157_ = _project_list;
			_tmp158_ = gee_abstract_list_get ((GeeAbstractList*) _tmp157_, _project_index);
			project = (VlsProject*) _tmp158_;
			{
				VlsProject* _tmp159_;
				g_debug ("server.vala:318: Building project ...");
				_tmp159_ = project;
				vls_project_build_if_stale (_tmp159_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch4_g_error;
				}
				g_debug ("server.vala:320: Publishing diagnostics ...");
				{
					GeeArrayList* _compilation_list = NULL;
					VlsProject* _tmp160_;
					GeeArrayList* _tmp161_;
					gint _compilation_size = 0;
					GeeArrayList* _tmp162_;
					gint _tmp163_;
					gint _tmp164_;
					gint _compilation_index = 0;
					_tmp160_ = project;
					_tmp161_ = vls_project_get_compilations (_tmp160_);
					_compilation_list = _tmp161_;
					_tmp162_ = _compilation_list;
					_tmp163_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp162_);
					_tmp164_ = _tmp163_;
					_compilation_size = _tmp164_;
					_compilation_index = -1;
					while (TRUE) {
						gint _tmp165_;
						gint _tmp166_;
						VlsCompilation* compilation = NULL;
						GeeArrayList* _tmp167_;
						gpointer _tmp168_;
						VlsProject* _tmp169_;
						VlsCompilation* _tmp170_;
						_compilation_index = _compilation_index + 1;
						_tmp165_ = _compilation_index;
						_tmp166_ = _compilation_size;
						if (!(_tmp165_ < _tmp166_)) {
							break;
						}
						_tmp167_ = _compilation_list;
						_tmp168_ = gee_abstract_list_get ((GeeAbstractList*) _tmp167_, _compilation_index);
						compilation = (VlsCompilation*) _tmp168_;
						_tmp169_ = project;
						_tmp170_ = compilation;
						vls_server_publishDiagnostics (self, _tmp169_, _tmp170_, client);
						_g_object_unref0 (compilation);
					}
					_g_object_unref0 (_compilation_list);
				}
			}
			goto __finally4;
			__catch4_g_error:
			{
				GError* e = NULL;
				GError* _tmp171_;
				const gchar* _tmp172_;
				const gchar* _tmp173_;
				gchar* _tmp174_;
				gchar* _tmp175_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp171_ = e;
				_tmp172_ = _tmp171_->message;
				_tmp173_ = string_to_string (_tmp172_);
				_tmp174_ = g_strconcat ("Failed to build project - ", _tmp173_, NULL);
				_tmp175_ = _tmp174_;
				vls_server_showMessage (self, client, _tmp175_, LSP_MESSAGE_TYPE_Error);
				_g_free0 (_tmp175_);
				_g_error_free0 (e);
			}
			__finally4:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (project);
				_g_object_unref0 (backend_project);
				_g_object_unref0 (new_projects);
				_g_object_unref0 (cc_files);
				_g_object_unref0 (meson_file);
				_g_free0 (root_path);
				_g_object_unref0 (root_dir);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_g_object_unref0 (project);
		}
	}
	_tmp176_ = gee_hash_set_new (VALA_TYPE_SOURCE_FILE, (GBoxedCopyFunc) vala_source_file_ref, (GDestroyNotify) vala_source_file_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp176_) {
		g_object_set_data ((GObject *) _tmp176_, "vala-creation-function", "Vls.Server.initialize");
	}
	packages = _tmp176_;
	_tmp177_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
	if (_tmp177_) {
		g_object_set_data ((GObject *) _tmp177_, "vala-creation-function", "Vls.Server.initialize");
	}
	custom_gir_dirs = _tmp177_;
	{
		GeeArrayList* _project_list = NULL;
		GeeArrayList* _tmp178_;
		gint _project_size = 0;
		GeeArrayList* _tmp179_;
		gint _tmp180_;
		gint _tmp181_;
		gint _project_index = 0;
		_tmp178_ = new_projects;
		_project_list = _tmp178_;
		_tmp179_ = _project_list;
		_tmp180_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp179_);
		_tmp181_ = _tmp180_;
		_project_size = _tmp181_;
		_project_index = -1;
		while (TRUE) {
			gint _tmp182_;
			gint _tmp183_;
			VlsProject* project = NULL;
			GeeArrayList* _tmp184_;
			gpointer _tmp185_;
			GeeHashSet* _tmp186_;
			VlsProject* _tmp187_;
			GeeCollection* _tmp188_;
			GeeCollection* _tmp189_;
			GeeHashSet* _tmp190_;
			VlsProject* _tmp191_;
			GeeCollection* _tmp192_;
			GeeCollection* _tmp193_;
			_project_index = _project_index + 1;
			_tmp182_ = _project_index;
			_tmp183_ = _project_size;
			if (!(_tmp182_ < _tmp183_)) {
				break;
			}
			_tmp184_ = _project_list;
			_tmp185_ = gee_abstract_list_get ((GeeAbstractList*) _tmp184_, _project_index);
			project = (VlsProject*) _tmp185_;
			_tmp186_ = packages;
			_tmp187_ = project;
			_tmp188_ = vls_project_get_packages (_tmp187_);
			_tmp189_ = _tmp188_;
			gee_collection_add_all ((GeeCollection*) _tmp186_, _tmp189_);
			_g_object_unref0 (_tmp189_);
			_tmp190_ = custom_gir_dirs;
			_tmp191_ = project;
			_tmp192_ = vls_project_get_custom_gir_dirs (_tmp191_);
			_tmp193_ = _tmp192_;
			gee_collection_add_all ((GeeCollection*) _tmp190_, _tmp193_);
			_g_object_unref0 (_tmp193_);
			_g_object_unref0 (project);
		}
	}
	_tmp194_ = packages;
	_tmp195_ = custom_gir_dirs;
	_tmp196_ = vls_gir_documentation_new ((GeeCollection*) _tmp194_, (GeeCollection*) _tmp195_);
	_vls_gir_documentation_unref0 (self->priv->documentation);
	self->priv->documentation = _tmp196_;
	_tmp197_ = _g_object_ref0 (client);
	_g_object_unref0 (self->priv->update_context_client);
	self->priv->update_context_client = _tmp197_;
	_vala_array_add13 (&self->priv->g_sources, &self->priv->g_sources_length1, &self->priv->_g_sources_size_, g_timeout_add_full (G_PRIORITY_DEFAULT, VLS_SERVER_check_update_context_period_ms, ___lambda38__gsource_func, g_object_ref (self), g_object_unref));
	{
		GeeArrayList* _project_list = NULL;
		GeeArrayList* _tmp198_;
		gint _project_size = 0;
		GeeArrayList* _tmp199_;
		gint _tmp200_;
		gint _tmp201_;
		gint _project_index = 0;
		_tmp198_ = new_projects;
		_project_list = _tmp198_;
		_tmp199_ = _project_list;
		_tmp200_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp199_);
		_tmp201_ = _tmp200_;
		_project_size = _tmp201_;
		_project_index = -1;
		while (TRUE) {
			gint _tmp202_;
			gint _tmp203_;
			VlsProject* project = NULL;
			GeeArrayList* _tmp204_;
			gpointer _tmp205_;
			GHashTable* _tmp206_;
			VlsProject* _tmp207_;
			VlsProject* _tmp208_;
			VlsProject* _tmp209_;
			gulong _tmp210_;
			_project_index = _project_index + 1;
			_tmp202_ = _project_index;
			_tmp203_ = _project_size;
			if (!(_tmp202_ < _tmp203_)) {
				break;
			}
			_tmp204_ = _project_list;
			_tmp205_ = gee_abstract_list_get ((GeeAbstractList*) _tmp204_, _project_index);
			project = (VlsProject*) _tmp205_;
			_tmp206_ = self->priv->projects;
			_tmp207_ = project;
			_tmp208_ = _g_object_ref0 (_tmp207_);
			_tmp209_ = project;
			_tmp210_ = g_signal_connect_object (_tmp209_, "changed", (GCallback) _vls_server_project_changed_event_vls_project_changed, self, 0);
			g_hash_table_insert (_tmp206_, _tmp208_, (gpointer) ((guintptr) _tmp210_));
			_g_object_unref0 (project);
		}
	}
	_g_object_unref0 (custom_gir_dirs);
	_g_object_unref0 (packages);
	_g_object_unref0 (backend_project);
	_g_object_unref0 (new_projects);
	_g_object_unref0 (cc_files);
	_g_object_unref0 (meson_file);
	_g_free0 (root_path);
	_g_object_unref0 (root_dir);
}

static void
vls_server_project_changed_event (VlsServer* self)
{
	JsonrpcClient* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->update_context_client;
	vls_server_request_context_update (self, _tmp0_);
	g_debug ("server.vala:351: requested context update for project change event");
}

static void
vls_server_cancelRequest (VlsServer* self,
                          JsonrpcClient* client,
                          GVariant* params)
{
	GVariant* id = NULL;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	VlsRequest* req = NULL;
	GVariant* _tmp2_;
	VlsRequest* _tmp3_;
	GeeHashSet* _tmp4_;
	VlsRequest* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = g_variant_lookup_value (params, "id", NULL);
	id = _tmp0_;
	_tmp1_ = id;
	if (_tmp1_ == NULL) {
		_g_variant_unref0 (id);
		return;
	}
	_tmp2_ = id;
	_tmp3_ = vls_request_new (_tmp2_, NULL);
	if (_tmp3_) {
		g_object_set_data ((GObject *) _tmp3_, "vala-creation-function", "Vls.Server.cancelRequest");
	}
	req = _tmp3_;
	_tmp4_ = self->priv->pending_requests;
	_tmp5_ = req;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp4_, _tmp5_);
	_g_object_unref0 (req);
	_g_variant_unref0 (id);
}

void
vls_server_reply_null (GVariant* id,
                       JsonrpcClient* client,
                       const gchar* method)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (id != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	{
		const GVariantType* _tmp0_;
		GVariant* _tmp1_;
		GVariant* _tmp2_;
		GCancellable* _tmp3_;
		_tmp0_ = G_VARIANT_TYPE_VARIANT;
		_tmp1_ = g_variant_new_maybe (_tmp0_, NULL);
		g_variant_ref_sink (_tmp1_);
		_tmp2_ = _tmp1_;
		_tmp3_ = vls_server_cancellable;
		jsonrpc_client_reply (client, id, _tmp2_, _tmp3_, &_inner_error0_);
		_g_variant_unref0 (_tmp2_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = string_to_string (method);
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		_tmp7_ = string_to_string (_tmp6_);
		_tmp8_ = g_strconcat ("[", _tmp4_, "] failed to reply to client: ", _tmp7_, NULL);
		_tmp9_ = _tmp8_;
		g_debug ("server.vala:371: %s", _tmp9_);
		_g_free0 (_tmp9_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static gchar*
_variant_get1 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static gchar*
_variant_get2 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static gchar*
_variant_get3 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static gpointer
_vala_source_file_ref0 (gpointer self)
{
	return self ? vala_source_file_ref (self) : NULL;
}

static void
vls_server_textDocumentDidOpen (VlsServer* self,
                                JsonrpcClient* client,
                                GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gchar* uri = NULL;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* languageId = NULL;
	GVariant* _tmp8_;
	const GVariantType* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* fileContents = NULL;
	GVariant* _tmp14_;
	const GVariantType* _tmp15_;
	GVariant* _tmp16_;
	GVariant* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_ = FALSE;
	const gchar* _tmp21_;
	const gchar* _tmp27_;
	VlsPair* doc_w_bt = NULL;
	GHashTable* _tmp28_;
	guint _tmp29_ = 0;
	gconstpointer* _tmp30_;
	VlsPair* _tmp44_;
	VlsPair* _tmp67_;
	ValaSourceFile* doc = NULL;
	VlsPair* _tmp69_;
	gconstpointer _tmp70_;
	gconstpointer _tmp71_;
	ValaSourceFile* _tmp72_;
	ValaSourceFile* _tmp73_;
	const gchar* _tmp74_;
	const gchar* _tmp75_;
	ValaSourceFile* _tmp77_;
	GeeHashSet* _tmp100_;
	const gchar* _tmp101_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
	document = _tmp1_;
	_tmp2_ = document;
	_tmp3_ = G_VARIANT_TYPE_STRING;
	_tmp4_ = g_variant_lookup_value (_tmp2_, "uri", _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _variant_get1 (_tmp5_);
	_tmp7_ = _tmp6_;
	_g_variant_unref0 (_tmp5_);
	uri = _tmp7_;
	_tmp8_ = document;
	_tmp9_ = G_VARIANT_TYPE_STRING;
	_tmp10_ = g_variant_lookup_value (_tmp8_, "languageId", _tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = _variant_get2 (_tmp11_);
	_tmp13_ = _tmp12_;
	_g_variant_unref0 (_tmp11_);
	languageId = _tmp13_;
	_tmp14_ = document;
	_tmp15_ = G_VARIANT_TYPE_STRING;
	_tmp16_ = g_variant_lookup_value (_tmp14_, "text", _tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = _variant_get3 (_tmp17_);
	_tmp19_ = _tmp18_;
	_g_variant_unref0 (_tmp17_);
	fileContents = _tmp19_;
	_tmp21_ = languageId;
	if (g_strcmp0 (_tmp21_, "vala") != 0) {
		const gchar* _tmp22_;
		_tmp22_ = languageId;
		_tmp20_ = g_strcmp0 (_tmp22_, "genie") != 0;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		_tmp23_ = languageId;
		_tmp24_ = string_to_string (_tmp23_);
		_tmp25_ = g_strconcat ("[textDocument/didOpen] ", _tmp24_, " file sent to vala language server", NULL);
		_tmp26_ = _tmp25_;
		g_warning ("server.vala:383: %s", _tmp26_);
		_g_free0 (_tmp26_);
		_g_free0 (fileContents);
		_g_free0 (languageId);
		_g_free0 (uri);
		_g_variant_unref0 (document);
		return;
	}
	_tmp27_ = uri;
	if (_tmp27_ == NULL) {
		g_warning ("server.vala:388: %s", "[textDocument/didOpen] null URI sent to vala language server");
		_g_free0 (fileContents);
		_g_free0 (languageId);
		_g_free0 (uri);
		_g_variant_unref0 (document);
		return;
	}
	doc_w_bt = NULL;
	_tmp28_ = self->priv->projects;
	_tmp30_ = g_hash_table_get_keys_as_array (_tmp28_, &_tmp29_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp30_;
		project_collection_length1 = _tmp29_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				{
					GeeArrayList* _tmp31_ = NULL;
					VlsProject* _tmp32_;
					const gchar* _tmp33_;
					const gchar* _tmp34_;
					GCancellable* _tmp35_;
					GeeArrayList* _tmp36_;
					gpointer _tmp37_;
					_tmp32_ = project;
					_tmp33_ = uri;
					_tmp34_ = fileContents;
					_tmp35_ = vls_server_cancellable;
					_tmp36_ = vls_project_open (_tmp32_, _tmp33_, _tmp34_, _tmp35_, &_inner_error0_);
					_tmp31_ = _tmp36_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
					_tmp37_ = gee_list_first ((GeeList*) _tmp31_);
					_g_object_unref0 (doc_w_bt);
					doc_w_bt = (VlsPair*) _tmp37_;
					_g_object_unref0 (_tmp31_);
					break;
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp38_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp38_ = e;
					if (!g_error_matches (_tmp38_, VLS_PROJECT_ERROR, VLS_PROJECT_ERROR_NOT_FOUND)) {
						const gchar* _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
						GError* _tmp42_;
						const gchar* _tmp43_;
						_tmp39_ = uri;
						_tmp40_ = g_uri_unescape_string (_tmp39_, NULL);
						_tmp41_ = _tmp40_;
						_tmp42_ = e;
						_tmp43_ = _tmp42_->message;
						g_warning ("server.vala:400: [textDocument/didOpen] failed to open %s - %s", _tmp41_, _tmp43_);
						_g_free0 (_tmp41_);
					}
					_g_error_free0 (e);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					project_collection = (g_free (project_collection), NULL);
					_g_object_unref0 (doc_w_bt);
					_g_free0 (fileContents);
					_g_free0 (languageId);
					_g_free0 (uri);
					_g_variant_unref0 (document);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp44_ = doc_w_bt;
	if (_tmp44_ == NULL) {
		{
			GeeArrayList* _tmp45_ = NULL;
			VlsDefaultProject* _tmp46_;
			const gchar* _tmp47_;
			const gchar* _tmp48_;
			GCancellable* _tmp49_;
			GeeArrayList* _tmp50_;
			gpointer _tmp51_;
			_tmp46_ = self->priv->default_project;
			_tmp47_ = uri;
			_tmp48_ = fileContents;
			_tmp49_ = vls_server_cancellable;
			_tmp50_ = vls_project_open ((VlsProject*) _tmp46_, _tmp47_, _tmp48_, _tmp49_, &_inner_error0_);
			_tmp45_ = _tmp50_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
			_tmp51_ = gee_list_first ((GeeList*) _tmp45_);
			_g_object_unref0 (doc_w_bt);
			doc_w_bt = (VlsPair*) _tmp51_;
			{
				GeeIterator* _pkg_it = NULL;
				VlsDefaultProject* _tmp52_;
				GeeCollection* _tmp53_;
				GeeCollection* _tmp54_;
				GeeIterator* _tmp55_;
				GeeIterator* _tmp56_;
				_tmp52_ = self->priv->default_project;
				_tmp53_ = vls_project_get_packages ((VlsProject*) _tmp52_);
				_tmp54_ = _tmp53_;
				_tmp55_ = gee_iterable_iterator ((GeeIterable*) _tmp54_);
				_tmp56_ = _tmp55_;
				_g_object_unref0 (_tmp54_);
				_pkg_it = _tmp56_;
				while (TRUE) {
					GeeIterator* _tmp57_;
					ValaSourceFile* pkg = NULL;
					GeeIterator* _tmp58_;
					gpointer _tmp59_;
					VlsGirDocumentation* _tmp60_;
					ValaSourceFile* _tmp61_;
					_tmp57_ = _pkg_it;
					if (!gee_iterator_next (_tmp57_)) {
						break;
					}
					_tmp58_ = _pkg_it;
					_tmp59_ = gee_iterator_get (_tmp58_);
					pkg = (ValaSourceFile*) _tmp59_;
					_tmp60_ = self->priv->documentation;
					_tmp61_ = pkg;
					vls_gir_documentation_add_package_from_source_file (_tmp60_, _tmp61_);
					_vala_source_file_unref0 (pkg);
				}
				_g_object_unref0 (_pkg_it);
			}
			vls_server_request_context_update (self, client);
			_g_object_unref0 (_tmp45_);
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp62_;
			gchar* _tmp63_;
			gchar* _tmp64_;
			GError* _tmp65_;
			const gchar* _tmp66_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp62_ = uri;
			_tmp63_ = g_uri_unescape_string (_tmp62_, NULL);
			_tmp64_ = _tmp63_;
			_tmp65_ = e;
			_tmp66_ = _tmp65_->message;
			g_warning ("server.vala:415: [textDocumnt/didOpen] failed to open %s - %s", _tmp64_, _tmp66_);
			_g_free0 (_tmp64_);
			_g_error_free0 (e);
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (doc_w_bt);
			_g_free0 (fileContents);
			_g_free0 (languageId);
			_g_free0 (uri);
			_g_variant_unref0 (document);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp67_ = doc_w_bt;
	if (_tmp67_ == NULL) {
		const gchar* _tmp68_;
		_tmp68_ = uri;
		g_warning ("server.vala:420: [textDocument/didOpen] could not open %s", _tmp68_);
		_g_object_unref0 (doc_w_bt);
		_g_free0 (fileContents);
		_g_free0 (languageId);
		_g_free0 (uri);
		_g_variant_unref0 (document);
		return;
	}
	_tmp69_ = doc_w_bt;
	_tmp70_ = vls_pair_get_first (_tmp69_);
	_tmp71_ = _tmp70_;
	_tmp72_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp71_);
	doc = _tmp72_;
	_tmp73_ = doc;
	_tmp74_ = vala_source_file_get_content (_tmp73_);
	_tmp75_ = _tmp74_;
	if (_tmp75_ == NULL) {
		ValaSourceFile* _tmp76_;
		_tmp76_ = doc;
		vala_source_file_get_mapped_contents (_tmp76_);
	}
	_tmp77_ = doc;
	if (VLS_IS_TEXT_DOCUMENT (_tmp77_)) {
		VlsTextDocument* tdoc = NULL;
		ValaSourceFile* _tmp78_;
		VlsTextDocument* _tmp79_;
		const gchar* _tmp80_;
		gchar* _tmp81_;
		gchar* _tmp82_;
		const gchar* _tmp83_;
		gchar* _tmp84_;
		gchar* _tmp85_;
		VlsTextDocument* _tmp86_;
		const gchar* _tmp87_;
		VlsTextDocument* _tmp88_;
		const gchar* _tmp89_;
		const gchar* _tmp90_;
		const gchar* _tmp91_;
		_tmp78_ = doc;
		_tmp79_ = _vala_source_file_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument));
		tdoc = _tmp79_;
		_tmp80_ = uri;
		_tmp81_ = g_uri_unescape_string (_tmp80_, NULL);
		_tmp82_ = _tmp81_;
		_tmp83_ = string_to_string (_tmp82_);
		_tmp84_ = g_strconcat ("[textDocument/didOpen] opened ", _tmp83_, NULL);
		_tmp85_ = _tmp84_;
		g_debug ("server.vala:432: %s", _tmp85_);
		_g_free0 (_tmp85_);
		_g_free0 (_tmp82_);
		_tmp86_ = tdoc;
		_tmp87_ = fileContents;
		vls_text_document_set_last_saved_content (_tmp86_, _tmp87_);
		_tmp88_ = tdoc;
		_tmp89_ = vala_source_file_get_content ((ValaSourceFile*) _tmp88_);
		_tmp90_ = _tmp89_;
		_tmp91_ = fileContents;
		if (g_strcmp0 (_tmp90_, _tmp91_) != 0) {
			VlsTextDocument* _tmp92_;
			const gchar* _tmp93_;
			_tmp92_ = tdoc;
			_tmp93_ = fileContents;
			vala_source_file_set_content ((ValaSourceFile*) _tmp92_, _tmp93_);
			vls_server_request_context_update (self, client);
			g_debug ("server.vala:437: %s", "[textDocument/didOpen] requested context update");
		}
		_vala_source_file_unref0 (tdoc);
	} else {
		const gchar* _tmp94_;
		gchar* _tmp95_;
		gchar* _tmp96_;
		const gchar* _tmp97_;
		gchar* _tmp98_;
		gchar* _tmp99_;
		_tmp94_ = uri;
		_tmp95_ = g_uri_unescape_string (_tmp94_, NULL);
		_tmp96_ = _tmp95_;
		_tmp97_ = string_to_string (_tmp96_);
		_tmp98_ = g_strconcat ("[textDocument/didOpen] opened read-only ", _tmp97_, NULL);
		_tmp99_ = _tmp98_;
		g_debug ("server.vala:440: %s", _tmp99_);
		_g_free0 (_tmp99_);
		_g_free0 (_tmp96_);
	}
	_tmp100_ = self->priv->open_files;
	_tmp101_ = uri;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp100_, _tmp101_);
	_vala_source_file_unref0 (doc);
	_g_object_unref0 (doc_w_bt);
	_g_free0 (fileContents);
	_g_free0 (languageId);
	_g_free0 (uri);
	_g_variant_unref0 (document);
}

static gchar*
_variant_get4 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static VlsProject**
_vala_array_dup12 (VlsProject** self,
                   gssize length)
{
	if (length >= 0) {
		VlsProject** result;
		gssize i;
		result = g_new0 (VlsProject*, length + 1);
		for (i = 0; i < length; i++) {
			VlsProject* _tmp0_;
			_tmp0_ = _g_object_ref0 (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_vala_array_add14 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (VlsProject*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
vls_server_textDocumentDidSave (VlsServer* self,
                                JsonrpcClient* client,
                                GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gchar* uri = NULL;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	VlsProject** all_projects = NULL;
	GHashTable* _tmp9_;
	guint _tmp10_ = 0;
	gconstpointer* _tmp11_;
	VlsProject** _tmp12_;
	gint _tmp12__length1;
	gint all_projects_length1;
	gint _all_projects_size_;
	VlsDefaultProject* _tmp13_;
	VlsProject* _tmp14_;
	VlsProject** _tmp15_;
	gint _tmp15__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
	document = _tmp1_;
	_tmp2_ = document;
	_tmp3_ = G_VARIANT_TYPE_STRING;
	_tmp4_ = g_variant_lookup_value (_tmp2_, "uri", _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _variant_get4 (_tmp5_);
	_tmp7_ = _tmp6_;
	_g_variant_unref0 (_tmp5_);
	uri = _tmp7_;
	_tmp8_ = uri;
	if (_tmp8_ == NULL) {
		g_warning ("server.vala:452: %s", "[textDocument/didSave] null URI sent to vala language server");
		_g_free0 (uri);
		_g_variant_unref0 (document);
		return;
	}
	_tmp9_ = self->priv->projects;
	_tmp11_ = g_hash_table_get_keys_as_array (_tmp9_, &_tmp10_);
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup12 (_tmp11_, _tmp10_) : _tmp11_;
	_tmp12__length1 = _tmp10_;
	_tmp11_ = (g_free (_tmp11_), NULL);
	all_projects = _tmp12_;
	all_projects_length1 = _tmp12__length1;
	_all_projects_size_ = all_projects_length1;
	_tmp13_ = self->priv->default_project;
	_tmp14_ = _g_object_ref0 ((VlsProject*) _tmp13_);
	_vala_array_add14 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp14_);
	_tmp15_ = all_projects;
	_tmp15__length1 = all_projects_length1;
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp15_;
		project_collection_length1 = _tmp15__length1;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* _tmp16_;
			VlsProject* project = NULL;
			_tmp16_ = _g_object_ref0 (project_collection[project_it]);
			project = _tmp16_;
			{
				{
					GeeArrayList* _pair_list = NULL;
					VlsProject* _tmp17_;
					const gchar* _tmp18_;
					GeeArrayList* _tmp19_;
					gint _pair_size = 0;
					GeeArrayList* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
					gint _pair_index = 0;
					_tmp17_ = project;
					_tmp18_ = uri;
					_tmp19_ = vls_project_lookup_compile_input_source_file (_tmp17_, _tmp18_);
					_pair_list = _tmp19_;
					_tmp20_ = _pair_list;
					_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
					_tmp22_ = _tmp21_;
					_pair_size = _tmp22_;
					_pair_index = -1;
					while (TRUE) {
						gint _tmp23_;
						gint _tmp24_;
						VlsPair* pair = NULL;
						GeeArrayList* _tmp25_;
						gpointer _tmp26_;
						VlsTextDocument* text_document = NULL;
						VlsPair* _tmp27_;
						gconstpointer _tmp28_;
						gconstpointer _tmp29_;
						ValaSourceFile* _tmp30_;
						VlsTextDocument* _tmp31_;
						VlsTextDocument* _tmp32_;
						VlsTextDocument* _tmp33_;
						VlsTextDocument* _tmp34_;
						const gchar* _tmp35_;
						const gchar* _tmp36_;
						const gchar* _tmp37_;
						VlsTextDocument* _tmp38_;
						gint _tmp39_;
						gint _tmp40_;
						_pair_index = _pair_index + 1;
						_tmp23_ = _pair_index;
						_tmp24_ = _pair_size;
						if (!(_tmp23_ < _tmp24_)) {
							break;
						}
						_tmp25_ = _pair_list;
						_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) _tmp25_, _pair_index);
						pair = (VlsPair*) _tmp26_;
						_tmp27_ = pair;
						_tmp28_ = vls_pair_get_first (_tmp27_);
						_tmp29_ = _tmp28_;
						_tmp30_ = (ValaSourceFile*) _tmp29_;
						_tmp31_ = _vala_source_file_ref0 (VLS_IS_TEXT_DOCUMENT (_tmp30_) ? ((VlsTextDocument*) _tmp30_) : NULL);
						text_document = _tmp31_;
						_tmp32_ = text_document;
						if (_tmp32_ == NULL) {
							g_warning ("server.vala:464: [textDocument/didSave] ignoring save to system file");
							_vala_source_file_unref0 (text_document);
							_g_object_unref0 (pair);
							continue;
						}
						_tmp33_ = text_document;
						_tmp34_ = text_document;
						_tmp35_ = vala_source_file_get_content ((ValaSourceFile*) _tmp34_);
						_tmp36_ = _tmp35_;
						vls_text_document_set_last_saved_content (_tmp33_, _tmp36_);
						_tmp37_ = uri;
						_tmp38_ = text_document;
						_tmp39_ = vls_text_document_get_last_saved_version (_tmp38_);
						_tmp40_ = _tmp39_;
						g_debug ("server.vala:470: [textDocument/didSave] last save of %s is now at vers" \
"ion %d", _tmp37_, _tmp40_);
						_vala_source_file_unref0 (text_document);
						_g_object_unref0 (pair);
					}
					_g_object_unref0 (_pair_list);
				}
				_g_object_unref0 (project);
			}
		}
	}
	all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_free0 (uri);
	_g_variant_unref0 (document);
}

static gchar*
_variant_get5 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static VlsProject**
_vala_array_dup13 (VlsProject** self,
                   gssize length)
{
	if (length >= 0) {
		VlsProject** result;
		gssize i;
		result = g_new0 (VlsProject*, length + 1);
		for (i = 0; i < length; i++) {
			VlsProject* _tmp0_;
			_tmp0_ = _g_object_ref0 (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_vala_array_add15 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (VlsProject*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
vls_server_textDocumentDidClose (VlsServer* self,
                                 JsonrpcClient* client,
                                 GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gchar* uri = NULL;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	VlsProject** all_projects = NULL;
	GHashTable* _tmp9_;
	guint _tmp10_ = 0;
	gconstpointer* _tmp11_;
	VlsProject** _tmp12_;
	gint _tmp12__length1;
	gint all_projects_length1;
	gint _all_projects_size_;
	VlsDefaultProject* _tmp13_;
	VlsProject* _tmp14_;
	VlsProject** _tmp15_;
	gint _tmp15__length1;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
	document = _tmp1_;
	_tmp2_ = document;
	_tmp3_ = G_VARIANT_TYPE_STRING;
	_tmp4_ = g_variant_lookup_value (_tmp2_, "uri", _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _variant_get5 (_tmp5_);
	_tmp7_ = _tmp6_;
	_g_variant_unref0 (_tmp5_);
	uri = _tmp7_;
	_tmp8_ = uri;
	if (_tmp8_ == NULL) {
		g_warning ("server.vala:480: %s", "[textDocument/didClose] null URI sent to vala language server");
		_g_free0 (uri);
		_g_variant_unref0 (document);
		return;
	}
	_tmp9_ = self->priv->projects;
	_tmp11_ = g_hash_table_get_keys_as_array (_tmp9_, &_tmp10_);
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup13 (_tmp11_, _tmp10_) : _tmp11_;
	_tmp12__length1 = _tmp10_;
	_tmp11_ = (g_free (_tmp11_), NULL);
	all_projects = _tmp12_;
	all_projects_length1 = _tmp12__length1;
	_all_projects_size_ = all_projects_length1;
	_tmp13_ = self->priv->default_project;
	_tmp14_ = _g_object_ref0 ((VlsProject*) _tmp13_);
	_vala_array_add15 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp14_);
	_tmp15_ = all_projects;
	_tmp15__length1 = all_projects_length1;
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp15_;
		project_collection_length1 = _tmp15__length1;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* _tmp16_;
			VlsProject* project = NULL;
			_tmp16_ = _g_object_ref0 (project_collection[project_it]);
			project = _tmp16_;
			{
				{
					gboolean _tmp17_ = FALSE;
					VlsProject* _tmp18_;
					const gchar* _tmp19_;
					const gchar* _tmp22_;
					_tmp18_ = project;
					_tmp19_ = uri;
					_tmp17_ = vls_project_close (_tmp18_, _tmp19_, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
					if (_tmp17_) {
						GeeHashSet* _tmp20_;
						const gchar* _tmp21_;
						_tmp20_ = self->priv->discarded_files;
						_tmp21_ = uri;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
						vls_server_request_context_update (self, client);
						g_debug ("server.vala:492: %s", "[textDocument/didClose] requested context update");
					}
					_tmp22_ = uri;
					g_debug ("server.vala:494: [textDocument/didClose] closed %s", _tmp22_);
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp23_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp23_ = e;
					if (!g_error_matches (_tmp23_, VLS_PROJECT_ERROR, VLS_PROJECT_ERROR_NOT_FOUND)) {
						const gchar* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						GError* _tmp27_;
						const gchar* _tmp28_;
						_tmp24_ = uri;
						_tmp25_ = g_uri_unescape_string (_tmp24_, NULL);
						_tmp26_ = _tmp25_;
						_tmp27_ = e;
						_tmp28_ = _tmp27_->message;
						g_warning ("server.vala:497: [textDocument/didClose] failed to close %s - %s", _tmp26_, _tmp28_);
						_g_free0 (_tmp26_);
					}
					_g_error_free0 (e);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (project);
					all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
					_g_free0 (uri);
					_g_variant_unref0 (document);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
				_g_object_unref0 (project);
			}
		}
	}
	all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_free0 (uri);
	_g_variant_unref0 (document);
}

static gchar*
_variant_get6 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static gint64
_variant_get7 (GVariant* value)
{
	return g_variant_get_int64 (value);
}

static VlsProject**
_vala_array_dup14 (VlsProject** self,
                   gssize length)
{
	if (length >= 0) {
		VlsProject** result;
		gssize i;
		result = g_new0 (VlsProject*, length + 1);
		for (i = 0; i < length; i++) {
			VlsProject* _tmp0_;
			_tmp0_ = _g_object_ref0 (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_vala_array_add16 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (VlsProject*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
vls_server_textDocumentDidChange (VlsServer* self,
                                  JsonrpcClient* client,
                                  GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	GVariant* changes = NULL;
	const GVariantType* _tmp2_;
	GVariant* _tmp3_;
	gchar* uri = NULL;
	GVariant* _tmp4_;
	const GVariantType* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gint64 version = 0LL;
	GVariant* _tmp10_;
	const GVariantType* _tmp11_;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	gint64 _tmp14_;
	gint64 _tmp15_;
	VlsProject** all_projects = NULL;
	GHashTable* _tmp16_;
	guint _tmp17_ = 0;
	gconstpointer* _tmp18_;
	VlsProject** _tmp19_;
	gint _tmp19__length1;
	gint all_projects_length1;
	gint _all_projects_size_;
	VlsDefaultProject* _tmp20_;
	VlsProject* _tmp21_;
	VlsProject** _tmp22_;
	gint _tmp22__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
	document = _tmp1_;
	_tmp2_ = G_VARIANT_TYPE_ARRAY;
	_tmp3_ = g_variant_lookup_value (params, "contentChanges", _tmp2_);
	changes = _tmp3_;
	_tmp4_ = document;
	_tmp5_ = G_VARIANT_TYPE_STRING;
	_tmp6_ = g_variant_lookup_value (_tmp4_, "uri", _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _variant_get6 (_tmp7_);
	_tmp9_ = _tmp8_;
	_g_variant_unref0 (_tmp7_);
	uri = _tmp9_;
	_tmp10_ = document;
	_tmp11_ = G_VARIANT_TYPE_INT64;
	_tmp12_ = g_variant_lookup_value (_tmp10_, "version", _tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = _variant_get7 (_tmp13_);
	_tmp15_ = _tmp14_;
	_g_variant_unref0 (_tmp13_);
	version = _tmp15_;
	_tmp16_ = self->priv->projects;
	_tmp18_ = g_hash_table_get_keys_as_array (_tmp16_, &_tmp17_);
	_tmp19_ = (_tmp18_ != NULL) ? _vala_array_dup14 (_tmp18_, _tmp17_) : _tmp18_;
	_tmp19__length1 = _tmp17_;
	_tmp18_ = (g_free (_tmp18_), NULL);
	all_projects = _tmp19_;
	all_projects_length1 = _tmp19__length1;
	_all_projects_size_ = all_projects_length1;
	_tmp20_ = self->priv->default_project;
	_tmp21_ = _g_object_ref0 ((VlsProject*) _tmp20_);
	_vala_array_add16 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp21_);
	_tmp22_ = all_projects;
	_tmp22__length1 = all_projects_length1;
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp22_;
		project_collection_length1 = _tmp22__length1;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* _tmp23_;
			VlsProject* project = NULL;
			_tmp23_ = _g_object_ref0 (project_collection[project_it]);
			project = _tmp23_;
			{
				{
					GeeArrayList* _pair_list = NULL;
					VlsProject* _tmp24_;
					const gchar* _tmp25_;
					GeeArrayList* _tmp26_;
					gint _pair_size = 0;
					GeeArrayList* _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					gint _pair_index = 0;
					_tmp24_ = project;
					_tmp25_ = uri;
					_tmp26_ = vls_project_lookup_compile_input_source_file (_tmp24_, _tmp25_);
					_pair_list = _tmp26_;
					_tmp27_ = _pair_list;
					_tmp28_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp27_);
					_tmp29_ = _tmp28_;
					_pair_size = _tmp29_;
					_pair_index = -1;
					while (TRUE) {
						gint _tmp30_;
						gint _tmp31_;
						VlsPair* pair = NULL;
						GeeArrayList* _tmp32_;
						gpointer _tmp33_;
						ValaSourceFile* source_file = NULL;
						VlsPair* _tmp34_;
						gconstpointer _tmp35_;
						gconstpointer _tmp36_;
						ValaSourceFile* _tmp37_;
						ValaSourceFile* _tmp38_;
						VlsTextDocument* source = NULL;
						ValaSourceFile* _tmp39_;
						VlsTextDocument* _tmp40_;
						VlsTextDocument* _tmp41_;
						gint _tmp42_;
						gint _tmp43_;
						ValaSourceFile* _tmp50_;
						const gchar* _tmp51_;
						const gchar* _tmp52_;
						GVariantIter* iter = NULL;
						GVariant* _tmp53_;
						GVariantIter* _tmp54_;
						GVariant* elem = NULL;
						GString* sb = NULL;
						VlsTextDocument* _tmp55_;
						const gchar* _tmp56_;
						const gchar* _tmp57_;
						GString* _tmp58_;
						VlsTextDocument* _tmp104_;
						GString* _tmp105_;
						const gchar* _tmp106_;
						VlsTextDocument* _tmp107_;
						GTimeZone* _tmp108_;
						GTimeZone* _tmp109_;
						GDateTime* _tmp110_;
						GDateTime* _tmp111_;
						VlsTextDocument* _tmp112_;
						_pair_index = _pair_index + 1;
						_tmp30_ = _pair_index;
						_tmp31_ = _pair_size;
						if (!(_tmp30_ < _tmp31_)) {
							break;
						}
						_tmp32_ = _pair_list;
						_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp32_, _pair_index);
						pair = (VlsPair*) _tmp33_;
						_tmp34_ = pair;
						_tmp35_ = vls_pair_get_first (_tmp34_);
						_tmp36_ = _tmp35_;
						_tmp37_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp36_);
						source_file = _tmp37_;
						_tmp38_ = source_file;
						if (!VLS_IS_TEXT_DOCUMENT (_tmp38_)) {
							g_warning ("server.vala:521: %s", "[textDocument/didChange] Ignoring change to system file");
							_vala_source_file_unref0 (source_file);
							_g_object_unref0 (pair);
							_g_object_unref0 (_pair_list);
							_g_object_unref0 (project);
							all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
							_g_free0 (uri);
							_g_variant_unref0 (changes);
							_g_variant_unref0 (document);
							return;
						}
						_tmp39_ = source_file;
						_tmp40_ = _vala_source_file_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument));
						source = _tmp40_;
						_tmp41_ = source;
						_tmp42_ = vls_text_document_get_version (_tmp41_);
						_tmp43_ = _tmp42_;
						if (((gint64) _tmp43_) >= version) {
							const gchar* _tmp44_;
							gchar* _tmp45_;
							gchar* _tmp46_;
							const gchar* _tmp47_;
							gchar* _tmp48_;
							gchar* _tmp49_;
							_tmp44_ = uri;
							_tmp45_ = g_uri_unescape_string (_tmp44_, NULL);
							_tmp46_ = _tmp45_;
							_tmp47_ = string_to_string (_tmp46_);
							_tmp48_ = g_strconcat ("[textDocument/didChange] rejecting outdated version of ", _tmp47_, NULL);
							_tmp49_ = _tmp48_;
							g_warning ("server.vala:527: %s", _tmp49_);
							_g_free0 (_tmp49_);
							_g_free0 (_tmp46_);
							_vala_source_file_unref0 (source);
							_vala_source_file_unref0 (source_file);
							_g_object_unref0 (pair);
							_g_object_unref0 (_pair_list);
							_g_object_unref0 (project);
							all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
							_g_free0 (uri);
							_g_variant_unref0 (changes);
							_g_variant_unref0 (document);
							return;
						}
						_tmp50_ = source_file;
						_tmp51_ = vala_source_file_get_content (_tmp50_);
						_tmp52_ = _tmp51_;
						if (_tmp52_ == NULL) {
							g_error ("server.vala:532: %s", "[textDocument/didChange] source content is null!");
						}
						_tmp53_ = changes;
						_tmp54_ = g_variant_iter_new (_tmp53_);
						iter = _tmp54_;
						elem = NULL;
						_tmp55_ = source;
						_tmp56_ = vala_source_file_get_content ((ValaSourceFile*) _tmp55_);
						_tmp57_ = _tmp56_;
						_tmp58_ = g_string_new (_tmp57_);
						sb = _tmp58_;
						while (TRUE) {
							GVariantIter* _tmp59_;
							GVariant* _tmp60_;
							GVariant* _tmp61_;
							LspTextDocumentContentChangeEvent* changeEvent = NULL;
							GVariant* _tmp62_;
							gpointer _tmp63_;
							LspTextDocumentContentChangeEvent* _tmp64_;
							LspRange* _tmp65_;
							LspRange* _tmp66_;
							_tmp59_ = iter;
							_tmp60_ = g_variant_iter_next_value (_tmp59_);
							_g_variant_unref0 (elem);
							elem = _tmp60_;
							_tmp61_ = elem;
							if (!(_tmp61_ != NULL)) {
								break;
							}
							_tmp62_ = elem;
							_tmp63_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp62_);
							changeEvent = (LspTextDocumentContentChangeEvent*) _tmp63_;
							_tmp64_ = changeEvent;
							_tmp65_ = lsp_text_document_content_change_event_get_range (_tmp64_);
							_tmp66_ = _tmp65_;
							if (_tmp66_ == NULL) {
								GString* _tmp67_;
								LspTextDocumentContentChangeEvent* _tmp68_;
								const gchar* _tmp69_;
								const gchar* _tmp70_;
								_tmp67_ = sb;
								_tmp68_ = changeEvent;
								_tmp69_ = lsp_text_document_content_change_event_get_text (_tmp68_);
								_tmp70_ = _tmp69_;
								g_string_assign (_tmp67_, _tmp70_);
							} else {
								LspPosition* start = NULL;
								LspTextDocumentContentChangeEvent* _tmp71_;
								LspRange* _tmp72_;
								LspRange* _tmp73_;
								LspPosition* _tmp74_;
								LspPosition* _tmp75_;
								LspPosition* _tmp76_;
								LspPosition* end = NULL;
								LspTextDocumentContentChangeEvent* _tmp77_;
								LspRange* _tmp78_;
								LspRange* _tmp79_;
								LspPosition* _tmp80_;
								LspPosition* _tmp81_;
								LspPosition* _tmp82_;
								gsize pos_begin = 0UL;
								GString* _tmp83_;
								const gchar* _tmp84_;
								LspPosition* _tmp85_;
								guint _tmp86_;
								guint _tmp87_;
								LspPosition* _tmp88_;
								guint _tmp89_;
								guint _tmp90_;
								gsize pos_end = 0UL;
								GString* _tmp91_;
								const gchar* _tmp92_;
								LspPosition* _tmp93_;
								guint _tmp94_;
								guint _tmp95_;
								LspPosition* _tmp96_;
								guint _tmp97_;
								guint _tmp98_;
								GString* _tmp99_;
								GString* _tmp100_;
								LspTextDocumentContentChangeEvent* _tmp101_;
								const gchar* _tmp102_;
								const gchar* _tmp103_;
								_tmp71_ = changeEvent;
								_tmp72_ = lsp_text_document_content_change_event_get_range (_tmp71_);
								_tmp73_ = _tmp72_;
								_tmp74_ = lsp_range_get_start (_tmp73_);
								_tmp75_ = _tmp74_;
								_tmp76_ = _g_object_ref0 (_tmp75_);
								start = _tmp76_;
								_tmp77_ = changeEvent;
								_tmp78_ = lsp_text_document_content_change_event_get_range (_tmp77_);
								_tmp79_ = _tmp78_;
								_tmp80_ = lsp_range_get_end (_tmp79_);
								_tmp81_ = _tmp80_;
								_tmp82_ = _g_object_ref0 (_tmp81_);
								end = _tmp82_;
								_tmp83_ = sb;
								_tmp84_ = _tmp83_->str;
								_tmp85_ = start;
								_tmp86_ = lsp_position_get_line (_tmp85_);
								_tmp87_ = _tmp86_;
								_tmp88_ = start;
								_tmp89_ = lsp_position_get_character (_tmp88_);
								_tmp90_ = _tmp89_;
								pos_begin = vls_util_get_string_pos (_tmp84_, _tmp87_, _tmp90_);
								_tmp91_ = sb;
								_tmp92_ = _tmp91_->str;
								_tmp93_ = end;
								_tmp94_ = lsp_position_get_line (_tmp93_);
								_tmp95_ = _tmp94_;
								_tmp96_ = end;
								_tmp97_ = lsp_position_get_character (_tmp96_);
								_tmp98_ = _tmp97_;
								pos_end = vls_util_get_string_pos (_tmp92_, _tmp95_, _tmp98_);
								_tmp99_ = sb;
								g_string_erase (_tmp99_, (gssize) pos_begin, (gssize) (pos_end - pos_begin));
								_tmp100_ = sb;
								_tmp101_ = changeEvent;
								_tmp102_ = lsp_text_document_content_change_event_get_text (_tmp101_);
								_tmp103_ = _tmp102_;
								g_string_insert (_tmp100_, (gssize) pos_begin, _tmp103_);
								_g_object_unref0 (end);
								_g_object_unref0 (start);
							}
							_g_object_unref0 (changeEvent);
						}
						_tmp104_ = source;
						_tmp105_ = sb;
						_tmp106_ = _tmp105_->str;
						vala_source_file_set_content ((ValaSourceFile*) _tmp104_, _tmp106_);
						_tmp107_ = source;
						_tmp108_ = g_time_zone_new_local ();
						_tmp109_ = _tmp108_;
						_tmp110_ = g_date_time_new_now (_tmp109_);
						_tmp111_ = _tmp110_;
						vls_text_document_set_last_updated (_tmp107_, _tmp111_);
						_g_date_time_unref0 (_tmp111_);
						_g_time_zone_unref0 (_tmp109_);
						_tmp112_ = source;
						vls_text_document_set_version (_tmp112_, (gint) version);
						vls_server_request_context_update (self, client);
						_g_string_free0 (sb);
						_g_variant_unref0 (elem);
						_g_variant_iter_free0 (iter);
						_vala_source_file_unref0 (source);
						_vala_source_file_unref0 (source_file);
						_g_object_unref0 (pair);
					}
					_g_object_unref0 (_pair_list);
				}
				_g_object_unref0 (project);
			}
		}
	}
	all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_free0 (uri);
	_g_variant_unref0 (changes);
	_g_variant_unref0 (document);
}

/** 
     * Indicate to the server that the code context(s) it is tracking may
     * need to be refreshed.
     * 
     * @param client        the client to eventually send a `publishDiagnostics` 
     *                      notification to, if the context is refreshed
     */
static void
vls_server_request_context_update (VlsServer* self,
                                   JsonrpcClient* client)
{
	JsonrpcClient* _tmp0_;
	gint64 delay_us = 0LL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (self->priv->update_context_client);
	self->priv->update_context_client = _tmp0_;
	self->priv->update_context_requests = self->priv->update_context_requests + 1;
	delay_us = MIN (VLS_SERVER_update_context_delay_inc_us * self->priv->update_context_requests, VLS_SERVER_update_context_delay_max_us);
	self->priv->update_context_time_us = g_get_monotonic_time () + delay_us;
}

/** 
     * Reconfigure the project if needed, and check whether we need to rebuild
     * the project and documentation engine if we have context update requests.
     */
static VlsProject**
_vala_array_dup15 (VlsProject** self,
                   gssize length)
{
	if (length >= 0) {
		VlsProject** result;
		gssize i;
		result = g_new0 (VlsProject*, length + 1);
		for (i = 0; i < length; i++) {
			VlsProject* _tmp0_;
			_tmp0_ = _g_object_ref0 (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_vala_array_add17 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (VlsProject*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar*
_________lambda39_ (VlsServer* self,
                    ValaSourceFile* f)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
	g_return_val_if_fail (f != NULL, NULL);
	_tmp0_ = vala_source_file_get_filename (f);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup (_tmp1_);
	result = _tmp2_;
	_vala_source_file_unref0 (f);
	return result;
}

static gpointer
__________lambda39__gee_map_func (gpointer g,
                                  gpointer self)
{
	gpointer result;
	result = _________lambda39_ ((VlsServer*) self, (ValaSourceFile*) g);
	return result;
}

static void
vls_server_check_update_context (VlsServer* self)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	if (self->priv->update_context_requests > ((gint64) 0)) {
		_tmp0_ = g_get_monotonic_time () >= self->priv->update_context_time_us;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		VlsProject** all_projects = NULL;
		GHashTable* _tmp1_;
		guint _tmp2_ = 0;
		gconstpointer* _tmp3_;
		VlsProject** _tmp4_;
		gint _tmp4__length1;
		gint all_projects_length1;
		gint _all_projects_size_;
		VlsDefaultProject* _tmp5_;
		VlsProject* _tmp6_;
		gboolean reconfigured_projects = FALSE;
		VlsProject** _tmp7_;
		gint _tmp7__length1;
		VlsGirDocumentation* _tmp165_;
		g_debug ("server.vala:583: updating contexts and publishing diagnostics...");
		self->priv->update_context_requests = (gint64) 0;
		self->priv->update_context_time_us = (gint64) 0;
		_tmp1_ = self->priv->projects;
		_tmp3_ = g_hash_table_get_keys_as_array (_tmp1_, &_tmp2_);
		_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup15 (_tmp3_, _tmp2_) : _tmp3_;
		_tmp4__length1 = _tmp2_;
		_tmp3_ = (g_free (_tmp3_), NULL);
		all_projects = _tmp4_;
		all_projects_length1 = _tmp4__length1;
		_all_projects_size_ = all_projects_length1;
		_tmp5_ = self->priv->default_project;
		_tmp6_ = _g_object_ref0 ((VlsProject*) _tmp5_);
		_vala_array_add17 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp6_);
		reconfigured_projects = FALSE;
		_tmp7_ = all_projects;
		_tmp7__length1 = all_projects_length1;
		{
			VlsProject** project_collection = NULL;
			gint project_collection_length1 = 0;
			gint _project_collection_size_ = 0;
			gint project_it = 0;
			project_collection = _tmp7_;
			project_collection_length1 = _tmp7__length1;
			for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
				VlsProject* _tmp8_;
				VlsProject* project = NULL;
				_tmp8_ = _g_object_ref0 (project_collection[project_it]);
				project = _tmp8_;
				{
					{
						gboolean reconfigured = FALSE;
						VlsProject* _tmp9_;
						GCancellable* _tmp10_;
						VlsProject* _tmp11_;
						GCancellable* _tmp12_;
						gboolean _tmp13_ = FALSE;
						_tmp9_ = project;
						_tmp10_ = vls_server_cancellable;
						reconfigured = vls_project_reconfigure_if_stale (_tmp9_, _tmp10_, &_inner_error0_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							goto __catch0_g_error;
						}
						reconfigured_projects |= reconfigured;
						_tmp11_ = project;
						_tmp12_ = vls_server_cancellable;
						vls_project_build_if_stale (_tmp11_, _tmp12_, &_inner_error0_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							goto __catch0_g_error;
						}
						if (reconfigured) {
							VlsProject* _tmp14_;
							VlsDefaultProject* _tmp15_;
							_tmp14_ = project;
							_tmp15_ = self->priv->default_project;
							_tmp13_ = _tmp14_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, VLS_TYPE_PROJECT, VlsProject);
						} else {
							_tmp13_ = FALSE;
						}
						if (_tmp13_) {
							GeeHashSet* newly_added = NULL;
							GeeHashSet* _tmp16_;
							_tmp16_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
							if (_tmp16_) {
								g_object_set_data ((GObject *) _tmp16_, "vala-creation-function", "Vls.Server.check_update_context");
							}
							newly_added = _tmp16_;
							{
								GeeArrayList* _compilation_list = NULL;
								VlsProject* _tmp17_;
								GeeArrayList* _tmp18_;
								gint _compilation_size = 0;
								GeeArrayList* _tmp19_;
								gint _tmp20_;
								gint _tmp21_;
								gint _compilation_index = 0;
								_tmp17_ = project;
								_tmp18_ = vls_project_get_compilations (_tmp17_);
								_compilation_list = _tmp18_;
								_tmp19_ = _compilation_list;
								_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
								_tmp21_ = _tmp20_;
								_compilation_size = _tmp21_;
								_compilation_index = -1;
								while (TRUE) {
									gint _tmp22_;
									gint _tmp23_;
									VlsCompilation* compilation = NULL;
									GeeArrayList* _tmp24_;
									gpointer _tmp25_;
									GeeHashSet* _tmp26_;
									VlsCompilation* _tmp27_;
									GeeCollection* _tmp28_;
									GeeCollection* _tmp29_;
									GeeIterator* _tmp30_;
									GeeIterator* _tmp31_;
									_compilation_index = _compilation_index + 1;
									_tmp22_ = _compilation_index;
									_tmp23_ = _compilation_size;
									if (!(_tmp22_ < _tmp23_)) {
										break;
									}
									_tmp24_ = _compilation_list;
									_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, _compilation_index);
									compilation = (VlsCompilation*) _tmp25_;
									_tmp26_ = newly_added;
									_tmp27_ = compilation;
									_tmp28_ = vls_compilation_get_project_files (_tmp27_);
									_tmp29_ = _tmp28_;
									_tmp30_ = gee_traversable_map ((GeeTraversable*) _tmp29_, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, __________lambda39__gee_map_func, self);
									_tmp31_ = _tmp30_;
									gee_collection_add_all_iterator ((GeeCollection*) _tmp26_, _tmp31_);
									_g_object_unref0 (_tmp31_);
									_g_object_unref0 (_tmp29_);
									_g_object_unref0 (compilation);
								}
								_g_object_unref0 (_compilation_list);
							}
							{
								GeeArrayList* _compilation_list = NULL;
								VlsDefaultProject* _tmp32_;
								GeeArrayList* _tmp33_;
								gint _compilation_size = 0;
								GeeArrayList* _tmp34_;
								gint _tmp35_;
								gint _tmp36_;
								gint _compilation_index = 0;
								_tmp32_ = self->priv->default_project;
								_tmp33_ = vls_project_get_compilations ((VlsProject*) _tmp32_);
								_compilation_list = _tmp33_;
								_tmp34_ = _compilation_list;
								_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
								_tmp36_ = _tmp35_;
								_compilation_size = _tmp36_;
								_compilation_index = -1;
								while (TRUE) {
									gint _tmp37_;
									gint _tmp38_;
									VlsCompilation* compilation = NULL;
									GeeArrayList* _tmp39_;
									gpointer _tmp40_;
									_compilation_index = _compilation_index + 1;
									_tmp37_ = _compilation_index;
									_tmp38_ = _compilation_size;
									if (!(_tmp37_ < _tmp38_)) {
										break;
									}
									_tmp39_ = _compilation_list;
									_tmp40_ = gee_abstract_list_get ((GeeAbstractList*) _tmp39_, _compilation_index);
									compilation = (VlsCompilation*) _tmp40_;
									{
										GeeIterator* _source_file_it = NULL;
										VlsCompilation* _tmp41_;
										GeeCollection* _tmp42_;
										GeeCollection* _tmp43_;
										GeeIterator* _tmp44_;
										GeeIterator* _tmp45_;
										_tmp41_ = compilation;
										_tmp42_ = vls_compilation_get_project_files (_tmp41_);
										_tmp43_ = _tmp42_;
										_tmp44_ = gee_iterable_iterator ((GeeIterable*) _tmp43_);
										_tmp45_ = _tmp44_;
										_g_object_unref0 (_tmp43_);
										_source_file_it = _tmp45_;
										while (TRUE) {
											GeeIterator* _tmp46_;
											ValaSourceFile* source_file = NULL;
											GeeIterator* _tmp47_;
											gpointer _tmp48_;
											GeeHashSet* _tmp49_;
											ValaSourceFile* _tmp50_;
											const gchar* _tmp51_;
											const gchar* _tmp52_;
											_tmp46_ = _source_file_it;
											if (!gee_iterator_next (_tmp46_)) {
												break;
											}
											_tmp47_ = _source_file_it;
											_tmp48_ = gee_iterator_get (_tmp47_);
											source_file = (ValaSourceFile*) _tmp48_;
											_tmp49_ = newly_added;
											_tmp50_ = source_file;
											_tmp51_ = vala_source_file_get_filename (_tmp50_);
											_tmp52_ = _tmp51_;
											if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp49_, _tmp52_)) {
												gchar* uri = NULL;
												ValaSourceFile* _tmp53_;
												const gchar* _tmp54_;
												const gchar* _tmp55_;
												GFile* _tmp56_;
												GFile* _tmp57_;
												gchar* _tmp58_;
												gchar* _tmp59_;
												_tmp53_ = source_file;
												_tmp54_ = vala_source_file_get_filename (_tmp53_);
												_tmp55_ = _tmp54_;
												_tmp56_ = g_file_new_for_path (_tmp55_);
												_tmp57_ = _tmp56_;
												_tmp58_ = g_file_get_uri (_tmp57_);
												_tmp59_ = _tmp58_;
												_g_object_unref0 (_tmp57_);
												uri = _tmp59_;
												{
													VlsDefaultProject* _tmp60_;
													const gchar* _tmp61_;
													GeeHashSet* _tmp62_;
													const gchar* _tmp63_;
													const gchar* _tmp64_;
													_tmp60_ = self->priv->default_project;
													_tmp61_ = uri;
													vls_project_close ((VlsProject*) _tmp60_, _tmp61_, &_inner_error0_);
													if (G_UNLIKELY (_inner_error0_ != NULL)) {
														goto __catch1_g_error;
													}
													_tmp62_ = self->priv->discarded_files;
													_tmp63_ = uri;
													gee_abstract_collection_add ((GeeAbstractCollection*) _tmp62_, _tmp63_);
													_tmp64_ = uri;
													g_debug ("server.vala:608: discarding %s from DefaultProject", _tmp64_);
												}
												goto __finally1;
												__catch1_g_error:
												{
													g_clear_error (&_inner_error0_);
												}
												__finally1:
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
													_g_free0 (uri);
													_vala_source_file_unref0 (source_file);
													_g_object_unref0 (_source_file_it);
													_g_object_unref0 (compilation);
													_g_object_unref0 (_compilation_list);
													_g_object_unref0 (newly_added);
													goto __catch0_g_error;
												}
												_g_free0 (uri);
											}
											_vala_source_file_unref0 (source_file);
										}
										_g_object_unref0 (_source_file_it);
									}
									_g_object_unref0 (compilation);
								}
								_g_object_unref0 (_compilation_list);
							}
							_g_object_unref0 (newly_added);
						}
						{
							GeeArrayList* _compilation_list = NULL;
							VlsProject* _tmp65_;
							GeeArrayList* _tmp66_;
							gint _compilation_size = 0;
							GeeArrayList* _tmp67_;
							gint _tmp68_;
							gint _tmp69_;
							gint _compilation_index = 0;
							_tmp65_ = project;
							_tmp66_ = vls_project_get_compilations (_tmp65_);
							_compilation_list = _tmp66_;
							_tmp67_ = _compilation_list;
							_tmp68_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp67_);
							_tmp69_ = _tmp68_;
							_compilation_size = _tmp69_;
							_compilation_index = -1;
							while (TRUE) {
								gint _tmp70_;
								gint _tmp71_;
								VlsCompilation* compilation = NULL;
								GeeArrayList* _tmp72_;
								gpointer _tmp73_;
								VlsProject* _tmp74_;
								VlsCompilation* _tmp75_;
								JsonrpcClient* _tmp76_;
								_compilation_index = _compilation_index + 1;
								_tmp70_ = _compilation_index;
								_tmp71_ = _compilation_size;
								if (!(_tmp70_ < _tmp71_)) {
									break;
								}
								_tmp72_ = _compilation_list;
								_tmp73_ = gee_abstract_list_get ((GeeAbstractList*) _tmp72_, _compilation_index);
								compilation = (VlsCompilation*) _tmp73_;
								_tmp74_ = project;
								_tmp75_ = compilation;
								_tmp76_ = self->priv->update_context_client;
								vls_server_publishDiagnostics (self, _tmp74_, _tmp75_, _tmp76_);
								_g_object_unref0 (compilation);
							}
							_g_object_unref0 (_compilation_list);
						}
					}
					goto __finally0;
					__catch0_g_error:
					{
						GError* e = NULL;
						GError* _tmp77_;
						const gchar* _tmp78_;
						JsonrpcClient* _tmp79_;
						GError* _tmp80_;
						const gchar* _tmp81_;
						const gchar* _tmp82_;
						gchar* _tmp83_;
						gchar* _tmp84_;
						e = _inner_error0_;
						_inner_error0_ = NULL;
						_tmp77_ = e;
						_tmp78_ = _tmp77_->message;
						g_warning ("server.vala:625: Failed to rebuild and/or reconfigure project: %s", _tmp78_);
						_tmp79_ = self->priv->update_context_client;
						_tmp80_ = e;
						_tmp81_ = _tmp80_->message;
						_tmp82_ = string_to_string (_tmp81_);
						_tmp83_ = g_strconcat ("Failed to rebuild/reconfigure project: ", _tmp82_, NULL);
						_tmp84_ = _tmp83_;
						vls_server_showMessage (self, _tmp79_, _tmp84_, LSP_MESSAGE_TYPE_Error);
						_g_free0 (_tmp84_);
						_g_error_free0 (e);
					}
					__finally0:
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (project);
						all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_g_object_unref0 (project);
				}
			}
		}
		if (reconfigured_projects) {
			GeeHashSet* orphaned_files = NULL;
			GeeHashSet* _tmp85_;
			GeeHashSet* _tmp86_;
			GeeHashSet* _tmp87_;
			GHashTable* _tmp88_;
			GList* _tmp89_;
			_tmp85_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
			if (_tmp85_) {
				g_object_set_data ((GObject *) _tmp85_, "vala-creation-function", "Vls.Server.check_update_context");
			}
			orphaned_files = _tmp85_;
			_tmp86_ = orphaned_files;
			_tmp87_ = self->priv->open_files;
			gee_collection_add_all ((GeeCollection*) _tmp86_, (GeeCollection*) _tmp87_);
			_tmp88_ = self->priv->projects;
			_tmp89_ = g_hash_table_get_keys (_tmp88_);
			{
				GList* project_collection = NULL;
				GList* project_it = NULL;
				project_collection = _tmp89_;
				for (project_it = project_collection; project_it != NULL; project_it = project_it->next) {
					VlsProject* project = NULL;
					project = (VlsProject*) project_it->data;
					{
						{
							GeeArrayList* _compilation_list = NULL;
							VlsProject* _tmp90_;
							GeeArrayList* _tmp91_;
							gint _compilation_size = 0;
							GeeArrayList* _tmp92_;
							gint _tmp93_;
							gint _tmp94_;
							gint _compilation_index = 0;
							_tmp90_ = project;
							_tmp91_ = vls_project_get_compilations (_tmp90_);
							_compilation_list = _tmp91_;
							_tmp92_ = _compilation_list;
							_tmp93_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp92_);
							_tmp94_ = _tmp93_;
							_compilation_size = _tmp94_;
							_compilation_index = -1;
							while (TRUE) {
								gint _tmp95_;
								gint _tmp96_;
								VlsCompilation* compilation = NULL;
								GeeArrayList* _tmp97_;
								gpointer _tmp98_;
								_compilation_index = _compilation_index + 1;
								_tmp95_ = _compilation_index;
								_tmp96_ = _compilation_size;
								if (!(_tmp95_ < _tmp96_)) {
									break;
								}
								_tmp97_ = _compilation_list;
								_tmp98_ = gee_abstract_list_get ((GeeAbstractList*) _tmp97_, _compilation_index);
								compilation = (VlsCompilation*) _tmp98_;
								{
									ValaList* _source_file_list = NULL;
									VlsCompilation* _tmp99_;
									ValaCodeContext* _tmp100_;
									ValaCodeContext* _tmp101_;
									ValaList* _tmp102_;
									gint _source_file_size = 0;
									ValaList* _tmp103_;
									gint _tmp104_;
									gint _tmp105_;
									gint _source_file_index = 0;
									_tmp99_ = compilation;
									_tmp100_ = vls_compilation_get_code_context (_tmp99_);
									_tmp101_ = _tmp100_;
									_tmp102_ = vala_code_context_get_source_files (_tmp101_);
									_source_file_list = _tmp102_;
									_tmp103_ = _source_file_list;
									_tmp104_ = vala_collection_get_size ((ValaCollection*) _tmp103_);
									_tmp105_ = _tmp104_;
									_source_file_size = _tmp105_;
									_source_file_index = -1;
									while (TRUE) {
										gint _tmp106_;
										gint _tmp107_;
										ValaSourceFile* source_file = NULL;
										ValaList* _tmp108_;
										gpointer _tmp109_;
										gchar* uri = NULL;
										ValaSourceFile* _tmp110_;
										const gchar* _tmp111_;
										const gchar* _tmp112_;
										GFile* _tmp113_;
										GFile* _tmp114_;
										gchar* _tmp115_;
										gchar* _tmp116_;
										GeeHashSet* _tmp117_;
										const gchar* _tmp118_;
										_source_file_index = _source_file_index + 1;
										_tmp106_ = _source_file_index;
										_tmp107_ = _source_file_size;
										if (!(_tmp106_ < _tmp107_)) {
											break;
										}
										_tmp108_ = _source_file_list;
										_tmp109_ = vala_list_get (_tmp108_, _source_file_index);
										source_file = (ValaSourceFile*) _tmp109_;
										_tmp110_ = source_file;
										_tmp111_ = vala_source_file_get_filename (_tmp110_);
										_tmp112_ = _tmp111_;
										_tmp113_ = g_file_new_for_path (_tmp112_);
										_tmp114_ = _tmp113_;
										_tmp115_ = g_file_get_uri (_tmp114_);
										_tmp116_ = _tmp115_;
										_g_object_unref0 (_tmp114_);
										uri = _tmp116_;
										_tmp117_ = orphaned_files;
										_tmp118_ = uri;
										gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp117_, _tmp118_);
										_g_free0 (uri);
										_vala_source_file_unref0 (source_file);
									}
								}
								_g_object_unref0 (compilation);
							}
							_g_object_unref0 (_compilation_list);
						}
					}
				}
				(project_collection == NULL) ? NULL : (project_collection = (g_list_free (project_collection), NULL));
			}
			{
				GeeIterator* _uri_it = NULL;
				GeeHashSet* _tmp119_;
				GeeIterator* _tmp120_;
				_tmp119_ = orphaned_files;
				_tmp120_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp119_);
				_uri_it = _tmp120_;
				while (TRUE) {
					GeeIterator* _tmp121_;
					gchar* uri = NULL;
					GeeIterator* _tmp122_;
					gpointer _tmp123_;
					_tmp121_ = _uri_it;
					if (!gee_iterator_next (_tmp121_)) {
						break;
					}
					_tmp122_ = _uri_it;
					_tmp123_ = gee_iterator_get (_tmp122_);
					uri = (gchar*) _tmp123_;
					{
						GeeArrayList* _tmp124_ = NULL;
						VlsDefaultProject* _tmp125_;
						const gchar* _tmp126_;
						GCancellable* _tmp127_;
						GeeArrayList* _tmp128_;
						VlsPair* opened = NULL;
						gpointer _tmp129_;
						ValaSourceFile* doc = NULL;
						VlsPair* _tmp130_;
						gconstpointer _tmp131_;
						gconstpointer _tmp132_;
						ValaSourceFile* _tmp133_;
						ValaSourceFile* _tmp134_;
						const gchar* _tmp135_;
						const gchar* _tmp136_;
						ValaSourceFile* _tmp138_;
						VlsDefaultProject* _tmp143_;
						VlsPair* _tmp144_;
						gconstpointer _tmp145_;
						gconstpointer _tmp146_;
						JsonrpcClient* _tmp147_;
						_tmp125_ = self->priv->default_project;
						_tmp126_ = uri;
						_tmp127_ = vls_server_cancellable;
						_tmp128_ = vls_project_open ((VlsProject*) _tmp125_, _tmp126_, NULL, _tmp127_, &_inner_error0_);
						_tmp124_ = _tmp128_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							goto __catch2_g_error;
						}
						_tmp129_ = gee_list_first ((GeeList*) _tmp124_);
						opened = (VlsPair*) _tmp129_;
						_tmp130_ = opened;
						_tmp131_ = vls_pair_get_first (_tmp130_);
						_tmp132_ = _tmp131_;
						_tmp133_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp132_);
						doc = _tmp133_;
						_tmp134_ = doc;
						_tmp135_ = vala_source_file_get_content (_tmp134_);
						_tmp136_ = _tmp135_;
						if (_tmp136_ == NULL) {
							ValaSourceFile* _tmp137_;
							_tmp137_ = doc;
							vala_source_file_get_mapped_contents (_tmp137_);
						}
						_tmp138_ = doc;
						if (VLS_IS_TEXT_DOCUMENT (_tmp138_)) {
							ValaSourceFile* _tmp139_;
							ValaSourceFile* _tmp140_;
							const gchar* _tmp141_;
							const gchar* _tmp142_;
							_tmp139_ = doc;
							_tmp140_ = doc;
							_tmp141_ = vala_source_file_get_content (_tmp140_);
							_tmp142_ = _tmp141_;
							vls_text_document_set_last_saved_content (G_TYPE_CHECK_INSTANCE_CAST (_tmp139_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument), _tmp142_);
						}
						_tmp143_ = self->priv->default_project;
						_tmp144_ = opened;
						_tmp145_ = vls_pair_get_second (_tmp144_);
						_tmp146_ = _tmp145_;
						_tmp147_ = self->priv->update_context_client;
						vls_server_publishDiagnostics (self, (VlsProject*) _tmp143_, (VlsCompilation*) _tmp146_, _tmp147_);
						_vala_source_file_unref0 (doc);
						_g_object_unref0 (opened);
						_g_object_unref0 (_tmp124_);
					}
					goto __finally2;
					__catch2_g_error:
					{
						GError* e = NULL;
						const gchar* _tmp148_;
						GError* _tmp149_;
						const gchar* _tmp150_;
						e = _inner_error0_;
						_inner_error0_ = NULL;
						_tmp148_ = uri;
						_tmp149_ = e;
						_tmp150_ = _tmp149_->message;
						g_warning ("server.vala:653: Failed to reopen in default project %s - %s", _tmp148_, _tmp150_);
						{
							JsonrpcClient* _tmp151_;
							const gchar* _tmp152_;
							GVariant* _tmp153_;
							GVariant* _tmp154_;
							const GVariantType* _tmp155_;
							GVariant** _tmp156_;
							GVariant** _tmp157_;
							gint _tmp157__length1;
							GVariant* _tmp158_;
							GVariant* _tmp159_;
							GVariant* _tmp160_;
							GVariant* _tmp161_;
							_tmp151_ = self->priv->update_context_client;
							_tmp152_ = uri;
							_tmp153_ = g_variant_new_string (_tmp152_);
							g_variant_ref_sink (_tmp153_);
							_tmp154_ = _tmp153_;
							_tmp155_ = G_VARIANT_TYPE_VARIANT;
							_tmp156_ = g_new0 (GVariant*, 0 + 1);
							_tmp157_ = _tmp156_;
							_tmp157__length1 = 0;
							_tmp158_ = g_variant_new_array (_tmp155_, _tmp157_, 0);
							g_variant_ref_sink (_tmp158_);
							_tmp159_ = _tmp158_;
							_tmp160_ = vls_server_buildDict (self, "uri", _tmp154_, "diagnostics", _tmp159_, NULL);
							_tmp161_ = _tmp160_;
							jsonrpc_client_send_notification (_tmp151_, "textDocument/publishDiagnostics", _tmp161_, NULL, &_inner_error0_);
							_g_variant_unref0 (_tmp161_);
							_g_variant_unref0 (_tmp159_);
							_tmp157_ = (_vala_array_free (_tmp157_, _tmp157__length1, (GDestroyNotify) g_variant_unref), NULL);
							_g_variant_unref0 (_tmp154_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								goto __catch3_g_error;
							}
						}
						goto __finally3;
						__catch3_g_error:
						{
							GError* e = NULL;
							const gchar* _tmp162_;
							GError* _tmp163_;
							const gchar* _tmp164_;
							e = _inner_error0_;
							_inner_error0_ = NULL;
							_tmp162_ = uri;
							_tmp163_ = e;
							_tmp164_ = _tmp163_->message;
							g_warning ("server.vala:664: Failed to clear diagnostics for %s - %s", _tmp162_, _tmp164_);
							_g_error_free0 (e);
						}
						__finally3:
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_g_error_free0 (e);
							_g_free0 (uri);
							_g_object_unref0 (_uri_it);
							_g_object_unref0 (orphaned_files);
							all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
						_g_error_free0 (e);
					}
					__finally2:
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_free0 (uri);
						_g_object_unref0 (_uri_it);
						_g_object_unref0 (orphaned_files);
						all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_g_free0 (uri);
				}
				_g_object_unref0 (_uri_it);
			}
			_g_object_unref0 (orphaned_files);
		}
		_tmp165_ = self->priv->documentation;
		vls_gir_documentation_rebuild_if_stale (_tmp165_);
		all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
	}
}

/**
     * Rather than satisfying all requests in `check_update_context ()`,
     * to avoid race conditions, we have to spawn a timeout to check for 
     * the right conditions to call `on_context_updated_func ()`.
     */
void
vls_server_wait_for_context_update (VlsServer* self,
                                    GVariant* id,
                                    VlsServerOnContextUpdatedFunc on_context_updated_func,
                                    gpointer on_context_updated_func_target,
                                    GDestroyNotify on_context_updated_func_target_destroy_notify)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (id != NULL);
	if (self->priv->update_context_requests == ((gint64) 0)) {
		on_context_updated_func (FALSE, on_context_updated_func_target);
	} else {
		VlsRequest* req = NULL;
		VlsRequest* _tmp0_;
		GeeHashSet* _tmp1_;
		VlsRequest* _tmp2_;
		VlsRequest* _tmp8_;
		VlsServerOnContextUpdatedFunc _tmp9_;
		gpointer _tmp9__target;
		GDestroyNotify _tmp9__target_destroy_notify;
		_tmp0_ = vls_request_new (id, NULL);
		if (_tmp0_) {
			g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "Vls.Server.wait_for_context_update");
		}
		req = _tmp0_;
		_tmp1_ = self->priv->pending_requests;
		_tmp2_ = req;
		if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _tmp2_)) {
			VlsRequest* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			_tmp3_ = req;
			_tmp4_ = vls_request_to_string (_tmp3_);
			_tmp5_ = _tmp4_;
			_tmp6_ = g_strconcat ("Request (", _tmp5_, "): request already in pending requests, this should not happen", NULL);
			_tmp7_ = _tmp6_;
			g_warning ("server.vala:689: %s", _tmp7_);
			_g_free0 (_tmp7_);
			_g_free0 (_tmp5_);
		}
		_tmp8_ = req;
		_tmp9_ = on_context_updated_func;
		_tmp9__target = on_context_updated_func_target;
		_tmp9__target_destroy_notify = on_context_updated_func_target_destroy_notify;
		on_context_updated_func = NULL;
		on_context_updated_func_target = NULL;
		on_context_updated_func_target_destroy_notify = NULL;
		vls_server_wait_for_context_update_aux (self, _tmp8_, _tmp9_, _tmp9__target, _tmp9__target_destroy_notify);
		_g_object_unref0 (req);
	}
	(on_context_updated_func_target_destroy_notify == NULL) ? NULL : (on_context_updated_func_target_destroy_notify (on_context_updated_func_target), NULL);
	on_context_updated_func = NULL;
	on_context_updated_func_target = NULL;
	on_context_updated_func_target_destroy_notify = NULL;
}

/**
     * Execute `on_context_updated_func ()` or wait.
     */
static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
	g_atomic_int_inc (&_data24_->_ref_count_);
	return _data24_;
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
		VlsServer* self;
		self = _data24_->self;
		_g_object_unref0 (_data24_->req);
		(_data24_->on_context_updated_func_target_destroy_notify == NULL) ? NULL : (_data24_->on_context_updated_func_target_destroy_notify (_data24_->on_context_updated_func_target), NULL);
		_data24_->on_context_updated_func = NULL;
		_data24_->on_context_updated_func_target = NULL;
		_data24_->on_context_updated_func_target_destroy_notify = NULL;
		_g_object_unref0 (self);
		g_slice_free (Block24Data, _data24_);
	}
}

static gboolean
___lambda40_ (Block24Data* _data24_)
{
	VlsServer* self;
	GeeHashSet* _tmp0_;
	gboolean result;
	self = _data24_->self;
	_tmp0_ = self->priv->pending_requests;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, _data24_->req)) {
		VlsServerOnContextUpdatedFunc _tmp1_;
		gpointer _tmp1__target;
		GDestroyNotify _tmp1__target_destroy_notify;
		_tmp1_ = _data24_->on_context_updated_func;
		_tmp1__target = _data24_->on_context_updated_func_target;
		_tmp1__target_destroy_notify = _data24_->on_context_updated_func_target_destroy_notify;
		_data24_->on_context_updated_func = NULL;
		_data24_->on_context_updated_func_target = NULL;
		_data24_->on_context_updated_func_target_destroy_notify = NULL;
		vls_server_wait_for_context_update_aux (self, _data24_->req, _tmp1_, _tmp1__target, _tmp1__target_destroy_notify);
	} else {
		_data24_->on_context_updated_func (TRUE, _data24_->on_context_updated_func_target);
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
____lambda40__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda40_ (self);
	return result;
}

static void
vls_server_wait_for_context_update_aux (VlsServer* self,
                                        VlsRequest* req,
                                        VlsServerOnContextUpdatedFunc on_context_updated_func,
                                        gpointer on_context_updated_func_target,
                                        GDestroyNotify on_context_updated_func_target_destroy_notify)
{
	Block24Data* _data24_;
	VlsRequest* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (req != NULL);
	_data24_ = g_slice_new0 (Block24Data);
	_data24_->_ref_count_ = 1;
	_data24_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (req);
	_g_object_unref0 (_data24_->req);
	_data24_->req = _tmp0_;
	(_data24_->on_context_updated_func_target_destroy_notify == NULL) ? NULL : (_data24_->on_context_updated_func_target_destroy_notify (_data24_->on_context_updated_func_target), NULL);
	_data24_->on_context_updated_func = NULL;
	_data24_->on_context_updated_func_target = NULL;
	_data24_->on_context_updated_func_target_destroy_notify = NULL;
	_data24_->on_context_updated_func = on_context_updated_func;
	_data24_->on_context_updated_func_target = on_context_updated_func_target;
	_data24_->on_context_updated_func_target_destroy_notify = on_context_updated_func_target_destroy_notify;
	if (self->priv->update_context_requests == ((gint64) 0)) {
		GeeHashSet* _tmp1_;
		_tmp1_ = self->priv->pending_requests;
		if (!gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, _data24_->req)) {
			_data24_->on_context_updated_func (TRUE, _data24_->on_context_updated_func_target);
		} else {
			_data24_->on_context_updated_func (FALSE, _data24_->on_context_updated_func_target);
		}
	} else {
		g_timeout_add_full (G_PRIORITY_DEFAULT, VLS_SERVER_wait_for_context_update_delay_ms, ____lambda40__gsource_func, block24_data_ref (_data24_), block24_data_unref);
	}
	block24_data_unref (_data24_);
	_data24_ = NULL;
}

static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
	g_atomic_int_inc (&_data25_->_ref_count_);
	return _data25_;
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
		VlsServer* self;
		self = _data25_->self;
		_g_object_unref0 (_data25_->doc_diags);
		_json_array_unref0 (_data25_->diags_without_source);
		_g_object_unref0 (_data25_->target);
		_g_object_unref0 (self);
		g_slice_free (Block25Data, _data25_);
	}
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
	return g_boxed_copy (json_node_get_type (), self);
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
	return self ? _vala_JsonNode_copy (self) : NULL;
}

static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}

static void
__lambda37_ (Block25Data* _data25_,
             VlsSourceMessage* err)
{
	VlsServer* self;
	ValaSourceReference* _tmp0_;
	ValaSourceReference* _tmp10_;
	ValaSourceFile* _tmp11_;
	ValaSourceFile* _tmp12_;
	ValaCodeContext* _tmp13_;
	ValaCodeContext* _tmp14_;
	ValaList* _tmp15_;
	ValaSourceReference* _tmp16_;
	ValaSourceFile* _tmp17_;
	ValaSourceFile* _tmp18_;
	LspDiagnostic* diag = NULL;
	ValaSourceReference* _tmp23_;
	ValaSourceLocation _tmp24_ = {0};
	ValaSourceLocation _tmp25_;
	ValaSourceReference* _tmp26_;
	ValaSourceLocation _tmp27_ = {0};
	ValaSourceLocation _tmp28_;
	LspPosition* _tmp29_ = NULL;
	ValaSourceReference* _tmp30_;
	ValaSourceLocation _tmp31_ = {0};
	ValaSourceLocation _tmp32_;
	ValaSourceReference* _tmp33_;
	ValaSourceLocation _tmp34_ = {0};
	ValaSourceLocation _tmp35_;
	LspPosition* _tmp36_ = NULL;
	LspRange* _tmp37_ = NULL;
	const gchar* _tmp38_;
	gchar* _tmp39_;
	LspDiagnostic* _tmp40_ = NULL;
	JsonNode* node = NULL;
	LspDiagnostic* _tmp41_;
	JsonNode* _tmp42_;
	gboolean _tmp43_ = FALSE;
	GeeHashMap* _tmp44_;
	ValaSourceReference* _tmp45_;
	ValaSourceFile* _tmp46_;
	ValaSourceFile* _tmp47_;
	GeeHashMap* _tmp60_;
	ValaSourceReference* _tmp61_;
	ValaSourceFile* _tmp62_;
	ValaSourceFile* _tmp63_;
	gpointer _tmp64_;
	JsonArray* _tmp65_;
	JsonNode* _tmp66_;
	JsonNode* _tmp67_;
	self = _data25_->self;
	g_return_if_fail (err != NULL);
	_tmp0_ = err->loc;
	if (_tmp0_ == NULL) {
		JsonArray* _tmp1_;
		LspPosition* _tmp2_ = NULL;
		LspPosition* _tmp3_ = NULL;
		LspRange* _tmp4_ = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		LspDiagnostic* _tmp7_ = NULL;
		LspDiagnostic* _tmp8_;
		JsonNode* _tmp9_;
		_tmp1_ = _data25_->diags_without_source;
		_tmp2_ = lsp_position_new ();
		lsp_position_set_line (_tmp2_, (guint) 1);
		lsp_position_set_character (_tmp2_, (guint) 1);
		_tmp3_ = lsp_position_new ();
		lsp_position_set_line (_tmp3_, (guint) 1);
		lsp_position_set_character (_tmp3_, (guint) 1);
		_tmp4_ = lsp_range_new ();
		lsp_range_set_start (_tmp4_, _tmp2_);
		_g_object_unref0 (_tmp2_);
		lsp_range_set_end (_tmp4_, _tmp3_);
		_g_object_unref0 (_tmp3_);
		_tmp5_ = err->message;
		_tmp6_ = g_strdup (_tmp5_);
		_tmp7_ = lsp_diagnostic_new ();
		lsp_diagnostic_set_range (_tmp7_, _tmp4_);
		_g_object_unref0 (_tmp4_);
		lsp_diagnostic_set_severity (_tmp7_, err->severity);
		lsp_diagnostic_set_message (_tmp7_, _tmp6_);
		_g_free0 (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = json_gobject_serialize ((GObject*) _tmp8_);
		json_array_add_element (_tmp1_, _tmp9_);
		_g_object_unref0 (_tmp8_);
		return;
	}
	_tmp10_ = err->loc;
	_tmp11_ = vala_source_reference_get_file (_tmp10_);
	_tmp12_ = _tmp11_;
	_vala_assert (_tmp12_ != NULL, "err.loc.file != null");
	_tmp13_ = vls_compilation_get_code_context (_data25_->target);
	_tmp14_ = _tmp13_;
	_tmp15_ = vala_code_context_get_source_files (_tmp14_);
	_tmp16_ = err->loc;
	_tmp17_ = vala_source_reference_get_file (_tmp16_);
	_tmp18_ = _tmp17_;
	if (!vala_collection_contains ((ValaCollection*) _tmp15_, _tmp18_)) {
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		_tmp19_ = err->message;
		_tmp20_ = string_to_string (_tmp19_);
		_tmp21_ = g_strconcat ("diagnostic has source not in compilation! - ", _tmp20_, NULL);
		_tmp22_ = _tmp21_;
		g_warning ("server.vala:751: %s", _tmp22_);
		_g_free0 (_tmp22_);
		return;
	}
	_tmp23_ = err->loc;
	vala_source_reference_get_begin (_tmp23_, &_tmp24_);
	_tmp25_ = _tmp24_;
	_tmp26_ = err->loc;
	vala_source_reference_get_begin (_tmp26_, &_tmp27_);
	_tmp28_ = _tmp27_;
	_tmp29_ = lsp_position_new ();
	lsp_position_set_line (_tmp29_, (guint) (_tmp25_.line - 1));
	lsp_position_set_character (_tmp29_, (guint) (_tmp28_.column - 1));
	_tmp30_ = err->loc;
	vala_source_reference_get_end (_tmp30_, &_tmp31_);
	_tmp32_ = _tmp31_;
	_tmp33_ = err->loc;
	vala_source_reference_get_end (_tmp33_, &_tmp34_);
	_tmp35_ = _tmp34_;
	_tmp36_ = lsp_position_new ();
	lsp_position_set_line (_tmp36_, (guint) (_tmp32_.line - 1));
	lsp_position_set_character (_tmp36_, (guint) _tmp35_.column);
	_tmp37_ = lsp_range_new ();
	lsp_range_set_start (_tmp37_, _tmp29_);
	_g_object_unref0 (_tmp29_);
	lsp_range_set_end (_tmp37_, _tmp36_);
	_g_object_unref0 (_tmp36_);
	_tmp38_ = err->message;
	_tmp39_ = g_strdup (_tmp38_);
	_tmp40_ = lsp_diagnostic_new ();
	lsp_diagnostic_set_range (_tmp40_, _tmp37_);
	_g_object_unref0 (_tmp37_);
	lsp_diagnostic_set_severity (_tmp40_, err->severity);
	lsp_diagnostic_set_message (_tmp40_, _tmp39_);
	_g_free0 (_tmp39_);
	diag = _tmp40_;
	_tmp41_ = diag;
	_tmp42_ = json_gobject_serialize ((GObject*) _tmp41_);
	node = _tmp42_;
	_tmp44_ = _data25_->doc_diags;
	_tmp45_ = err->loc;
	_tmp46_ = vala_source_reference_get_file (_tmp45_);
	_tmp47_ = _tmp46_;
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp44_, _tmp47_)) {
		_tmp43_ = TRUE;
	} else {
		GeeHashMap* _tmp48_;
		ValaSourceReference* _tmp49_;
		ValaSourceFile* _tmp50_;
		ValaSourceFile* _tmp51_;
		gpointer _tmp52_;
		JsonArray* _tmp53_;
		_tmp48_ = _data25_->doc_diags;
		_tmp49_ = err->loc;
		_tmp50_ = vala_source_reference_get_file (_tmp49_);
		_tmp51_ = _tmp50_;
		_tmp52_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp48_, _tmp51_);
		_tmp53_ = (JsonArray*) _tmp52_;
		_tmp43_ = _tmp53_ == NULL;
		_json_array_unref0 (_tmp53_);
	}
	if (_tmp43_) {
		GeeHashMap* _tmp54_;
		ValaSourceReference* _tmp55_;
		ValaSourceFile* _tmp56_;
		ValaSourceFile* _tmp57_;
		JsonArray* _tmp58_;
		JsonArray* _tmp59_;
		_tmp54_ = _data25_->doc_diags;
		_tmp55_ = err->loc;
		_tmp56_ = vala_source_reference_get_file (_tmp55_);
		_tmp57_ = _tmp56_;
		_tmp58_ = json_array_new ();
		_tmp59_ = _tmp58_;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp54_, _tmp57_, _tmp59_);
		_json_array_unref0 (_tmp59_);
	}
	_tmp60_ = _data25_->doc_diags;
	_tmp61_ = err->loc;
	_tmp62_ = vala_source_reference_get_file (_tmp61_);
	_tmp63_ = _tmp62_;
	_tmp64_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp60_, _tmp63_);
	_tmp65_ = (JsonArray*) _tmp64_;
	_tmp66_ = node;
	_tmp67_ = __vala_JsonNode_copy0 (_tmp66_);
	json_array_add_element (_tmp65_, _tmp67_);
	_json_array_unref0 (_tmp65_);
	__vala_JsonNode_free0 (node);
	_g_object_unref0 (diag);
}

static void
___lambda37__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda37_ (self, (VlsSourceMessage*) data);
}

static void
vls_server_publishDiagnostics (VlsServer* self,
                               VlsProject* project,
                               VlsCompilation* target,
                               JsonrpcClient* client)
{
	Block25Data* _data25_;
	VlsCompilation* _tmp0_;
	JsonArray* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GeeHashMap* _tmp4_;
	VlsReporter* _tmp17_;
	VlsReporter* _tmp18_;
	GPtrArray* _tmp19_;
	GeeArrayList* discarded_files_published = NULL;
	GeeArrayList* _tmp20_;
	GeeHashSet* _tmp41_;
	GeeArrayList* _tmp42_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (project != NULL);
	g_return_if_fail (target != NULL);
	g_return_if_fail (client != NULL);
	_data25_ = g_slice_new0 (Block25Data);
	_data25_->_ref_count_ = 1;
	_data25_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (target);
	_g_object_unref0 (_data25_->target);
	_data25_->target = _tmp0_;
	_tmp1_ = json_array_new ();
	_data25_->diags_without_source = _tmp1_;
	_tmp2_ = vls_build_target_get_id ((VlsBuildTarget*) _data25_->target);
	_tmp3_ = _tmp2_;
	g_debug ("server.vala:725: publishing diagnostics for Compilation target %s", _tmp3_);
	_tmp4_ = gee_hash_map_new (VALA_TYPE_SOURCE_FILE, (GBoxedCopyFunc) vala_source_file_ref, (GDestroyNotify) vala_source_file_unref, json_array_get_type (), (GBoxedCopyFunc) json_array_ref, (GDestroyNotify) json_array_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp4_) {
		g_object_set_data ((GObject *) _tmp4_, "vala-creation-function", "Vls.Server.publishDiagnostics");
	}
	_data25_->doc_diags = _tmp4_;
	{
		ValaList* _file_list = NULL;
		ValaCodeContext* _tmp5_;
		ValaCodeContext* _tmp6_;
		ValaList* _tmp7_;
		gint _file_size = 0;
		ValaList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _file_index = 0;
		_tmp5_ = vls_compilation_get_code_context (_data25_->target);
		_tmp6_ = _tmp5_;
		_tmp7_ = vala_code_context_get_source_files (_tmp6_);
		_file_list = _tmp7_;
		_tmp8_ = _file_list;
		_tmp9_ = vala_collection_get_size ((ValaCollection*) _tmp8_);
		_tmp10_ = _tmp9_;
		_file_size = _tmp10_;
		_file_index = -1;
		while (TRUE) {
			gint _tmp11_;
			gint _tmp12_;
			ValaSourceFile* file = NULL;
			ValaList* _tmp13_;
			gpointer _tmp14_;
			GeeHashMap* _tmp15_;
			ValaSourceFile* _tmp16_;
			_file_index = _file_index + 1;
			_tmp11_ = _file_index;
			_tmp12_ = _file_size;
			if (!(_tmp11_ < _tmp12_)) {
				break;
			}
			_tmp13_ = _file_list;
			_tmp14_ = vala_list_get (_tmp13_, _file_index);
			file = (ValaSourceFile*) _tmp14_;
			_tmp15_ = _data25_->doc_diags;
			_tmp16_ = file;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, _tmp16_, NULL);
			_vala_source_file_unref0 (file);
		}
	}
	_tmp17_ = vls_compilation_get_reporter (_data25_->target);
	_tmp18_ = _tmp17_;
	_tmp19_ = _tmp18_->messages;
	g_ptr_array_foreach (_tmp19_, ___lambda37__gfunc, _data25_);
	_tmp20_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	if (_tmp20_) {
		g_object_set_data ((GObject *) _tmp20_, "vala-creation-function", "Vls.Server.publishDiagnostics");
	}
	discarded_files_published = _tmp20_;
	{
		GeeIterator* _discarded_uri_it = NULL;
		GeeHashSet* _tmp21_;
		GeeIterator* _tmp22_;
		_tmp21_ = self->priv->discarded_files;
		_tmp22_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp21_);
		_discarded_uri_it = _tmp22_;
		while (TRUE) {
			GeeIterator* _tmp23_;
			gchar* discarded_uri = NULL;
			GeeIterator* _tmp24_;
			gpointer _tmp25_;
			_tmp23_ = _discarded_uri_it;
			if (!gee_iterator_next (_tmp23_)) {
				break;
			}
			_tmp24_ = _discarded_uri_it;
			_tmp25_ = gee_iterator_get (_tmp24_);
			discarded_uri = (gchar*) _tmp25_;
			{
				const gchar* _tmp26_;
				GVariant* _tmp27_;
				GVariant* _tmp28_;
				const GVariantType* _tmp29_;
				GVariant** _tmp30_;
				GVariant** _tmp31_;
				gint _tmp31__length1;
				GVariant* _tmp32_;
				GVariant* _tmp33_;
				GVariant* _tmp34_;
				GVariant* _tmp35_;
				GeeArrayList* _tmp36_;
				const gchar* _tmp37_;
				_tmp26_ = discarded_uri;
				_tmp27_ = g_variant_new_string (_tmp26_);
				g_variant_ref_sink (_tmp27_);
				_tmp28_ = _tmp27_;
				_tmp29_ = G_VARIANT_TYPE_VARIANT;
				_tmp30_ = g_new0 (GVariant*, 0 + 1);
				_tmp31_ = _tmp30_;
				_tmp31__length1 = 0;
				_tmp32_ = g_variant_new_array (_tmp29_, _tmp31_, 0);
				g_variant_ref_sink (_tmp32_);
				_tmp33_ = _tmp32_;
				_tmp34_ = vls_server_buildDict (self, "uri", _tmp28_, "diagnostics", _tmp33_, NULL);
				_tmp35_ = _tmp34_;
				jsonrpc_client_send_notification (client, "textDocument/publishDiagnostics", _tmp35_, NULL, &_inner_error0_);
				_g_variant_unref0 (_tmp35_);
				_g_variant_unref0 (_tmp33_);
				_tmp31_ = (_vala_array_free (_tmp31_, _tmp31__length1, (GDestroyNotify) g_variant_unref), NULL);
				_g_variant_unref0 (_tmp28_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
				_tmp36_ = discarded_files_published;
				_tmp37_ = discarded_uri;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, _tmp37_);
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				const gchar* _tmp38_;
				GError* _tmp39_;
				const gchar* _tmp40_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp38_ = discarded_uri;
				_tmp39_ = e;
				_tmp40_ = _tmp39_->message;
				g_warning ("server.vala:789: [publishDiagnostics] failed to publish empty diags fo" \
"r %s: %s", _tmp38_, _tmp40_);
				_g_error_free0 (e);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (discarded_uri);
				_g_object_unref0 (_discarded_uri_it);
				_g_object_unref0 (discarded_files_published);
				block25_data_unref (_data25_);
				_data25_ = NULL;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_g_free0 (discarded_uri);
		}
		_g_object_unref0 (_discarded_uri_it);
	}
	_tmp41_ = self->priv->discarded_files;
	_tmp42_ = discarded_files_published;
	gee_collection_remove_all ((GeeCollection*) _tmp41_, (GeeCollection*) _tmp42_);
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp43_;
		GeeSet* _tmp44_;
		GeeSet* _tmp45_;
		GeeSet* _tmp46_;
		GeeIterator* _tmp47_;
		GeeIterator* _tmp48_;
		_tmp43_ = _data25_->doc_diags;
		_tmp44_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp43_);
		_tmp45_ = _tmp44_;
		_tmp46_ = _tmp45_;
		_tmp47_ = gee_iterable_iterator ((GeeIterable*) _tmp46_);
		_tmp48_ = _tmp47_;
		_g_object_unref0 (_tmp46_);
		_entry_it = _tmp48_;
		while (TRUE) {
			GeeIterator* _tmp49_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp50_;
			gpointer _tmp51_;
			GVariant* diags_variant_array = NULL;
			GFile* gfile = NULL;
			GeeMapEntry* _tmp52_;
			gconstpointer _tmp53_;
			gconstpointer _tmp54_;
			const gchar* _tmp55_;
			const gchar* _tmp56_;
			ValaCodeContext* _tmp57_;
			ValaCodeContext* _tmp58_;
			const gchar* _tmp59_;
			const gchar* _tmp60_;
			GFile* _tmp61_;
			GeeMapEntry* _tmp62_;
			gconstpointer _tmp63_;
			gconstpointer _tmp64_;
			_tmp49_ = _entry_it;
			if (!gee_iterator_next (_tmp49_)) {
				break;
			}
			_tmp50_ = _entry_it;
			_tmp51_ = gee_iterator_get (_tmp50_);
			entry = (GeeMapEntry*) _tmp51_;
			_tmp52_ = entry;
			_tmp53_ = gee_map_entry_get_key (_tmp52_);
			_tmp54_ = _tmp53_;
			_tmp55_ = vala_source_file_get_filename ((ValaSourceFile*) _tmp54_);
			_tmp56_ = _tmp55_;
			_tmp57_ = vls_compilation_get_code_context (_data25_->target);
			_tmp58_ = _tmp57_;
			_tmp59_ = vala_code_context_get_directory (_tmp58_);
			_tmp60_ = _tmp59_;
			_tmp61_ = g_file_new_for_commandline_arg_and_cwd (_tmp56_, _tmp60_);
			gfile = _tmp61_;
			_tmp62_ = entry;
			_tmp63_ = gee_map_entry_get_value (_tmp62_);
			_tmp64_ = _tmp63_;
			if (((JsonArray*) _tmp64_) != NULL) {
				{
					GVariant* _tmp65_ = NULL;
					JsonNode* _tmp66_;
					JsonNode* _tmp67_;
					GeeMapEntry* _tmp68_;
					gconstpointer _tmp69_;
					gconstpointer _tmp70_;
					JsonNode* _tmp71_;
					GVariant* _tmp72_;
					GVariant* _tmp73_;
					GVariant* _tmp74_;
					_tmp66_ = json_node_alloc ();
					_tmp67_ = _tmp66_;
					_tmp68_ = entry;
					_tmp69_ = gee_map_entry_get_value (_tmp68_);
					_tmp70_ = _tmp69_;
					_tmp71_ = json_node_init_array (_tmp67_, (JsonArray*) _tmp70_);
					_tmp72_ = json_gvariant_deserialize (_tmp71_, NULL, &_inner_error0_);
					_tmp73_ = _tmp72_;
					__vala_JsonNode_free0 (_tmp67_);
					_tmp65_ = _tmp73_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch1_g_error;
					}
					_tmp74_ = _tmp65_;
					_tmp65_ = NULL;
					if (_tmp74_ != NULL) {
						g_variant_ref_sink (_tmp74_);
					}
					_g_variant_unref0 (diags_variant_array);
					diags_variant_array = _tmp74_;
					_g_variant_unref0 (_tmp65_);
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					GFile* _tmp75_;
					gchar* _tmp76_;
					gchar* _tmp77_;
					const gchar* _tmp78_;
					GError* _tmp79_;
					const gchar* _tmp80_;
					const gchar* _tmp81_;
					gchar* _tmp82_;
					gchar* _tmp83_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp75_ = gfile;
					_tmp76_ = g_file_get_uri (_tmp75_);
					_tmp77_ = _tmp76_;
					_tmp78_ = string_to_string (_tmp77_);
					_tmp79_ = e;
					_tmp80_ = _tmp79_->message;
					_tmp81_ = string_to_string (_tmp80_);
					_tmp82_ = g_strconcat ("[publishDiagnostics] failed to deserialize diags for `", _tmp78_, "': ", _tmp81_, NULL);
					_tmp83_ = _tmp82_;
					g_warning ("server.vala:805: %s", _tmp83_);
					_g_free0 (_tmp83_);
					_g_free0 (_tmp77_);
					_g_error_free0 (e);
					_g_object_unref0 (gfile);
					_g_variant_unref0 (diags_variant_array);
					_g_object_unref0 (entry);
					continue;
				}
				__finally1:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (gfile);
					_g_variant_unref0 (diags_variant_array);
					_g_object_unref0 (entry);
					_g_object_unref0 (_entry_it);
					_g_object_unref0 (discarded_files_published);
					block25_data_unref (_data25_);
					_data25_ = NULL;
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			} else {
				const GVariantType* _tmp84_;
				GVariant** _tmp85_;
				GVariant** _tmp86_;
				gint _tmp86__length1;
				GVariant* _tmp87_;
				_tmp84_ = G_VARIANT_TYPE_VARIANT;
				_tmp85_ = g_new0 (GVariant*, 0 + 1);
				_tmp86_ = _tmp85_;
				_tmp86__length1 = 0;
				_tmp87_ = g_variant_new_array (_tmp84_, _tmp86_, 0);
				g_variant_ref_sink (_tmp87_);
				_g_variant_unref0 (diags_variant_array);
				diags_variant_array = _tmp87_;
				_tmp86_ = (_vala_array_free (_tmp86_, _tmp86__length1, (GDestroyNotify) g_variant_unref), NULL);
			}
			{
				GFile* _tmp88_;
				gchar* _tmp89_;
				gchar* _tmp90_;
				GVariant* _tmp91_;
				GVariant* _tmp92_;
				GVariant* _tmp93_;
				GVariant* _tmp94_;
				GVariant* _tmp95_;
				GCancellable* _tmp96_;
				_tmp88_ = gfile;
				_tmp89_ = g_file_get_uri (_tmp88_);
				_tmp90_ = _tmp89_;
				_tmp91_ = g_variant_new_string (_tmp90_);
				g_variant_ref_sink (_tmp91_);
				_tmp92_ = _tmp91_;
				_tmp93_ = diags_variant_array;
				_tmp94_ = vls_server_buildDict (self, "uri", _tmp92_, "diagnostics", _tmp93_, NULL);
				_tmp95_ = _tmp94_;
				_tmp96_ = vls_server_cancellable;
				jsonrpc_client_send_notification (client, "textDocument/publishDiagnostics", _tmp95_, _tmp96_, &_inner_error0_);
				_g_variant_unref0 (_tmp95_);
				_g_variant_unref0 (_tmp92_);
				_g_free0 (_tmp90_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* e = NULL;
				GError* _tmp97_;
				const gchar* _tmp98_;
				const gchar* _tmp99_;
				gchar* _tmp100_;
				gchar* _tmp101_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp97_ = e;
				_tmp98_ = _tmp97_->message;
				_tmp99_ = string_to_string (_tmp98_);
				_tmp100_ = g_strconcat ("[publishDiagnostics] failed to notify client: ", _tmp99_, NULL);
				_tmp101_ = _tmp100_;
				g_warning ("server.vala:821: %s", _tmp101_);
				_g_free0 (_tmp101_);
				_g_error_free0 (e);
			}
			__finally2:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (gfile);
				_g_variant_unref0 (diags_variant_array);
				_g_object_unref0 (entry);
				_g_object_unref0 (_entry_it);
				_g_object_unref0 (discarded_files_published);
				block25_data_unref (_data25_);
				_data25_ = NULL;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_g_object_unref0 (gfile);
			_g_variant_unref0 (diags_variant_array);
			_g_object_unref0 (entry);
		}
		_g_object_unref0 (_entry_it);
	}
	{
		GVariant* diags_wo_src_variant_array = NULL;
		JsonNode* _tmp102_;
		JsonNode* _tmp103_;
		JsonArray* _tmp104_;
		JsonNode* _tmp105_;
		GVariant* _tmp106_;
		GVariant* _tmp107_;
		const gchar* _tmp108_;
		const gchar* _tmp109_;
		GFile* _tmp110_;
		GFile* _tmp111_;
		gchar* _tmp112_;
		gchar* _tmp113_;
		GVariant* _tmp114_;
		GVariant* _tmp115_;
		GVariant* _tmp116_;
		GVariant* _tmp117_;
		GVariant* _tmp118_;
		GCancellable* _tmp119_;
		_tmp102_ = json_node_alloc ();
		_tmp103_ = _tmp102_;
		_tmp104_ = _data25_->diags_without_source;
		_tmp105_ = json_node_init_array (_tmp103_, _tmp104_);
		_tmp106_ = json_gvariant_deserialize (_tmp105_, NULL, &_inner_error0_);
		if (_tmp106_ != NULL) {
			g_variant_ref_sink (_tmp106_);
		}
		_tmp107_ = _tmp106_;
		__vala_JsonNode_free0 (_tmp103_);
		diags_wo_src_variant_array = _tmp107_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch3_g_error;
		}
		_tmp108_ = vls_project_get_root_path (project);
		_tmp109_ = _tmp108_;
		_tmp110_ = g_file_new_for_path (_tmp109_);
		_tmp111_ = _tmp110_;
		_tmp112_ = g_file_get_uri (_tmp111_);
		_tmp113_ = _tmp112_;
		_tmp114_ = g_variant_new_string (_tmp113_);
		g_variant_ref_sink (_tmp114_);
		_tmp115_ = _tmp114_;
		_tmp116_ = diags_wo_src_variant_array;
		_tmp117_ = vls_server_buildDict (self, "uri", _tmp115_, "diagnostics", _tmp116_, NULL);
		_tmp118_ = _tmp117_;
		_tmp119_ = vls_server_cancellable;
		jsonrpc_client_send_notification (client, "textDocument/publishDiagnostics", _tmp118_, _tmp119_, &_inner_error0_);
		_g_variant_unref0 (_tmp118_);
		_g_variant_unref0 (_tmp115_);
		_g_free0 (_tmp113_);
		_g_object_unref0 (_tmp111_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (diags_wo_src_variant_array);
			goto __catch3_g_error;
		}
		_g_variant_unref0 (diags_wo_src_variant_array);
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp120_;
		const gchar* _tmp121_;
		const gchar* _tmp122_;
		gchar* _tmp123_;
		gchar* _tmp124_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp120_ = e;
		_tmp121_ = _tmp120_->message;
		_tmp122_ = string_to_string (_tmp121_);
		_tmp123_ = g_strconcat ("[publishDiagnostics] failed to publish diags without source: ", _tmp122_, NULL);
		_tmp124_ = _tmp123_;
		g_warning ("server.vala:838: %s", _tmp124_);
		_g_free0 (_tmp124_);
		_g_error_free0 (e);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (discarded_files_published);
		block25_data_unref (_data25_);
		_data25_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (discarded_files_published);
	block25_data_unref (_data25_);
	_data25_ = NULL;
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

ValaCodeNode*
vls_server_get_best (VlsFindSymbol* fs,
                     ValaSourceFile* file)
{
	ValaCodeNode* best = NULL;
	ValaCodeNode* _tmp60_;
	ValaCodeNode* _tmp61_;
	ValaCodeNode* _tmp62_;
	ValaCodeNode* result;
	g_return_val_if_fail (fs != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	best = NULL;
	{
		GeeList* _node_list = NULL;
		GeeList* _tmp0_;
		gint _node_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _node_index = 0;
		_tmp0_ = fs->result;
		_node_list = _tmp0_;
		_tmp1_ = _node_list;
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_node_size = _tmp3_;
		_node_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			ValaCodeNode* node = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			ValaCodeNode* _tmp8_;
			_node_index = _node_index + 1;
			_tmp4_ = _node_index;
			_tmp5_ = _node_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _node_list;
			_tmp7_ = gee_list_get (_tmp6_, _node_index);
			node = (ValaCodeNode*) _tmp7_;
			_tmp8_ = best;
			if (_tmp8_ == NULL) {
				ValaCodeNode* _tmp9_;
				ValaCodeNode* _tmp10_;
				_tmp9_ = node;
				_tmp10_ = _vala_code_node_ref0 (_tmp9_);
				_vala_code_node_unref0 (best);
				best = _tmp10_;
			} else {
				LspPosition* best_begin = NULL;
				ValaCodeNode* _tmp11_;
				ValaSourceReference* _tmp12_;
				ValaSourceReference* _tmp13_;
				ValaSourceLocation _tmp14_ = {0};
				ValaSourceLocation _tmp15_;
				LspPosition* _tmp16_;
				LspPosition* best_end = NULL;
				ValaCodeNode* _tmp17_;
				ValaSourceReference* _tmp18_;
				ValaSourceReference* _tmp19_;
				ValaSourceLocation _tmp20_ = {0};
				ValaSourceLocation _tmp21_;
				LspPosition* _tmp22_;
				LspPosition* node_begin = NULL;
				ValaCodeNode* _tmp23_;
				ValaSourceReference* _tmp24_;
				ValaSourceReference* _tmp25_;
				ValaSourceLocation _tmp26_ = {0};
				ValaSourceLocation _tmp27_;
				LspPosition* _tmp28_;
				LspPosition* node_end = NULL;
				ValaCodeNode* _tmp29_;
				ValaSourceReference* _tmp30_;
				ValaSourceReference* _tmp31_;
				ValaSourceLocation _tmp32_ = {0};
				ValaSourceLocation _tmp33_;
				LspPosition* _tmp34_;
				gboolean _tmp35_ = FALSE;
				gboolean _tmp36_ = FALSE;
				LspPosition* _tmp37_;
				LspPosition* _tmp38_;
				_tmp11_ = best;
				_tmp12_ = vala_code_node_get_source_reference (_tmp11_);
				_tmp13_ = _tmp12_;
				vala_source_reference_get_begin (_tmp13_, &_tmp14_);
				_tmp15_ = _tmp14_;
				_tmp16_ = lsp_position_new_from_libvala (&_tmp15_);
				if (_tmp16_) {
					g_object_set_data ((GObject *) _tmp16_, "vala-creation-function", "Vls.Server.get_best");
				}
				best_begin = _tmp16_;
				_tmp17_ = best;
				_tmp18_ = vala_code_node_get_source_reference (_tmp17_);
				_tmp19_ = _tmp18_;
				vala_source_reference_get_end (_tmp19_, &_tmp20_);
				_tmp21_ = _tmp20_;
				_tmp22_ = lsp_position_new_from_libvala (&_tmp21_);
				if (_tmp22_) {
					g_object_set_data ((GObject *) _tmp22_, "vala-creation-function", "Vls.Server.get_best");
				}
				best_end = _tmp22_;
				_tmp23_ = node;
				_tmp24_ = vala_code_node_get_source_reference (_tmp23_);
				_tmp25_ = _tmp24_;
				vala_source_reference_get_begin (_tmp25_, &_tmp26_);
				_tmp27_ = _tmp26_;
				_tmp28_ = lsp_position_new_from_libvala (&_tmp27_);
				if (_tmp28_) {
					g_object_set_data ((GObject *) _tmp28_, "vala-creation-function", "Vls.Server.get_best");
				}
				node_begin = _tmp28_;
				_tmp29_ = node;
				_tmp30_ = vala_code_node_get_source_reference (_tmp29_);
				_tmp31_ = _tmp30_;
				vala_source_reference_get_end (_tmp31_, &_tmp32_);
				_tmp33_ = _tmp32_;
				_tmp34_ = lsp_position_new_from_libvala (&_tmp33_);
				if (_tmp34_) {
					g_object_set_data ((GObject *) _tmp34_, "vala-creation-function", "Vls.Server.get_best");
				}
				node_end = _tmp34_;
				_tmp37_ = best_begin;
				_tmp38_ = node_begin;
				if (gee_comparable_compare_to ((GeeComparable*) _tmp37_, _tmp38_) <= 0) {
					LspPosition* _tmp39_;
					LspPosition* _tmp40_;
					_tmp39_ = node_end;
					_tmp40_ = best_end;
					_tmp36_ = gee_comparable_compare_to ((GeeComparable*) _tmp39_, _tmp40_) <= 0;
				} else {
					_tmp36_ = FALSE;
				}
				if (_tmp36_) {
					gboolean _tmp41_ = FALSE;
					gboolean _tmp42_ = FALSE;
					gboolean _tmp43_ = FALSE;
					gboolean _tmp44_ = FALSE;
					LspPosition* _tmp45_;
					LspPosition* _tmp46_;
					_tmp45_ = best_begin;
					_tmp46_ = node_begin;
					if (gee_comparable_compare_to ((GeeComparable*) _tmp45_, _tmp46_) == 0) {
						LspPosition* _tmp47_;
						LspPosition* _tmp48_;
						_tmp47_ = node_end;
						_tmp48_ = best_end;
						_tmp44_ = gee_comparable_compare_to ((GeeComparable*) _tmp47_, _tmp48_) == 0;
					} else {
						_tmp44_ = FALSE;
					}
					if (!_tmp44_) {
						_tmp43_ = TRUE;
					} else {
						gboolean _tmp49_ = FALSE;
						ValaCodeNode* _tmp50_;
						_tmp50_ = best;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp50_, VALA_TYPE_LOCAL_VARIABLE)) {
							ValaCodeNode* _tmp51_;
							_tmp51_ = node;
							_tmp49_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp51_, VALA_TYPE_LOCAL_VARIABLE);
						} else {
							_tmp49_ = FALSE;
						}
						_tmp43_ = _tmp49_;
					}
					if (_tmp43_) {
						_tmp42_ = TRUE;
					} else {
						gboolean _tmp52_ = FALSE;
						ValaCodeNode* _tmp53_;
						_tmp53_ = best;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp53_, VALA_TYPE_FIELD)) {
							ValaCodeNode* _tmp54_;
							_tmp54_ = node;
							_tmp52_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp54_, VALA_TYPE_PROPERTY);
						} else {
							_tmp52_ = FALSE;
						}
						_tmp42_ = _tmp52_;
					}
					if (_tmp42_) {
						_tmp41_ = TRUE;
					} else {
						gboolean _tmp55_ = FALSE;
						ValaCodeNode* _tmp56_;
						_tmp56_ = best;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp56_, VALA_TYPE_NULL_LITERAL)) {
							ValaCodeNode* _tmp57_;
							_tmp57_ = node;
							_tmp55_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp57_, VALA_TYPE_METHOD);
						} else {
							_tmp55_ = FALSE;
						}
						_tmp41_ = _tmp55_;
					}
					_tmp35_ = _tmp41_;
				} else {
					_tmp35_ = FALSE;
				}
				if (_tmp35_) {
					ValaCodeNode* _tmp58_;
					ValaCodeNode* _tmp59_;
					_tmp58_ = node;
					_tmp59_ = _vala_code_node_ref0 (_tmp58_);
					_vala_code_node_unref0 (best);
					best = _tmp59_;
				}
				_g_object_unref0 (node_end);
				_g_object_unref0 (node_begin);
				_g_object_unref0 (best_end);
				_g_object_unref0 (best_begin);
			}
			_vala_code_node_unref0 (node);
		}
	}
	_tmp60_ = best;
	_vala_assert (_tmp60_ != NULL, "best != null");
	_tmp61_ = best;
	_tmp62_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, VALA_TYPE_CODE_NODE, ValaCodeNode));
	result = _tmp62_;
	_vala_code_node_unref0 (best);
	return result;
}

static Block26Data*
block26_data_ref (Block26Data* _data26_)
{
	g_atomic_int_inc (&_data26_->_ref_count_);
	return _data26_;
}

static void
block26_data_unref (void * _userdata_)
{
	Block26Data* _data26_;
	_data26_ = (Block26Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data26_->_ref_count_)) {
		VlsServer* self;
		self = _data26_->self;
		_g_object_unref0 (_data26_->selected_project);
		_g_object_unref0 (_data26_->results);
		_g_object_unref0 (_data26_->p);
		_g_object_unref0 (_data26_->client);
		_g_free0 (_data26_->method);
		_g_variant_unref0 (_data26_->id);
		_g_object_unref0 (self);
		g_slice_free (Block26Data, _data26_);
	}
}

static void
__lambda41_ (Block26Data* _data26_,
             gboolean request_cancelled)
{
	VlsServer* self;
	ValaSourceFile* file = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	VlsPair* _tmp2_;
	gconstpointer _tmp3_;
	gconstpointer _tmp4_;
	ValaSourceFile* _tmp5_;
	ValaSourceFile* _tmp6_;
	VlsCompilation* compilation = NULL;
	GeeArrayList* _tmp7_;
	gpointer _tmp8_;
	VlsPair* _tmp9_;
	gconstpointer _tmp10_;
	gconstpointer _tmp11_;
	VlsCompilation* _tmp12_;
	VlsCompilation* _tmp13_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	VlsFindSymbol* fs = NULL;
	ValaSourceFile* _tmp17_;
	LspTextDocumentPositionParams* _tmp18_;
	LspPosition* _tmp19_;
	LspPosition* _tmp20_;
	VlsFindSymbol* _tmp21_;
	VlsFindSymbol* _tmp22_;
	GeeList* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	ValaCodeNode* best = NULL;
	VlsFindSymbol* _tmp32_;
	ValaSourceFile* _tmp33_;
	ValaCodeNode* _tmp34_;
	gboolean _tmp35_ = FALSE;
	ValaCodeNode* _tmp36_;
	ValaCodeNode* _tmp134_;
	LspLocation* location = NULL;
	ValaCodeNode* _tmp138_;
	ValaSourceReference* _tmp139_;
	ValaSourceReference* _tmp140_;
	LspLocation* _tmp141_;
	LspLocation* _tmp142_;
	const gchar* _tmp143_;
	const gchar* _tmp144_;
	GError* _inner_error0_ = NULL;
	self = _data26_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data26_->id, _data26_->client, _data26_->method);
		return;
	}
	_tmp0_ = _data26_->results;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
	_tmp2_ = (VlsPair*) _tmp1_;
	_tmp3_ = vls_pair_get_first (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp2_);
	file = _tmp6_;
	_tmp7_ = _data26_->results;
	_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, 0);
	_tmp9_ = (VlsPair*) _tmp8_;
	_tmp10_ = vls_pair_get_second (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = _g_object_ref0 ((VlsCompilation*) _tmp11_);
	_tmp13_ = _tmp12_;
	_g_object_unref0 (_tmp9_);
	compilation = _tmp13_;
	_tmp14_ = compilation;
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
	_tmp16_ = _tmp15_;
	vala_code_context_push (_tmp16_);
	_tmp17_ = file;
	_tmp18_ = _data26_->p;
	_tmp19_ = lsp_text_document_position_params_get_position (_tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = vls_find_symbol_new (_tmp17_, _tmp20_, TRUE, NULL);
	fs = _tmp21_;
	_tmp22_ = fs;
	_tmp23_ = _tmp22_->result;
	_tmp24_ = gee_collection_get_size ((GeeCollection*) _tmp23_);
	_tmp25_ = _tmp24_;
	if (_tmp25_ == 0) {
		g_debug ("server.vala:916: [%s] find symbol is empty", _data26_->method);
		{
			const GVariantType* _tmp26_;
			GVariant* _tmp27_;
			GVariant* _tmp28_;
			GCancellable* _tmp29_;
			_tmp26_ = G_VARIANT_TYPE_VARIANT;
			_tmp27_ = g_variant_new_maybe (_tmp26_, NULL);
			g_variant_ref_sink (_tmp27_);
			_tmp28_ = _tmp27_;
			_tmp29_ = vls_server_cancellable;
			jsonrpc_client_reply (_data26_->client, _data26_->id, _tmp28_, _tmp29_, &_inner_error0_);
			_g_variant_unref0 (_tmp28_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp30_;
			const gchar* _tmp31_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp30_ = e;
			_tmp31_ = _tmp30_->message;
			g_debug ("server.vala:920: [textDocument/definition] failed to reply to client: " \
"%s", _tmp31_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_vala_code_visitor_unref0 (fs);
			_g_object_unref0 (compilation);
			_vala_source_file_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (file);
		return;
	}
	_tmp32_ = fs;
	_tmp33_ = file;
	_tmp34_ = vls_server_get_best (_tmp32_, _tmp33_);
	best = _tmp34_;
	_tmp36_ = best;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp36_, VALA_TYPE_EXPRESSION)) {
		ValaCodeNode* _tmp37_;
		_tmp37_ = best;
		_tmp35_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp37_, VALA_TYPE_LITERAL);
	} else {
		_tmp35_ = FALSE;
	}
	if (_tmp35_) {
		ValaExpression* b = NULL;
		ValaCodeNode* _tmp38_;
		ValaExpression* _tmp39_;
		ValaCodeNode* _tmp40_;
		ValaExpression* _tmp41_;
		ValaSymbol* _tmp42_;
		ValaSymbol* _tmp43_;
		gboolean _tmp44_ = FALSE;
		ValaExpression* _tmp45_;
		ValaSymbol* _tmp46_;
		ValaSymbol* _tmp47_;
		_tmp38_ = best;
		_tmp39_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, VALA_TYPE_EXPRESSION, ValaExpression));
		b = _tmp39_;
		_tmp40_ = best;
		_tmp41_ = b;
		_tmp42_ = vala_expression_get_symbol_reference (_tmp41_);
		_tmp43_ = _tmp42_;
		g_debug ("server.vala:930: best (%p) is a Expression (symbol_reference = %p)", _tmp40_, _tmp43_);
		_tmp45_ = b;
		_tmp46_ = vala_expression_get_symbol_reference (_tmp45_);
		_tmp47_ = _tmp46_;
		if (_tmp47_ != NULL) {
			ValaExpression* _tmp48_;
			ValaSymbol* _tmp49_;
			ValaSymbol* _tmp50_;
			ValaSourceReference* _tmp51_;
			ValaSourceReference* _tmp52_;
			_tmp48_ = b;
			_tmp49_ = vala_expression_get_symbol_reference (_tmp48_);
			_tmp50_ = _tmp49_;
			_tmp51_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp50_);
			_tmp52_ = _tmp51_;
			_tmp44_ = _tmp52_ != NULL;
		} else {
			_tmp44_ = FALSE;
		}
		if (_tmp44_) {
			ValaExpression* _tmp53_;
			ValaSymbol* _tmp54_;
			ValaSymbol* _tmp55_;
			ValaCodeNode* _tmp56_;
			ValaCodeNode* _tmp57_;
			ValaCodeNode* _tmp58_;
			gchar* _tmp59_;
			gchar* _tmp60_;
			_tmp53_ = b;
			_tmp54_ = vala_expression_get_symbol_reference (_tmp53_);
			_tmp55_ = _tmp54_;
			_tmp56_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp55_);
			_vala_code_node_unref0 (best);
			best = _tmp56_;
			_tmp57_ = best;
			_tmp58_ = best;
			_tmp59_ = vala_code_node_to_string (_tmp58_);
			_tmp60_ = _tmp59_;
			g_debug ("server.vala:933: best is now the symbol_referenece => %p (%s)", _tmp57_, _tmp60_);
			_g_free0 (_tmp60_);
		}
		_vala_code_node_unref0 (b);
	} else {
		ValaCodeNode* _tmp61_;
		_tmp61_ = best;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp61_, VALA_TYPE_DATA_TYPE)) {
			ValaCodeNode* _tmp62_;
			ValaSymbol* _tmp63_;
			_tmp62_ = best;
			_tmp63_ = vls_symbol_references_get_symbol_data_type_refers_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, VALA_TYPE_DATA_TYPE, ValaDataType));
			_vala_code_node_unref0 (best);
			best = (ValaCodeNode*) _tmp63_;
		} else {
			ValaCodeNode* _tmp64_;
			_tmp64_ = best;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp64_, VALA_TYPE_USING_DIRECTIVE)) {
				ValaCodeNode* _tmp65_;
				ValaSymbol* _tmp66_;
				ValaSymbol* _tmp67_;
				ValaCodeNode* _tmp68_;
				_tmp65_ = best;
				_tmp66_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp67_ = _tmp66_;
				_tmp68_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp67_);
				_vala_code_node_unref0 (best);
				best = _tmp68_;
			} else {
				ValaCodeNode* _tmp69_;
				_tmp69_ = best;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp69_, VALA_TYPE_METHOD)) {
					ValaMethod* m = NULL;
					ValaCodeNode* _tmp70_;
					ValaMethod* _tmp71_;
					gboolean _tmp72_ = FALSE;
					ValaMethod* _tmp73_;
					ValaMethod* _tmp74_;
					ValaMethod* _tmp75_;
					ValaMethod* _tmp76_;
					_tmp70_ = best;
					_tmp71_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, VALA_TYPE_METHOD, ValaMethod));
					m = _tmp71_;
					_tmp73_ = m;
					_tmp74_ = vala_method_get_base_interface_method (_tmp73_);
					_tmp75_ = _tmp74_;
					_tmp76_ = m;
					if (_tmp75_ != _tmp76_) {
						ValaMethod* _tmp77_;
						ValaMethod* _tmp78_;
						ValaMethod* _tmp79_;
						_tmp77_ = m;
						_tmp78_ = vala_method_get_base_interface_method (_tmp77_);
						_tmp79_ = _tmp78_;
						_tmp72_ = _tmp79_ != NULL;
					} else {
						_tmp72_ = FALSE;
					}
					if (_tmp72_) {
						ValaMethod* _tmp80_;
						ValaMethod* _tmp81_;
						ValaMethod* _tmp82_;
						ValaCodeNode* _tmp83_;
						_tmp80_ = m;
						_tmp81_ = vala_method_get_base_interface_method (_tmp80_);
						_tmp82_ = _tmp81_;
						_tmp83_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp82_);
						_vala_code_node_unref0 (best);
						best = _tmp83_;
					} else {
						gboolean _tmp84_ = FALSE;
						ValaMethod* _tmp85_;
						ValaMethod* _tmp86_;
						ValaMethod* _tmp87_;
						ValaMethod* _tmp88_;
						_tmp85_ = m;
						_tmp86_ = vala_method_get_base_method (_tmp85_);
						_tmp87_ = _tmp86_;
						_tmp88_ = m;
						if (_tmp87_ != _tmp88_) {
							ValaMethod* _tmp89_;
							ValaMethod* _tmp90_;
							ValaMethod* _tmp91_;
							_tmp89_ = m;
							_tmp90_ = vala_method_get_base_method (_tmp89_);
							_tmp91_ = _tmp90_;
							_tmp84_ = _tmp91_ != NULL;
						} else {
							_tmp84_ = FALSE;
						}
						if (_tmp84_) {
							ValaMethod* _tmp92_;
							ValaMethod* _tmp93_;
							ValaMethod* _tmp94_;
							ValaCodeNode* _tmp95_;
							_tmp92_ = m;
							_tmp93_ = vala_method_get_base_method (_tmp92_);
							_tmp94_ = _tmp93_;
							_tmp95_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp94_);
							_vala_code_node_unref0 (best);
							best = _tmp95_;
						} else {
							_vala_code_node_unref0 (best);
							best = NULL;
						}
					}
					_vala_code_node_unref0 (m);
				} else {
					ValaCodeNode* _tmp96_;
					_tmp96_ = best;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp96_, VALA_TYPE_PROPERTY)) {
						ValaProperty* prop = NULL;
						ValaCodeNode* _tmp97_;
						ValaProperty* _tmp98_;
						gboolean _tmp99_ = FALSE;
						ValaProperty* _tmp100_;
						ValaProperty* _tmp101_;
						ValaProperty* _tmp102_;
						ValaProperty* _tmp103_;
						_tmp97_ = best;
						_tmp98_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp97_, VALA_TYPE_PROPERTY, ValaProperty));
						prop = _tmp98_;
						_tmp100_ = prop;
						_tmp101_ = vala_property_get_base_interface_property (_tmp100_);
						_tmp102_ = _tmp101_;
						_tmp103_ = prop;
						if (_tmp102_ != _tmp103_) {
							ValaProperty* _tmp104_;
							ValaProperty* _tmp105_;
							ValaProperty* _tmp106_;
							_tmp104_ = prop;
							_tmp105_ = vala_property_get_base_interface_property (_tmp104_);
							_tmp106_ = _tmp105_;
							_tmp99_ = _tmp106_ != NULL;
						} else {
							_tmp99_ = FALSE;
						}
						if (_tmp99_) {
							ValaProperty* _tmp107_;
							ValaProperty* _tmp108_;
							ValaProperty* _tmp109_;
							ValaCodeNode* _tmp110_;
							_tmp107_ = prop;
							_tmp108_ = vala_property_get_base_interface_property (_tmp107_);
							_tmp109_ = _tmp108_;
							_tmp110_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp109_);
							_vala_code_node_unref0 (best);
							best = _tmp110_;
						} else {
							gboolean _tmp111_ = FALSE;
							ValaProperty* _tmp112_;
							ValaProperty* _tmp113_;
							ValaProperty* _tmp114_;
							ValaProperty* _tmp115_;
							_tmp112_ = prop;
							_tmp113_ = vala_property_get_base_property (_tmp112_);
							_tmp114_ = _tmp113_;
							_tmp115_ = prop;
							if (_tmp114_ != _tmp115_) {
								ValaProperty* _tmp116_;
								ValaProperty* _tmp117_;
								ValaProperty* _tmp118_;
								_tmp116_ = prop;
								_tmp117_ = vala_property_get_base_property (_tmp116_);
								_tmp118_ = _tmp117_;
								_tmp111_ = _tmp118_ != NULL;
							} else {
								_tmp111_ = FALSE;
							}
							if (_tmp111_) {
								ValaProperty* _tmp119_;
								ValaProperty* _tmp120_;
								ValaProperty* _tmp121_;
								ValaCodeNode* _tmp122_;
								_tmp119_ = prop;
								_tmp120_ = vala_property_get_base_property (_tmp119_);
								_tmp121_ = _tmp120_;
								_tmp122_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp121_);
								_vala_code_node_unref0 (best);
								best = _tmp122_;
							} else {
								_vala_code_node_unref0 (best);
								best = NULL;
							}
						}
						_vala_code_node_unref0 (prop);
					} else {
						const gchar* _tmp123_ = NULL;
						ValaCodeNode* _tmp124_;
						_tmp124_ = best;
						if (_tmp124_ != NULL) {
							ValaCodeNode* _tmp125_;
							const gchar* _tmp126_;
							const gchar* _tmp127_;
							_tmp125_ = best;
							_tmp126_ = vala_code_node_get_type_name (_tmp125_);
							_tmp127_ = _tmp126_;
							_tmp123_ = _tmp127_;
						} else {
							_tmp123_ = NULL;
						}
						g_debug ("server.vala:958: [%s] best is %s, which we can't handle", _data26_->method, _tmp123_);
						{
							const GVariantType* _tmp128_;
							GVariant* _tmp129_;
							GVariant* _tmp130_;
							GCancellable* _tmp131_;
							_tmp128_ = G_VARIANT_TYPE_VARIANT;
							_tmp129_ = g_variant_new_maybe (_tmp128_, NULL);
							g_variant_ref_sink (_tmp129_);
							_tmp130_ = _tmp129_;
							_tmp131_ = vls_server_cancellable;
							jsonrpc_client_reply (_data26_->client, _data26_->id, _tmp130_, _tmp131_, &_inner_error0_);
							_g_variant_unref0 (_tmp130_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								goto __catch1_g_error;
							}
						}
						goto __finally1;
						__catch1_g_error:
						{
							GError* e = NULL;
							GError* _tmp132_;
							const gchar* _tmp133_;
							e = _inner_error0_;
							_inner_error0_ = NULL;
							_tmp132_ = e;
							_tmp133_ = _tmp132_->message;
							g_debug ("server.vala:962: [textDocument/definition] failed to reply to client: " \
"%s", _tmp133_);
							_g_error_free0 (e);
						}
						__finally1:
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_vala_code_node_unref0 (best);
							_vala_code_visitor_unref0 (fs);
							_g_object_unref0 (compilation);
							_vala_source_file_unref0 (file);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
						vala_code_context_pop ();
						_vala_code_node_unref0 (best);
						_vala_code_visitor_unref0 (fs);
						_g_object_unref0 (compilation);
						_vala_source_file_unref0 (file);
						return;
					}
				}
			}
		}
	}
	_tmp134_ = best;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp134_, VALA_TYPE_SYMBOL)) {
		VlsProject* _tmp135_;
		ValaCodeNode* _tmp136_;
		ValaSymbol* _tmp137_;
		_tmp135_ = _data26_->selected_project;
		_tmp136_ = best;
		_tmp137_ = vls_symbol_references_find_real_symbol (_tmp135_, G_TYPE_CHECK_INSTANCE_CAST (_tmp136_, VALA_TYPE_SYMBOL, ValaSymbol));
		_vala_code_node_unref0 (best);
		best = (ValaCodeNode*) _tmp137_;
	}
	_tmp138_ = best;
	_tmp139_ = vala_code_node_get_source_reference (_tmp138_);
	_tmp140_ = _tmp139_;
	_tmp141_ = lsp_location_new_from_sourceref (_tmp140_);
	if (_tmp141_) {
		g_object_set_data ((GObject *) _tmp141_, "vala-creation-function", "Vls.Server.textDocumentDefinition._lambda41_");
	}
	location = _tmp141_;
	_tmp142_ = location;
	_tmp143_ = lsp_location_get_uri (_tmp142_);
	_tmp144_ = _tmp143_;
	g_debug ("server.vala:972: [textDocument/definition] found location ... %s", _tmp144_);
	{
		GVariant* _tmp145_ = NULL;
		LspLocation* _tmp146_;
		GVariant* _tmp147_;
		GCancellable* _tmp148_;
		_tmp146_ = location;
		_tmp147_ = vls_util_object_to_variant ((GObject*) _tmp146_, &_inner_error0_);
		_tmp145_ = _tmp147_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch2_g_error;
		}
		_tmp148_ = vls_server_cancellable;
		jsonrpc_client_reply (_data26_->client, _data26_->id, _tmp145_, _tmp148_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (_tmp145_);
			goto __catch2_g_error;
		}
		_g_variant_unref0 (_tmp145_);
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp149_;
		const gchar* _tmp150_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp149_ = e;
		_tmp150_ = _tmp149_->message;
		g_debug ("server.vala:976: [textDocument/definition] failed to reply to client: " \
"%s", _tmp150_);
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (location);
		_vala_code_node_unref0 (best);
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_g_object_unref0 (location);
	_vala_code_node_unref0 (best);
	_vala_code_visitor_unref0 (fs);
	_g_object_unref0 (compilation);
	_vala_source_file_unref0 (file);
}

static void
___lambda41__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda41_ (self, request_cancelled);
}

static void
vls_server_textDocumentDefinition (VlsServer* self,
                                   JsonrpcServer* _self_,
                                   JsonrpcClient* client,
                                   const gchar* method,
                                   GVariant* id,
                                   GVariant* params)
{
	Block26Data* _data26_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	GeeArrayList* _tmp4_;
	GHashTable* _tmp5_;
	guint _tmp6_ = 0;
	gconstpointer* _tmp7_;
	VlsProject* _tmp20_;
	GeeArrayList* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data26_ = g_slice_new0 (Block26Data);
	_data26_->_ref_count_ = 1;
	_data26_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data26_->client);
	_data26_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data26_->method);
	_data26_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data26_->id);
	_data26_->id = _tmp2_;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	_data26_->p = (LspTextDocumentPositionParams*) _tmp3_;
	_tmp4_ = gee_array_list_new (VLS_TYPE_PAIR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp4_) {
		g_object_set_data ((GObject *) _tmp4_, "vala-creation-function", "Vls.Server.textDocumentDefinition");
	}
	_data26_->results = _tmp4_;
	_data26_->selected_project = NULL;
	_tmp5_ = self->priv->projects;
	_tmp7_ = g_hash_table_get_keys_as_array (_tmp5_, &_tmp6_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp7_;
		project_collection_length1 = _tmp6_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				VlsProject* _tmp8_;
				LspTextDocumentPositionParams* _tmp9_;
				LspTextDocumentIdentifier* _tmp10_;
				LspTextDocumentIdentifier* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				GeeArrayList* _tmp14_;
				GeeArrayList* _tmp15_;
				gboolean _tmp16_;
				gboolean _tmp17_;
				_tmp8_ = project;
				_tmp9_ = _data26_->p;
				_tmp10_ = lsp_text_document_position_params_get_textDocument (_tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = lsp_text_document_identifier_get_uri (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = vls_project_lookup_compile_input_source_file (_tmp8_, _tmp13_);
				_g_object_unref0 (_data26_->results);
				_data26_->results = _tmp14_;
				_tmp15_ = _data26_->results;
				_tmp16_ = gee_collection_get_is_empty ((GeeCollection*) _tmp15_);
				_tmp17_ = _tmp16_;
				if (!_tmp17_) {
					VlsProject* _tmp18_;
					VlsProject* _tmp19_;
					_tmp18_ = project;
					_tmp19_ = _g_object_ref0 (_tmp18_);
					_g_object_unref0 (_data26_->selected_project);
					_data26_->selected_project = _tmp19_;
					break;
				}
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp20_ = _data26_->selected_project;
	if (_tmp20_ == NULL) {
		VlsDefaultProject* _tmp21_;
		LspTextDocumentPositionParams* _tmp22_;
		LspTextDocumentIdentifier* _tmp23_;
		LspTextDocumentIdentifier* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		GeeArrayList* _tmp27_;
		VlsDefaultProject* _tmp28_;
		VlsProject* _tmp29_;
		_tmp21_ = self->priv->default_project;
		_tmp22_ = _data26_->p;
		_tmp23_ = lsp_text_document_position_params_get_textDocument (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = lsp_text_document_identifier_get_uri (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = vls_project_lookup_compile_input_source_file ((VlsProject*) _tmp21_, _tmp26_);
		_g_object_unref0 (_data26_->results);
		_data26_->results = _tmp27_;
		_tmp28_ = self->priv->default_project;
		_tmp29_ = _g_object_ref0 ((VlsProject*) _tmp28_);
		_g_object_unref0 (_data26_->selected_project);
		_data26_->selected_project = _tmp29_;
	}
	_tmp30_ = _data26_->results;
	_tmp31_ = gee_collection_get_is_empty ((GeeCollection*) _tmp30_);
	_tmp32_ = _tmp31_;
	if (_tmp32_) {
		const gchar* _tmp33_;
		LspTextDocumentPositionParams* _tmp34_;
		LspTextDocumentIdentifier* _tmp35_;
		LspTextDocumentIdentifier* _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		_tmp33_ = string_to_string (_data26_->method);
		_tmp34_ = _data26_->p;
		_tmp35_ = lsp_text_document_position_params_get_textDocument (_tmp34_);
		_tmp36_ = _tmp35_;
		_tmp37_ = lsp_text_document_identifier_get_uri (_tmp36_);
		_tmp38_ = _tmp37_;
		_tmp39_ = string_to_string (_tmp38_);
		_tmp40_ = g_strconcat ("[", _tmp33_, "] file `", _tmp39_, "' not found", NULL);
		_tmp41_ = _tmp40_;
		g_debug ("server.vala:897: %s", _tmp41_);
		_g_free0 (_tmp41_);
		vls_server_reply_null (_data26_->id, _data26_->client, _data26_->method);
		block26_data_unref (_data26_);
		_data26_ = NULL;
		return;
	}
	vls_server_wait_for_context_update (self, _data26_->id, ___lambda41__vls_server_on_context_updated_func, block26_data_ref (_data26_), block26_data_unref);
	block26_data_unref (_data26_);
	_data26_ = NULL;
}

static Block27Data*
block27_data_ref (Block27Data* _data27_)
{
	g_atomic_int_inc (&_data27_->_ref_count_);
	return _data27_;
}

static void
block27_data_unref (void * _userdata_)
{
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
		VlsServer* self;
		self = _data27_->self;
		_g_object_unref0 (_data27_->results);
		_g_object_unref0 (_data27_->p);
		_g_object_unref0 (_data27_->client);
		_g_free0 (_data27_->method);
		_g_variant_unref0 (_data27_->id);
		_g_object_unref0 (self);
		g_slice_free (Block27Data, _data27_);
	}
}

static void
__lambda42_ (Block27Data* _data27_,
             gboolean request_cancelled)
{
	VlsServer* self;
	ValaSourceFile* file = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	VlsPair* _tmp2_;
	gconstpointer _tmp3_;
	gconstpointer _tmp4_;
	ValaSourceFile* _tmp5_;
	ValaSourceFile* _tmp6_;
	VlsCompilation* compilation = NULL;
	GeeArrayList* _tmp7_;
	gpointer _tmp8_;
	VlsPair* _tmp9_;
	gconstpointer _tmp10_;
	gconstpointer _tmp11_;
	VlsCompilation* _tmp12_;
	VlsCompilation* _tmp13_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaSourceFile* _tmp17_;
	ValaCodeContext* _tmp18_;
	ValaCodeContext* _tmp19_;
	VlsCompilation* _tmp25_;
	ValaCodeContext* _tmp26_;
	ValaCodeContext* _tmp27_;
	JsonArray* array = NULL;
	JsonArray* _tmp28_;
	VlsSymbolEnumerator* syms = NULL;
	VlsCompilation* _tmp29_;
	ValaSourceFile* _tmp30_;
	VlsCodeAnalyzer* _tmp31_;
	VlsSymbolEnumerator* _tmp32_;
	LspInitializeParams* _tmp33_;
	LspClientCapabilities* _tmp34_;
	LspClientCapabilities* _tmp35_;
	LspTextDocumentClientCapabilities* _tmp36_;
	LspTextDocumentClientCapabilities* _tmp37_;
	LspDocumentSymbolCapabilities* _tmp38_;
	LspDocumentSymbolCapabilities* _tmp39_;
	gboolean _tmp40_;
	gboolean _tmp41_;
	GError* _inner_error0_ = NULL;
	self = _data27_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data27_->id, _data27_->client, _data27_->method);
		return;
	}
	_tmp0_ = _data27_->results;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
	_tmp2_ = (VlsPair*) _tmp1_;
	_tmp3_ = vls_pair_get_first (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp2_);
	file = _tmp6_;
	_tmp7_ = _data27_->results;
	_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, 0);
	_tmp9_ = (VlsPair*) _tmp8_;
	_tmp10_ = vls_pair_get_second (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = _g_object_ref0 ((VlsCompilation*) _tmp11_);
	_tmp13_ = _tmp12_;
	_g_object_unref0 (_tmp9_);
	compilation = _tmp13_;
	_tmp14_ = compilation;
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = file;
	_tmp18_ = vala_source_file_get_context (_tmp17_);
	_tmp19_ = _tmp18_;
	if (_tmp16_ != _tmp19_) {
		LspTextDocumentPositionParams* _tmp20_;
		LspTextDocumentIdentifier* _tmp21_;
		LspTextDocumentIdentifier* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		_tmp20_ = _data27_->p;
		_tmp21_ = lsp_text_document_position_params_get_textDocument (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = lsp_text_document_identifier_get_uri (_tmp22_);
		_tmp24_ = _tmp23_;
		g_debug ("server.vala:1021: [%s] file (%s) context != compilation.code_context; " \
"not proceeding further", _data27_->method, _tmp24_);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (file);
		return;
	}
	_tmp25_ = compilation;
	_tmp26_ = vls_compilation_get_code_context (_tmp25_);
	_tmp27_ = _tmp26_;
	vala_code_context_push (_tmp27_);
	_tmp28_ = json_array_new ();
	array = _tmp28_;
	_tmp29_ = compilation;
	_tmp30_ = file;
	_tmp31_ = vls_compilation_get_analysis_for_file (_tmp29_, VLS_TYPE_SYMBOL_ENUMERATOR, (GBoxedCopyFunc) vala_code_visitor_ref, (GDestroyNotify) vala_code_visitor_unref, _tmp30_);
	_tmp32_ = VLS_IS_SYMBOL_ENUMERATOR (_tmp31_) ? ((VlsSymbolEnumerator*) _tmp31_) : NULL;
	if (_tmp32_ == NULL) {
		_vala_code_visitor_unref0 (_tmp31_);
	}
	syms = _tmp32_;
	_tmp33_ = self->priv->init_params;
	_tmp34_ = lsp_initialize_params_get_capabilities (_tmp33_);
	_tmp35_ = _tmp34_;
	_tmp36_ = lsp_client_capabilities_get_textDocument (_tmp35_);
	_tmp37_ = _tmp36_;
	_tmp38_ = lsp_text_document_client_capabilities_get_documentSymbol (_tmp37_);
	_tmp39_ = _tmp38_;
	_tmp40_ = lsp_document_symbol_capabilities_get_hierarchicalDocumentSymbolSupport (_tmp39_);
	_tmp41_ = _tmp40_;
	if (_tmp41_) {
		{
			GeeIterator* _dsym_it = NULL;
			VlsSymbolEnumerator* _tmp42_;
			GeeIterator* _tmp43_;
			_tmp42_ = syms;
			_tmp43_ = vls_symbol_enumerator_iterator (_tmp42_);
			_dsym_it = _tmp43_;
			while (TRUE) {
				GeeIterator* _tmp44_;
				LspDocumentSymbol* dsym = NULL;
				GeeIterator* _tmp45_;
				gpointer _tmp46_;
				JsonArray* _tmp47_;
				LspDocumentSymbol* _tmp48_;
				JsonNode* _tmp49_;
				_tmp44_ = _dsym_it;
				if (!gee_iterator_next (_tmp44_)) {
					break;
				}
				_tmp45_ = _dsym_it;
				_tmp46_ = gee_iterator_get (_tmp45_);
				dsym = (LspDocumentSymbol*) _tmp46_;
				_tmp47_ = array;
				_tmp48_ = dsym;
				_tmp49_ = json_gobject_serialize ((GObject*) _tmp48_);
				json_array_add_element (_tmp47_, _tmp49_);
				_g_object_unref0 (dsym);
			}
			_g_object_unref0 (_dsym_it);
		}
	} else {
		{
			GeeIterator* _dsym_it = NULL;
			VlsSymbolEnumerator* _tmp50_;
			GeeIterable* _tmp51_;
			GeeIterable* _tmp52_;
			GeeIterator* _tmp53_;
			GeeIterator* _tmp54_;
			_tmp50_ = syms;
			_tmp51_ = vls_symbol_enumerator_flattened (_tmp50_);
			_tmp52_ = _tmp51_;
			_tmp53_ = gee_iterable_iterator (_tmp52_);
			_tmp54_ = _tmp53_;
			_g_object_unref0 (_tmp52_);
			_dsym_it = _tmp54_;
			while (TRUE) {
				GeeIterator* _tmp55_;
				LspSymbolInformation* dsym = NULL;
				GeeIterator* _tmp56_;
				gpointer _tmp57_;
				JsonArray* _tmp58_;
				LspSymbolInformation* _tmp59_;
				JsonNode* _tmp60_;
				_tmp55_ = _dsym_it;
				if (!gee_iterator_next (_tmp55_)) {
					break;
				}
				_tmp56_ = _dsym_it;
				_tmp57_ = gee_iterator_get (_tmp56_);
				dsym = (LspSymbolInformation*) _tmp57_;
				_tmp58_ = array;
				_tmp59_ = dsym;
				_tmp60_ = json_gobject_serialize ((GObject*) _tmp59_);
				json_array_add_element (_tmp58_, _tmp60_);
				_g_object_unref0 (dsym);
			}
			_g_object_unref0 (_dsym_it);
		}
	}
	{
		GVariant* _result_ = NULL;
		JsonNode* _tmp61_;
		JsonNode* _tmp62_;
		JsonArray* _tmp63_;
		JsonNode* _tmp64_;
		GVariant* _tmp65_;
		GVariant* _tmp66_;
		GVariant* _tmp67_;
		GCancellable* _tmp68_;
		_tmp61_ = json_node_alloc ();
		_tmp62_ = _tmp61_;
		_tmp63_ = array;
		_tmp64_ = json_node_init_array (_tmp62_, _tmp63_);
		_tmp65_ = json_gvariant_deserialize (_tmp64_, NULL, &_inner_error0_);
		if (_tmp65_ != NULL) {
			g_variant_ref_sink (_tmp65_);
		}
		_tmp66_ = _tmp65_;
		__vala_JsonNode_free0 (_tmp62_);
		_result_ = _tmp66_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp67_ = _result_;
		_tmp68_ = vls_server_cancellable;
		jsonrpc_client_reply (_data27_->client, _data27_->id, _tmp67_, _tmp68_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (_result_);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (_result_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp69_;
		const gchar* _tmp70_;
		const gchar* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp69_ = e;
		_tmp70_ = _tmp69_->message;
		_tmp71_ = string_to_string (_tmp70_);
		_tmp72_ = g_strconcat ("[textDocument/documentSymbol] failed to reply to client: ", _tmp71_, NULL);
		_tmp73_ = _tmp72_;
		g_debug ("server.vala:1046: %s", _tmp73_);
		_g_free0 (_tmp73_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_vala_code_visitor_unref0 (syms);
		_json_array_unref0 (array);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_vala_code_visitor_unref0 (syms);
	_json_array_unref0 (array);
	_g_object_unref0 (compilation);
	_vala_source_file_unref0 (file);
}

static void
___lambda42__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda42_ (self, request_cancelled);
}

static void
vls_server_textDocumentDocumentSymbol (VlsServer* self,
                                       JsonrpcServer* _self_,
                                       JsonrpcClient* client,
                                       const gchar* method,
                                       GVariant* id,
                                       GVariant* params)
{
	Block27Data* _data27_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	GeeArrayList* _tmp4_;
	VlsProject* selected_project = NULL;
	GHashTable* _tmp5_;
	guint _tmp6_ = 0;
	gconstpointer* _tmp7_;
	VlsProject* _tmp20_;
	GeeArrayList* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data27_ = g_slice_new0 (Block27Data);
	_data27_->_ref_count_ = 1;
	_data27_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data27_->client);
	_data27_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data27_->method);
	_data27_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data27_->id);
	_data27_->id = _tmp2_;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	_data27_->p = (LspTextDocumentPositionParams*) _tmp3_;
	_tmp4_ = gee_array_list_new (VLS_TYPE_PAIR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp4_) {
		g_object_set_data ((GObject *) _tmp4_, "vala-creation-function", "Vls.Server.textDocumentDocumentSymbol");
	}
	_data27_->results = _tmp4_;
	selected_project = NULL;
	_tmp5_ = self->priv->projects;
	_tmp7_ = g_hash_table_get_keys_as_array (_tmp5_, &_tmp6_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp7_;
		project_collection_length1 = _tmp6_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				VlsProject* _tmp8_;
				LspTextDocumentPositionParams* _tmp9_;
				LspTextDocumentIdentifier* _tmp10_;
				LspTextDocumentIdentifier* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				GeeArrayList* _tmp14_;
				GeeArrayList* _tmp15_;
				gboolean _tmp16_;
				gboolean _tmp17_;
				_tmp8_ = project;
				_tmp9_ = _data27_->p;
				_tmp10_ = lsp_text_document_position_params_get_textDocument (_tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = lsp_text_document_identifier_get_uri (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = vls_project_lookup_compile_input_source_file (_tmp8_, _tmp13_);
				_g_object_unref0 (_data27_->results);
				_data27_->results = _tmp14_;
				_tmp15_ = _data27_->results;
				_tmp16_ = gee_collection_get_is_empty ((GeeCollection*) _tmp15_);
				_tmp17_ = _tmp16_;
				if (!_tmp17_) {
					VlsProject* _tmp18_;
					VlsProject* _tmp19_;
					_tmp18_ = project;
					_tmp19_ = _g_object_ref0 (_tmp18_);
					_g_object_unref0 (selected_project);
					selected_project = _tmp19_;
					break;
				}
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp20_ = selected_project;
	if (_tmp20_ == NULL) {
		VlsDefaultProject* _tmp21_;
		LspTextDocumentPositionParams* _tmp22_;
		LspTextDocumentIdentifier* _tmp23_;
		LspTextDocumentIdentifier* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		GeeArrayList* _tmp27_;
		VlsDefaultProject* _tmp28_;
		VlsProject* _tmp29_;
		_tmp21_ = self->priv->default_project;
		_tmp22_ = _data27_->p;
		_tmp23_ = lsp_text_document_position_params_get_textDocument (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = lsp_text_document_identifier_get_uri (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = vls_project_lookup_compile_input_source_file ((VlsProject*) _tmp21_, _tmp26_);
		_g_object_unref0 (_data27_->results);
		_data27_->results = _tmp27_;
		_tmp28_ = self->priv->default_project;
		_tmp29_ = _g_object_ref0 ((VlsProject*) _tmp28_);
		_g_object_unref0 (selected_project);
		selected_project = _tmp29_;
	}
	_tmp30_ = _data27_->results;
	_tmp31_ = gee_collection_get_is_empty ((GeeCollection*) _tmp30_);
	_tmp32_ = _tmp31_;
	if (_tmp32_) {
		const gchar* _tmp33_;
		LspTextDocumentPositionParams* _tmp34_;
		LspTextDocumentIdentifier* _tmp35_;
		LspTextDocumentIdentifier* _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		_tmp33_ = string_to_string (_data27_->method);
		_tmp34_ = _data27_->p;
		_tmp35_ = lsp_text_document_position_params_get_textDocument (_tmp34_);
		_tmp36_ = _tmp35_;
		_tmp37_ = lsp_text_document_identifier_get_uri (_tmp36_);
		_tmp38_ = _tmp37_;
		_tmp39_ = string_to_string (_tmp38_);
		_tmp40_ = g_strconcat ("[", _tmp33_, "] file `", _tmp39_, "' not found", NULL);
		_tmp41_ = _tmp40_;
		g_debug ("server.vala:999: %s", _tmp41_);
		_g_free0 (_tmp41_);
		vls_server_reply_null (_data27_->id, _data27_->client, _data27_->method);
		_g_object_unref0 (selected_project);
		block27_data_unref (_data27_);
		_data27_ = NULL;
		return;
	}
	vls_server_wait_for_context_update (self, _data27_->id, ___lambda42__vls_server_on_context_updated_func, block27_data_ref (_data27_), block27_data_unref);
	_g_object_unref0 (selected_project);
	block27_data_unref (_data27_);
	_data27_ = NULL;
}

static gpointer
_vala_comment_ref0 (gpointer self)
{
	return self ? vala_comment_ref (self) : NULL;
}

VlsDocComment*
vls_server_get_symbol_documentation (VlsServer* self,
                                     VlsProject* project,
                                     ValaSymbol* sym)
{
	VlsCompilation* compilation = NULL;
	ValaSymbol* real_sym = NULL;
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	ValaSymbol* root = NULL;
	ValaSymbol* _tmp11_;
	VlsCompilation* _tmp28_;
	ValaComment* comment = NULL;
	VlsDocComment* doc_comment = NULL;
	ValaSymbol* gir_sym = NULL;
	VlsGirDocumentation* _tmp29_;
	ValaSymbol* _tmp30_;
	gboolean _tmp31_ = FALSE;
	ValaSymbol* _tmp32_;
	ValaComment* _tmp43_;
	gboolean _tmp65_ = FALSE;
	VlsDocComment* _tmp66_;
	GError* _inner_error0_ = NULL;
	VlsDocComment* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (project != NULL, NULL);
	g_return_val_if_fail (sym != NULL, NULL);
	compilation = NULL;
	_tmp0_ = vls_symbol_references_find_real_symbol (project, sym);
	real_sym = _tmp0_;
	_tmp1_ = real_sym;
	sym = _tmp1_;
	root = NULL;
	{
		ValaSymbol* node = NULL;
		ValaSymbol* _tmp2_;
		_tmp2_ = _vala_code_node_ref0 (sym);
		node = _tmp2_;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				ValaSymbol* _tmp8_;
				ValaSymbol* _tmp9_;
				ValaSymbol* _tmp10_;
				if (!_tmp3_) {
					ValaSymbol* _tmp4_;
					ValaSymbol* _tmp5_;
					ValaSymbol* _tmp6_;
					ValaSymbol* _tmp7_;
					_tmp4_ = node;
					_tmp5_ = vala_symbol_get_parent_symbol (_tmp4_);
					_tmp6_ = _tmp5_;
					_tmp7_ = _vala_code_node_ref0 (_tmp6_);
					_vala_code_node_unref0 (node);
					node = _tmp7_;
				}
				_tmp3_ = FALSE;
				_tmp8_ = node;
				if (!(_tmp8_ != NULL)) {
					break;
				}
				_tmp9_ = node;
				_tmp10_ = _vala_code_node_ref0 (_tmp9_);
				_vala_code_node_unref0 (root);
				root = _tmp10_;
			}
		}
		_vala_code_node_unref0 (node);
	}
	_tmp11_ = root;
	_vala_assert (_tmp11_ != NULL, "root != null");
	{
		GeeArrayList* _project_compilation_list = NULL;
		GeeArrayList* _tmp12_;
		gint _project_compilation_size = 0;
		GeeArrayList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _project_compilation_index = 0;
		_tmp12_ = vls_project_get_compilations (project);
		_project_compilation_list = _tmp12_;
		_tmp13_ = _project_compilation_list;
		_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
		_tmp15_ = _tmp14_;
		_project_compilation_size = _tmp15_;
		_project_compilation_index = -1;
		while (TRUE) {
			gint _tmp16_;
			gint _tmp17_;
			VlsCompilation* project_compilation = NULL;
			GeeArrayList* _tmp18_;
			gpointer _tmp19_;
			VlsCompilation* _tmp20_;
			ValaCodeContext* _tmp21_;
			ValaCodeContext* _tmp22_;
			ValaNamespace* _tmp23_;
			ValaNamespace* _tmp24_;
			ValaSymbol* _tmp25_;
			_project_compilation_index = _project_compilation_index + 1;
			_tmp16_ = _project_compilation_index;
			_tmp17_ = _project_compilation_size;
			if (!(_tmp16_ < _tmp17_)) {
				break;
			}
			_tmp18_ = _project_compilation_list;
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _project_compilation_index);
			project_compilation = (VlsCompilation*) _tmp19_;
			_tmp20_ = project_compilation;
			_tmp21_ = vls_compilation_get_code_context (_tmp20_);
			_tmp22_ = _tmp21_;
			_tmp23_ = vala_code_context_get_root (_tmp22_);
			_tmp24_ = _tmp23_;
			_tmp25_ = root;
			if (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, VALA_TYPE_SYMBOL, ValaSymbol) == _tmp25_) {
				VlsCompilation* _tmp26_;
				VlsCompilation* _tmp27_;
				_tmp26_ = project_compilation;
				_tmp27_ = _g_object_ref0 (_tmp26_);
				_g_object_unref0 (compilation);
				compilation = _tmp27_;
				_g_object_unref0 (project_compilation);
				break;
			}
			_g_object_unref0 (project_compilation);
		}
		_g_object_unref0 (_project_compilation_list);
	}
	_tmp28_ = compilation;
	if (_tmp28_ == NULL) {
		result = NULL;
		_vala_code_node_unref0 (root);
		_vala_code_node_unref0 (real_sym);
		_g_object_unref0 (compilation);
		return result;
	}
	comment = NULL;
	doc_comment = NULL;
	_tmp29_ = self->priv->documentation;
	_tmp30_ = vls_gir_documentation_find_gir_symbol (_tmp29_, sym);
	gir_sym = _tmp30_;
	_tmp32_ = gir_sym;
	if (_tmp32_ != NULL) {
		ValaSymbol* _tmp33_;
		ValaComment* _tmp34_;
		ValaComment* _tmp35_;
		_tmp33_ = gir_sym;
		_tmp34_ = vala_symbol_get_comment (_tmp33_);
		_tmp35_ = _tmp34_;
		_tmp31_ = _tmp35_ != NULL;
	} else {
		_tmp31_ = FALSE;
	}
	if (_tmp31_) {
		ValaSymbol* _tmp36_;
		ValaComment* _tmp37_;
		ValaComment* _tmp38_;
		ValaComment* _tmp39_;
		_tmp36_ = gir_sym;
		_tmp37_ = vala_symbol_get_comment (_tmp36_);
		_tmp38_ = _tmp37_;
		_tmp39_ = _vala_comment_ref0 (_tmp38_);
		_vala_comment_unref0 (comment);
		comment = _tmp39_;
	} else {
		ValaComment* _tmp40_;
		ValaComment* _tmp41_;
		ValaComment* _tmp42_;
		_tmp40_ = vala_symbol_get_comment (sym);
		_tmp41_ = _tmp40_;
		_tmp42_ = _vala_comment_ref0 (_tmp41_);
		_vala_comment_unref0 (comment);
		comment = _tmp42_;
	}
	_tmp43_ = comment;
	if (_tmp43_ != NULL) {
		{
			gboolean _tmp44_ = FALSE;
			ValaComment* _tmp45_;
			_tmp45_ = comment;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp45_, VALA_TYPE_GIR_COMMENT)) {
				_tmp44_ = TRUE;
			} else {
				gboolean _tmp46_ = FALSE;
				ValaSymbol* _tmp47_;
				_tmp47_ = gir_sym;
				if (_tmp47_ != NULL) {
					ValaSymbol* _tmp48_;
					ValaComment* _tmp49_;
					ValaComment* _tmp50_;
					ValaComment* _tmp51_;
					_tmp48_ = gir_sym;
					_tmp49_ = vala_symbol_get_comment (_tmp48_);
					_tmp50_ = _tmp49_;
					_tmp51_ = comment;
					_tmp46_ = _tmp50_ == _tmp51_;
				} else {
					_tmp46_ = FALSE;
				}
				_tmp44_ = _tmp46_;
			}
			if (_tmp44_) {
				VlsDocComment* _tmp52_ = NULL;
				ValaComment* _tmp53_;
				VlsGirDocumentation* _tmp54_;
				VlsCompilation* _tmp55_;
				VlsDocComment* _tmp56_;
				VlsDocComment* _tmp57_;
				_tmp53_ = comment;
				_tmp54_ = self->priv->documentation;
				_tmp55_ = compilation;
				_tmp56_ = vls_doc_comment_new_from_gir_comment (_tmp53_, _tmp54_, _tmp55_, &_inner_error0_);
				_tmp52_ = _tmp56_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == G_REGEX_ERROR) {
						goto __catch0_g_regex_error;
					}
					_vala_code_node_unref0 (gir_sym);
					_vls_doc_comment_unref0 (doc_comment);
					_vala_comment_unref0 (comment);
					_vala_code_node_unref0 (root);
					_vala_code_node_unref0 (real_sym);
					_g_object_unref0 (compilation);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
				_tmp57_ = _tmp52_;
				_tmp52_ = NULL;
				_vls_doc_comment_unref0 (doc_comment);
				doc_comment = _tmp57_;
				_vls_doc_comment_unref0 (_tmp52_);
			} else {
				VlsDocComment* _tmp58_ = NULL;
				ValaComment* _tmp59_;
				VlsCompilation* _tmp60_;
				VlsDocComment* _tmp61_;
				VlsDocComment* _tmp62_;
				_tmp59_ = comment;
				_tmp60_ = compilation;
				_tmp61_ = vls_doc_comment_new_from_valadoc_comment (_tmp59_, sym, _tmp60_, &_inner_error0_);
				_tmp58_ = _tmp61_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == G_REGEX_ERROR) {
						goto __catch0_g_regex_error;
					}
					_vala_code_node_unref0 (gir_sym);
					_vls_doc_comment_unref0 (doc_comment);
					_vala_comment_unref0 (comment);
					_vala_code_node_unref0 (root);
					_vala_code_node_unref0 (real_sym);
					_g_object_unref0 (compilation);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
				_tmp62_ = _tmp58_;
				_tmp58_ = NULL;
				_vls_doc_comment_unref0 (doc_comment);
				doc_comment = _tmp62_;
				_vls_doc_comment_unref0 (_tmp58_);
			}
		}
		goto __finally0;
		__catch0_g_regex_error:
		{
			GError* e = NULL;
			GError* _tmp63_;
			const gchar* _tmp64_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp63_ = e;
			_tmp64_ = _tmp63_->message;
			g_warning ("server.vala:1085: failed to render comment - %s", _tmp64_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_vala_code_node_unref0 (gir_sym);
			_vls_doc_comment_unref0 (doc_comment);
			_vala_comment_unref0 (comment);
			_vala_code_node_unref0 (root);
			_vala_code_node_unref0 (real_sym);
			_g_object_unref0 (compilation);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp66_ = doc_comment;
	if (_tmp66_ == NULL) {
		_tmp65_ = G_TYPE_CHECK_INSTANCE_TYPE (sym, VALA_TYPE_PARAMETER);
	} else {
		_tmp65_ = FALSE;
	}
	if (_tmp65_) {
		VlsDocComment* parent_doc = NULL;
		ValaSymbol* _tmp67_;
		ValaSymbol* _tmp68_;
		VlsDocComment* _tmp69_;
		VlsDocComment* _tmp70_;
		_tmp67_ = vala_symbol_get_parent_symbol (sym);
		_tmp68_ = _tmp67_;
		_tmp69_ = vls_server_get_symbol_documentation (self, project, _tmp68_);
		parent_doc = _tmp69_;
		_tmp70_ = parent_doc;
		if (_tmp70_ != NULL) {
			gchar* doc = NULL;
			VlsDocComment* _tmp71_;
			GeeHashMap* _tmp72_;
			GeeHashMap* _tmp73_;
			const gchar* _tmp74_;
			const gchar* _tmp75_;
			gpointer _tmp76_;
			const gchar* _tmp77_;
			_tmp71_ = parent_doc;
			_tmp72_ = vls_doc_comment_get_parameters (_tmp71_);
			_tmp73_ = _tmp72_;
			_tmp74_ = vala_symbol_get_name (sym);
			_tmp75_ = _tmp74_;
			_tmp76_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp73_, _tmp75_);
			doc = (gchar*) _tmp76_;
			_tmp77_ = doc;
			if (_tmp77_ != NULL) {
				const gchar* _tmp78_;
				VlsDocComment* _tmp79_;
				_tmp78_ = doc;
				_tmp79_ = vls_doc_comment_new (_tmp78_);
				_vls_doc_comment_unref0 (doc_comment);
				doc_comment = _tmp79_;
			}
			_g_free0 (doc);
		}
		_vls_doc_comment_unref0 (parent_doc);
	}
	result = doc_comment;
	_vala_code_node_unref0 (gir_sym);
	_vala_comment_unref0 (comment);
	_vala_code_node_unref0 (root);
	_vala_code_node_unref0 (real_sym);
	_g_object_unref0 (compilation);
	return result;
}

static void
vls_server_textDocumentCompletion (VlsServer* self,
                                   JsonrpcServer* _self_,
                                   JsonrpcClient* client,
                                   const gchar* method,
                                   GVariant* id,
                                   GVariant* params)
{
	LspCompletionParams* p = NULL;
	gpointer _tmp0_;
	GeeArrayList* results = NULL;
	GeeArrayList* _tmp1_;
	VlsProject* selected_project = NULL;
	GHashTable* _tmp2_;
	guint _tmp3_ = 0;
	gconstpointer* _tmp4_;
	VlsProject* _tmp17_;
	GeeArrayList* _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	VlsProject* _tmp39_;
	GeeArrayList* _tmp40_;
	gpointer _tmp41_;
	VlsPair* _tmp42_;
	gconstpointer _tmp43_;
	gconstpointer _tmp44_;
	GeeArrayList* _tmp45_;
	gpointer _tmp46_;
	VlsPair* _tmp47_;
	gconstpointer _tmp48_;
	gconstpointer _tmp49_;
	LspCompletionParams* _tmp50_;
	LspPosition* _tmp51_;
	LspPosition* _tmp52_;
	LspCompletionParams* _tmp53_;
	LspCompletionContext* _tmp54_;
	LspCompletionContext* _tmp55_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_COMPLETION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspCompletionParams*) _tmp0_;
	_tmp1_ = gee_array_list_new (VLS_TYPE_PAIR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp1_) {
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "Vls.Server.textDocumentCompletion");
	}
	results = _tmp1_;
	selected_project = NULL;
	_tmp2_ = self->priv->projects;
	_tmp4_ = g_hash_table_get_keys_as_array (_tmp2_, &_tmp3_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp4_;
		project_collection_length1 = _tmp3_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				VlsProject* _tmp5_;
				LspCompletionParams* _tmp6_;
				LspTextDocumentIdentifier* _tmp7_;
				LspTextDocumentIdentifier* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				GeeArrayList* _tmp11_;
				GeeArrayList* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
				_tmp5_ = project;
				_tmp6_ = p;
				_tmp7_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = lsp_text_document_identifier_get_uri (_tmp8_);
				_tmp10_ = _tmp9_;
				_tmp11_ = vls_project_lookup_compile_input_source_file (_tmp5_, _tmp10_);
				_g_object_unref0 (results);
				results = _tmp11_;
				_tmp12_ = results;
				_tmp13_ = gee_collection_get_is_empty ((GeeCollection*) _tmp12_);
				_tmp14_ = _tmp13_;
				if (!_tmp14_) {
					VlsProject* _tmp15_;
					VlsProject* _tmp16_;
					_tmp15_ = project;
					_tmp16_ = _g_object_ref0 (_tmp15_);
					_g_object_unref0 (selected_project);
					selected_project = _tmp16_;
					break;
				}
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp17_ = selected_project;
	if (_tmp17_ == NULL) {
		VlsDefaultProject* _tmp18_;
		LspCompletionParams* _tmp19_;
		LspTextDocumentIdentifier* _tmp20_;
		LspTextDocumentIdentifier* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		GeeArrayList* _tmp24_;
		VlsDefaultProject* _tmp25_;
		VlsProject* _tmp26_;
		_tmp18_ = self->priv->default_project;
		_tmp19_ = p;
		_tmp20_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = lsp_text_document_identifier_get_uri (_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp24_ = vls_project_lookup_compile_input_source_file ((VlsProject*) _tmp18_, _tmp23_);
		_g_object_unref0 (results);
		results = _tmp24_;
		_tmp25_ = self->priv->default_project;
		_tmp26_ = _g_object_ref0 ((VlsProject*) _tmp25_);
		_g_object_unref0 (selected_project);
		selected_project = _tmp26_;
	}
	_tmp27_ = results;
	_tmp28_ = gee_collection_get_is_empty ((GeeCollection*) _tmp27_);
	_tmp29_ = _tmp28_;
	if (_tmp29_) {
		const gchar* _tmp30_;
		LspCompletionParams* _tmp31_;
		LspTextDocumentIdentifier* _tmp32_;
		LspTextDocumentIdentifier* _tmp33_;
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		_tmp30_ = string_to_string (method);
		_tmp31_ = p;
		_tmp32_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _tmp31_);
		_tmp33_ = _tmp32_;
		_tmp34_ = lsp_text_document_identifier_get_uri (_tmp33_);
		_tmp35_ = _tmp34_;
		_tmp36_ = string_to_string (_tmp35_);
		_tmp37_ = g_strconcat ("[", _tmp30_, "] failed to find file ", _tmp36_, NULL);
		_tmp38_ = _tmp37_;
		g_debug ("server.vala:1118: %s", _tmp38_);
		_g_free0 (_tmp38_);
		vls_server_reply_null (id, client, method);
		_g_object_unref0 (selected_project);
		_g_object_unref0 (results);
		_g_object_unref0 (p);
		return;
	}
	_tmp39_ = selected_project;
	_tmp40_ = results;
	_tmp41_ = gee_abstract_list_get ((GeeAbstractList*) _tmp40_, 0);
	_tmp42_ = (VlsPair*) _tmp41_;
	_tmp43_ = vls_pair_get_first (_tmp42_);
	_tmp44_ = _tmp43_;
	_tmp45_ = results;
	_tmp46_ = gee_abstract_list_get ((GeeAbstractList*) _tmp45_, 0);
	_tmp47_ = (VlsPair*) _tmp46_;
	_tmp48_ = vls_pair_get_second (_tmp47_);
	_tmp49_ = _tmp48_;
	_tmp50_ = p;
	_tmp51_ = lsp_text_document_position_params_get_position ((LspTextDocumentPositionParams*) _tmp50_);
	_tmp52_ = _tmp51_;
	_tmp53_ = p;
	_tmp54_ = lsp_completion_params_get_context (_tmp53_);
	_tmp55_ = _tmp54_;
	vls_completion_engine_begin_response (self, _tmp39_, client, id, method, (ValaSourceFile*) _tmp44_, (VlsCompilation*) _tmp49_, _tmp52_, _tmp55_);
	_g_object_unref0 (_tmp47_);
	_g_object_unref0 (_tmp42_);
	_g_object_unref0 (selected_project);
	_g_object_unref0 (results);
	_g_object_unref0 (p);
}

static void
vls_server_textDocumentSignatureHelp (VlsServer* self,
                                      JsonrpcServer* _self_,
                                      JsonrpcClient* client,
                                      const gchar* method,
                                      GVariant* id,
                                      GVariant* params)
{
	LspTextDocumentPositionParams* p = NULL;
	gpointer _tmp0_;
	GeeArrayList* results = NULL;
	GeeArrayList* _tmp1_;
	VlsProject* selected_project = NULL;
	GHashTable* _tmp2_;
	guint _tmp3_ = 0;
	gconstpointer* _tmp4_;
	VlsProject* _tmp17_;
	GeeArrayList* _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	VlsProject* _tmp35_;
	GeeArrayList* _tmp36_;
	gpointer _tmp37_;
	VlsPair* _tmp38_;
	gconstpointer _tmp39_;
	gconstpointer _tmp40_;
	GeeArrayList* _tmp41_;
	gpointer _tmp42_;
	VlsPair* _tmp43_;
	gconstpointer _tmp44_;
	gconstpointer _tmp45_;
	LspTextDocumentPositionParams* _tmp46_;
	LspPosition* _tmp47_;
	LspPosition* _tmp48_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspTextDocumentPositionParams*) _tmp0_;
	_tmp1_ = gee_array_list_new (VLS_TYPE_PAIR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp1_) {
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "Vls.Server.textDocumentSignatureHelp");
	}
	results = _tmp1_;
	selected_project = NULL;
	_tmp2_ = self->priv->projects;
	_tmp4_ = g_hash_table_get_keys_as_array (_tmp2_, &_tmp3_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp4_;
		project_collection_length1 = _tmp3_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				VlsProject* _tmp5_;
				LspTextDocumentPositionParams* _tmp6_;
				LspTextDocumentIdentifier* _tmp7_;
				LspTextDocumentIdentifier* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				GeeArrayList* _tmp11_;
				GeeArrayList* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
				_tmp5_ = project;
				_tmp6_ = p;
				_tmp7_ = lsp_text_document_position_params_get_textDocument (_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = lsp_text_document_identifier_get_uri (_tmp8_);
				_tmp10_ = _tmp9_;
				_tmp11_ = vls_project_lookup_compile_input_source_file (_tmp5_, _tmp10_);
				_g_object_unref0 (results);
				results = _tmp11_;
				_tmp12_ = results;
				_tmp13_ = gee_collection_get_is_empty ((GeeCollection*) _tmp12_);
				_tmp14_ = _tmp13_;
				if (!_tmp14_) {
					VlsProject* _tmp15_;
					VlsProject* _tmp16_;
					_tmp15_ = project;
					_tmp16_ = _g_object_ref0 (_tmp15_);
					_g_object_unref0 (selected_project);
					selected_project = _tmp16_;
					break;
				}
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp17_ = selected_project;
	if (_tmp17_ == NULL) {
		VlsDefaultProject* _tmp18_;
		LspTextDocumentPositionParams* _tmp19_;
		LspTextDocumentIdentifier* _tmp20_;
		LspTextDocumentIdentifier* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		GeeArrayList* _tmp24_;
		VlsDefaultProject* _tmp25_;
		VlsProject* _tmp26_;
		_tmp18_ = self->priv->default_project;
		_tmp19_ = p;
		_tmp20_ = lsp_text_document_position_params_get_textDocument (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = lsp_text_document_identifier_get_uri (_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp24_ = vls_project_lookup_compile_input_source_file ((VlsProject*) _tmp18_, _tmp23_);
		_g_object_unref0 (results);
		results = _tmp24_;
		_tmp25_ = self->priv->default_project;
		_tmp26_ = _g_object_ref0 ((VlsProject*) _tmp25_);
		_g_object_unref0 (selected_project);
		selected_project = _tmp26_;
	}
	_tmp27_ = results;
	_tmp28_ = gee_collection_get_is_empty ((GeeCollection*) _tmp27_);
	_tmp29_ = _tmp28_;
	if (_tmp29_) {
		LspTextDocumentPositionParams* _tmp30_;
		LspTextDocumentIdentifier* _tmp31_;
		LspTextDocumentIdentifier* _tmp32_;
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		_tmp30_ = p;
		_tmp31_ = lsp_text_document_position_params_get_textDocument (_tmp30_);
		_tmp32_ = _tmp31_;
		_tmp33_ = lsp_text_document_identifier_get_uri (_tmp32_);
		_tmp34_ = _tmp33_;
		g_debug ("server.vala:1146: unknown file %s", _tmp34_);
		vls_server_reply_null (id, client, "textDocument/signatureHelp");
		_g_object_unref0 (selected_project);
		_g_object_unref0 (results);
		_g_object_unref0 (p);
		return;
	}
	_tmp35_ = selected_project;
	_tmp36_ = results;
	_tmp37_ = gee_abstract_list_get ((GeeAbstractList*) _tmp36_, 0);
	_tmp38_ = (VlsPair*) _tmp37_;
	_tmp39_ = vls_pair_get_first (_tmp38_);
	_tmp40_ = _tmp39_;
	_tmp41_ = results;
	_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, 0);
	_tmp43_ = (VlsPair*) _tmp42_;
	_tmp44_ = vls_pair_get_second (_tmp43_);
	_tmp45_ = _tmp44_;
	_tmp46_ = p;
	_tmp47_ = lsp_text_document_position_params_get_position (_tmp46_);
	_tmp48_ = _tmp47_;
	vls_signature_help_engine_begin_response (self, _tmp35_, client, id, method, (ValaSourceFile*) _tmp40_, (VlsCompilation*) _tmp45_, _tmp48_);
	_g_object_unref0 (_tmp43_);
	_g_object_unref0 (_tmp38_);
	_g_object_unref0 (selected_project);
	_g_object_unref0 (results);
	_g_object_unref0 (p);
}

static Block28Data*
block28_data_ref (Block28Data* _data28_)
{
	g_atomic_int_inc (&_data28_->_ref_count_);
	return _data28_;
}

static void
block28_data_unref (void * _userdata_)
{
	Block28Data* _data28_;
	_data28_ = (Block28Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data28_->_ref_count_)) {
		VlsServer* self;
		self = _data28_->self;
		_g_object_unref0 (_data28_->pos);
		_g_object_unref0 (_data28_->selected_project);
		_g_object_unref0 (_data28_->results);
		_g_object_unref0 (_data28_->client);
		_g_variant_unref0 (_data28_->id);
		_g_object_unref0 (self);
		g_slice_free (Block28Data, _data28_);
	}
}

static gpointer
_vala_scope_ref0 (gpointer self)
{
	return self ? vala_scope_ref (self) : NULL;
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static void
__lambda53_ (Block28Data* _data28_,
             gboolean request_cancelled)
{
	VlsServer* self;
	ValaSourceFile* doc = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	VlsPair* _tmp2_;
	gconstpointer _tmp3_;
	gconstpointer _tmp4_;
	ValaSourceFile* _tmp5_;
	ValaSourceFile* _tmp6_;
	VlsCompilation* compilation = NULL;
	GeeArrayList* _tmp7_;
	gpointer _tmp8_;
	VlsPair* _tmp9_;
	gconstpointer _tmp10_;
	gconstpointer _tmp11_;
	VlsCompilation* _tmp12_;
	VlsCompilation* _tmp13_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	VlsFindSymbol* fs = NULL;
	ValaSourceFile* _tmp17_;
	LspPosition* _tmp18_;
	VlsFindSymbol* _tmp19_;
	VlsFindSymbol* _tmp20_;
	GeeList* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	ValaScope* scope = NULL;
	ValaSourceFile* _tmp24_;
	LspPosition* _tmp25_;
	VlsFindScope* _tmp26_;
	VlsFindScope* _tmp27_;
	ValaSymbol* _tmp28_;
	ValaSymbol* _tmp29_;
	ValaScope* _tmp30_;
	ValaScope* _tmp31_;
	ValaScope* _tmp32_;
	ValaScope* _tmp33_;
	ValaCodeNode* _result_ = NULL;
	VlsFindSymbol* _tmp34_;
	ValaSourceFile* _tmp35_;
	ValaCodeNode* _tmp36_;
	gboolean _tmp37_ = FALSE;
	gboolean _tmp38_ = FALSE;
	ValaCodeNode* _tmp39_;
	ValaDataType* data_type = NULL;
	ValaList* method_type_arguments = NULL;
	ValaSymbol* symbol = NULL;
	ValaCodeNode* _tmp44_;
	gboolean _tmp111_ = FALSE;
	gboolean _tmp112_ = FALSE;
	gboolean _tmp113_ = FALSE;
	ValaSymbol* _tmp114_;
	LspHover* hoverInfo = NULL;
	LspHover* _tmp131_;
	LspRange* symbol_range = NULL;
	ValaSymbol* _tmp132_;
	LspRange* _tmp161_;
	gchar* representation = NULL;
	ValaDataType* _tmp168_;
	ValaSymbol* _tmp169_;
	ValaScope* _tmp170_;
	ValaList* _tmp171_;
	gchar* _tmp172_;
	const gchar* _tmp173_;
	GError* _inner_error0_ = NULL;
	self = _data28_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data28_->id, _data28_->client, "textDocument/hover");
		return;
	}
	_tmp0_ = _data28_->results;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
	_tmp2_ = (VlsPair*) _tmp1_;
	_tmp3_ = vls_pair_get_first (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp2_);
	doc = _tmp6_;
	_tmp7_ = _data28_->results;
	_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, 0);
	_tmp9_ = (VlsPair*) _tmp8_;
	_tmp10_ = vls_pair_get_second (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = _g_object_ref0 ((VlsCompilation*) _tmp11_);
	_tmp13_ = _tmp12_;
	_g_object_unref0 (_tmp9_);
	compilation = _tmp13_;
	_tmp14_ = compilation;
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
	_tmp16_ = _tmp15_;
	vala_code_context_push (_tmp16_);
	_tmp17_ = doc;
	_tmp18_ = _data28_->pos;
	_tmp19_ = vls_find_symbol_new (_tmp17_, _tmp18_, TRUE, NULL);
	fs = _tmp19_;
	_tmp20_ = fs;
	_tmp21_ = _tmp20_->result;
	_tmp22_ = gee_collection_get_size ((GeeCollection*) _tmp21_);
	_tmp23_ = _tmp22_;
	if (_tmp23_ == 0) {
		vls_server_reply_null (_data28_->id, _data28_->client, "textDocument/hover");
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		return;
	}
	_tmp24_ = doc;
	_tmp25_ = _data28_->pos;
	_tmp26_ = vls_find_scope_new (_tmp24_, _tmp25_, TRUE);
	_tmp27_ = _tmp26_;
	_tmp28_ = vls_find_scope_get_best_block (_tmp27_);
	_tmp29_ = _tmp28_;
	_tmp30_ = vala_symbol_get_scope (_tmp29_);
	_tmp31_ = _tmp30_;
	_tmp32_ = _vala_scope_ref0 (_tmp31_);
	_tmp33_ = _tmp32_;
	_vala_code_visitor_unref0 (_tmp27_);
	scope = _tmp33_;
	_tmp34_ = fs;
	_tmp35_ = doc;
	_tmp36_ = vls_server_get_best (_tmp34_, _tmp35_);
	_result_ = _tmp36_;
	_tmp39_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp39_, VALA_TYPE_METHOD)) {
		ValaCodeNode* _tmp40_;
		gboolean _tmp41_;
		gboolean _tmp42_;
		_tmp40_ = _result_;
		_tmp41_ = vala_method_get_closure (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, VALA_TYPE_METHOD, ValaMethod));
		_tmp42_ = _tmp41_;
		_tmp38_ = _tmp42_;
	} else {
		_tmp38_ = FALSE;
	}
	if (_tmp38_) {
		_tmp37_ = TRUE;
	} else {
		ValaCodeNode* _tmp43_;
		_tmp43_ = _result_;
		_tmp37_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp43_, VALA_TYPE_PROPERTY_ACCESSOR);
	}
	if (_tmp37_) {
		vls_server_reply_null (_data28_->id, _data28_->client, "textDocument/hover");
		vala_code_context_pop ();
		_vala_code_node_unref0 (_result_);
		_vala_scope_unref0 (scope);
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		return;
	}
	data_type = NULL;
	method_type_arguments = NULL;
	symbol = NULL;
	_tmp44_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp44_, VALA_TYPE_EXPRESSION)) {
		ValaExpression* expr = NULL;
		ValaCodeNode* _tmp45_;
		ValaExpression* _tmp46_;
		ValaExpression* _tmp47_;
		ValaSymbol* _tmp48_;
		ValaSymbol* _tmp49_;
		ValaSymbol* _tmp50_;
		ValaExpression* _tmp51_;
		ValaDataType* _tmp52_;
		ValaDataType* _tmp53_;
		ValaDataType* _tmp54_;
		gboolean _tmp55_ = FALSE;
		ValaSymbol* _tmp56_;
		ValaExpression* _tmp78_;
		ValaCodeNode* _tmp79_;
		ValaCodeNode* _tmp80_;
		gboolean _tmp87_ = FALSE;
		gboolean _tmp88_ = FALSE;
		ValaSymbol* _tmp89_;
		_tmp45_ = _result_;
		_tmp46_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, VALA_TYPE_EXPRESSION, ValaExpression));
		expr = _tmp46_;
		_tmp47_ = expr;
		_tmp48_ = vala_expression_get_symbol_reference (_tmp47_);
		_tmp49_ = _tmp48_;
		_tmp50_ = _vala_code_node_ref0 (_tmp49_);
		_vala_code_node_unref0 (symbol);
		symbol = _tmp50_;
		_tmp51_ = expr;
		_tmp52_ = vala_expression_get_value_type (_tmp51_);
		_tmp53_ = _tmp52_;
		_tmp54_ = _vala_code_node_ref0 (_tmp53_);
		_vala_code_node_unref0 (data_type);
		data_type = _tmp54_;
		_tmp56_ = symbol;
		if (_tmp56_ != NULL) {
			ValaExpression* _tmp57_;
			_tmp57_ = expr;
			_tmp55_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp57_, VALA_TYPE_MEMBER_ACCESS);
		} else {
			_tmp55_ = FALSE;
		}
		if (_tmp55_) {
			ValaMemberAccess* ma = NULL;
			ValaExpression* _tmp58_;
			ValaMemberAccess* _tmp59_;
			gboolean _tmp60_ = FALSE;
			ValaMemberAccess* _tmp61_;
			ValaExpression* _tmp62_;
			ValaExpression* _tmp63_;
			ValaMemberAccess* _tmp75_;
			ValaList* _tmp76_;
			ValaList* _tmp77_;
			_tmp58_ = expr;
			_tmp59_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, VALA_TYPE_MEMBER_ACCESS, ValaMemberAccess));
			ma = _tmp59_;
			_tmp61_ = ma;
			_tmp62_ = vala_member_access_get_inner (_tmp61_);
			_tmp63_ = _tmp62_;
			if (_tmp63_ != NULL) {
				ValaMemberAccess* _tmp64_;
				ValaExpression* _tmp65_;
				ValaExpression* _tmp66_;
				ValaDataType* _tmp67_;
				ValaDataType* _tmp68_;
				_tmp64_ = ma;
				_tmp65_ = vala_member_access_get_inner (_tmp64_);
				_tmp66_ = _tmp65_;
				_tmp67_ = vala_expression_get_value_type (_tmp66_);
				_tmp68_ = _tmp67_;
				_tmp60_ = _tmp68_ != NULL;
			} else {
				_tmp60_ = FALSE;
			}
			if (_tmp60_) {
				ValaMemberAccess* _tmp69_;
				ValaExpression* _tmp70_;
				ValaExpression* _tmp71_;
				ValaDataType* _tmp72_;
				ValaDataType* _tmp73_;
				ValaDataType* _tmp74_;
				_tmp69_ = ma;
				_tmp70_ = vala_member_access_get_inner (_tmp69_);
				_tmp71_ = _tmp70_;
				_tmp72_ = vala_expression_get_value_type (_tmp71_);
				_tmp73_ = _tmp72_;
				_tmp74_ = _vala_code_node_ref0 (_tmp73_);
				_vala_code_node_unref0 (data_type);
				data_type = _tmp74_;
			}
			_tmp75_ = ma;
			_tmp76_ = vala_member_access_get_type_arguments (_tmp75_);
			_tmp77_ = _vala_iterable_ref0 (_tmp76_);
			_vala_iterable_unref0 (method_type_arguments);
			method_type_arguments = _tmp77_;
			_vala_code_node_unref0 (ma);
		}
		_tmp78_ = expr;
		_tmp79_ = vala_code_node_get_parent_node ((ValaCodeNode*) _tmp78_);
		_tmp80_ = _tmp79_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp80_, VALA_TYPE_OBJECT_CREATION_EXPRESSION)) {
			ValaExpression* _tmp81_;
			ValaCodeNode* _tmp82_;
			ValaCodeNode* _tmp83_;
			ValaDataType* _tmp84_;
			ValaDataType* _tmp85_;
			ValaDataType* _tmp86_;
			_tmp81_ = expr;
			_tmp82_ = vala_code_node_get_parent_node ((ValaCodeNode*) _tmp81_);
			_tmp83_ = _tmp82_;
			_tmp84_ = vala_expression_get_value_type ((ValaExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp83_, VALA_TYPE_OBJECT_CREATION_EXPRESSION, ValaObjectCreationExpression));
			_tmp85_ = _tmp84_;
			_tmp86_ = _vala_code_node_ref0 (_tmp85_);
			_vala_code_node_unref0 (data_type);
			data_type = _tmp86_;
		}
		_tmp89_ = symbol;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp89_, VALA_TYPE_VARIABLE)) {
			ValaDataType* _tmp90_;
			_tmp90_ = data_type;
			_tmp88_ = _tmp90_ != NULL;
		} else {
			_tmp88_ = FALSE;
		}
		if (_tmp88_) {
			ValaDataType* _tmp91_;
			ValaSymbol* _tmp92_;
			ValaDataType* _tmp93_;
			ValaDataType* _tmp94_;
			_tmp91_ = data_type;
			_tmp92_ = symbol;
			_tmp93_ = vala_variable_get_variable_type (G_TYPE_CHECK_INSTANCE_CAST (_tmp92_, VALA_TYPE_VARIABLE, ValaVariable));
			_tmp94_ = _tmp93_;
			_tmp87_ = vala_data_type_equals (_tmp91_, _tmp94_);
		} else {
			_tmp87_ = FALSE;
		}
		if (_tmp87_) {
			_vala_code_node_unref0 (data_type);
			data_type = NULL;
		}
		_vala_code_node_unref0 (expr);
	} else {
		ValaCodeNode* _tmp95_;
		_tmp95_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp95_, VALA_TYPE_SYMBOL)) {
			ValaCodeNode* _tmp96_;
			ValaSymbol* _tmp97_;
			_tmp96_ = _result_;
			_tmp97_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp96_, VALA_TYPE_SYMBOL, ValaSymbol));
			_vala_code_node_unref0 (symbol);
			symbol = _tmp97_;
		} else {
			ValaCodeNode* _tmp98_;
			_tmp98_ = _result_;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp98_, VALA_TYPE_DATA_TYPE)) {
				ValaCodeNode* _tmp99_;
				ValaDataType* _tmp100_;
				ValaDataType* _tmp101_;
				ValaSymbol* _tmp102_;
				_tmp99_ = _result_;
				_tmp100_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp99_, VALA_TYPE_DATA_TYPE, ValaDataType));
				_vala_code_node_unref0 (data_type);
				data_type = _tmp100_;
				_tmp101_ = data_type;
				_tmp102_ = vls_symbol_references_get_symbol_data_type_refers_to (_tmp101_);
				_vala_code_node_unref0 (symbol);
				symbol = _tmp102_;
			} else {
				ValaCodeNode* _tmp103_;
				_tmp103_ = _result_;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp103_, VALA_TYPE_USING_DIRECTIVE)) {
					ValaCodeNode* _tmp104_;
					ValaSymbol* _tmp105_;
					ValaSymbol* _tmp106_;
					ValaSymbol* _tmp107_;
					_tmp104_ = _result_;
					_tmp105_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp104_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
					_tmp106_ = _tmp105_;
					_tmp107_ = _vala_code_node_ref0 (_tmp106_);
					_vala_code_node_unref0 (symbol);
					symbol = _tmp107_;
				} else {
					ValaCodeNode* _tmp108_;
					const gchar* _tmp109_;
					const gchar* _tmp110_;
					_tmp108_ = _result_;
					_tmp109_ = vala_code_node_get_type_name (_tmp108_);
					_tmp110_ = _tmp109_;
					g_warning ("server.vala:1244: result as %s not matched", _tmp110_);
				}
			}
		}
	}
	_tmp114_ = symbol;
	if (_tmp114_ != NULL) {
		ValaSymbol* _tmp115_;
		const gchar* _tmp116_;
		const gchar* _tmp117_;
		_tmp115_ = symbol;
		_tmp116_ = vala_symbol_get_name (_tmp115_);
		_tmp117_ = _tmp116_;
		_tmp113_ = _tmp117_ != NULL;
	} else {
		_tmp113_ = FALSE;
	}
	if (_tmp113_) {
		ValaSymbol* _tmp118_;
		const gchar* _tmp119_;
		const gchar* _tmp120_;
		_tmp118_ = symbol;
		_tmp119_ = vala_symbol_get_name (_tmp118_);
		_tmp120_ = _tmp119_;
		_tmp112_ = string_get (_tmp120_, (glong) 0) == '.';
	} else {
		_tmp112_ = FALSE;
	}
	if (_tmp112_) {
		ValaSymbol* _tmp121_;
		const gchar* _tmp122_;
		const gchar* _tmp123_;
		_tmp121_ = symbol;
		_tmp122_ = vala_symbol_get_name (_tmp121_);
		_tmp123_ = _tmp122_;
		_tmp111_ = g_ascii_isdigit (string_get (_tmp123_, (glong) 1));
	} else {
		_tmp111_ = FALSE;
	}
	if (_tmp111_) {
		gboolean _tmp124_ = FALSE;
		ValaSymbol* _tmp125_;
		_tmp125_ = symbol;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp125_, VALA_TYPE_VARIABLE)) {
			ValaDataType* _tmp126_;
			_tmp126_ = data_type;
			_tmp124_ = _tmp126_ == NULL;
		} else {
			_tmp124_ = FALSE;
		}
		if (_tmp124_) {
			ValaSymbol* _tmp127_;
			ValaDataType* _tmp128_;
			ValaDataType* _tmp129_;
			ValaDataType* _tmp130_;
			_tmp127_ = symbol;
			_tmp128_ = vala_variable_get_variable_type (G_TYPE_CHECK_INSTANCE_CAST (_tmp127_, VALA_TYPE_VARIABLE, ValaVariable));
			_tmp129_ = _tmp128_;
			_tmp130_ = _vala_code_node_ref0 (_tmp129_);
			_vala_code_node_unref0 (data_type);
			data_type = _tmp130_;
		}
		_vala_code_node_unref0 (symbol);
		symbol = NULL;
	}
	_tmp131_ = lsp_hover_new ();
	if (_tmp131_) {
		g_object_set_data ((GObject *) _tmp131_, "vala-creation-function", "Vls.Server.textDocumentHover._lambda53_");
	}
	hoverInfo = _tmp131_;
	symbol_range = NULL;
	_tmp132_ = symbol;
	if (_tmp132_ != NULL) {
		ValaCodeNode* _tmp133_;
		ValaSymbol* _tmp134_;
		LspRange* _tmp135_;
		LspRange* _tmp136_;
		_tmp133_ = _result_;
		_tmp134_ = symbol;
		_tmp135_ = vls_symbol_references_get_replacement_range (_tmp133_, _tmp134_);
		_g_object_unref0 (symbol_range);
		symbol_range = _tmp135_;
		_tmp136_ = symbol_range;
		if (_tmp136_ != NULL) {
			gboolean found_component = FALSE;
			LspRange* _tmp137_;
			LspPosition* _tmp138_;
			found_component = FALSE;
			_tmp137_ = symbol_range;
			_tmp138_ = _data28_->pos;
			if (!lsp_range_contains (_tmp137_, _tmp138_)) {
				{
					GeeIterator* _component_it = NULL;
					ValaCodeNode* _tmp139_;
					GeeCollection* _tmp140_;
					GeeCollection* _tmp141_;
					GeeIterator* _tmp142_;
					GeeIterator* _tmp143_;
					_tmp139_ = _result_;
					_tmp140_ = vls_symbol_references_get_visible_components_of_code_node (_tmp139_);
					_tmp141_ = _tmp140_;
					_tmp142_ = gee_iterable_iterator ((GeeIterable*) _tmp141_);
					_tmp143_ = _tmp142_;
					_g_object_unref0 (_tmp141_);
					_component_it = _tmp143_;
					while (TRUE) {
						GeeIterator* _tmp144_;
						VlsPair* component = NULL;
						GeeIterator* _tmp145_;
						gpointer _tmp146_;
						VlsPair* _tmp147_;
						gconstpointer _tmp148_;
						gconstpointer _tmp149_;
						LspPosition* _tmp150_;
						_tmp144_ = _component_it;
						if (!gee_iterator_next (_tmp144_)) {
							break;
						}
						_tmp145_ = _component_it;
						_tmp146_ = gee_iterator_get (_tmp145_);
						component = (VlsPair*) _tmp146_;
						_tmp147_ = component;
						_tmp148_ = vls_pair_get_second (_tmp147_);
						_tmp149_ = _tmp148_;
						_tmp150_ = _data28_->pos;
						if (lsp_range_contains ((LspRange*) _tmp149_, _tmp150_)) {
							LspHover* _tmp151_;
							VlsPair* _tmp152_;
							gconstpointer _tmp153_;
							gconstpointer _tmp154_;
							VlsPair* _tmp155_;
							gconstpointer _tmp156_;
							gconstpointer _tmp157_;
							ValaSymbol* _tmp158_;
							_tmp151_ = hoverInfo;
							_tmp152_ = component;
							_tmp153_ = vls_pair_get_second (_tmp152_);
							_tmp154_ = _tmp153_;
							lsp_hover_set_range (_tmp151_, (LspRange*) _tmp154_);
							_tmp155_ = component;
							_tmp156_ = vls_pair_get_first (_tmp155_);
							_tmp157_ = _tmp156_;
							_tmp158_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp157_);
							_vala_code_node_unref0 (symbol);
							symbol = _tmp158_;
							_vala_code_node_unref0 (data_type);
							data_type = NULL;
							_vala_iterable_unref0 (method_type_arguments);
							method_type_arguments = NULL;
							found_component = TRUE;
							_g_object_unref0 (component);
							break;
						}
						_g_object_unref0 (component);
					}
					_g_object_unref0 (_component_it);
				}
			}
			if (!found_component) {
				LspHover* _tmp159_;
				LspRange* _tmp160_;
				_tmp159_ = hoverInfo;
				_tmp160_ = symbol_range;
				lsp_hover_set_range (_tmp159_, _tmp160_);
			}
		}
	}
	_tmp161_ = symbol_range;
	if (_tmp161_ == NULL) {
		LspHover* _tmp162_;
		ValaCodeNode* _tmp163_;
		ValaSourceReference* _tmp164_;
		ValaSourceReference* _tmp165_;
		LspRange* _tmp166_;
		LspRange* _tmp167_;
		_tmp162_ = hoverInfo;
		_tmp163_ = _result_;
		_tmp164_ = vala_code_node_get_source_reference (_tmp163_);
		_tmp165_ = _tmp164_;
		_tmp166_ = lsp_range_new_from_sourceref (_tmp165_);
		if (_tmp166_) {
			g_object_set_data ((GObject *) _tmp166_, "vala-creation-function", "Vls.Server.textDocumentHover._lambda53_");
		}
		_tmp167_ = _tmp166_;
		lsp_hover_set_range (_tmp162_, _tmp167_);
		_g_object_unref0 (_tmp167_);
	}
	_tmp168_ = data_type;
	_tmp169_ = symbol;
	_tmp170_ = scope;
	_tmp171_ = method_type_arguments;
	_tmp172_ = vls_code_help_get_symbol_representation (_tmp168_, _tmp169_, _tmp170_, TRUE, _tmp171_, NULL, TRUE, FALSE, NULL, TRUE);
	representation = _tmp172_;
	_tmp173_ = representation;
	if (_tmp173_ != NULL) {
		LspHover* _tmp174_;
		GeeList* _tmp175_;
		GeeList* _tmp176_;
		gchar* _tmp177_;
		const gchar* _tmp178_;
		gchar* _tmp179_;
		LspMarkedString* _tmp180_ = NULL;
		LspMarkedString* _tmp181_;
		ValaSymbol* _tmp182_;
		_tmp174_ = hoverInfo;
		_tmp175_ = lsp_hover_get_contents (_tmp174_);
		_tmp176_ = _tmp175_;
		_tmp177_ = g_strdup ("vala");
		_tmp178_ = representation;
		_tmp179_ = g_strdup (_tmp178_);
		_tmp180_ = lsp_marked_string_new ();
		lsp_marked_string_set_language (_tmp180_, _tmp177_);
		_g_free0 (_tmp177_);
		lsp_marked_string_set_value (_tmp180_, _tmp179_);
		_g_free0 (_tmp179_);
		_tmp181_ = _tmp180_;
		gee_collection_add ((GeeCollection*) _tmp176_, _tmp181_);
		_g_object_unref0 (_tmp181_);
		_tmp182_ = symbol;
		if (_tmp182_ != NULL) {
			VlsDocComment* comment = NULL;
			VlsProject* _tmp183_;
			ValaSymbol* _tmp184_;
			VlsDocComment* _tmp185_;
			VlsDocComment* _tmp186_;
			_tmp183_ = _data28_->selected_project;
			_tmp184_ = symbol;
			_tmp185_ = vls_server_get_symbol_documentation (self, _tmp183_, _tmp184_);
			comment = _tmp185_;
			_tmp186_ = comment;
			if (_tmp186_ != NULL) {
				LspHover* _tmp187_;
				GeeList* _tmp188_;
				GeeList* _tmp189_;
				VlsDocComment* _tmp190_;
				const gchar* _tmp191_;
				const gchar* _tmp192_;
				gchar* _tmp193_;
				LspMarkedString* _tmp194_ = NULL;
				LspMarkedString* _tmp195_;
				_tmp187_ = hoverInfo;
				_tmp188_ = lsp_hover_get_contents (_tmp187_);
				_tmp189_ = _tmp188_;
				_tmp190_ = comment;
				_tmp191_ = vls_doc_comment_get_body (_tmp190_);
				_tmp192_ = _tmp191_;
				_tmp193_ = g_strdup (_tmp192_);
				_tmp194_ = lsp_marked_string_new ();
				lsp_marked_string_set_value (_tmp194_, _tmp193_);
				_g_free0 (_tmp193_);
				_tmp195_ = _tmp194_;
				gee_collection_add ((GeeCollection*) _tmp189_, _tmp195_);
				_g_object_unref0 (_tmp195_);
			}
			_vls_doc_comment_unref0 (comment);
		}
	}
	{
		GVariant* _tmp196_ = NULL;
		LspHover* _tmp197_;
		GVariant* _tmp198_;
		GCancellable* _tmp199_;
		_tmp197_ = hoverInfo;
		_tmp198_ = vls_util_object_to_variant ((GObject*) _tmp197_, &_inner_error0_);
		_tmp196_ = _tmp198_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp199_ = vls_server_cancellable;
		jsonrpc_client_reply (_data28_->client, _data28_->id, _tmp196_, _tmp199_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (_tmp196_);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (_tmp196_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp200_;
		const gchar* _tmp201_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp200_ = e;
		_tmp201_ = _tmp200_->message;
		g_warning ("server.vala:1324: [textDocument/hover] failed to reply to client: %s", _tmp201_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (representation);
		_g_object_unref0 (symbol_range);
		_g_object_unref0 (hoverInfo);
		_vala_code_node_unref0 (symbol);
		_vala_iterable_unref0 (method_type_arguments);
		_vala_code_node_unref0 (data_type);
		_vala_code_node_unref0 (_result_);
		_vala_scope_unref0 (scope);
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_g_free0 (representation);
	_g_object_unref0 (symbol_range);
	_g_object_unref0 (hoverInfo);
	_vala_code_node_unref0 (symbol);
	_vala_iterable_unref0 (method_type_arguments);
	_vala_code_node_unref0 (data_type);
	_vala_code_node_unref0 (_result_);
	_vala_scope_unref0 (scope);
	_vala_code_visitor_unref0 (fs);
	_g_object_unref0 (compilation);
	_vala_source_file_unref0 (doc);
}

static void
___lambda53__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda53_ (self, request_cancelled);
}

static void
vls_server_textDocumentHover (VlsServer* self,
                              JsonrpcServer* _self_,
                              JsonrpcClient* client,
                              const gchar* method,
                              GVariant* id,
                              GVariant* params)
{
	Block28Data* _data28_;
	JsonrpcClient* _tmp0_;
	GVariant* _tmp1_;
	LspTextDocumentPositionParams* p = NULL;
	gpointer _tmp2_;
	GeeArrayList* _tmp3_;
	GHashTable* _tmp4_;
	guint _tmp5_ = 0;
	gconstpointer* _tmp6_;
	VlsProject* _tmp19_;
	GeeArrayList* _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	LspTextDocumentPositionParams* _tmp42_;
	LspPosition* _tmp43_;
	LspPosition* _tmp44_;
	LspPosition* _tmp45_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data28_ = g_slice_new0 (Block28Data);
	_data28_->_ref_count_ = 1;
	_data28_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data28_->client);
	_data28_->client = _tmp0_;
	_tmp1_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data28_->id);
	_data28_->id = _tmp1_;
	_tmp2_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspTextDocumentPositionParams*) _tmp2_;
	_tmp3_ = gee_array_list_new (VLS_TYPE_PAIR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp3_) {
		g_object_set_data ((GObject *) _tmp3_, "vala-creation-function", "Vls.Server.textDocumentHover");
	}
	_data28_->results = _tmp3_;
	_data28_->selected_project = NULL;
	_tmp4_ = self->priv->projects;
	_tmp6_ = g_hash_table_get_keys_as_array (_tmp4_, &_tmp5_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp6_;
		project_collection_length1 = _tmp5_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				VlsProject* _tmp7_;
				LspTextDocumentPositionParams* _tmp8_;
				LspTextDocumentIdentifier* _tmp9_;
				LspTextDocumentIdentifier* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
				GeeArrayList* _tmp13_;
				GeeArrayList* _tmp14_;
				gboolean _tmp15_;
				gboolean _tmp16_;
				_tmp7_ = project;
				_tmp8_ = p;
				_tmp9_ = lsp_text_document_position_params_get_textDocument (_tmp8_);
				_tmp10_ = _tmp9_;
				_tmp11_ = lsp_text_document_identifier_get_uri (_tmp10_);
				_tmp12_ = _tmp11_;
				_tmp13_ = vls_project_lookup_compile_input_source_file (_tmp7_, _tmp12_);
				_g_object_unref0 (_data28_->results);
				_data28_->results = _tmp13_;
				_tmp14_ = _data28_->results;
				_tmp15_ = gee_collection_get_is_empty ((GeeCollection*) _tmp14_);
				_tmp16_ = _tmp15_;
				if (!_tmp16_) {
					VlsProject* _tmp17_;
					VlsProject* _tmp18_;
					_tmp17_ = project;
					_tmp18_ = _g_object_ref0 (_tmp17_);
					_g_object_unref0 (_data28_->selected_project);
					_data28_->selected_project = _tmp18_;
					break;
				}
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp19_ = _data28_->selected_project;
	if (_tmp19_ == NULL) {
		VlsDefaultProject* _tmp20_;
		LspTextDocumentPositionParams* _tmp21_;
		LspTextDocumentIdentifier* _tmp22_;
		LspTextDocumentIdentifier* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		GeeArrayList* _tmp26_;
		VlsDefaultProject* _tmp27_;
		VlsProject* _tmp28_;
		_tmp20_ = self->priv->default_project;
		_tmp21_ = p;
		_tmp22_ = lsp_text_document_position_params_get_textDocument (_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp24_ = lsp_text_document_identifier_get_uri (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = vls_project_lookup_compile_input_source_file ((VlsProject*) _tmp20_, _tmp25_);
		_g_object_unref0 (_data28_->results);
		_data28_->results = _tmp26_;
		_tmp27_ = self->priv->default_project;
		_tmp28_ = _g_object_ref0 ((VlsProject*) _tmp27_);
		_g_object_unref0 (_data28_->selected_project);
		_data28_->selected_project = _tmp28_;
	}
	_tmp29_ = _data28_->results;
	_tmp30_ = gee_collection_get_is_empty ((GeeCollection*) _tmp29_);
	_tmp31_ = _tmp30_;
	if (_tmp31_) {
		LspTextDocumentPositionParams* _tmp32_;
		LspTextDocumentIdentifier* _tmp33_;
		LspTextDocumentIdentifier* _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		_tmp32_ = p;
		_tmp33_ = lsp_text_document_position_params_get_textDocument (_tmp32_);
		_tmp34_ = _tmp33_;
		_tmp35_ = lsp_text_document_identifier_get_uri (_tmp34_);
		_tmp36_ = _tmp35_;
		_tmp37_ = g_uri_unescape_string (_tmp36_, NULL);
		_tmp38_ = _tmp37_;
		_tmp39_ = string_to_string (_tmp38_);
		_tmp40_ = g_strconcat ("file `", _tmp39_, "' not found", NULL);
		_tmp41_ = _tmp40_;
		g_debug ("server.vala:1174: %s", _tmp41_);
		_g_free0 (_tmp41_);
		_g_free0 (_tmp38_);
		vls_server_reply_null (_data28_->id, _data28_->client, "textDocument/hover");
		_g_object_unref0 (p);
		block28_data_unref (_data28_);
		_data28_ = NULL;
		return;
	}
	_tmp42_ = p;
	_tmp43_ = lsp_text_document_position_params_get_position (_tmp42_);
	_tmp44_ = _tmp43_;
	_tmp45_ = _g_object_ref0 (_tmp44_);
	_data28_->pos = _tmp45_;
	vls_server_wait_for_context_update (self, _data28_->id, ___lambda53__vls_server_on_context_updated_func, block28_data_ref (_data28_), block28_data_unref);
	_g_object_unref0 (p);
	block28_data_unref (_data28_);
	_data28_ = NULL;
}

static LspDocumentHighlightKind
vls_server_determine_node_highlight_kind (VlsServer* self,
                                          ValaCodeNode* node)
{
	ValaCodeNode* previous_node = NULL;
	ValaCodeNode* _tmp0_;
	LspDocumentHighlightKind result;
	g_return_val_if_fail (self != NULL, LSP_DOCUMENT_HIGHLIGHT_KIND_Text);
	g_return_val_if_fail (node != NULL, LSP_DOCUMENT_HIGHLIGHT_KIND_Text);
	_tmp0_ = _vala_code_node_ref0 (node);
	previous_node = _tmp0_;
	{
		ValaCodeNode* current_node = NULL;
		ValaCodeNode* _tmp1_;
		ValaCodeNode* _tmp2_;
		ValaCodeNode* _tmp3_;
		_tmp1_ = vala_code_node_get_parent_node (node);
		_tmp2_ = _tmp1_;
		_tmp3_ = _vala_code_node_ref0 (_tmp2_);
		current_node = _tmp3_;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				ValaCodeNode* _tmp11_;
				ValaCodeNode* _tmp12_;
				if (!_tmp4_) {
					ValaCodeNode* _tmp5_;
					ValaCodeNode* _tmp6_;
					ValaCodeNode* _tmp7_;
					ValaCodeNode* _tmp8_;
					ValaCodeNode* _tmp9_;
					ValaCodeNode* _tmp10_;
					_tmp5_ = current_node;
					_tmp6_ = vala_code_node_get_parent_node (_tmp5_);
					_tmp7_ = _tmp6_;
					_tmp8_ = _vala_code_node_ref0 (_tmp7_);
					_vala_code_node_unref0 (current_node);
					current_node = _tmp8_;
					_tmp9_ = current_node;
					_tmp10_ = _vala_code_node_ref0 (_tmp9_);
					_vala_code_node_unref0 (previous_node);
					previous_node = _tmp10_;
				}
				_tmp4_ = FALSE;
				_tmp11_ = current_node;
				if (!(_tmp11_ != NULL)) {
					break;
				}
				_tmp12_ = current_node;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, VALA_TYPE_METHOD_CALL)) {
					result = LSP_DOCUMENT_HIGHLIGHT_KIND_Read;
					_vala_code_node_unref0 (current_node);
					_vala_code_node_unref0 (previous_node);
					return result;
				} else {
					ValaCodeNode* _tmp13_;
					_tmp13_ = current_node;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, VALA_TYPE_ASSIGNMENT)) {
						ValaCodeNode* _tmp14_;
						ValaCodeNode* _tmp15_;
						ValaExpression* _tmp16_;
						ValaExpression* _tmp17_;
						_tmp14_ = previous_node;
						_tmp15_ = current_node;
						_tmp16_ = vala_assignment_get_left (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, VALA_TYPE_ASSIGNMENT, ValaAssignment));
						_tmp17_ = _tmp16_;
						if (_tmp14_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, VALA_TYPE_CODE_NODE, ValaCodeNode)) {
							result = LSP_DOCUMENT_HIGHLIGHT_KIND_Write;
							_vala_code_node_unref0 (current_node);
							_vala_code_node_unref0 (previous_node);
							return result;
						} else {
							ValaCodeNode* _tmp18_;
							ValaCodeNode* _tmp19_;
							ValaExpression* _tmp20_;
							ValaExpression* _tmp21_;
							_tmp18_ = previous_node;
							_tmp19_ = current_node;
							_tmp20_ = vala_assignment_get_right (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, VALA_TYPE_ASSIGNMENT, ValaAssignment));
							_tmp21_ = _tmp20_;
							if (_tmp18_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, VALA_TYPE_CODE_NODE, ValaCodeNode)) {
								result = LSP_DOCUMENT_HIGHLIGHT_KIND_Read;
								_vala_code_node_unref0 (current_node);
								_vala_code_node_unref0 (previous_node);
								return result;
							}
						}
					} else {
						gboolean _tmp22_ = FALSE;
						ValaCodeNode* _tmp23_;
						_tmp23_ = current_node;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, VALA_TYPE_DECLARATION_STATEMENT)) {
							ValaCodeNode* _tmp24_;
							ValaSymbol* _tmp25_;
							ValaSymbol* _tmp26_;
							_tmp24_ = current_node;
							_tmp25_ = vala_declaration_statement_get_declaration (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, VALA_TYPE_DECLARATION_STATEMENT, ValaDeclarationStatement));
							_tmp26_ = _tmp25_;
							_tmp22_ = node == G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, VALA_TYPE_CODE_NODE, ValaCodeNode);
						} else {
							_tmp22_ = FALSE;
						}
						if (_tmp22_) {
							result = LSP_DOCUMENT_HIGHLIGHT_KIND_Write;
							_vala_code_node_unref0 (current_node);
							_vala_code_node_unref0 (previous_node);
							return result;
						} else {
							gboolean _tmp27_ = FALSE;
							ValaCodeNode* _tmp28_;
							_tmp28_ = current_node;
							if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, VALA_TYPE_FOREACH_STATEMENT)) {
								ValaCodeNode* _tmp29_;
								ValaLocalVariable* _tmp30_;
								ValaLocalVariable* _tmp31_;
								_tmp29_ = current_node;
								_tmp30_ = vala_foreach_statement_get_element_variable (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, VALA_TYPE_FOREACH_STATEMENT, ValaForeachStatement));
								_tmp31_ = _tmp30_;
								_tmp27_ = node == G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, VALA_TYPE_CODE_NODE, ValaCodeNode);
							} else {
								_tmp27_ = FALSE;
							}
							if (_tmp27_) {
								result = LSP_DOCUMENT_HIGHLIGHT_KIND_Write;
								_vala_code_node_unref0 (current_node);
								_vala_code_node_unref0 (previous_node);
								return result;
							} else {
								ValaCodeNode* _tmp32_;
								_tmp32_ = current_node;
								if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp32_, VALA_TYPE_STATEMENT)) {
									result = LSP_DOCUMENT_HIGHLIGHT_KIND_Read;
									_vala_code_node_unref0 (current_node);
									_vala_code_node_unref0 (previous_node);
									return result;
								}
							}
						}
					}
				}
			}
		}
		_vala_code_node_unref0 (current_node);
	}
	result = LSP_DOCUMENT_HIGHLIGHT_KIND_Text;
	_vala_code_node_unref0 (previous_node);
	return result;
}

static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
	g_atomic_int_inc (&_data29_->_ref_count_);
	return _data29_;
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
		VlsServer* self;
		self = _data29_->self;
		_g_object_unref0 (_data29_->pos);
		_g_object_unref0 (_data29_->selected_project);
		_g_object_unref0 (_data29_->results);
		_g_object_unref0 (_data29_->client);
		_g_free0 (_data29_->method);
		_g_variant_unref0 (_data29_->id);
		_g_object_unref0 (self);
		g_slice_free (Block29Data, _data29_);
	}
}

static void
__lambda54_ (Block29Data* _data29_,
             gboolean request_cancelled)
{
	VlsServer* self;
	ValaSourceFile* doc = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	VlsPair* _tmp2_;
	gconstpointer _tmp3_;
	gconstpointer _tmp4_;
	ValaSourceFile* _tmp5_;
	ValaSourceFile* _tmp6_;
	VlsCompilation* compilation = NULL;
	GeeArrayList* _tmp7_;
	gpointer _tmp8_;
	VlsPair* _tmp9_;
	gconstpointer _tmp10_;
	gconstpointer _tmp11_;
	VlsCompilation* _tmp12_;
	VlsCompilation* _tmp13_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	VlsFindSymbol* fs = NULL;
	ValaSourceFile* _tmp17_;
	LspPosition* _tmp18_;
	VlsFindSymbol* _tmp19_;
	VlsFindSymbol* _tmp20_;
	GeeList* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	ValaCodeNode* _result_ = NULL;
	VlsFindSymbol* _tmp27_;
	ValaSourceFile* _tmp28_;
	ValaCodeNode* _tmp29_;
	ValaSymbol* symbol = NULL;
	JsonArray* json_array = NULL;
	JsonArray* _tmp30_;
	GeeHashMap* references = NULL;
	GeeHashMap* _tmp31_;
	gboolean _tmp32_ = FALSE;
	ValaCodeNode* _tmp33_;
	gboolean _tmp53_ = FALSE;
	ValaCodeNode* _tmp54_;
	ValaCodeNode* _tmp60_;
	ValaSymbol* _tmp61_;
	const gchar* _tmp62_;
	ValaCodeNode* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	ValaCodeNode* _tmp66_;
	const gchar* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	gchar* _tmp70_;
	gchar* _tmp71_;
	gboolean _tmp72_ = FALSE;
	const gchar* _tmp130_;
	GeeHashMap* _tmp131_;
	gint _tmp132_;
	gint _tmp133_;
	gchar* _tmp134_;
	gchar* _tmp135_;
	gchar* _tmp136_;
	gchar* _tmp137_;
	GError* _inner_error0_ = NULL;
	self = _data29_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data29_->id, _data29_->client, _data29_->method);
		return;
	}
	_tmp0_ = _data29_->results;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
	_tmp2_ = (VlsPair*) _tmp1_;
	_tmp3_ = vls_pair_get_first (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp2_);
	doc = _tmp6_;
	_tmp7_ = _data29_->results;
	_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, 0);
	_tmp9_ = (VlsPair*) _tmp8_;
	_tmp10_ = vls_pair_get_second (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = _g_object_ref0 ((VlsCompilation*) _tmp11_);
	_tmp13_ = _tmp12_;
	_g_object_unref0 (_tmp9_);
	compilation = _tmp13_;
	_tmp14_ = compilation;
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
	_tmp16_ = _tmp15_;
	vala_code_context_push (_tmp16_);
	_tmp17_ = doc;
	_tmp18_ = _data29_->pos;
	_tmp19_ = vls_find_symbol_new (_tmp17_, _tmp18_, TRUE, NULL);
	fs = _tmp19_;
	_tmp20_ = fs;
	_tmp21_ = _tmp20_->result;
	_tmp22_ = gee_collection_get_size ((GeeCollection*) _tmp21_);
	_tmp23_ = _tmp22_;
	if (_tmp23_ == 0) {
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		_tmp24_ = string_to_string (_data29_->method);
		_tmp25_ = g_strconcat ("[", _tmp24_, "] no results found", NULL);
		_tmp26_ = _tmp25_;
		g_debug ("server.vala:1396: %s", _tmp26_);
		_g_free0 (_tmp26_);
		vls_server_reply_null (_data29_->id, _data29_->client, _data29_->method);
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		return;
	}
	_tmp27_ = fs;
	_tmp28_ = doc;
	_tmp29_ = vls_server_get_best (_tmp27_, _tmp28_);
	_result_ = _tmp29_;
	_tmp30_ = json_array_new ();
	json_array = _tmp30_;
	_tmp31_ = gee_hash_map_new (LSP_TYPE_RANGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp31_) {
		g_object_set_data ((GObject *) _tmp31_, "vala-creation-function", "Vls.Server.textDocumentReferences._lambda54_");
	}
	references = _tmp31_;
	_tmp33_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, VALA_TYPE_EXPRESSION)) {
		ValaCodeNode* _tmp34_;
		ValaSymbol* _tmp35_;
		ValaSymbol* _tmp36_;
		_tmp34_ = _result_;
		_tmp35_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, VALA_TYPE_EXPRESSION, ValaExpression));
		_tmp36_ = _tmp35_;
		_tmp32_ = _tmp36_ != NULL;
	} else {
		_tmp32_ = FALSE;
	}
	if (_tmp32_) {
		ValaCodeNode* _tmp37_;
		ValaSymbol* _tmp38_;
		ValaSymbol* _tmp39_;
		ValaCodeNode* _tmp40_;
		_tmp37_ = _result_;
		_tmp38_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, VALA_TYPE_EXPRESSION, ValaExpression));
		_tmp39_ = _tmp38_;
		_tmp40_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp39_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp40_;
	} else {
		ValaCodeNode* _tmp41_;
		_tmp41_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp41_, VALA_TYPE_DATA_TYPE)) {
			ValaCodeNode* _tmp42_;
			ValaSymbol* _tmp43_;
			_tmp42_ = _result_;
			_tmp43_ = vls_symbol_references_get_symbol_data_type_refers_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, VALA_TYPE_DATA_TYPE, ValaDataType));
			_vala_code_node_unref0 (_result_);
			_result_ = (ValaCodeNode*) _tmp43_;
		} else {
			gboolean _tmp44_ = FALSE;
			ValaCodeNode* _tmp45_;
			_tmp45_ = _result_;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp45_, VALA_TYPE_USING_DIRECTIVE)) {
				ValaCodeNode* _tmp46_;
				ValaSymbol* _tmp47_;
				ValaSymbol* _tmp48_;
				_tmp46_ = _result_;
				_tmp47_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp48_ = _tmp47_;
				_tmp44_ = _tmp48_ != NULL;
			} else {
				_tmp44_ = FALSE;
			}
			if (_tmp44_) {
				ValaCodeNode* _tmp49_;
				ValaSymbol* _tmp50_;
				ValaSymbol* _tmp51_;
				ValaCodeNode* _tmp52_;
				_tmp49_ = _result_;
				_tmp50_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp51_ = _tmp50_;
				_tmp52_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp51_);
				_vala_code_node_unref0 (_result_);
				_result_ = _tmp52_;
			}
		}
	}
	_tmp54_ = _result_;
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp54_, VALA_TYPE_SYMBOL)) {
		_tmp53_ = TRUE;
	} else {
		gboolean _tmp55_ = FALSE;
		ValaCodeNode* _tmp56_;
		_tmp56_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp56_, VALA_TYPE_METHOD)) {
			ValaCodeNode* _tmp57_;
			gboolean _tmp58_;
			gboolean _tmp59_;
			_tmp57_ = _result_;
			_tmp58_ = vala_method_get_closure (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, VALA_TYPE_METHOD, ValaMethod));
			_tmp59_ = _tmp58_;
			_tmp55_ = _tmp59_;
		} else {
			_tmp55_ = FALSE;
		}
		_tmp53_ = _tmp55_;
	}
	if (_tmp53_) {
		vls_server_reply_null (_data29_->id, _data29_->client, _data29_->method);
		vala_code_context_pop ();
		_g_object_unref0 (references);
		_json_array_unref0 (json_array);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		return;
	}
	_tmp60_ = _result_;
	_tmp61_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, VALA_TYPE_SYMBOL, ValaSymbol));
	_vala_code_node_unref0 (symbol);
	symbol = _tmp61_;
	_tmp62_ = string_to_string (_data29_->method);
	_tmp63_ = _result_;
	_tmp64_ = vala_code_node_to_string (_tmp63_);
	_tmp65_ = _tmp64_;
	_tmp66_ = _result_;
	_tmp67_ = vala_code_node_get_type_name (_tmp66_);
	_tmp68_ = _tmp67_;
	_tmp69_ = string_to_string (_tmp68_);
	_tmp70_ = g_strconcat ("[", _tmp62_, "] got best: ", _tmp65_, " (", _tmp69_, ")", NULL);
	_tmp71_ = _tmp70_;
	g_debug ("server.vala:1424: %s", _tmp71_);
	_g_free0 (_tmp71_);
	_g_free0 (_tmp65_);
	if (_data29_->is_highlight) {
		_tmp72_ = TRUE;
	} else {
		ValaSymbol* _tmp73_;
		_tmp73_ = symbol;
		_tmp72_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp73_, VALA_TYPE_LOCAL_VARIABLE);
	}
	if (_tmp72_) {
		ValaSourceFile* _tmp74_;
		ValaSymbol* _tmp75_;
		GeeHashMap* _tmp76_;
		_tmp74_ = doc;
		_tmp75_ = symbol;
		_tmp76_ = references;
		vls_symbol_references_list_in_file (_tmp74_, _tmp75_, _data29_->include_declaration, _tmp76_);
	} else {
		GeeHashSet* generated_vapis = NULL;
		GeeHashSet* _tmp77_;
		GeeHashSet* shown_files = NULL;
		GeeHashSet* _tmp91_;
		_tmp77_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
		if (_tmp77_) {
			g_object_set_data ((GObject *) _tmp77_, "vala-creation-function", "Vls.Server.textDocumentReferences._lambda54_");
		}
		generated_vapis = _tmp77_;
		{
			GeeArrayList* _btarget_list = NULL;
			VlsProject* _tmp78_;
			GeeArrayList* _tmp79_;
			gint _btarget_size = 0;
			GeeArrayList* _tmp80_;
			gint _tmp81_;
			gint _tmp82_;
			gint _btarget_index = 0;
			_tmp78_ = _data29_->selected_project;
			_tmp79_ = vls_project_get_compilations (_tmp78_);
			_btarget_list = _tmp79_;
			_tmp80_ = _btarget_list;
			_tmp81_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp80_);
			_tmp82_ = _tmp81_;
			_btarget_size = _tmp82_;
			_btarget_index = -1;
			while (TRUE) {
				gint _tmp83_;
				gint _tmp84_;
				VlsCompilation* btarget = NULL;
				GeeArrayList* _tmp85_;
				gpointer _tmp86_;
				GeeHashSet* _tmp87_;
				VlsCompilation* _tmp88_;
				GeeArrayList* _tmp89_;
				GeeArrayList* _tmp90_;
				_btarget_index = _btarget_index + 1;
				_tmp83_ = _btarget_index;
				_tmp84_ = _btarget_size;
				if (!(_tmp83_ < _tmp84_)) {
					break;
				}
				_tmp85_ = _btarget_list;
				_tmp86_ = gee_abstract_list_get ((GeeAbstractList*) _tmp85_, _btarget_index);
				btarget = (VlsCompilation*) _tmp86_;
				_tmp87_ = generated_vapis;
				_tmp88_ = btarget;
				_tmp89_ = vls_build_target_get_output ((VlsBuildTarget*) _tmp88_);
				_tmp90_ = _tmp89_;
				gee_collection_add_all ((GeeCollection*) _tmp87_, (GeeCollection*) _tmp90_);
				_g_object_unref0 (btarget);
			}
			_g_object_unref0 (_btarget_list);
		}
		_tmp91_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
		if (_tmp91_) {
			g_object_set_data ((GObject *) _tmp91_, "vala-creation-function", "Vls.Server.textDocumentReferences._lambda54_");
		}
		shown_files = _tmp91_;
		{
			GeeIterator* _btarget_w_sym_it = NULL;
			VlsProject* _tmp92_;
			ValaSymbol* _tmp93_;
			GeeCollection* _tmp94_;
			GeeCollection* _tmp95_;
			GeeIterator* _tmp96_;
			GeeIterator* _tmp97_;
			_tmp92_ = _data29_->selected_project;
			_tmp93_ = symbol;
			_tmp94_ = vls_symbol_references_get_compilations_using_symbol (_tmp92_, _tmp93_);
			_tmp95_ = _tmp94_;
			_tmp96_ = gee_iterable_iterator ((GeeIterable*) _tmp95_);
			_tmp97_ = _tmp96_;
			_g_object_unref0 (_tmp95_);
			_btarget_w_sym_it = _tmp97_;
			while (TRUE) {
				GeeIterator* _tmp98_;
				VlsPair* btarget_w_sym = NULL;
				GeeIterator* _tmp99_;
				gpointer _tmp100_;
				_tmp98_ = _btarget_w_sym_it;
				if (!gee_iterator_next (_tmp98_)) {
					break;
				}
				_tmp99_ = _btarget_w_sym_it;
				_tmp100_ = gee_iterator_get (_tmp99_);
				btarget_w_sym = (VlsPair*) _tmp100_;
				{
					ValaList* _project_file_list = NULL;
					VlsPair* _tmp101_;
					gconstpointer _tmp102_;
					gconstpointer _tmp103_;
					ValaCodeContext* _tmp104_;
					ValaCodeContext* _tmp105_;
					ValaList* _tmp106_;
					gint _project_file_size = 0;
					ValaList* _tmp107_;
					gint _tmp108_;
					gint _tmp109_;
					gint _project_file_index = 0;
					_tmp101_ = btarget_w_sym;
					_tmp102_ = vls_pair_get_first (_tmp101_);
					_tmp103_ = _tmp102_;
					_tmp104_ = vls_compilation_get_code_context ((VlsCompilation*) _tmp103_);
					_tmp105_ = _tmp104_;
					_tmp106_ = vala_code_context_get_source_files (_tmp105_);
					_project_file_list = _tmp106_;
					_tmp107_ = _project_file_list;
					_tmp108_ = vala_collection_get_size ((ValaCollection*) _tmp107_);
					_tmp109_ = _tmp108_;
					_project_file_size = _tmp109_;
					_project_file_index = -1;
					while (TRUE) {
						gint _tmp110_;
						gint _tmp111_;
						ValaSourceFile* project_file = NULL;
						ValaList* _tmp112_;
						gpointer _tmp113_;
						GFile* file = NULL;
						ValaSourceFile* _tmp114_;
						const gchar* _tmp115_;
						const gchar* _tmp116_;
						GFile* _tmp117_;
						gboolean _tmp118_ = FALSE;
						GeeHashSet* _tmp119_;
						GFile* _tmp120_;
						ValaSourceFile* _tmp123_;
						VlsPair* _tmp124_;
						gconstpointer _tmp125_;
						gconstpointer _tmp126_;
						GeeHashMap* _tmp127_;
						GeeHashSet* _tmp128_;
						GFile* _tmp129_;
						_project_file_index = _project_file_index + 1;
						_tmp110_ = _project_file_index;
						_tmp111_ = _project_file_size;
						if (!(_tmp110_ < _tmp111_)) {
							break;
						}
						_tmp112_ = _project_file_list;
						_tmp113_ = vala_list_get (_tmp112_, _project_file_index);
						project_file = (ValaSourceFile*) _tmp113_;
						_tmp114_ = project_file;
						_tmp115_ = vala_source_file_get_filename (_tmp114_);
						_tmp116_ = _tmp115_;
						_tmp117_ = g_file_new_for_commandline_arg (_tmp116_);
						file = _tmp117_;
						_tmp119_ = generated_vapis;
						_tmp120_ = file;
						if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp119_, _tmp120_)) {
							_tmp118_ = TRUE;
						} else {
							GeeHashSet* _tmp121_;
							GFile* _tmp122_;
							_tmp121_ = shown_files;
							_tmp122_ = file;
							_tmp118_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp121_, _tmp122_);
						}
						if (_tmp118_) {
							_g_object_unref0 (file);
							_vala_source_file_unref0 (project_file);
							continue;
						}
						_tmp123_ = project_file;
						_tmp124_ = btarget_w_sym;
						_tmp125_ = vls_pair_get_second (_tmp124_);
						_tmp126_ = _tmp125_;
						_tmp127_ = references;
						vls_symbol_references_list_in_file (_tmp123_, (ValaSymbol*) _tmp126_, _data29_->include_declaration, _tmp127_);
						_tmp128_ = shown_files;
						_tmp129_ = file;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp128_, _tmp129_);
						_g_object_unref0 (file);
						_vala_source_file_unref0 (project_file);
					}
				}
				_g_object_unref0 (btarget_w_sym);
			}
			_g_object_unref0 (_btarget_w_sym_it);
		}
		_g_object_unref0 (shown_files);
		_g_object_unref0 (generated_vapis);
	}
	_tmp130_ = string_to_string (_data29_->method);
	_tmp131_ = references;
	_tmp132_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp131_);
	_tmp133_ = _tmp132_;
	_tmp134_ = g_strdup_printf ("%i", _tmp133_);
	_tmp135_ = _tmp134_;
	_tmp136_ = g_strconcat ("[", _tmp130_, "] found ", _tmp135_, " reference(s)", NULL);
	_tmp137_ = _tmp136_;
	g_debug ("server.vala:1447: %s", _tmp137_);
	_g_free0 (_tmp137_);
	_g_free0 (_tmp135_);
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp138_;
		GeeIterator* _tmp139_;
		_tmp138_ = references;
		_tmp139_ = gee_iterable_iterator ((GeeIterable*) _tmp138_);
		_entry_it = _tmp139_;
		while (TRUE) {
			GeeIterator* _tmp140_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp141_;
			gpointer _tmp142_;
			_tmp140_ = _entry_it;
			if (!gee_iterator_next (_tmp140_)) {
				break;
			}
			_tmp141_ = _entry_it;
			_tmp142_ = gee_iterator_get (_tmp141_);
			entry = (GeeMapEntry*) _tmp142_;
			if (_data29_->is_highlight) {
				JsonArray* _tmp143_;
				GeeMapEntry* _tmp144_;
				gconstpointer _tmp145_;
				gconstpointer _tmp146_;
				LspRange* _tmp147_;
				GeeMapEntry* _tmp148_;
				gconstpointer _tmp149_;
				gconstpointer _tmp150_;
				LspDocumentHighlight* _tmp151_ = NULL;
				LspDocumentHighlight* _tmp152_;
				JsonNode* _tmp153_;
				_tmp143_ = json_array;
				_tmp144_ = entry;
				_tmp145_ = gee_map_entry_get_key (_tmp144_);
				_tmp146_ = _tmp145_;
				_tmp147_ = _g_object_ref0 ((LspRange*) _tmp146_);
				_tmp148_ = entry;
				_tmp149_ = gee_map_entry_get_value (_tmp148_);
				_tmp150_ = _tmp149_;
				_tmp151_ = lsp_document_highlight_new ();
				lsp_document_highlight_set_range (_tmp151_, _tmp147_);
				_g_object_unref0 (_tmp147_);
				lsp_document_highlight_set_kind (_tmp151_, vls_server_determine_node_highlight_kind (self, (ValaCodeNode*) _tmp150_));
				_tmp152_ = _tmp151_;
				_tmp153_ = json_gobject_serialize ((GObject*) _tmp152_);
				json_array_add_element (_tmp143_, _tmp153_);
				_g_object_unref0 (_tmp152_);
			} else {
				JsonArray* _tmp154_;
				GeeMapEntry* _tmp155_;
				gconstpointer _tmp156_;
				gconstpointer _tmp157_;
				ValaSourceReference* _tmp158_;
				ValaSourceReference* _tmp159_;
				ValaSourceFile* _tmp160_;
				ValaSourceFile* _tmp161_;
				const gchar* _tmp162_;
				const gchar* _tmp163_;
				GeeMapEntry* _tmp164_;
				gconstpointer _tmp165_;
				gconstpointer _tmp166_;
				LspLocation* _tmp167_;
				LspLocation* _tmp168_;
				JsonNode* _tmp169_;
				_tmp154_ = json_array;
				_tmp155_ = entry;
				_tmp156_ = gee_map_entry_get_value (_tmp155_);
				_tmp157_ = _tmp156_;
				_tmp158_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp157_);
				_tmp159_ = _tmp158_;
				_tmp160_ = vala_source_reference_get_file (_tmp159_);
				_tmp161_ = _tmp160_;
				_tmp162_ = vala_source_file_get_filename (_tmp161_);
				_tmp163_ = _tmp162_;
				_tmp164_ = entry;
				_tmp165_ = gee_map_entry_get_key (_tmp164_);
				_tmp166_ = _tmp165_;
				_tmp167_ = lsp_location_new (_tmp163_, (LspRange*) _tmp166_);
				if (_tmp167_) {
					g_object_set_data ((GObject *) _tmp167_, "vala-creation-function", "Vls.Server.textDocumentReferences._lambda54_");
				}
				_tmp168_ = _tmp167_;
				_tmp169_ = json_gobject_serialize ((GObject*) _tmp168_);
				json_array_add_element (_tmp154_, _tmp169_);
				_g_object_unref0 (_tmp168_);
			}
			_g_object_unref0 (entry);
		}
		_g_object_unref0 (_entry_it);
	}
	{
		GVariant* variant_array = NULL;
		JsonNode* _tmp170_;
		JsonNode* _tmp171_;
		JsonArray* _tmp172_;
		JsonNode* _tmp173_;
		GVariant* _tmp174_;
		GVariant* _tmp175_;
		GVariant* _tmp176_;
		GCancellable* _tmp177_;
		_tmp170_ = json_node_alloc ();
		_tmp171_ = _tmp170_;
		_tmp172_ = json_array;
		_tmp173_ = json_node_init_array (_tmp171_, _tmp172_);
		_tmp174_ = json_gvariant_deserialize (_tmp173_, NULL, &_inner_error0_);
		if (_tmp174_ != NULL) {
			g_variant_ref_sink (_tmp174_);
		}
		_tmp175_ = _tmp174_;
		__vala_JsonNode_free0 (_tmp171_);
		variant_array = _tmp175_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp176_ = variant_array;
		_tmp177_ = vls_server_cancellable;
		jsonrpc_client_reply (_data29_->client, _data29_->id, _tmp176_, _tmp177_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (variant_array);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (variant_array);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp178_;
		GError* _tmp179_;
		const gchar* _tmp180_;
		const gchar* _tmp181_;
		gchar* _tmp182_;
		gchar* _tmp183_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp178_ = string_to_string (_data29_->method);
		_tmp179_ = e;
		_tmp180_ = _tmp179_->message;
		_tmp181_ = string_to_string (_tmp180_);
		_tmp182_ = g_strconcat ("[", _tmp178_, "] failed to reply to client: ", _tmp181_, NULL);
		_tmp183_ = _tmp182_;
		g_debug ("server.vala:1463: %s", _tmp183_);
		_g_free0 (_tmp183_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (references);
		_json_array_unref0 (json_array);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_g_object_unref0 (references);
	_json_array_unref0 (json_array);
	_vala_code_node_unref0 (symbol);
	_vala_code_node_unref0 (_result_);
	_vala_code_visitor_unref0 (fs);
	_g_object_unref0 (compilation);
	_vala_source_file_unref0 (doc);
}

static void
___lambda54__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda54_ (self, request_cancelled);
}

static void
vls_server_textDocumentReferences (VlsServer* self,
                                   JsonrpcServer* _self_,
                                   JsonrpcClient* client,
                                   const gchar* method,
                                   GVariant* id,
                                   GVariant* params)
{
	Block29Data* _data29_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	LspReferenceParams* p = NULL;
	gpointer _tmp3_;
	GeeArrayList* _tmp4_;
	GHashTable* _tmp5_;
	guint _tmp6_ = 0;
	gconstpointer* _tmp7_;
	VlsProject* _tmp20_;
	GeeArrayList* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	LspReferenceParams* _tmp43_;
	LspPosition* _tmp44_;
	LspPosition* _tmp45_;
	LspPosition* _tmp46_;
	gboolean _tmp47_ = FALSE;
	LspReferenceParams* _tmp48_;
	LspReferenceParamsReferenceContext* _tmp49_;
	LspReferenceParamsReferenceContext* _tmp50_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data29_ = g_slice_new0 (Block29Data);
	_data29_->_ref_count_ = 1;
	_data29_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data29_->client);
	_data29_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data29_->method);
	_data29_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data29_->id);
	_data29_->id = _tmp2_;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_REFERENCE_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspReferenceParams*) _tmp3_;
	_tmp4_ = gee_array_list_new (VLS_TYPE_PAIR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp4_) {
		g_object_set_data ((GObject *) _tmp4_, "vala-creation-function", "Vls.Server.textDocumentReferences");
	}
	_data29_->results = _tmp4_;
	_data29_->selected_project = NULL;
	_tmp5_ = self->priv->projects;
	_tmp7_ = g_hash_table_get_keys_as_array (_tmp5_, &_tmp6_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp7_;
		project_collection_length1 = _tmp6_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				VlsProject* _tmp8_;
				LspReferenceParams* _tmp9_;
				LspTextDocumentIdentifier* _tmp10_;
				LspTextDocumentIdentifier* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				GeeArrayList* _tmp14_;
				GeeArrayList* _tmp15_;
				gboolean _tmp16_;
				gboolean _tmp17_;
				_tmp8_ = project;
				_tmp9_ = p;
				_tmp10_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = lsp_text_document_identifier_get_uri (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = vls_project_lookup_compile_input_source_file (_tmp8_, _tmp13_);
				_g_object_unref0 (_data29_->results);
				_data29_->results = _tmp14_;
				_tmp15_ = _data29_->results;
				_tmp16_ = gee_collection_get_is_empty ((GeeCollection*) _tmp15_);
				_tmp17_ = _tmp16_;
				if (!_tmp17_) {
					VlsProject* _tmp18_;
					VlsProject* _tmp19_;
					_tmp18_ = project;
					_tmp19_ = _g_object_ref0 (_tmp18_);
					_g_object_unref0 (_data29_->selected_project);
					_data29_->selected_project = _tmp19_;
					break;
				}
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp20_ = _data29_->selected_project;
	if (_tmp20_ == NULL) {
		VlsDefaultProject* _tmp21_;
		LspReferenceParams* _tmp22_;
		LspTextDocumentIdentifier* _tmp23_;
		LspTextDocumentIdentifier* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		GeeArrayList* _tmp27_;
		VlsDefaultProject* _tmp28_;
		VlsProject* _tmp29_;
		_tmp21_ = self->priv->default_project;
		_tmp22_ = p;
		_tmp23_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = lsp_text_document_identifier_get_uri (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = vls_project_lookup_compile_input_source_file ((VlsProject*) _tmp21_, _tmp26_);
		_g_object_unref0 (_data29_->results);
		_data29_->results = _tmp27_;
		_tmp28_ = self->priv->default_project;
		_tmp29_ = _g_object_ref0 ((VlsProject*) _tmp28_);
		_g_object_unref0 (_data29_->selected_project);
		_data29_->selected_project = _tmp29_;
	}
	_tmp30_ = _data29_->results;
	_tmp31_ = gee_collection_get_is_empty ((GeeCollection*) _tmp30_);
	_tmp32_ = _tmp31_;
	if (_tmp32_) {
		LspReferenceParams* _tmp33_;
		LspTextDocumentIdentifier* _tmp34_;
		LspTextDocumentIdentifier* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		_tmp33_ = p;
		_tmp34_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _tmp33_);
		_tmp35_ = _tmp34_;
		_tmp36_ = lsp_text_document_identifier_get_uri (_tmp35_);
		_tmp37_ = _tmp36_;
		_tmp38_ = g_uri_unescape_string (_tmp37_, NULL);
		_tmp39_ = _tmp38_;
		_tmp40_ = string_to_string (_tmp39_);
		_tmp41_ = g_strconcat ("file `", _tmp40_, "' not found", NULL);
		_tmp42_ = _tmp41_;
		g_debug ("server.vala:1375: %s", _tmp42_);
		_g_free0 (_tmp42_);
		_g_free0 (_tmp39_);
		vls_server_reply_null (_data29_->id, _data29_->client, _data29_->method);
		_g_object_unref0 (p);
		block29_data_unref (_data29_);
		_data29_ = NULL;
		return;
	}
	_tmp43_ = p;
	_tmp44_ = lsp_text_document_position_params_get_position ((LspTextDocumentPositionParams*) _tmp43_);
	_tmp45_ = _tmp44_;
	_tmp46_ = _g_object_ref0 (_tmp45_);
	_data29_->pos = _tmp46_;
	_data29_->is_highlight = g_strcmp0 (_data29_->method, "textDocument/documentHighlight") == 0;
	_tmp48_ = p;
	_tmp49_ = lsp_reference_params_get_context (_tmp48_);
	_tmp50_ = _tmp49_;
	if (_tmp50_ != NULL) {
		LspReferenceParams* _tmp51_;
		LspReferenceParamsReferenceContext* _tmp52_;
		LspReferenceParamsReferenceContext* _tmp53_;
		gboolean _tmp54_;
		gboolean _tmp55_;
		_tmp51_ = p;
		_tmp52_ = lsp_reference_params_get_context (_tmp51_);
		_tmp53_ = _tmp52_;
		_tmp54_ = lsp_reference_params_reference_context_get_includeDeclaration (_tmp53_);
		_tmp55_ = _tmp54_;
		_tmp47_ = _tmp55_;
	} else {
		_tmp47_ = TRUE;
	}
	_data29_->include_declaration = _tmp47_;
	vls_server_wait_for_context_update (self, _data29_->id, ___lambda54__vls_server_on_context_updated_func, block29_data_ref (_data29_), block29_data_unref);
	_g_object_unref0 (p);
	block29_data_unref (_data29_);
	_data29_ = NULL;
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
	g_atomic_int_inc (&_data30_->_ref_count_);
	return _data30_;
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
		VlsServer* self;
		self = _data30_->self;
		_g_object_unref0 (_data30_->pos);
		_g_object_unref0 (_data30_->selected_project);
		_g_object_unref0 (_data30_->results);
		_g_object_unref0 (_data30_->client);
		_g_free0 (_data30_->method);
		_g_variant_unref0 (_data30_->id);
		_g_object_unref0 (self);
		g_slice_free (Block30Data, _data30_);
	}
}

static gboolean
_______lambda60_ (ValaCodeNode* needle,
                  ValaCodeNode* node)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
	g_return_val_if_fail (needle != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	if (G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_OBJECT_TYPE_SYMBOL)) {
		_tmp0_ = vala_typesymbol_is_subtype_of ((ValaTypeSymbol*) G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol), (ValaTypeSymbol*) G_TYPE_CHECK_INSTANCE_CAST (needle, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol));
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static gboolean
________lambda60__vls_find_symbol_filter (ValaCodeNode* needle,
                                          ValaCodeNode* hay_node)
{
	gboolean result;
	result = _______lambda60_ (needle, hay_node);
	return result;
}

static gboolean
________lambda61_ (ValaCodeNode* needle,
                   ValaCodeNode* node)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
	g_return_val_if_fail (needle != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	if (needle != node) {
		_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_METHOD);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp2_ = FALSE;
		ValaMethod* _tmp3_;
		ValaMethod* _tmp4_;
		_tmp3_ = vala_method_get_base_method (G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_METHOD, ValaMethod));
		_tmp4_ = _tmp3_;
		if (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, VALA_TYPE_CODE_NODE, ValaCodeNode) == needle) {
			_tmp2_ = TRUE;
		} else {
			ValaMethod* _tmp5_;
			ValaMethod* _tmp6_;
			_tmp5_ = vala_method_get_base_interface_method (G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_METHOD, ValaMethod));
			_tmp6_ = _tmp5_;
			_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, VALA_TYPE_CODE_NODE, ValaCodeNode) == needle;
		}
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static gboolean
_________lambda61__vls_find_symbol_filter (ValaCodeNode* needle,
                                           ValaCodeNode* hay_node)
{
	gboolean result;
	result = ________lambda61_ (needle, hay_node);
	return result;
}

static gboolean
________lambda62_ (ValaCodeNode* needle,
                   ValaCodeNode* node)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
	g_return_val_if_fail (needle != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	if (needle != node) {
		_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_PROPERTY);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp2_ = FALSE;
		ValaProperty* _tmp3_;
		ValaProperty* _tmp4_;
		_tmp3_ = vala_property_get_base_property (G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_PROPERTY, ValaProperty));
		_tmp4_ = _tmp3_;
		if (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, VALA_TYPE_CODE_NODE, ValaCodeNode) == needle) {
			_tmp2_ = TRUE;
		} else {
			ValaProperty* _tmp5_;
			ValaProperty* _tmp6_;
			_tmp5_ = vala_property_get_base_interface_property (G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_PROPERTY, ValaProperty));
			_tmp6_ = _tmp5_;
			_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, VALA_TYPE_CODE_NODE, ValaCodeNode) == needle;
		}
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static gboolean
_________lambda62__vls_find_symbol_filter (ValaCodeNode* needle,
                                           ValaCodeNode* hay_node)
{
	gboolean result;
	result = ________lambda62_ (needle, hay_node);
	return result;
}

static void
__lambda59_ (Block30Data* _data30_,
             gboolean request_cancelled)
{
	VlsServer* self;
	ValaSourceFile* doc = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	VlsPair* _tmp2_;
	gconstpointer _tmp3_;
	gconstpointer _tmp4_;
	ValaSourceFile* _tmp5_;
	ValaSourceFile* _tmp6_;
	VlsCompilation* compilation = NULL;
	GeeArrayList* _tmp7_;
	gpointer _tmp8_;
	VlsPair* _tmp9_;
	gconstpointer _tmp10_;
	gconstpointer _tmp11_;
	VlsCompilation* _tmp12_;
	VlsCompilation* _tmp13_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	VlsFindSymbol* fs = NULL;
	ValaSourceFile* _tmp17_;
	LspPosition* _tmp18_;
	VlsFindSymbol* _tmp19_;
	VlsFindSymbol* _tmp20_;
	GeeList* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	ValaCodeNode* _result_ = NULL;
	VlsFindSymbol* _tmp27_;
	ValaSourceFile* _tmp28_;
	ValaCodeNode* _tmp29_;
	ValaSymbol* symbol = NULL;
	JsonArray* json_array = NULL;
	JsonArray* _tmp30_;
	GeeArrayList* references = NULL;
	GeeArrayList* _tmp31_;
	gboolean _tmp32_ = FALSE;
	ValaCodeNode* _tmp33_;
	const gchar* _tmp41_;
	ValaCodeNode* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	ValaCodeNode* _tmp45_;
	const gchar* _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gboolean _tmp51_ = FALSE;
	ValaCodeNode* _tmp52_;
	gboolean is_abstract_type = FALSE;
	gboolean _tmp58_ = FALSE;
	ValaCodeNode* _tmp59_;
	gboolean is_abstract_or_virtual_method = FALSE;
	gboolean _tmp67_ = FALSE;
	ValaCodeNode* _tmp68_;
	gboolean is_abstract_or_virtual_property = FALSE;
	gboolean _tmp76_ = FALSE;
	gboolean _tmp77_ = FALSE;
	GeeHashSet* generated_vapis = NULL;
	GeeHashSet* _tmp83_;
	GeeHashSet* shown_files = NULL;
	GeeHashSet* _tmp97_;
	const gchar* _tmp147_;
	GeeArrayList* _tmp148_;
	gint _tmp149_;
	gint _tmp150_;
	gchar* _tmp151_;
	gchar* _tmp152_;
	gchar* _tmp153_;
	gchar* _tmp154_;
	GError* _inner_error0_ = NULL;
	self = _data30_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data30_->id, _data30_->client, _data30_->method);
		return;
	}
	_tmp0_ = _data30_->results;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
	_tmp2_ = (VlsPair*) _tmp1_;
	_tmp3_ = vls_pair_get_first (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp2_);
	doc = _tmp6_;
	_tmp7_ = _data30_->results;
	_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, 0);
	_tmp9_ = (VlsPair*) _tmp8_;
	_tmp10_ = vls_pair_get_second (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = _g_object_ref0 ((VlsCompilation*) _tmp11_);
	_tmp13_ = _tmp12_;
	_g_object_unref0 (_tmp9_);
	compilation = _tmp13_;
	_tmp14_ = compilation;
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
	_tmp16_ = _tmp15_;
	vala_code_context_push (_tmp16_);
	_tmp17_ = doc;
	_tmp18_ = _data30_->pos;
	_tmp19_ = vls_find_symbol_new (_tmp17_, _tmp18_, TRUE, NULL);
	fs = _tmp19_;
	_tmp20_ = fs;
	_tmp21_ = _tmp20_->result;
	_tmp22_ = gee_collection_get_size ((GeeCollection*) _tmp21_);
	_tmp23_ = _tmp22_;
	if (_tmp23_ == 0) {
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		_tmp24_ = string_to_string (_data30_->method);
		_tmp25_ = g_strconcat ("[", _tmp24_, "] no results found", NULL);
		_tmp26_ = _tmp25_;
		g_debug ("server.vala:1506: %s", _tmp26_);
		_g_free0 (_tmp26_);
		vls_server_reply_null (_data30_->id, _data30_->client, _data30_->method);
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		return;
	}
	_tmp27_ = fs;
	_tmp28_ = doc;
	_tmp29_ = vls_server_get_best (_tmp27_, _tmp28_);
	_result_ = _tmp29_;
	_tmp30_ = json_array_new ();
	json_array = _tmp30_;
	_tmp31_ = gee_array_list_new (VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL);
	if (_tmp31_) {
		g_object_set_data ((GObject *) _tmp31_, "vala-creation-function", "Vls.Server.textDocumentImplementation._lambda59_");
	}
	references = _tmp31_;
	_tmp33_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, VALA_TYPE_DATA_TYPE)) {
		ValaCodeNode* _tmp34_;
		ValaTypeSymbol* _tmp35_;
		ValaTypeSymbol* _tmp36_;
		_tmp34_ = _result_;
		_tmp35_ = vala_data_type_get_type_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, VALA_TYPE_DATA_TYPE, ValaDataType));
		_tmp36_ = _tmp35_;
		_tmp32_ = _tmp36_ != NULL;
	} else {
		_tmp32_ = FALSE;
	}
	if (_tmp32_) {
		ValaCodeNode* _tmp37_;
		ValaTypeSymbol* _tmp38_;
		ValaTypeSymbol* _tmp39_;
		ValaCodeNode* _tmp40_;
		_tmp37_ = _result_;
		_tmp38_ = vala_data_type_get_type_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, VALA_TYPE_DATA_TYPE, ValaDataType));
		_tmp39_ = _tmp38_;
		_tmp40_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp39_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp40_;
	}
	_tmp41_ = string_to_string (_data30_->method);
	_tmp42_ = _result_;
	_tmp43_ = vala_code_node_to_string (_tmp42_);
	_tmp44_ = _tmp43_;
	_tmp45_ = _result_;
	_tmp46_ = vala_code_node_get_type_name (_tmp45_);
	_tmp47_ = _tmp46_;
	_tmp48_ = string_to_string (_tmp47_);
	_tmp49_ = g_strconcat ("[", _tmp41_, "] got best: ", _tmp44_, " (", _tmp48_, ")", NULL);
	_tmp50_ = _tmp49_;
	g_debug ("server.vala:1521: %s", _tmp50_);
	_g_free0 (_tmp50_);
	_g_free0 (_tmp44_);
	_tmp52_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp52_, VALA_TYPE_INTERFACE)) {
		_tmp51_ = TRUE;
	} else {
		gboolean _tmp53_ = FALSE;
		ValaCodeNode* _tmp54_;
		_tmp54_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp54_, VALA_TYPE_CLASS)) {
			ValaCodeNode* _tmp55_;
			gboolean _tmp56_;
			gboolean _tmp57_;
			_tmp55_ = _result_;
			_tmp56_ = vala_class_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, VALA_TYPE_CLASS, ValaClass));
			_tmp57_ = _tmp56_;
			_tmp53_ = _tmp57_;
		} else {
			_tmp53_ = FALSE;
		}
		_tmp51_ = _tmp53_;
	}
	is_abstract_type = _tmp51_;
	_tmp59_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp59_, VALA_TYPE_METHOD)) {
		gboolean _tmp60_ = FALSE;
		ValaCodeNode* _tmp61_;
		gboolean _tmp62_;
		gboolean _tmp63_;
		_tmp61_ = _result_;
		_tmp62_ = vala_method_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, VALA_TYPE_METHOD, ValaMethod));
		_tmp63_ = _tmp62_;
		if (_tmp63_) {
			_tmp60_ = TRUE;
		} else {
			ValaCodeNode* _tmp64_;
			gboolean _tmp65_;
			gboolean _tmp66_;
			_tmp64_ = _result_;
			_tmp65_ = vala_method_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, VALA_TYPE_METHOD, ValaMethod));
			_tmp66_ = _tmp65_;
			_tmp60_ = _tmp66_;
		}
		_tmp58_ = _tmp60_;
	} else {
		_tmp58_ = FALSE;
	}
	is_abstract_or_virtual_method = _tmp58_;
	_tmp68_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp68_, VALA_TYPE_PROPERTY)) {
		gboolean _tmp69_ = FALSE;
		ValaCodeNode* _tmp70_;
		gboolean _tmp71_;
		gboolean _tmp72_;
		_tmp70_ = _result_;
		_tmp71_ = vala_property_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, VALA_TYPE_PROPERTY, ValaProperty));
		_tmp72_ = _tmp71_;
		if (_tmp72_) {
			_tmp69_ = TRUE;
		} else {
			ValaCodeNode* _tmp73_;
			gboolean _tmp74_;
			gboolean _tmp75_;
			_tmp73_ = _result_;
			_tmp74_ = vala_property_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp73_, VALA_TYPE_PROPERTY, ValaProperty));
			_tmp75_ = _tmp74_;
			_tmp69_ = _tmp75_;
		}
		_tmp67_ = _tmp69_;
	} else {
		_tmp67_ = FALSE;
	}
	is_abstract_or_virtual_property = _tmp67_;
	if (!is_abstract_type) {
		_tmp77_ = !is_abstract_or_virtual_method;
	} else {
		_tmp77_ = FALSE;
	}
	if (_tmp77_) {
		_tmp76_ = !is_abstract_or_virtual_property;
	} else {
		_tmp76_ = FALSE;
	}
	if (_tmp76_) {
		const gchar* _tmp78_;
		gchar* _tmp79_;
		gchar* _tmp80_;
		_tmp78_ = string_to_string (_data30_->method);
		_tmp79_ = g_strconcat ("[", _tmp78_, "] best is neither an abstract type/interface nor abstract/virtual meth" \
"od/property", NULL);
		_tmp80_ = _tmp79_;
		g_debug ("server.vala:1529: %s", _tmp80_);
		_g_free0 (_tmp80_);
		vls_server_reply_null (_data30_->id, _data30_->client, _data30_->method);
		vala_code_context_pop ();
		_g_object_unref0 (references);
		_json_array_unref0 (json_array);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		return;
	} else {
		ValaCodeNode* _tmp81_;
		ValaSymbol* _tmp82_;
		_tmp81_ = _result_;
		_tmp82_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp81_, VALA_TYPE_SYMBOL, ValaSymbol));
		_vala_code_node_unref0 (symbol);
		symbol = _tmp82_;
	}
	_tmp83_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
	if (_tmp83_) {
		g_object_set_data ((GObject *) _tmp83_, "vala-creation-function", "Vls.Server.textDocumentImplementation._lambda59_");
	}
	generated_vapis = _tmp83_;
	{
		GeeArrayList* _btarget_list = NULL;
		VlsProject* _tmp84_;
		GeeArrayList* _tmp85_;
		gint _btarget_size = 0;
		GeeArrayList* _tmp86_;
		gint _tmp87_;
		gint _tmp88_;
		gint _btarget_index = 0;
		_tmp84_ = _data30_->selected_project;
		_tmp85_ = vls_project_get_compilations (_tmp84_);
		_btarget_list = _tmp85_;
		_tmp86_ = _btarget_list;
		_tmp87_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp86_);
		_tmp88_ = _tmp87_;
		_btarget_size = _tmp88_;
		_btarget_index = -1;
		while (TRUE) {
			gint _tmp89_;
			gint _tmp90_;
			VlsCompilation* btarget = NULL;
			GeeArrayList* _tmp91_;
			gpointer _tmp92_;
			GeeHashSet* _tmp93_;
			VlsCompilation* _tmp94_;
			GeeArrayList* _tmp95_;
			GeeArrayList* _tmp96_;
			_btarget_index = _btarget_index + 1;
			_tmp89_ = _btarget_index;
			_tmp90_ = _btarget_size;
			if (!(_tmp89_ < _tmp90_)) {
				break;
			}
			_tmp91_ = _btarget_list;
			_tmp92_ = gee_abstract_list_get ((GeeAbstractList*) _tmp91_, _btarget_index);
			btarget = (VlsCompilation*) _tmp92_;
			_tmp93_ = generated_vapis;
			_tmp94_ = btarget;
			_tmp95_ = vls_build_target_get_output ((VlsBuildTarget*) _tmp94_);
			_tmp96_ = _tmp95_;
			gee_collection_add_all ((GeeCollection*) _tmp93_, (GeeCollection*) _tmp96_);
			_g_object_unref0 (btarget);
		}
		_g_object_unref0 (_btarget_list);
	}
	_tmp97_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
	if (_tmp97_) {
		g_object_set_data ((GObject *) _tmp97_, "vala-creation-function", "Vls.Server.textDocumentImplementation._lambda59_");
	}
	shown_files = _tmp97_;
	{
		GeeIterator* _btarget_w_sym_it = NULL;
		VlsProject* _tmp98_;
		ValaSymbol* _tmp99_;
		GeeCollection* _tmp100_;
		GeeCollection* _tmp101_;
		GeeIterator* _tmp102_;
		GeeIterator* _tmp103_;
		_tmp98_ = _data30_->selected_project;
		_tmp99_ = symbol;
		_tmp100_ = vls_symbol_references_get_compilations_using_symbol (_tmp98_, _tmp99_);
		_tmp101_ = _tmp100_;
		_tmp102_ = gee_iterable_iterator ((GeeIterable*) _tmp101_);
		_tmp103_ = _tmp102_;
		_g_object_unref0 (_tmp101_);
		_btarget_w_sym_it = _tmp103_;
		while (TRUE) {
			GeeIterator* _tmp104_;
			VlsPair* btarget_w_sym = NULL;
			GeeIterator* _tmp105_;
			gpointer _tmp106_;
			_tmp104_ = _btarget_w_sym_it;
			if (!gee_iterator_next (_tmp104_)) {
				break;
			}
			_tmp105_ = _btarget_w_sym_it;
			_tmp106_ = gee_iterator_get (_tmp105_);
			btarget_w_sym = (VlsPair*) _tmp106_;
			{
				ValaList* _file_list = NULL;
				VlsPair* _tmp107_;
				gconstpointer _tmp108_;
				gconstpointer _tmp109_;
				ValaCodeContext* _tmp110_;
				ValaCodeContext* _tmp111_;
				ValaList* _tmp112_;
				gint _file_size = 0;
				ValaList* _tmp113_;
				gint _tmp114_;
				gint _tmp115_;
				gint _file_index = 0;
				_tmp107_ = btarget_w_sym;
				_tmp108_ = vls_pair_get_first (_tmp107_);
				_tmp109_ = _tmp108_;
				_tmp110_ = vls_compilation_get_code_context ((VlsCompilation*) _tmp109_);
				_tmp111_ = _tmp110_;
				_tmp112_ = vala_code_context_get_source_files (_tmp111_);
				_file_list = _tmp112_;
				_tmp113_ = _file_list;
				_tmp114_ = vala_collection_get_size ((ValaCollection*) _tmp113_);
				_tmp115_ = _tmp114_;
				_file_size = _tmp115_;
				_file_index = -1;
				while (TRUE) {
					gint _tmp116_;
					gint _tmp117_;
					ValaSourceFile* file = NULL;
					ValaList* _tmp118_;
					gpointer _tmp119_;
					GFile* gfile = NULL;
					ValaSourceFile* _tmp120_;
					const gchar* _tmp121_;
					const gchar* _tmp122_;
					GFile* _tmp123_;
					gboolean _tmp124_ = FALSE;
					GeeHashSet* _tmp125_;
					GFile* _tmp126_;
					VlsFindSymbol* fs2 = NULL;
					GeeArrayList* _tmp142_;
					VlsFindSymbol* _tmp143_;
					GeeList* _tmp144_;
					GeeHashSet* _tmp145_;
					GFile* _tmp146_;
					_file_index = _file_index + 1;
					_tmp116_ = _file_index;
					_tmp117_ = _file_size;
					if (!(_tmp116_ < _tmp117_)) {
						break;
					}
					_tmp118_ = _file_list;
					_tmp119_ = vala_list_get (_tmp118_, _file_index);
					file = (ValaSourceFile*) _tmp119_;
					_tmp120_ = file;
					_tmp121_ = vala_source_file_get_filename (_tmp120_);
					_tmp122_ = _tmp121_;
					_tmp123_ = g_file_new_for_commandline_arg (_tmp122_);
					gfile = _tmp123_;
					_tmp125_ = generated_vapis;
					_tmp126_ = gfile;
					if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp125_, _tmp126_)) {
						_tmp124_ = TRUE;
					} else {
						GeeHashSet* _tmp127_;
						GFile* _tmp128_;
						_tmp127_ = shown_files;
						_tmp128_ = gfile;
						_tmp124_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp127_, _tmp128_);
					}
					if (_tmp124_) {
						_g_object_unref0 (gfile);
						_vala_source_file_unref0 (file);
						continue;
					}
					if (is_abstract_type) {
						ValaSourceFile* _tmp129_;
						VlsPair* _tmp130_;
						gconstpointer _tmp131_;
						gconstpointer _tmp132_;
						VlsFindSymbol* _tmp133_;
						_tmp129_ = file;
						_tmp130_ = btarget_w_sym;
						_tmp131_ = vls_pair_get_second (_tmp130_);
						_tmp132_ = _tmp131_;
						_tmp133_ = vls_find_symbol_new_with_filter (_tmp129_, (ValaCodeNode*) ((ValaSymbol*) _tmp132_), ________lambda60__vls_find_symbol_filter, FALSE);
						_vala_code_visitor_unref0 (fs2);
						fs2 = _tmp133_;
					} else {
						if (is_abstract_or_virtual_method) {
							ValaSourceFile* _tmp134_;
							VlsPair* _tmp135_;
							gconstpointer _tmp136_;
							gconstpointer _tmp137_;
							VlsFindSymbol* _tmp138_;
							_tmp134_ = file;
							_tmp135_ = btarget_w_sym;
							_tmp136_ = vls_pair_get_second (_tmp135_);
							_tmp137_ = _tmp136_;
							_tmp138_ = vls_find_symbol_new_with_filter (_tmp134_, (ValaCodeNode*) ((ValaSymbol*) _tmp137_), _________lambda61__vls_find_symbol_filter, FALSE);
							_vala_code_visitor_unref0 (fs2);
							fs2 = _tmp138_;
						} else {
							ValaSourceFile* _tmp139_;
							ValaSymbol* _tmp140_;
							VlsFindSymbol* _tmp141_;
							_tmp139_ = file;
							_tmp140_ = symbol;
							_tmp141_ = vls_find_symbol_new_with_filter (_tmp139_, (ValaCodeNode*) _tmp140_, _________lambda62__vls_find_symbol_filter, FALSE);
							_vala_code_visitor_unref0 (fs2);
							fs2 = _tmp141_;
						}
					}
					_tmp142_ = references;
					_tmp143_ = fs2;
					_tmp144_ = _tmp143_->result;
					gee_array_list_add_all (_tmp142_, (GeeCollection*) _tmp144_);
					_tmp145_ = shown_files;
					_tmp146_ = gfile;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp145_, _tmp146_);
					_vala_code_visitor_unref0 (fs2);
					_g_object_unref0 (gfile);
					_vala_source_file_unref0 (file);
				}
			}
			_g_object_unref0 (btarget_w_sym);
		}
		_g_object_unref0 (_btarget_w_sym_it);
	}
	_tmp147_ = string_to_string (_data30_->method);
	_tmp148_ = references;
	_tmp149_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp148_);
	_tmp150_ = _tmp149_;
	_tmp151_ = g_strdup_printf ("%i", _tmp150_);
	_tmp152_ = _tmp151_;
	_tmp153_ = g_strconcat ("[", _tmp147_, "] found ", _tmp152_, " reference(s)", NULL);
	_tmp154_ = _tmp153_;
	g_debug ("server.vala:1570: %s", _tmp154_);
	_g_free0 (_tmp154_);
	_g_free0 (_tmp152_);
	{
		GeeArrayList* _node_list = NULL;
		GeeArrayList* _tmp155_;
		gint _node_size = 0;
		GeeArrayList* _tmp156_;
		gint _tmp157_;
		gint _tmp158_;
		gint _node_index = 0;
		_tmp155_ = references;
		_node_list = _tmp155_;
		_tmp156_ = _node_list;
		_tmp157_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp156_);
		_tmp158_ = _tmp157_;
		_node_size = _tmp158_;
		_node_index = -1;
		while (TRUE) {
			gint _tmp159_;
			gint _tmp160_;
			ValaCodeNode* node = NULL;
			GeeArrayList* _tmp161_;
			gpointer _tmp162_;
			ValaCodeNode* real_node = NULL;
			ValaCodeNode* _tmp163_;
			ValaCodeNode* _tmp164_;
			ValaCodeNode* _tmp165_;
			JsonArray* _tmp169_;
			ValaCodeNode* _tmp170_;
			ValaSourceReference* _tmp171_;
			ValaSourceReference* _tmp172_;
			LspLocation* _tmp173_;
			LspLocation* _tmp174_;
			JsonNode* _tmp175_;
			_node_index = _node_index + 1;
			_tmp159_ = _node_index;
			_tmp160_ = _node_size;
			if (!(_tmp159_ < _tmp160_)) {
				break;
			}
			_tmp161_ = _node_list;
			_tmp162_ = gee_abstract_list_get ((GeeAbstractList*) _tmp161_, _node_index);
			node = (ValaCodeNode*) _tmp162_;
			_tmp163_ = node;
			_tmp164_ = _vala_code_node_ref0 (_tmp163_);
			real_node = _tmp164_;
			_tmp165_ = node;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp165_, VALA_TYPE_SYMBOL)) {
				VlsProject* _tmp166_;
				ValaCodeNode* _tmp167_;
				ValaSymbol* _tmp168_;
				_tmp166_ = _data30_->selected_project;
				_tmp167_ = node;
				_tmp168_ = vls_symbol_references_find_real_symbol (_tmp166_, G_TYPE_CHECK_INSTANCE_CAST (_tmp167_, VALA_TYPE_SYMBOL, ValaSymbol));
				_vala_code_node_unref0 (real_node);
				real_node = (ValaCodeNode*) _tmp168_;
			}
			_tmp169_ = json_array;
			_tmp170_ = real_node;
			_tmp171_ = vala_code_node_get_source_reference (_tmp170_);
			_tmp172_ = _tmp171_;
			_tmp173_ = lsp_location_new_from_sourceref (_tmp172_);
			if (_tmp173_) {
				g_object_set_data ((GObject *) _tmp173_, "vala-creation-function", "Vls.Server.textDocumentImplementation._lambda59_");
			}
			_tmp174_ = _tmp173_;
			_tmp175_ = json_gobject_serialize ((GObject*) _tmp174_);
			json_array_add_element (_tmp169_, _tmp175_);
			_g_object_unref0 (_tmp174_);
			_vala_code_node_unref0 (real_node);
			_vala_code_node_unref0 (node);
		}
	}
	{
		GVariant* variant_array = NULL;
		JsonNode* _tmp176_;
		JsonNode* _tmp177_;
		JsonArray* _tmp178_;
		JsonNode* _tmp179_;
		GVariant* _tmp180_;
		GVariant* _tmp181_;
		GVariant* _tmp182_;
		GCancellable* _tmp183_;
		_tmp176_ = json_node_alloc ();
		_tmp177_ = _tmp176_;
		_tmp178_ = json_array;
		_tmp179_ = json_node_init_array (_tmp177_, _tmp178_);
		_tmp180_ = json_gvariant_deserialize (_tmp179_, NULL, &_inner_error0_);
		if (_tmp180_ != NULL) {
			g_variant_ref_sink (_tmp180_);
		}
		_tmp181_ = _tmp180_;
		__vala_JsonNode_free0 (_tmp177_);
		variant_array = _tmp181_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp182_ = variant_array;
		_tmp183_ = vls_server_cancellable;
		jsonrpc_client_reply (_data30_->client, _data30_->id, _tmp182_, _tmp183_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (variant_array);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (variant_array);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp184_;
		GError* _tmp185_;
		const gchar* _tmp186_;
		const gchar* _tmp187_;
		gchar* _tmp188_;
		gchar* _tmp189_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp184_ = string_to_string (_data30_->method);
		_tmp185_ = e;
		_tmp186_ = _tmp185_->message;
		_tmp187_ = string_to_string (_tmp186_);
		_tmp188_ = g_strconcat ("[", _tmp184_, "] failed to reply to client: ", _tmp187_, NULL);
		_tmp189_ = _tmp188_;
		g_debug ("server.vala:1582: %s", _tmp189_);
		_g_free0 (_tmp189_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (shown_files);
		_g_object_unref0 (generated_vapis);
		_g_object_unref0 (references);
		_json_array_unref0 (json_array);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_g_object_unref0 (shown_files);
	_g_object_unref0 (generated_vapis);
	_g_object_unref0 (references);
	_json_array_unref0 (json_array);
	_vala_code_node_unref0 (symbol);
	_vala_code_node_unref0 (_result_);
	_vala_code_visitor_unref0 (fs);
	_g_object_unref0 (compilation);
	_vala_source_file_unref0 (doc);
}

static void
___lambda59__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda59_ (self, request_cancelled);
}

static void
vls_server_textDocumentImplementation (VlsServer* self,
                                       JsonrpcServer* _self_,
                                       JsonrpcClient* client,
                                       const gchar* method,
                                       GVariant* id,
                                       GVariant* params)
{
	Block30Data* _data30_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	LspTextDocumentPositionParams* p = NULL;
	gpointer _tmp3_;
	GeeArrayList* _tmp4_;
	GHashTable* _tmp5_;
	guint _tmp6_ = 0;
	gconstpointer* _tmp7_;
	VlsProject* _tmp20_;
	GeeArrayList* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	LspTextDocumentPositionParams* _tmp43_;
	LspPosition* _tmp44_;
	LspPosition* _tmp45_;
	LspPosition* _tmp46_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data30_ = g_slice_new0 (Block30Data);
	_data30_->_ref_count_ = 1;
	_data30_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data30_->client);
	_data30_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data30_->method);
	_data30_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data30_->id);
	_data30_->id = _tmp2_;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspTextDocumentPositionParams*) _tmp3_;
	_tmp4_ = gee_array_list_new (VLS_TYPE_PAIR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp4_) {
		g_object_set_data ((GObject *) _tmp4_, "vala-creation-function", "Vls.Server.textDocumentImplementation");
	}
	_data30_->results = _tmp4_;
	_data30_->selected_project = NULL;
	_tmp5_ = self->priv->projects;
	_tmp7_ = g_hash_table_get_keys_as_array (_tmp5_, &_tmp6_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp7_;
		project_collection_length1 = _tmp6_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				VlsProject* _tmp8_;
				LspTextDocumentPositionParams* _tmp9_;
				LspTextDocumentIdentifier* _tmp10_;
				LspTextDocumentIdentifier* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				GeeArrayList* _tmp14_;
				GeeArrayList* _tmp15_;
				gboolean _tmp16_;
				gboolean _tmp17_;
				_tmp8_ = project;
				_tmp9_ = p;
				_tmp10_ = lsp_text_document_position_params_get_textDocument (_tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = lsp_text_document_identifier_get_uri (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = vls_project_lookup_compile_input_source_file (_tmp8_, _tmp13_);
				_g_object_unref0 (_data30_->results);
				_data30_->results = _tmp14_;
				_tmp15_ = _data30_->results;
				_tmp16_ = gee_collection_get_is_empty ((GeeCollection*) _tmp15_);
				_tmp17_ = _tmp16_;
				if (!_tmp17_) {
					VlsProject* _tmp18_;
					VlsProject* _tmp19_;
					_tmp18_ = project;
					_tmp19_ = _g_object_ref0 (_tmp18_);
					_g_object_unref0 (_data30_->selected_project);
					_data30_->selected_project = _tmp19_;
					break;
				}
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp20_ = _data30_->selected_project;
	if (_tmp20_ == NULL) {
		VlsDefaultProject* _tmp21_;
		LspTextDocumentPositionParams* _tmp22_;
		LspTextDocumentIdentifier* _tmp23_;
		LspTextDocumentIdentifier* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		GeeArrayList* _tmp27_;
		VlsDefaultProject* _tmp28_;
		VlsProject* _tmp29_;
		_tmp21_ = self->priv->default_project;
		_tmp22_ = p;
		_tmp23_ = lsp_text_document_position_params_get_textDocument (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = lsp_text_document_identifier_get_uri (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = vls_project_lookup_compile_input_source_file ((VlsProject*) _tmp21_, _tmp26_);
		_g_object_unref0 (_data30_->results);
		_data30_->results = _tmp27_;
		_tmp28_ = self->priv->default_project;
		_tmp29_ = _g_object_ref0 ((VlsProject*) _tmp28_);
		_g_object_unref0 (_data30_->selected_project);
		_data30_->selected_project = _tmp29_;
	}
	_tmp30_ = _data30_->results;
	_tmp31_ = gee_collection_get_is_empty ((GeeCollection*) _tmp30_);
	_tmp32_ = _tmp31_;
	if (_tmp32_) {
		LspTextDocumentPositionParams* _tmp33_;
		LspTextDocumentIdentifier* _tmp34_;
		LspTextDocumentIdentifier* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		_tmp33_ = p;
		_tmp34_ = lsp_text_document_position_params_get_textDocument (_tmp33_);
		_tmp35_ = _tmp34_;
		_tmp36_ = lsp_text_document_identifier_get_uri (_tmp35_);
		_tmp37_ = _tmp36_;
		_tmp38_ = g_uri_unescape_string (_tmp37_, NULL);
		_tmp39_ = _tmp38_;
		_tmp40_ = string_to_string (_tmp39_);
		_tmp41_ = g_strconcat ("file `", _tmp40_, "' not found", NULL);
		_tmp42_ = _tmp41_;
		g_debug ("server.vala:1487: %s", _tmp42_);
		_g_free0 (_tmp42_);
		_g_free0 (_tmp39_);
		vls_server_reply_null (_data30_->id, _data30_->client, _data30_->method);
		_g_object_unref0 (p);
		block30_data_unref (_data30_);
		_data30_ = NULL;
		return;
	}
	_tmp43_ = p;
	_tmp44_ = lsp_text_document_position_params_get_position (_tmp43_);
	_tmp45_ = _tmp44_;
	_tmp46_ = _g_object_ref0 (_tmp45_);
	_data30_->pos = _tmp46_;
	vls_server_wait_for_context_update (self, _data30_->id, ___lambda59__vls_server_on_context_updated_func, block30_data_ref (_data30_), block30_data_unref);
	_g_object_unref0 (p);
	block30_data_unref (_data30_);
	_data30_ = NULL;
}

static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
	g_atomic_int_inc (&_data31_->_ref_count_);
	return _data31_;
}

static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
		VlsServer* self;
		self = _data31_->self;
		_g_free0 (_data31_->query);
		_g_object_unref0 (_data31_->client);
		_g_free0 (_data31_->method);
		_g_variant_unref0 (_data31_->id);
		_g_object_unref0 (self);
		g_slice_free (Block31Data, _data31_);
	}
}

static gchar*
_variant_get8 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
	g_atomic_int_inc (&_data32_->_ref_count_);
	return _data32_;
}

static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
		VlsServer* self;
		self = _data32_->_data31_->self;
		_json_array_unref0 (_data32_->json_array);
		block31_data_unref (_data32_->_data31_);
		_data32_->_data31_ = NULL;
		g_slice_free (Block32Data, _data32_);
	}
}

static VlsProject**
_vala_array_dup16 (VlsProject** self,
                   gssize length)
{
	if (length >= 0) {
		VlsProject** result;
		gssize i;
		result = g_new0 (VlsProject*, length + 1);
		for (i = 0; i < length; i++) {
			VlsProject* _tmp0_;
			_tmp0_ = _g_object_ref0 (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_vala_array_add18 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (VlsProject*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gboolean
_______lambda64_ (Block32Data* _data32_,
                  LspSymbolInformation* dsym)
{
	Block31Data* _data31_;
	VlsServer* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
	_data31_ = _data32_->_data31_;
	self = _data31_->self;
	g_return_val_if_fail (dsym != NULL, FALSE);
	_tmp0_ = lsp_symbol_information_get_name (dsym);
	_tmp1_ = _tmp0_;
	result = g_str_match_string (_data31_->query, _tmp1_, TRUE);
	return result;
}

static gboolean
________lambda64__gee_predicate (gconstpointer g,
                                 gpointer self)
{
	gboolean result;
	result = _______lambda64_ (self, (LspSymbolInformation*) g);
	return result;
}

static gboolean
_______lambda65_ (Block32Data* _data32_,
                  LspSymbolInformation* dsym)
{
	Block31Data* _data31_;
	VlsServer* self;
	JsonArray* _tmp0_;
	JsonNode* _tmp1_;
	gboolean result;
	_data31_ = _data32_->_data31_;
	self = _data31_->self;
	g_return_val_if_fail (dsym != NULL, FALSE);
	_tmp0_ = _data32_->json_array;
	_tmp1_ = json_gobject_serialize ((GObject*) dsym);
	json_array_add_element (_tmp0_, _tmp1_);
	result = TRUE;
	_g_object_unref0 (dsym);
	return result;
}

static gboolean
________lambda65__gee_forall_func (gpointer g,
                                   gpointer self)
{
	gboolean result;
	result = _______lambda65_ (self, (LspSymbolInformation*) g);
	return result;
}

static void
__lambda63_ (Block31Data* _data31_,
             gboolean request_cancelled)
{
	VlsServer* self;
	Block32Data* _data32_;
	JsonArray* _tmp0_;
	VlsProject** all_projects = NULL;
	GHashTable* _tmp1_;
	guint _tmp2_ = 0;
	gconstpointer* _tmp3_;
	VlsProject** _tmp4_;
	gint _tmp4__length1;
	gint all_projects_length1;
	gint _all_projects_size_;
	VlsDefaultProject* _tmp5_;
	VlsProject* _tmp6_;
	VlsProject** _tmp7_;
	gint _tmp7__length1;
	const gchar* _tmp38_;
	JsonArray* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	GError* _inner_error0_ = NULL;
	self = _data31_->self;
	_data32_ = g_slice_new0 (Block32Data);
	_data32_->_ref_count_ = 1;
	_data32_->_data31_ = block31_data_ref (_data31_);
	if (request_cancelled) {
		vls_server_reply_null (_data31_->id, _data31_->client, _data31_->method);
		block32_data_unref (_data32_);
		_data32_ = NULL;
		return;
	}
	_tmp0_ = json_array_new ();
	_data32_->json_array = _tmp0_;
	_tmp1_ = self->priv->projects;
	_tmp3_ = g_hash_table_get_keys_as_array (_tmp1_, &_tmp2_);
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup16 (_tmp3_, _tmp2_) : _tmp3_;
	_tmp4__length1 = _tmp2_;
	_tmp3_ = (g_free (_tmp3_), NULL);
	all_projects = _tmp4_;
	all_projects_length1 = _tmp4__length1;
	_all_projects_size_ = all_projects_length1;
	_tmp5_ = self->priv->default_project;
	_tmp6_ = _g_object_ref0 ((VlsProject*) _tmp5_);
	_vala_array_add18 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp6_);
	_tmp7_ = all_projects;
	_tmp7__length1 = all_projects_length1;
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp7_;
		project_collection_length1 = _tmp7__length1;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* _tmp8_;
			VlsProject* project = NULL;
			_tmp8_ = _g_object_ref0 (project_collection[project_it]);
			project = _tmp8_;
			{
				{
					GeeIterator* _source_pair_it = NULL;
					VlsProject* _tmp9_;
					GeeIterable* _tmp10_;
					GeeIterable* _tmp11_;
					GeeIterator* _tmp12_;
					GeeIterator* _tmp13_;
					_tmp9_ = project;
					_tmp10_ = vls_project_get_project_source_files (_tmp9_);
					_tmp11_ = _tmp10_;
					_tmp12_ = gee_iterable_iterator (_tmp11_);
					_tmp13_ = _tmp12_;
					_g_object_unref0 (_tmp11_);
					_source_pair_it = _tmp13_;
					while (TRUE) {
						GeeIterator* _tmp14_;
						GeeMapEntry* source_pair = NULL;
						GeeIterator* _tmp15_;
						gpointer _tmp16_;
						ValaSourceFile* text_document = NULL;
						GeeMapEntry* _tmp17_;
						gconstpointer _tmp18_;
						gconstpointer _tmp19_;
						ValaSourceFile* _tmp20_;
						VlsCompilation* compilation = NULL;
						GeeMapEntry* _tmp21_;
						gconstpointer _tmp22_;
						gconstpointer _tmp23_;
						VlsCompilation* _tmp24_;
						VlsCompilation* _tmp25_;
						ValaCodeContext* _tmp26_;
						ValaCodeContext* _tmp27_;
						VlsSymbolEnumerator* symbol_enumerator = NULL;
						VlsCompilation* _tmp28_;
						ValaSourceFile* _tmp29_;
						VlsCodeAnalyzer* _tmp30_;
						VlsSymbolEnumerator* _tmp31_;
						VlsSymbolEnumerator* _tmp32_;
						_tmp14_ = _source_pair_it;
						if (!gee_iterator_next (_tmp14_)) {
							break;
						}
						_tmp15_ = _source_pair_it;
						_tmp16_ = gee_iterator_get (_tmp15_);
						source_pair = (GeeMapEntry*) _tmp16_;
						_tmp17_ = source_pair;
						_tmp18_ = gee_map_entry_get_key (_tmp17_);
						_tmp19_ = _tmp18_;
						_tmp20_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp19_);
						text_document = _tmp20_;
						_tmp21_ = source_pair;
						_tmp22_ = gee_map_entry_get_value (_tmp21_);
						_tmp23_ = _tmp22_;
						_tmp24_ = _g_object_ref0 ((VlsCompilation*) _tmp23_);
						compilation = _tmp24_;
						_tmp25_ = compilation;
						_tmp26_ = vls_compilation_get_code_context (_tmp25_);
						_tmp27_ = _tmp26_;
						vala_code_context_push (_tmp27_);
						_tmp28_ = compilation;
						_tmp29_ = text_document;
						_tmp30_ = vls_compilation_get_analysis_for_file (_tmp28_, VLS_TYPE_SYMBOL_ENUMERATOR, (GBoxedCopyFunc) vala_code_visitor_ref, (GDestroyNotify) vala_code_visitor_unref, _tmp29_);
						_tmp31_ = VLS_IS_SYMBOL_ENUMERATOR (_tmp30_) ? ((VlsSymbolEnumerator*) _tmp30_) : NULL;
						if (_tmp31_ == NULL) {
							_vala_code_visitor_unref0 (_tmp30_);
						}
						symbol_enumerator = _tmp31_;
						_tmp32_ = symbol_enumerator;
						if (_tmp32_ != NULL) {
							VlsSymbolEnumerator* _tmp33_;
							GeeIterable* _tmp34_;
							GeeIterable* _tmp35_;
							GeeIterator* _tmp36_;
							GeeIterator* _tmp37_;
							_tmp33_ = symbol_enumerator;
							_tmp34_ = vls_symbol_enumerator_flattened (_tmp33_);
							_tmp35_ = _tmp34_;
							_tmp36_ = gee_traversable_filter ((GeeTraversable*) _tmp35_, ________lambda64__gee_predicate, block32_data_ref (_data32_), block32_data_unref);
							_tmp37_ = _tmp36_;
							gee_traversable_foreach ((GeeTraversable*) _tmp37_, ________lambda65__gee_forall_func, _data32_);
							_g_object_unref0 (_tmp37_);
							_g_object_unref0 (_tmp35_);
						}
						vala_code_context_pop ();
						_vala_code_visitor_unref0 (symbol_enumerator);
						_g_object_unref0 (compilation);
						_vala_source_file_unref0 (text_document);
						_g_object_unref0 (source_pair);
					}
					_g_object_unref0 (_source_pair_it);
				}
				_g_object_unref0 (project);
			}
		}
	}
	_tmp38_ = string_to_string (_data31_->method);
	_tmp39_ = _data32_->json_array;
	_tmp40_ = g_strdup_printf ("%u", json_array_get_length (_tmp39_));
	_tmp41_ = _tmp40_;
	_tmp42_ = string_to_string (_data31_->query);
	_tmp43_ = g_strconcat ("[", _tmp38_, "] found ", _tmp41_, " element(s) matching `", _tmp42_, "'", NULL);
	_tmp44_ = _tmp43_;
	g_debug ("server.vala:1622: %s", _tmp44_);
	_g_free0 (_tmp44_);
	_g_free0 (_tmp41_);
	{
		GVariant* variant_array = NULL;
		JsonNode* _tmp45_;
		JsonNode* _tmp46_;
		JsonArray* _tmp47_;
		JsonNode* _tmp48_;
		GVariant* _tmp49_;
		GVariant* _tmp50_;
		GVariant* _tmp51_;
		GCancellable* _tmp52_;
		_tmp45_ = json_node_alloc ();
		_tmp46_ = _tmp45_;
		_tmp47_ = _data32_->json_array;
		_tmp48_ = json_node_init_array (_tmp46_, _tmp47_);
		_tmp49_ = json_gvariant_deserialize (_tmp48_, NULL, &_inner_error0_);
		if (_tmp49_ != NULL) {
			g_variant_ref_sink (_tmp49_);
		}
		_tmp50_ = _tmp49_;
		__vala_JsonNode_free0 (_tmp46_);
		variant_array = _tmp50_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp51_ = variant_array;
		_tmp52_ = vls_server_cancellable;
		jsonrpc_client_reply (_data31_->client, _data31_->id, _tmp51_, _tmp52_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (variant_array);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (variant_array);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp53_;
		GError* _tmp54_;
		const gchar* _tmp55_;
		const gchar* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp53_ = string_to_string (_data31_->method);
		_tmp54_ = e;
		_tmp55_ = _tmp54_->message;
		_tmp56_ = string_to_string (_tmp55_);
		_tmp57_ = g_strconcat ("[", _tmp53_, "] failed to reply to client: ", _tmp56_, NULL);
		_tmp58_ = _tmp57_;
		g_debug ("server.vala:1627: %s", _tmp58_);
		_g_free0 (_tmp58_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
		block32_data_unref (_data32_);
		_data32_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
	block32_data_unref (_data32_);
	_data32_ = NULL;
}

static void
___lambda63__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda63_ (self, request_cancelled);
}

static void
vls_server_handle_workspace_symbol_request (VlsServer* self,
                                            JsonrpcServer* _self_,
                                            JsonrpcClient* client,
                                            const gchar* method,
                                            GVariant* id,
                                            GVariant* params)
{
	Block31Data* _data31_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data31_ = g_slice_new0 (Block31Data);
	_data31_->_ref_count_ = 1;
	_data31_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data31_->client);
	_data31_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data31_->method);
	_data31_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data31_->id);
	_data31_->id = _tmp2_;
	_tmp3_ = G_VARIANT_TYPE_STRING;
	_tmp4_ = g_variant_lookup_value (params, "query", _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _variant_get8 (_tmp5_);
	_tmp7_ = _tmp6_;
	_g_variant_unref0 (_tmp5_);
	_data31_->query = _tmp7_;
	vls_server_wait_for_context_update (self, _data31_->id, ___lambda63__vls_server_on_context_updated_func, block31_data_ref (_data31_), block31_data_unref);
	block31_data_unref (_data31_);
	_data31_ = NULL;
}

static Block33Data*
block33_data_ref (Block33Data* _data33_)
{
	g_atomic_int_inc (&_data33_->_ref_count_);
	return _data33_;
}

static void
block33_data_unref (void * _userdata_)
{
	Block33Data* _data33_;
	_data33_ = (Block33Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data33_->_ref_count_)) {
		VlsServer* self;
		self = _data33_->self;
		_g_object_unref0 (_data33_->pos);
		_g_object_unref0 (_data33_->selected_project);
		_g_object_unref0 (_data33_->results);
		_g_free0 (_data33_->new_name);
		_g_object_unref0 (_data33_->client);
		_g_free0 (_data33_->method);
		_g_variant_unref0 (_data33_->id);
		_g_object_unref0 (self);
		g_slice_free (Block33Data, _data33_);
	}
}

static gchar*
_variant_get9 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static void
__lambda66_ (Block33Data* _data33_,
             gboolean request_cancelled)
{
	VlsServer* self;
	ValaSourceFile* doc = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	VlsPair* _tmp2_;
	gconstpointer _tmp3_;
	gconstpointer _tmp4_;
	ValaSourceFile* _tmp5_;
	ValaSourceFile* _tmp6_;
	VlsCompilation* compilation = NULL;
	GeeArrayList* _tmp7_;
	gpointer _tmp8_;
	VlsPair* _tmp9_;
	gconstpointer _tmp10_;
	gconstpointer _tmp11_;
	VlsCompilation* _tmp12_;
	VlsCompilation* _tmp13_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	VlsFindSymbol* fs = NULL;
	ValaSourceFile* _tmp17_;
	LspPosition* _tmp18_;
	VlsFindSymbol* _tmp19_;
	VlsFindSymbol* _tmp20_;
	GeeList* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	ValaCodeNode* _result_ = NULL;
	VlsFindSymbol* _tmp27_;
	ValaSourceFile* _tmp28_;
	ValaCodeNode* _tmp29_;
	ValaSymbol* symbol = NULL;
	GeeHashMap* references = NULL;
	GeeHashMap* _tmp30_;
	gboolean _tmp31_ = FALSE;
	ValaCodeNode* _tmp32_;
	gboolean _tmp52_ = FALSE;
	ValaCodeNode* _tmp53_;
	ValaCodeNode* _tmp59_;
	ValaSymbol* _tmp60_;
	ValaSymbol* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	ValaSymbol* _tmp64_;
	ValaSourceReference* _tmp65_;
	ValaSourceReference* _tmp66_;
	gchar* _tmp67_;
	gchar* _tmp68_;
	GeeHashSet* generated_vapis = NULL;
	GeeHashSet* _tmp69_;
	GeeHashSet* shown_files = NULL;
	GeeHashSet* _tmp83_;
	gboolean _tmp84_ = FALSE;
	gboolean _tmp85_ = FALSE;
	gboolean _tmp86_ = FALSE;
	ValaSymbol* _tmp87_;
	gboolean is_abstract_or_virtual = FALSE;
	GeeHashMap* _tmp179_;
	gint _tmp180_;
	gint _tmp181_;
	GeeHashMap* edits = NULL;
	GeeHashMap* _tmp182_;
	GeeHashMap* source_files = NULL;
	GeeHashMap* _tmp183_;
	JsonArray* text_document_edits_json = NULL;
	JsonArray* _tmp246_;
	GError* _inner_error0_ = NULL;
	self = _data33_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data33_->id, _data33_->client, _data33_->method);
		return;
	}
	_tmp0_ = _data33_->results;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
	_tmp2_ = (VlsPair*) _tmp1_;
	_tmp3_ = vls_pair_get_first (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp2_);
	doc = _tmp6_;
	_tmp7_ = _data33_->results;
	_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, 0);
	_tmp9_ = (VlsPair*) _tmp8_;
	_tmp10_ = vls_pair_get_second (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = _g_object_ref0 ((VlsCompilation*) _tmp11_);
	_tmp13_ = _tmp12_;
	_g_object_unref0 (_tmp9_);
	compilation = _tmp13_;
	_tmp14_ = compilation;
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
	_tmp16_ = _tmp15_;
	vala_code_context_push (_tmp16_);
	_tmp17_ = doc;
	_tmp18_ = _data33_->pos;
	_tmp19_ = vls_find_symbol_new (_tmp17_, _tmp18_, TRUE, NULL);
	fs = _tmp19_;
	_tmp20_ = fs;
	_tmp21_ = _tmp20_->result;
	_tmp22_ = gee_collection_get_size ((GeeCollection*) _tmp21_);
	_tmp23_ = _tmp22_;
	if (_tmp23_ == 0) {
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		_tmp24_ = string_to_string (_data33_->method);
		_tmp25_ = g_strconcat ("[", _tmp24_, "] no results found", NULL);
		_tmp26_ = _tmp25_;
		g_debug ("server.vala:1680: %s", _tmp26_);
		_g_free0 (_tmp26_);
		vls_server_reply_null (_data33_->id, _data33_->client, _data33_->method);
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		return;
	}
	_tmp27_ = fs;
	_tmp28_ = doc;
	_tmp29_ = vls_server_get_best (_tmp27_, _tmp28_);
	_result_ = _tmp29_;
	_tmp30_ = gee_hash_map_new (LSP_TYPE_RANGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp30_) {
		g_object_set_data ((GObject *) _tmp30_, "vala-creation-function", "Vls.Server.textDocumentRename._lambda66_");
	}
	references = _tmp30_;
	_tmp32_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp32_, VALA_TYPE_EXPRESSION)) {
		ValaCodeNode* _tmp33_;
		ValaSymbol* _tmp34_;
		ValaSymbol* _tmp35_;
		_tmp33_ = _result_;
		_tmp34_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, VALA_TYPE_EXPRESSION, ValaExpression));
		_tmp35_ = _tmp34_;
		_tmp31_ = _tmp35_ != NULL;
	} else {
		_tmp31_ = FALSE;
	}
	if (_tmp31_) {
		ValaCodeNode* _tmp36_;
		ValaSymbol* _tmp37_;
		ValaSymbol* _tmp38_;
		ValaCodeNode* _tmp39_;
		_tmp36_ = _result_;
		_tmp37_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, VALA_TYPE_EXPRESSION, ValaExpression));
		_tmp38_ = _tmp37_;
		_tmp39_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp38_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp39_;
	} else {
		ValaCodeNode* _tmp40_;
		_tmp40_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp40_, VALA_TYPE_DATA_TYPE)) {
			ValaCodeNode* _tmp41_;
			ValaSymbol* _tmp42_;
			_tmp41_ = _result_;
			_tmp42_ = vls_symbol_references_get_symbol_data_type_refers_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, VALA_TYPE_DATA_TYPE, ValaDataType));
			_vala_code_node_unref0 (_result_);
			_result_ = (ValaCodeNode*) _tmp42_;
		} else {
			gboolean _tmp43_ = FALSE;
			ValaCodeNode* _tmp44_;
			_tmp44_ = _result_;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp44_, VALA_TYPE_USING_DIRECTIVE)) {
				ValaCodeNode* _tmp45_;
				ValaSymbol* _tmp46_;
				ValaSymbol* _tmp47_;
				_tmp45_ = _result_;
				_tmp46_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp47_ = _tmp46_;
				_tmp43_ = _tmp47_ != NULL;
			} else {
				_tmp43_ = FALSE;
			}
			if (_tmp43_) {
				ValaCodeNode* _tmp48_;
				ValaSymbol* _tmp49_;
				ValaSymbol* _tmp50_;
				ValaCodeNode* _tmp51_;
				_tmp48_ = _result_;
				_tmp49_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp50_ = _tmp49_;
				_tmp51_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp50_);
				_vala_code_node_unref0 (_result_);
				_result_ = _tmp51_;
			}
		}
	}
	_tmp53_ = _result_;
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp53_, VALA_TYPE_SYMBOL)) {
		_tmp52_ = TRUE;
	} else {
		gboolean _tmp54_ = FALSE;
		ValaCodeNode* _tmp55_;
		_tmp55_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp55_, VALA_TYPE_METHOD)) {
			ValaCodeNode* _tmp56_;
			gboolean _tmp57_;
			gboolean _tmp58_;
			_tmp56_ = _result_;
			_tmp57_ = vala_method_get_closure (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, VALA_TYPE_METHOD, ValaMethod));
			_tmp58_ = _tmp57_;
			_tmp54_ = _tmp58_;
		} else {
			_tmp54_ = FALSE;
		}
		_tmp52_ = _tmp54_;
	}
	if (_tmp52_) {
		g_debug ("server.vala:1700: [%s] result is not a symbol", _data33_->method);
		vls_server_reply_null (_data33_->id, _data33_->client, _data33_->method);
		vala_code_context_pop ();
		_g_object_unref0 (references);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		return;
	}
	_tmp59_ = _result_;
	_tmp60_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, VALA_TYPE_SYMBOL, ValaSymbol));
	_vala_code_node_unref0 (symbol);
	symbol = _tmp60_;
	_tmp61_ = symbol;
	_tmp62_ = vala_symbol_get_full_name (_tmp61_);
	_tmp63_ = _tmp62_;
	_tmp64_ = symbol;
	_tmp65_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp64_);
	_tmp66_ = _tmp65_;
	_tmp67_ = vala_source_reference_to_string (_tmp66_);
	_tmp68_ = _tmp67_;
	g_debug ("server.vala:1708: [%s] got symbol %s @ %s", _data33_->method, _tmp63_, _tmp68_);
	_g_free0 (_tmp68_);
	_g_free0 (_tmp63_);
	_tmp69_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
	if (_tmp69_) {
		g_object_set_data ((GObject *) _tmp69_, "vala-creation-function", "Vls.Server.textDocumentRename._lambda66_");
	}
	generated_vapis = _tmp69_;
	{
		GeeArrayList* _btarget_list = NULL;
		VlsProject* _tmp70_;
		GeeArrayList* _tmp71_;
		gint _btarget_size = 0;
		GeeArrayList* _tmp72_;
		gint _tmp73_;
		gint _tmp74_;
		gint _btarget_index = 0;
		_tmp70_ = _data33_->selected_project;
		_tmp71_ = vls_project_get_compilations (_tmp70_);
		_btarget_list = _tmp71_;
		_tmp72_ = _btarget_list;
		_tmp73_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp72_);
		_tmp74_ = _tmp73_;
		_btarget_size = _tmp74_;
		_btarget_index = -1;
		while (TRUE) {
			gint _tmp75_;
			gint _tmp76_;
			VlsCompilation* btarget = NULL;
			GeeArrayList* _tmp77_;
			gpointer _tmp78_;
			GeeHashSet* _tmp79_;
			VlsCompilation* _tmp80_;
			GeeArrayList* _tmp81_;
			GeeArrayList* _tmp82_;
			_btarget_index = _btarget_index + 1;
			_tmp75_ = _btarget_index;
			_tmp76_ = _btarget_size;
			if (!(_tmp75_ < _tmp76_)) {
				break;
			}
			_tmp77_ = _btarget_list;
			_tmp78_ = gee_abstract_list_get ((GeeAbstractList*) _tmp77_, _btarget_index);
			btarget = (VlsCompilation*) _tmp78_;
			_tmp79_ = generated_vapis;
			_tmp80_ = btarget;
			_tmp81_ = vls_build_target_get_output ((VlsBuildTarget*) _tmp80_);
			_tmp82_ = _tmp81_;
			gee_collection_add_all ((GeeCollection*) _tmp79_, (GeeCollection*) _tmp82_);
			_g_object_unref0 (btarget);
		}
		_g_object_unref0 (_btarget_list);
	}
	_tmp83_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
	if (_tmp83_) {
		g_object_set_data ((GObject *) _tmp83_, "vala-creation-function", "Vls.Server.textDocumentRename._lambda66_");
	}
	shown_files = _tmp83_;
	_tmp87_ = symbol;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp87_, VALA_TYPE_PROPERTY)) {
		gboolean _tmp88_ = FALSE;
		ValaSymbol* _tmp89_;
		gboolean _tmp90_;
		gboolean _tmp91_;
		_tmp89_ = symbol;
		_tmp90_ = vala_property_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp89_, VALA_TYPE_PROPERTY, ValaProperty));
		_tmp91_ = _tmp90_;
		if (_tmp91_) {
			_tmp88_ = TRUE;
		} else {
			ValaSymbol* _tmp92_;
			gboolean _tmp93_;
			gboolean _tmp94_;
			_tmp92_ = symbol;
			_tmp93_ = vala_property_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp92_, VALA_TYPE_PROPERTY, ValaProperty));
			_tmp94_ = _tmp93_;
			_tmp88_ = _tmp94_;
		}
		_tmp86_ = _tmp88_;
	} else {
		_tmp86_ = FALSE;
	}
	if (_tmp86_) {
		_tmp85_ = TRUE;
	} else {
		gboolean _tmp95_ = FALSE;
		ValaSymbol* _tmp96_;
		_tmp96_ = symbol;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp96_, VALA_TYPE_METHOD)) {
			gboolean _tmp97_ = FALSE;
			ValaSymbol* _tmp98_;
			gboolean _tmp99_;
			gboolean _tmp100_;
			_tmp98_ = symbol;
			_tmp99_ = vala_method_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp98_, VALA_TYPE_METHOD, ValaMethod));
			_tmp100_ = _tmp99_;
			if (_tmp100_) {
				_tmp97_ = TRUE;
			} else {
				ValaSymbol* _tmp101_;
				gboolean _tmp102_;
				gboolean _tmp103_;
				_tmp101_ = symbol;
				_tmp102_ = vala_method_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp101_, VALA_TYPE_METHOD, ValaMethod));
				_tmp103_ = _tmp102_;
				_tmp97_ = _tmp103_;
			}
			_tmp95_ = _tmp97_;
		} else {
			_tmp95_ = FALSE;
		}
		_tmp85_ = _tmp95_;
	}
	if (_tmp85_) {
		_tmp84_ = TRUE;
	} else {
		gboolean _tmp104_ = FALSE;
		ValaSymbol* _tmp105_;
		_tmp105_ = symbol;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp105_, VALA_TYPE_SIGNAL)) {
			ValaSymbol* _tmp106_;
			gboolean _tmp107_;
			gboolean _tmp108_;
			_tmp106_ = symbol;
			_tmp107_ = vala_signal_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp106_, VALA_TYPE_SIGNAL, ValaSignal));
			_tmp108_ = _tmp107_;
			_tmp104_ = _tmp108_;
		} else {
			_tmp104_ = FALSE;
		}
		_tmp84_ = _tmp104_;
	}
	is_abstract_or_virtual = _tmp84_;
	{
		GeeIterator* _btarget_w_sym_it = NULL;
		VlsProject* _tmp109_;
		ValaSymbol* _tmp110_;
		GeeCollection* _tmp111_;
		GeeCollection* _tmp112_;
		GeeIterator* _tmp113_;
		GeeIterator* _tmp114_;
		_tmp109_ = _data33_->selected_project;
		_tmp110_ = symbol;
		_tmp111_ = vls_symbol_references_get_compilations_using_symbol (_tmp109_, _tmp110_);
		_tmp112_ = _tmp111_;
		_tmp113_ = gee_iterable_iterator ((GeeIterable*) _tmp112_);
		_tmp114_ = _tmp113_;
		_g_object_unref0 (_tmp112_);
		_btarget_w_sym_it = _tmp114_;
		while (TRUE) {
			GeeIterator* _tmp115_;
			VlsPair* btarget_w_sym = NULL;
			GeeIterator* _tmp116_;
			gpointer _tmp117_;
			_tmp115_ = _btarget_w_sym_it;
			if (!gee_iterator_next (_tmp115_)) {
				break;
			}
			_tmp116_ = _btarget_w_sym_it;
			_tmp117_ = gee_iterator_get (_tmp116_);
			btarget_w_sym = (VlsPair*) _tmp117_;
			{
				ValaList* _project_file_list = NULL;
				VlsPair* _tmp118_;
				gconstpointer _tmp119_;
				gconstpointer _tmp120_;
				ValaCodeContext* _tmp121_;
				ValaCodeContext* _tmp122_;
				ValaList* _tmp123_;
				gint _project_file_size = 0;
				ValaList* _tmp124_;
				gint _tmp125_;
				gint _tmp126_;
				gint _project_file_index = 0;
				_tmp118_ = btarget_w_sym;
				_tmp119_ = vls_pair_get_first (_tmp118_);
				_tmp120_ = _tmp119_;
				_tmp121_ = vls_compilation_get_code_context ((VlsCompilation*) _tmp120_);
				_tmp122_ = _tmp121_;
				_tmp123_ = vala_code_context_get_source_files (_tmp122_);
				_project_file_list = _tmp123_;
				_tmp124_ = _project_file_list;
				_tmp125_ = vala_collection_get_size ((ValaCollection*) _tmp124_);
				_tmp126_ = _tmp125_;
				_project_file_size = _tmp126_;
				_project_file_index = -1;
				while (TRUE) {
					gint _tmp127_;
					gint _tmp128_;
					ValaSourceFile* project_file = NULL;
					ValaList* _tmp129_;
					gpointer _tmp130_;
					GFile* file = NULL;
					ValaSourceFile* _tmp131_;
					const gchar* _tmp132_;
					const gchar* _tmp133_;
					GFile* _tmp134_;
					gboolean _tmp135_ = FALSE;
					GeeHashSet* _tmp136_;
					GFile* _tmp137_;
					GeeHashMap* file_references = NULL;
					GeeHashMap* _tmp140_;
					GFile* _tmp141_;
					gchar* _tmp142_;
					gchar* _tmp143_;
					ValaSourceFile* _tmp144_;
					VlsPair* _tmp145_;
					gconstpointer _tmp146_;
					gconstpointer _tmp147_;
					GeeHashMap* _tmp148_;
					gboolean _tmp157_ = FALSE;
					ValaSourceFile* _tmp158_;
					GeeHashSet* _tmp177_;
					GFile* _tmp178_;
					_project_file_index = _project_file_index + 1;
					_tmp127_ = _project_file_index;
					_tmp128_ = _project_file_size;
					if (!(_tmp127_ < _tmp128_)) {
						break;
					}
					_tmp129_ = _project_file_list;
					_tmp130_ = vala_list_get (_tmp129_, _project_file_index);
					project_file = (ValaSourceFile*) _tmp130_;
					_tmp131_ = project_file;
					_tmp132_ = vala_source_file_get_filename (_tmp131_);
					_tmp133_ = _tmp132_;
					_tmp134_ = g_file_new_for_commandline_arg (_tmp133_);
					file = _tmp134_;
					_tmp136_ = generated_vapis;
					_tmp137_ = file;
					if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp136_, _tmp137_)) {
						_tmp135_ = TRUE;
					} else {
						GeeHashSet* _tmp138_;
						GFile* _tmp139_;
						_tmp138_ = shown_files;
						_tmp139_ = file;
						_tmp135_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp138_, _tmp139_);
					}
					if (_tmp135_) {
						_g_object_unref0 (file);
						_vala_source_file_unref0 (project_file);
						continue;
					}
					_tmp140_ = gee_hash_map_new (LSP_TYPE_RANGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
					if (_tmp140_) {
						g_object_set_data ((GObject *) _tmp140_, "vala-creation-function", "Vls.Server.textDocumentRename._lambda66_");
					}
					file_references = _tmp140_;
					_tmp141_ = file;
					_tmp142_ = g_file_get_uri (_tmp141_);
					_tmp143_ = _tmp142_;
					g_debug ("server.vala:1726: [%s] looking for references in %s ...", _data33_->method, _tmp143_);
					_g_free0 (_tmp143_);
					_tmp144_ = project_file;
					_tmp145_ = btarget_w_sym;
					_tmp146_ = vls_pair_get_second (_tmp145_);
					_tmp147_ = _tmp146_;
					_tmp148_ = file_references;
					vls_symbol_references_list_in_file (_tmp144_, (ValaSymbol*) _tmp147_, TRUE, _tmp148_);
					if (is_abstract_or_virtual) {
						GFile* _tmp149_;
						gchar* _tmp150_;
						gchar* _tmp151_;
						ValaSourceFile* _tmp152_;
						VlsPair* _tmp153_;
						gconstpointer _tmp154_;
						gconstpointer _tmp155_;
						GeeHashMap* _tmp156_;
						_tmp149_ = file;
						_tmp150_ = g_file_get_uri (_tmp149_);
						_tmp151_ = _tmp150_;
						g_debug ("server.vala:1729: [%s] looking for implementations of abstract/virtual" \
" symbol in %s ...", _data33_->method, _tmp151_);
						_g_free0 (_tmp151_);
						_tmp152_ = project_file;
						_tmp153_ = btarget_w_sym;
						_tmp154_ = vls_pair_get_second (_tmp153_);
						_tmp155_ = _tmp154_;
						_tmp156_ = file_references;
						vls_symbol_references_list_implementations_of_virtual_symbol (_tmp152_, (ValaSymbol*) _tmp155_, _tmp156_);
					}
					_tmp158_ = project_file;
					if (!VLS_IS_TEXT_DOCUMENT (_tmp158_)) {
						GeeHashMap* _tmp159_;
						gint _tmp160_;
						gint _tmp161_;
						_tmp159_ = file_references;
						_tmp160_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp159_);
						_tmp161_ = _tmp160_;
						_tmp157_ = _tmp161_ > 0;
					} else {
						_tmp157_ = FALSE;
					}
					if (_tmp157_) {
						ValaSourceFile* _tmp162_;
						const gchar* _tmp163_;
						const gchar* _tmp164_;
						_tmp162_ = project_file;
						_tmp163_ = vala_source_file_get_filename (_tmp162_);
						_tmp164_ = _tmp163_;
						g_debug ("server.vala:1735: [%s] disallowing requested modification of %s", _data33_->method, _tmp164_);
						vls_server_reply_null (_data33_->id, _data33_->client, _data33_->method);
						vala_code_context_pop ();
						_g_object_unref0 (file_references);
						_g_object_unref0 (file);
						_vala_source_file_unref0 (project_file);
						_g_object_unref0 (btarget_w_sym);
						_g_object_unref0 (_btarget_w_sym_it);
						_g_object_unref0 (shown_files);
						_g_object_unref0 (generated_vapis);
						_g_object_unref0 (references);
						_vala_code_node_unref0 (symbol);
						_vala_code_node_unref0 (_result_);
						_vala_code_visitor_unref0 (fs);
						_g_object_unref0 (compilation);
						_vala_source_file_unref0 (doc);
						return;
					}
					{
						GeeIterator* _entry_it = NULL;
						GeeHashMap* _tmp165_;
						GeeIterator* _tmp166_;
						_tmp165_ = file_references;
						_tmp166_ = gee_iterable_iterator ((GeeIterable*) _tmp165_);
						_entry_it = _tmp166_;
						while (TRUE) {
							GeeIterator* _tmp167_;
							GeeMapEntry* entry = NULL;
							GeeIterator* _tmp168_;
							gpointer _tmp169_;
							GeeHashMap* _tmp170_;
							GeeMapEntry* _tmp171_;
							gconstpointer _tmp172_;
							gconstpointer _tmp173_;
							GeeMapEntry* _tmp174_;
							gconstpointer _tmp175_;
							gconstpointer _tmp176_;
							_tmp167_ = _entry_it;
							if (!gee_iterator_next (_tmp167_)) {
								break;
							}
							_tmp168_ = _entry_it;
							_tmp169_ = gee_iterator_get (_tmp168_);
							entry = (GeeMapEntry*) _tmp169_;
							_tmp170_ = references;
							_tmp171_ = entry;
							_tmp172_ = gee_map_entry_get_key (_tmp171_);
							_tmp173_ = _tmp172_;
							_tmp174_ = entry;
							_tmp175_ = gee_map_entry_get_value (_tmp174_);
							_tmp176_ = _tmp175_;
							gee_abstract_map_set ((GeeAbstractMap*) _tmp170_, (LspRange*) _tmp173_, (ValaCodeNode*) _tmp176_);
							_g_object_unref0 (entry);
						}
						_g_object_unref0 (_entry_it);
					}
					_tmp177_ = shown_files;
					_tmp178_ = file;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp177_, _tmp178_);
					_g_object_unref0 (file_references);
					_g_object_unref0 (file);
					_vala_source_file_unref0 (project_file);
				}
			}
			_g_object_unref0 (btarget_w_sym);
		}
		_g_object_unref0 (_btarget_w_sym_it);
	}
	_tmp179_ = references;
	_tmp180_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp179_);
	_tmp181_ = _tmp180_;
	g_debug ("server.vala:1745: [%s] found %d references", _data33_->method, _tmp181_);
	_tmp182_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp182_) {
		g_object_set_data ((GObject *) _tmp182_, "vala-creation-function", "Vls.Server.textDocumentRename._lambda66_");
	}
	edits = _tmp182_;
	_tmp183_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, VALA_TYPE_SOURCE_FILE, (GBoxedCopyFunc) vala_source_file_ref, (GDestroyNotify) vala_source_file_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp183_) {
		g_object_set_data ((GObject *) _tmp183_, "vala-creation-function", "Vls.Server.textDocumentRename._lambda66_");
	}
	source_files = _tmp183_;
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp184_;
		GeeIterator* _tmp185_;
		_tmp184_ = references;
		_tmp185_ = gee_iterable_iterator ((GeeIterable*) _tmp184_);
		_entry_it = _tmp185_;
		while (TRUE) {
			GeeIterator* _tmp186_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp187_;
			gpointer _tmp188_;
			ValaCodeNode* code_node = NULL;
			GeeMapEntry* _tmp189_;
			gconstpointer _tmp190_;
			gconstpointer _tmp191_;
			ValaCodeNode* _tmp192_;
			LspRange* source_range = NULL;
			GeeMapEntry* _tmp193_;
			gconstpointer _tmp194_;
			gconstpointer _tmp195_;
			LspRange* _tmp196_;
			ValaCodeNode* _tmp197_;
			gchar* _tmp198_;
			gchar* _tmp199_;
			ValaCodeNode* _tmp200_;
			ValaSourceReference* _tmp201_;
			ValaSourceReference* _tmp202_;
			gchar* _tmp203_;
			gchar* _tmp204_;
			GFile* file = NULL;
			ValaCodeNode* _tmp205_;
			ValaSourceReference* _tmp206_;
			ValaSourceReference* _tmp207_;
			ValaSourceFile* _tmp208_;
			ValaSourceFile* _tmp209_;
			const gchar* _tmp210_;
			const gchar* _tmp211_;
			GFile* _tmp212_;
			GeeHashMap* _tmp213_;
			GFile* _tmp214_;
			gchar* _tmp215_;
			gchar* _tmp216_;
			gboolean _tmp217_;
			GeeArrayList* file_edits = NULL;
			GeeHashMap* _tmp224_;
			GFile* _tmp225_;
			gchar* _tmp226_;
			gchar* _tmp227_;
			gpointer _tmp228_;
			GeeArrayList* _tmp229_;
			GeeArrayList* _tmp230_;
			LspRange* _tmp231_;
			LspRange* _tmp232_;
			const gchar* _tmp233_;
			gchar* _tmp234_;
			LspTextEdit* _tmp235_ = NULL;
			LspTextEdit* _tmp236_;
			GeeHashMap* _tmp237_;
			GFile* _tmp238_;
			gchar* _tmp239_;
			gchar* _tmp240_;
			ValaCodeNode* _tmp241_;
			ValaSourceReference* _tmp242_;
			ValaSourceReference* _tmp243_;
			ValaSourceFile* _tmp244_;
			ValaSourceFile* _tmp245_;
			_tmp186_ = _entry_it;
			if (!gee_iterator_next (_tmp186_)) {
				break;
			}
			_tmp187_ = _entry_it;
			_tmp188_ = gee_iterator_get (_tmp187_);
			entry = (GeeMapEntry*) _tmp188_;
			_tmp189_ = entry;
			_tmp190_ = gee_map_entry_get_value (_tmp189_);
			_tmp191_ = _tmp190_;
			_tmp192_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp191_);
			code_node = _tmp192_;
			_tmp193_ = entry;
			_tmp194_ = gee_map_entry_get_key (_tmp193_);
			_tmp195_ = _tmp194_;
			_tmp196_ = _g_object_ref0 ((LspRange*) _tmp195_);
			source_range = _tmp196_;
			_tmp197_ = code_node;
			_tmp198_ = vls_code_help_get_expression_representation (_tmp197_);
			_tmp199_ = _tmp198_;
			_tmp200_ = code_node;
			_tmp201_ = vala_code_node_get_source_reference (_tmp200_);
			_tmp202_ = _tmp201_;
			_tmp203_ = vala_source_reference_to_string (_tmp202_);
			_tmp204_ = _tmp203_;
			g_debug ("server.vala:1755: [%s] editing reference %s @ %s ...", _data33_->method, _tmp199_, _tmp204_);
			_g_free0 (_tmp204_);
			_g_free0 (_tmp199_);
			_tmp205_ = code_node;
			_tmp206_ = vala_code_node_get_source_reference (_tmp205_);
			_tmp207_ = _tmp206_;
			_tmp208_ = vala_source_reference_get_file (_tmp207_);
			_tmp209_ = _tmp208_;
			_tmp210_ = vala_source_file_get_filename (_tmp209_);
			_tmp211_ = _tmp210_;
			_tmp212_ = g_file_new_for_commandline_arg (_tmp211_);
			file = _tmp212_;
			_tmp213_ = edits;
			_tmp214_ = file;
			_tmp215_ = g_file_get_uri (_tmp214_);
			_tmp216_ = _tmp215_;
			_tmp217_ = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp213_, _tmp216_);
			_g_free0 (_tmp216_);
			if (_tmp217_) {
				GeeHashMap* _tmp218_;
				GFile* _tmp219_;
				gchar* _tmp220_;
				gchar* _tmp221_;
				GeeArrayList* _tmp222_;
				GeeArrayList* _tmp223_;
				_tmp218_ = edits;
				_tmp219_ = file;
				_tmp220_ = g_file_get_uri (_tmp219_);
				_tmp221_ = _tmp220_;
				_tmp222_ = gee_array_list_new (LSP_TYPE_TEXT_EDIT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
				if (_tmp222_) {
					g_object_set_data ((GObject *) _tmp222_, "vala-creation-function", "Vls.Server.textDocumentRename._lambda66_");
				}
				_tmp223_ = _tmp222_;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp218_, _tmp221_, _tmp223_);
				_g_object_unref0 (_tmp223_);
				_g_free0 (_tmp221_);
			}
			_tmp224_ = edits;
			_tmp225_ = file;
			_tmp226_ = g_file_get_uri (_tmp225_);
			_tmp227_ = _tmp226_;
			_tmp228_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp224_, _tmp227_);
			_tmp229_ = (GeeArrayList*) _tmp228_;
			_g_free0 (_tmp227_);
			file_edits = _tmp229_;
			_tmp230_ = file_edits;
			_tmp231_ = source_range;
			_tmp232_ = _g_object_ref0 (_tmp231_);
			_tmp233_ = _data33_->new_name;
			_tmp234_ = g_strdup (_tmp233_);
			_tmp235_ = lsp_text_edit_new ();
			lsp_text_edit_set_range (_tmp235_, _tmp232_);
			_g_object_unref0 (_tmp232_);
			lsp_text_edit_set_newText (_tmp235_, _tmp234_);
			_g_free0 (_tmp234_);
			_tmp236_ = _tmp235_;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp230_, _tmp236_);
			_g_object_unref0 (_tmp236_);
			_tmp237_ = source_files;
			_tmp238_ = file;
			_tmp239_ = g_file_get_uri (_tmp238_);
			_tmp240_ = _tmp239_;
			_tmp241_ = code_node;
			_tmp242_ = vala_code_node_get_source_reference (_tmp241_);
			_tmp243_ = _tmp242_;
			_tmp244_ = vala_source_reference_get_file (_tmp243_);
			_tmp245_ = _tmp244_;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp237_, _tmp240_, _tmp245_);
			_g_free0 (_tmp240_);
			_g_object_unref0 (file_edits);
			_g_object_unref0 (file);
			_g_object_unref0 (source_range);
			_vala_code_node_unref0 (code_node);
			_g_object_unref0 (entry);
		}
		_g_object_unref0 (_entry_it);
	}
	_tmp246_ = json_array_new ();
	text_document_edits_json = _tmp246_;
	{
		GeeIterator* _uri_it = NULL;
		GeeHashMap* _tmp247_;
		GeeSet* _tmp248_;
		GeeSet* _tmp249_;
		GeeSet* _tmp250_;
		GeeIterator* _tmp251_;
		GeeIterator* _tmp252_;
		_tmp247_ = edits;
		_tmp248_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp247_);
		_tmp249_ = _tmp248_;
		_tmp250_ = _tmp249_;
		_tmp251_ = gee_iterable_iterator ((GeeIterable*) _tmp250_);
		_tmp252_ = _tmp251_;
		_g_object_unref0 (_tmp250_);
		_uri_it = _tmp252_;
		while (TRUE) {
			GeeIterator* _tmp253_;
			gchar* uri = NULL;
			GeeIterator* _tmp254_;
			gpointer _tmp255_;
			JsonArray* _tmp256_;
			GeeHashMap* _tmp257_;
			const gchar* _tmp258_;
			gpointer _tmp259_;
			VlsTextDocument* _tmp260_;
			gint _tmp261_;
			gint _tmp262_;
			const gchar* _tmp263_;
			gchar* _tmp264_;
			LspVersionedTextDocumentIdentifier* _tmp265_ = NULL;
			GeeHashMap* _tmp266_;
			const gchar* _tmp267_;
			gpointer _tmp268_;
			LspTextDocumentEdit* _tmp269_ = NULL;
			LspTextDocumentEdit* _tmp270_;
			JsonNode* _tmp271_;
			_tmp253_ = _uri_it;
			if (!gee_iterator_next (_tmp253_)) {
				break;
			}
			_tmp254_ = _uri_it;
			_tmp255_ = gee_iterator_get (_tmp254_);
			uri = (gchar*) _tmp255_;
			_tmp256_ = text_document_edits_json;
			_tmp257_ = source_files;
			_tmp258_ = uri;
			_tmp259_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp257_, _tmp258_);
			_tmp260_ = G_TYPE_CHECK_INSTANCE_CAST ((ValaSourceFile*) _tmp259_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument);
			_tmp261_ = vls_text_document_get_version (_tmp260_);
			_tmp262_ = _tmp261_;
			_tmp263_ = uri;
			_tmp264_ = g_strdup (_tmp263_);
			_tmp265_ = lsp_versioned_text_document_identifier_new ();
			lsp_versioned_text_document_identifier_set_version (_tmp265_, _tmp262_);
			lsp_text_document_identifier_set_uri ((LspTextDocumentIdentifier*) _tmp265_, _tmp264_);
			_g_free0 (_tmp264_);
			_tmp266_ = edits;
			_tmp267_ = uri;
			_tmp268_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp266_, _tmp267_);
			_tmp269_ = lsp_text_document_edit_new ();
			lsp_text_document_edit_set_textDocument (_tmp269_, _tmp265_);
			_g_object_unref0 (_tmp265_);
			lsp_text_document_edit_set_edits (_tmp269_, (GeeArrayList*) _tmp268_);
			_g_object_unref0 (_tmp268_);
			_tmp270_ = _tmp269_;
			_tmp271_ = json_gobject_serialize ((GObject*) _tmp270_);
			json_array_add_element (_tmp256_, _tmp271_);
			_g_object_unref0 (_tmp270_);
			_vala_source_file_unref0 (_tmp260_);
			_g_free0 (uri);
		}
		_g_object_unref0 (_uri_it);
	}
	{
		GVariant* changes = NULL;
		JsonNode* _tmp272_;
		JsonNode* _tmp273_;
		JsonArray* _tmp274_;
		JsonNode* _tmp275_;
		GVariant* _tmp276_;
		GVariant* _tmp277_;
		GVariant* _tmp278_;
		GVariant* _tmp279_;
		GVariant* _tmp280_;
		GCancellable* _tmp281_;
		_tmp272_ = json_node_alloc ();
		_tmp273_ = _tmp272_;
		_tmp274_ = text_document_edits_json;
		_tmp275_ = json_node_init_array (_tmp273_, _tmp274_);
		_tmp276_ = json_gvariant_deserialize (_tmp275_, NULL, &_inner_error0_);
		if (_tmp276_ != NULL) {
			g_variant_ref_sink (_tmp276_);
		}
		_tmp277_ = _tmp276_;
		__vala_JsonNode_free0 (_tmp273_);
		changes = _tmp277_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp278_ = changes;
		_tmp279_ = vls_server_buildDict (self, "documentChanges", _tmp278_, NULL);
		_tmp280_ = _tmp279_;
		_tmp281_ = vls_server_cancellable;
		jsonrpc_client_reply (_data33_->client, _data33_->id, _tmp280_, _tmp281_, &_inner_error0_);
		_g_variant_unref0 (_tmp280_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (changes);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (changes);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp282_;
		const gchar* _tmp283_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp282_ = e;
		_tmp283_ = _tmp282_->message;
		g_warning ("server.vala:1792: [%s] failed to reply to client - %s", _data33_->method, _tmp283_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_json_array_unref0 (text_document_edits_json);
		_g_object_unref0 (source_files);
		_g_object_unref0 (edits);
		_g_object_unref0 (shown_files);
		_g_object_unref0 (generated_vapis);
		_g_object_unref0 (references);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_json_array_unref0 (text_document_edits_json);
	_g_object_unref0 (source_files);
	_g_object_unref0 (edits);
	_g_object_unref0 (shown_files);
	_g_object_unref0 (generated_vapis);
	_g_object_unref0 (references);
	_vala_code_node_unref0 (symbol);
	_vala_code_node_unref0 (_result_);
	_vala_code_visitor_unref0 (fs);
	_g_object_unref0 (compilation);
	_vala_source_file_unref0 (doc);
}

static void
___lambda66__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda66_ (self, request_cancelled);
}

static void
vls_server_textDocumentRename (VlsServer* self,
                               JsonrpcServer* _self_,
                               JsonrpcClient* client,
                               const gchar* method,
                               GVariant* id,
                               GVariant* params)
{
	Block33Data* _data33_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	LspTextDocumentPositionParams* p = NULL;
	gpointer _tmp10_;
	GeeArrayList* _tmp11_;
	GHashTable* _tmp12_;
	guint _tmp13_ = 0;
	gconstpointer* _tmp14_;
	VlsProject* _tmp27_;
	GeeArrayList* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	LspTextDocumentPositionParams* _tmp50_;
	LspPosition* _tmp51_;
	LspPosition* _tmp52_;
	LspPosition* _tmp53_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data33_ = g_slice_new0 (Block33Data);
	_data33_->_ref_count_ = 1;
	_data33_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data33_->client);
	_data33_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data33_->method);
	_data33_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data33_->id);
	_data33_->id = _tmp2_;
	_tmp3_ = G_VARIANT_TYPE_STRING;
	_tmp4_ = g_variant_lookup_value (params, "newName", _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _variant_get9 (_tmp5_);
	_tmp7_ = _tmp6_;
	_g_variant_unref0 (_tmp5_);
	_data33_->new_name = _tmp7_;
	_tmp8_ = _data33_->new_name;
	if (!g_regex_match (_thread_safe_regex_init (&_tmp_regex_1, "^(?=[^\\d])[^\\s~`!#%^&*()\\-\\+={}\\[\\]|\\\\\\/?.>,<'\";:]+$", 0), _tmp8_, 0, NULL)) {
		GCancellable* _tmp9_;
		_tmp9_ = vls_server_cancellable;
		jsonrpc_client_reply_error_async (_data33_->client, _data33_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, "Invalid symbol name. Symbol names cannot start with a number and must " \
"not contain any operators.", _tmp9_, NULL, NULL);
		block33_data_unref (_data33_);
		_data33_ = NULL;
		return;
	}
	_tmp10_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspTextDocumentPositionParams*) _tmp10_;
	_tmp11_ = gee_array_list_new (VLS_TYPE_PAIR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp11_) {
		g_object_set_data ((GObject *) _tmp11_, "vala-creation-function", "Vls.Server.textDocumentRename");
	}
	_data33_->results = _tmp11_;
	_data33_->selected_project = NULL;
	_tmp12_ = self->priv->projects;
	_tmp14_ = g_hash_table_get_keys_as_array (_tmp12_, &_tmp13_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp14_;
		project_collection_length1 = _tmp13_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				VlsProject* _tmp15_;
				LspTextDocumentPositionParams* _tmp16_;
				LspTextDocumentIdentifier* _tmp17_;
				LspTextDocumentIdentifier* _tmp18_;
				const gchar* _tmp19_;
				const gchar* _tmp20_;
				GeeArrayList* _tmp21_;
				GeeArrayList* _tmp22_;
				gboolean _tmp23_;
				gboolean _tmp24_;
				_tmp15_ = project;
				_tmp16_ = p;
				_tmp17_ = lsp_text_document_position_params_get_textDocument (_tmp16_);
				_tmp18_ = _tmp17_;
				_tmp19_ = lsp_text_document_identifier_get_uri (_tmp18_);
				_tmp20_ = _tmp19_;
				_tmp21_ = vls_project_lookup_compile_input_source_file (_tmp15_, _tmp20_);
				_g_object_unref0 (_data33_->results);
				_data33_->results = _tmp21_;
				_tmp22_ = _data33_->results;
				_tmp23_ = gee_collection_get_is_empty ((GeeCollection*) _tmp22_);
				_tmp24_ = _tmp23_;
				if (!_tmp24_) {
					VlsProject* _tmp25_;
					VlsProject* _tmp26_;
					_tmp25_ = project;
					_tmp26_ = _g_object_ref0 (_tmp25_);
					_g_object_unref0 (_data33_->selected_project);
					_data33_->selected_project = _tmp26_;
					break;
				}
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp27_ = _data33_->selected_project;
	if (_tmp27_ == NULL) {
		VlsDefaultProject* _tmp28_;
		LspTextDocumentPositionParams* _tmp29_;
		LspTextDocumentIdentifier* _tmp30_;
		LspTextDocumentIdentifier* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		GeeArrayList* _tmp34_;
		VlsDefaultProject* _tmp35_;
		VlsProject* _tmp36_;
		_tmp28_ = self->priv->default_project;
		_tmp29_ = p;
		_tmp30_ = lsp_text_document_position_params_get_textDocument (_tmp29_);
		_tmp31_ = _tmp30_;
		_tmp32_ = lsp_text_document_identifier_get_uri (_tmp31_);
		_tmp33_ = _tmp32_;
		_tmp34_ = vls_project_lookup_compile_input_source_file ((VlsProject*) _tmp28_, _tmp33_);
		_g_object_unref0 (_data33_->results);
		_data33_->results = _tmp34_;
		_tmp35_ = self->priv->default_project;
		_tmp36_ = _g_object_ref0 ((VlsProject*) _tmp35_);
		_g_object_unref0 (_data33_->selected_project);
		_data33_->selected_project = _tmp36_;
	}
	_tmp37_ = _data33_->results;
	_tmp38_ = gee_collection_get_is_empty ((GeeCollection*) _tmp37_);
	_tmp39_ = _tmp38_;
	if (_tmp39_) {
		LspTextDocumentPositionParams* _tmp40_;
		LspTextDocumentIdentifier* _tmp41_;
		LspTextDocumentIdentifier* _tmp42_;
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		const gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		_tmp40_ = p;
		_tmp41_ = lsp_text_document_position_params_get_textDocument (_tmp40_);
		_tmp42_ = _tmp41_;
		_tmp43_ = lsp_text_document_identifier_get_uri (_tmp42_);
		_tmp44_ = _tmp43_;
		_tmp45_ = g_uri_unescape_string (_tmp44_, NULL);
		_tmp46_ = _tmp45_;
		_tmp47_ = string_to_string (_tmp46_);
		_tmp48_ = g_strconcat ("file `", _tmp47_, "' not found", NULL);
		_tmp49_ = _tmp48_;
		g_debug ("server.vala:1661: %s", _tmp49_);
		_g_free0 (_tmp49_);
		_g_free0 (_tmp46_);
		vls_server_reply_null (_data33_->id, _data33_->client, _data33_->method);
		_g_object_unref0 (p);
		block33_data_unref (_data33_);
		_data33_ = NULL;
		return;
	}
	_tmp50_ = p;
	_tmp51_ = lsp_text_document_position_params_get_position (_tmp50_);
	_tmp52_ = _tmp51_;
	_tmp53_ = _g_object_ref0 (_tmp52_);
	_data33_->pos = _tmp53_;
	vls_server_wait_for_context_update (self, _data33_->id, ___lambda66__vls_server_on_context_updated_func, block33_data_ref (_data33_), block33_data_unref);
	_g_object_unref0 (p);
	block33_data_unref (_data33_);
	_data33_ = NULL;
}

static Block34Data*
block34_data_ref (Block34Data* _data34_)
{
	g_atomic_int_inc (&_data34_->_ref_count_);
	return _data34_;
}

static void
block34_data_unref (void * _userdata_)
{
	Block34Data* _data34_;
	_data34_ = (Block34Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data34_->_ref_count_)) {
		VlsServer* self;
		self = _data34_->self;
		_g_object_unref0 (_data34_->pos);
		_g_object_unref0 (_data34_->selected_project);
		_g_object_unref0 (_data34_->results);
		_g_object_unref0 (_data34_->client);
		_g_free0 (_data34_->method);
		_g_variant_unref0 (_data34_->id);
		_g_object_unref0 (self);
		g_slice_free (Block34Data, _data34_);
	}
}

static void
__lambda68_ (Block34Data* _data34_,
             gboolean request_cancelled)
{
	VlsServer* self;
	ValaSourceFile* doc = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	VlsPair* _tmp2_;
	gconstpointer _tmp3_;
	gconstpointer _tmp4_;
	ValaSourceFile* _tmp5_;
	ValaSourceFile* _tmp6_;
	VlsCompilation* compilation = NULL;
	GeeArrayList* _tmp7_;
	gpointer _tmp8_;
	VlsPair* _tmp9_;
	gconstpointer _tmp10_;
	gconstpointer _tmp11_;
	VlsCompilation* _tmp12_;
	VlsCompilation* _tmp13_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	VlsFindSymbol* fs = NULL;
	ValaSourceFile* _tmp17_;
	LspPosition* _tmp18_;
	VlsFindSymbol* _tmp19_;
	VlsFindSymbol* _tmp20_;
	GeeList* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	ValaCodeNode* initial_result = NULL;
	VlsFindSymbol* _tmp25_;
	ValaSourceFile* _tmp26_;
	ValaCodeNode* _tmp27_;
	ValaCodeNode* _result_ = NULL;
	ValaCodeNode* _tmp28_;
	ValaCodeNode* _tmp29_;
	ValaSymbol* symbol = NULL;
	gboolean _tmp30_ = FALSE;
	ValaCodeNode* _tmp31_;
	gboolean _tmp51_ = FALSE;
	ValaCodeNode* _tmp52_;
	ValaCodeNode* _tmp59_;
	ValaSymbol* _tmp60_;
	LspRange* replacement_range = NULL;
	ValaCodeNode* _tmp61_;
	ValaSymbol* _tmp62_;
	LspRange* _tmp63_;
	gboolean _tmp64_ = FALSE;
	LspRange* _tmp65_;
	GError* _inner_error0_ = NULL;
	self = _data34_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data34_->id, _data34_->client, _data34_->method);
		return;
	}
	_tmp0_ = _data34_->results;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
	_tmp2_ = (VlsPair*) _tmp1_;
	_tmp3_ = vls_pair_get_first (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp2_);
	doc = _tmp6_;
	_tmp7_ = _data34_->results;
	_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, 0);
	_tmp9_ = (VlsPair*) _tmp8_;
	_tmp10_ = vls_pair_get_second (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = _g_object_ref0 ((VlsCompilation*) _tmp11_);
	_tmp13_ = _tmp12_;
	_g_object_unref0 (_tmp9_);
	compilation = _tmp13_;
	_tmp14_ = compilation;
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
	_tmp16_ = _tmp15_;
	vala_code_context_push (_tmp16_);
	_tmp17_ = doc;
	_tmp18_ = _data34_->pos;
	_tmp19_ = vls_find_symbol_new (_tmp17_, _tmp18_, TRUE, NULL);
	fs = _tmp19_;
	_tmp20_ = fs;
	_tmp21_ = _tmp20_->result;
	_tmp22_ = gee_collection_get_size ((GeeCollection*) _tmp21_);
	_tmp23_ = _tmp22_;
	if (_tmp23_ == 0) {
		GCancellable* _tmp24_;
		_tmp24_ = vls_server_cancellable;
		jsonrpc_client_reply_error_async (_data34_->client, _data34_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, "There is no symbol at the cursor.", _tmp24_, NULL, NULL);
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		return;
	}
	_tmp25_ = fs;
	_tmp26_ = doc;
	_tmp27_ = vls_server_get_best (_tmp25_, _tmp26_);
	initial_result = _tmp27_;
	_tmp28_ = initial_result;
	_tmp29_ = _vala_code_node_ref0 (_tmp28_);
	_result_ = _tmp29_;
	_tmp31_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp31_, VALA_TYPE_EXPRESSION)) {
		ValaCodeNode* _tmp32_;
		ValaSymbol* _tmp33_;
		ValaSymbol* _tmp34_;
		_tmp32_ = _result_;
		_tmp33_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, VALA_TYPE_EXPRESSION, ValaExpression));
		_tmp34_ = _tmp33_;
		_tmp30_ = _tmp34_ != NULL;
	} else {
		_tmp30_ = FALSE;
	}
	if (_tmp30_) {
		ValaCodeNode* _tmp35_;
		ValaSymbol* _tmp36_;
		ValaSymbol* _tmp37_;
		ValaCodeNode* _tmp38_;
		_tmp35_ = _result_;
		_tmp36_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, VALA_TYPE_EXPRESSION, ValaExpression));
		_tmp37_ = _tmp36_;
		_tmp38_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp37_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp38_;
	} else {
		ValaCodeNode* _tmp39_;
		_tmp39_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp39_, VALA_TYPE_DATA_TYPE)) {
			ValaCodeNode* _tmp40_;
			ValaSymbol* _tmp41_;
			_tmp40_ = _result_;
			_tmp41_ = vls_symbol_references_get_symbol_data_type_refers_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, VALA_TYPE_DATA_TYPE, ValaDataType));
			_vala_code_node_unref0 (_result_);
			_result_ = (ValaCodeNode*) _tmp41_;
		} else {
			gboolean _tmp42_ = FALSE;
			ValaCodeNode* _tmp43_;
			_tmp43_ = _result_;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp43_, VALA_TYPE_USING_DIRECTIVE)) {
				ValaCodeNode* _tmp44_;
				ValaSymbol* _tmp45_;
				ValaSymbol* _tmp46_;
				_tmp44_ = _result_;
				_tmp45_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp46_ = _tmp45_;
				_tmp42_ = _tmp46_ != NULL;
			} else {
				_tmp42_ = FALSE;
			}
			if (_tmp42_) {
				ValaCodeNode* _tmp47_;
				ValaSymbol* _tmp48_;
				ValaSymbol* _tmp49_;
				ValaCodeNode* _tmp50_;
				_tmp47_ = _result_;
				_tmp48_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp49_ = _tmp48_;
				_tmp50_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp49_);
				_vala_code_node_unref0 (_result_);
				_result_ = _tmp50_;
			}
		}
	}
	_tmp52_ = _result_;
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp52_, VALA_TYPE_SYMBOL)) {
		_tmp51_ = TRUE;
	} else {
		gboolean _tmp53_ = FALSE;
		ValaCodeNode* _tmp54_;
		_tmp54_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp54_, VALA_TYPE_METHOD)) {
			ValaCodeNode* _tmp55_;
			gboolean _tmp56_;
			gboolean _tmp57_;
			_tmp55_ = _result_;
			_tmp56_ = vala_method_get_closure (G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, VALA_TYPE_METHOD, ValaMethod));
			_tmp57_ = _tmp56_;
			_tmp53_ = _tmp57_;
		} else {
			_tmp53_ = FALSE;
		}
		_tmp51_ = _tmp53_;
	}
	if (_tmp51_) {
		GCancellable* _tmp58_;
		_tmp58_ = vls_server_cancellable;
		jsonrpc_client_reply_error_async (_data34_->client, _data34_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, "There is no symbol at the cursor.", _tmp58_, NULL, NULL);
		vala_code_context_pop ();
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_node_unref0 (initial_result);
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		return;
	}
	_tmp59_ = _result_;
	_tmp60_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, VALA_TYPE_SYMBOL, ValaSymbol));
	_vala_code_node_unref0 (symbol);
	symbol = _tmp60_;
	_tmp61_ = initial_result;
	_tmp62_ = symbol;
	_tmp63_ = vls_symbol_references_get_replacement_range (_tmp61_, _tmp62_);
	replacement_range = _tmp63_;
	_tmp65_ = replacement_range;
	if (_tmp65_ == NULL) {
		_tmp64_ = TRUE;
	} else {
		ValaSymbol* _tmp66_;
		ValaSourceReference* _tmp67_;
		ValaSourceReference* _tmp68_;
		_tmp66_ = symbol;
		_tmp67_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp66_);
		_tmp68_ = _tmp67_;
		_tmp64_ = _tmp68_ == NULL;
	}
	if (_tmp64_) {
		GCancellable* _tmp69_;
		_tmp69_ = vls_server_cancellable;
		jsonrpc_client_reply_error_async (_data34_->client, _data34_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, "There is no symbol at the cursor.", _tmp69_, NULL, NULL);
		vala_code_context_pop ();
		_g_object_unref0 (replacement_range);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_node_unref0 (initial_result);
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		return;
	}
	{
		GeeIterator* _btarget_w_sym_it = NULL;
		VlsProject* _tmp70_;
		ValaSymbol* _tmp71_;
		GeeCollection* _tmp72_;
		GeeCollection* _tmp73_;
		GeeIterator* _tmp74_;
		GeeIterator* _tmp75_;
		_tmp70_ = _data34_->selected_project;
		_tmp71_ = symbol;
		_tmp72_ = vls_symbol_references_get_compilations_using_symbol (_tmp70_, _tmp71_);
		_tmp73_ = _tmp72_;
		_tmp74_ = gee_iterable_iterator ((GeeIterable*) _tmp73_);
		_tmp75_ = _tmp74_;
		_g_object_unref0 (_tmp73_);
		_btarget_w_sym_it = _tmp75_;
		while (TRUE) {
			GeeIterator* _tmp76_;
			VlsPair* btarget_w_sym = NULL;
			GeeIterator* _tmp77_;
			gpointer _tmp78_;
			VlsPair* _tmp79_;
			gconstpointer _tmp80_;
			gconstpointer _tmp81_;
			ValaSourceReference* _tmp82_;
			ValaSourceReference* _tmp83_;
			ValaSourceFile* _tmp84_;
			ValaSourceFile* _tmp85_;
			_tmp76_ = _btarget_w_sym_it;
			if (!gee_iterator_next (_tmp76_)) {
				break;
			}
			_tmp77_ = _btarget_w_sym_it;
			_tmp78_ = gee_iterator_get (_tmp77_);
			btarget_w_sym = (VlsPair*) _tmp78_;
			_tmp79_ = btarget_w_sym;
			_tmp80_ = vls_pair_get_second (_tmp79_);
			_tmp81_ = _tmp80_;
			_tmp82_ = vala_code_node_get_source_reference ((ValaCodeNode*) ((ValaSymbol*) _tmp81_));
			_tmp83_ = _tmp82_;
			_tmp84_ = vala_source_reference_get_file (_tmp83_);
			_tmp85_ = _tmp84_;
			if (!VLS_IS_TEXT_DOCUMENT (_tmp85_)) {
				gchar* pkg = NULL;
				VlsPair* _tmp86_;
				gconstpointer _tmp87_;
				gconstpointer _tmp88_;
				ValaSourceReference* _tmp89_;
				ValaSourceReference* _tmp90_;
				ValaSourceFile* _tmp91_;
				ValaSourceFile* _tmp92_;
				const gchar* _tmp93_;
				const gchar* _tmp94_;
				gchar* _tmp95_;
				gchar* _tmp96_ = NULL;
				const gchar* _tmp97_;
				gchar* _tmp102_;
				gchar* _tmp103_;
				GCancellable* _tmp104_;
				_tmp86_ = btarget_w_sym;
				_tmp87_ = vls_pair_get_second (_tmp86_);
				_tmp88_ = _tmp87_;
				_tmp89_ = vala_code_node_get_source_reference ((ValaCodeNode*) ((ValaSymbol*) _tmp88_));
				_tmp90_ = _tmp89_;
				_tmp91_ = vala_source_reference_get_file (_tmp90_);
				_tmp92_ = _tmp91_;
				_tmp93_ = vala_source_file_get_package_name (_tmp92_);
				_tmp94_ = _tmp93_;
				_tmp95_ = g_strdup (_tmp94_);
				pkg = _tmp95_;
				_tmp97_ = pkg;
				if (_tmp97_ != NULL) {
					const gchar* _tmp98_;
					const gchar* _tmp99_;
					gchar* _tmp100_;
					_tmp98_ = pkg;
					_tmp99_ = string_to_string (_tmp98_);
					_tmp100_ = g_strconcat (" (", _tmp99_, ").", NULL);
					_g_free0 (_tmp96_);
					_tmp96_ = _tmp100_;
				} else {
					gchar* _tmp101_;
					_tmp101_ = g_strdup (".");
					_g_free0 (_tmp96_);
					_tmp96_ = _tmp101_;
				}
				_tmp102_ = g_strconcat ("Cannot rename a symbol defined in a system library", _tmp96_, NULL);
				_tmp103_ = _tmp102_;
				_tmp104_ = vls_server_cancellable;
				jsonrpc_client_reply_error_async (_data34_->client, _data34_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, _tmp103_, _tmp104_, NULL, NULL);
				_g_free0 (_tmp103_);
				vala_code_context_pop ();
				_g_free0 (_tmp96_);
				_g_free0 (pkg);
				_g_object_unref0 (btarget_w_sym);
				_g_object_unref0 (_btarget_w_sym_it);
				_g_object_unref0 (replacement_range);
				_vala_code_node_unref0 (symbol);
				_vala_code_node_unref0 (_result_);
				_vala_code_node_unref0 (initial_result);
				_vala_code_visitor_unref0 (fs);
				_g_object_unref0 (compilation);
				_vala_source_file_unref0 (doc);
				return;
			}
			_g_object_unref0 (btarget_w_sym);
		}
		_g_object_unref0 (_btarget_w_sym_it);
	}
	{
		GVariant* _tmp105_ = NULL;
		LspRange* _tmp106_;
		GVariant* _tmp107_;
		ValaSymbol* _tmp108_;
		const gchar* _tmp109_;
		const gchar* _tmp110_;
		GVariant* _tmp111_;
		GVariant* _tmp112_;
		GVariant* _tmp113_;
		GVariant* _tmp114_;
		GCancellable* _tmp115_;
		_tmp106_ = replacement_range;
		_tmp107_ = vls_util_object_to_variant ((GObject*) _tmp106_, &_inner_error0_);
		_tmp105_ = _tmp107_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp108_ = symbol;
		_tmp109_ = vala_symbol_get_name (_tmp108_);
		_tmp110_ = _tmp109_;
		_tmp111_ = g_variant_new_string (_tmp110_);
		g_variant_ref_sink (_tmp111_);
		_tmp112_ = _tmp111_;
		_tmp113_ = vls_server_buildDict (self, "range", _tmp105_, "placeholder", _tmp112_, NULL);
		_tmp114_ = _tmp113_;
		_tmp115_ = vls_server_cancellable;
		jsonrpc_client_reply (_data34_->client, _data34_->id, _tmp114_, _tmp115_, &_inner_error0_);
		_g_variant_unref0 (_tmp114_);
		_g_variant_unref0 (_tmp112_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (_tmp105_);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (_tmp105_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp116_;
		const gchar* _tmp117_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp116_ = e;
		_tmp117_ = _tmp116_->message;
		g_warning ("server.vala:1908: [%s] failed to reply with success - %s", _data34_->method, _tmp117_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (replacement_range);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_node_unref0 (initial_result);
		_vala_code_visitor_unref0 (fs);
		_g_object_unref0 (compilation);
		_vala_source_file_unref0 (doc);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_g_object_unref0 (replacement_range);
	_vala_code_node_unref0 (symbol);
	_vala_code_node_unref0 (_result_);
	_vala_code_node_unref0 (initial_result);
	_vala_code_visitor_unref0 (fs);
	_g_object_unref0 (compilation);
	_vala_source_file_unref0 (doc);
}

static void
___lambda68__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda68_ (self, request_cancelled);
}

static void
vls_server_textDocumentPrepareRename (VlsServer* self,
                                      JsonrpcServer* _self_,
                                      JsonrpcClient* client,
                                      const gchar* method,
                                      GVariant* id,
                                      GVariant* params)
{
	Block34Data* _data34_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	LspTextDocumentPositionParams* p = NULL;
	gpointer _tmp3_;
	GeeArrayList* _tmp4_;
	GHashTable* _tmp5_;
	guint _tmp6_ = 0;
	gconstpointer* _tmp7_;
	VlsProject* _tmp20_;
	GeeArrayList* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	LspTextDocumentPositionParams* _tmp43_;
	LspPosition* _tmp44_;
	LspPosition* _tmp45_;
	LspPosition* _tmp46_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data34_ = g_slice_new0 (Block34Data);
	_data34_->_ref_count_ = 1;
	_data34_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data34_->client);
	_data34_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data34_->method);
	_data34_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data34_->id);
	_data34_->id = _tmp2_;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspTextDocumentPositionParams*) _tmp3_;
	_tmp4_ = gee_array_list_new (VLS_TYPE_PAIR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp4_) {
		g_object_set_data ((GObject *) _tmp4_, "vala-creation-function", "Vls.Server.textDocumentPrepareRename");
	}
	_data34_->results = _tmp4_;
	_data34_->selected_project = NULL;
	_tmp5_ = self->priv->projects;
	_tmp7_ = g_hash_table_get_keys_as_array (_tmp5_, &_tmp6_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp7_;
		project_collection_length1 = _tmp6_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				VlsProject* _tmp8_;
				LspTextDocumentPositionParams* _tmp9_;
				LspTextDocumentIdentifier* _tmp10_;
				LspTextDocumentIdentifier* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				GeeArrayList* _tmp14_;
				GeeArrayList* _tmp15_;
				gboolean _tmp16_;
				gboolean _tmp17_;
				_tmp8_ = project;
				_tmp9_ = p;
				_tmp10_ = lsp_text_document_position_params_get_textDocument (_tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = lsp_text_document_identifier_get_uri (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = vls_project_lookup_compile_input_source_file (_tmp8_, _tmp13_);
				_g_object_unref0 (_data34_->results);
				_data34_->results = _tmp14_;
				_tmp15_ = _data34_->results;
				_tmp16_ = gee_collection_get_is_empty ((GeeCollection*) _tmp15_);
				_tmp17_ = _tmp16_;
				if (!_tmp17_) {
					VlsProject* _tmp18_;
					VlsProject* _tmp19_;
					_tmp18_ = project;
					_tmp19_ = _g_object_ref0 (_tmp18_);
					_g_object_unref0 (_data34_->selected_project);
					_data34_->selected_project = _tmp19_;
					break;
				}
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp20_ = _data34_->selected_project;
	if (_tmp20_ == NULL) {
		VlsDefaultProject* _tmp21_;
		LspTextDocumentPositionParams* _tmp22_;
		LspTextDocumentIdentifier* _tmp23_;
		LspTextDocumentIdentifier* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		GeeArrayList* _tmp27_;
		VlsDefaultProject* _tmp28_;
		VlsProject* _tmp29_;
		_tmp21_ = self->priv->default_project;
		_tmp22_ = p;
		_tmp23_ = lsp_text_document_position_params_get_textDocument (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = lsp_text_document_identifier_get_uri (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = vls_project_lookup_compile_input_source_file ((VlsProject*) _tmp21_, _tmp26_);
		_g_object_unref0 (_data34_->results);
		_data34_->results = _tmp27_;
		_tmp28_ = self->priv->default_project;
		_tmp29_ = _g_object_ref0 ((VlsProject*) _tmp28_);
		_g_object_unref0 (_data34_->selected_project);
		_data34_->selected_project = _tmp29_;
	}
	_tmp30_ = _data34_->results;
	_tmp31_ = gee_collection_get_is_empty ((GeeCollection*) _tmp30_);
	_tmp32_ = _tmp31_;
	if (_tmp32_) {
		LspTextDocumentPositionParams* _tmp33_;
		LspTextDocumentIdentifier* _tmp34_;
		LspTextDocumentIdentifier* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		_tmp33_ = p;
		_tmp34_ = lsp_text_document_position_params_get_textDocument (_tmp33_);
		_tmp35_ = _tmp34_;
		_tmp36_ = lsp_text_document_identifier_get_uri (_tmp35_);
		_tmp37_ = _tmp36_;
		_tmp38_ = g_uri_unescape_string (_tmp37_, NULL);
		_tmp39_ = _tmp38_;
		_tmp40_ = string_to_string (_tmp39_);
		_tmp41_ = g_strconcat ("file `", _tmp40_, "' not found", NULL);
		_tmp42_ = _tmp41_;
		g_debug ("server.vala:1816: %s", _tmp42_);
		_g_free0 (_tmp42_);
		_g_free0 (_tmp39_);
		vls_server_reply_null (_data34_->id, _data34_->client, _data34_->method);
		_g_object_unref0 (p);
		block34_data_unref (_data34_);
		_data34_ = NULL;
		return;
	}
	_tmp43_ = p;
	_tmp44_ = lsp_text_document_position_params_get_position (_tmp43_);
	_tmp45_ = _tmp44_;
	_tmp46_ = _g_object_ref0 (_tmp45_);
	_data34_->pos = _tmp46_;
	vls_server_wait_for_context_update (self, _data34_->id, ___lambda68__vls_server_on_context_updated_func, block34_data_ref (_data34_), block34_data_unref);
	_g_object_unref0 (p);
	block34_data_unref (_data34_);
	_data34_ = NULL;
}

/**
     * handle an incoming `textDocument/codeLens` request
     */
static gchar*
_variant_get10 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static void
vls_server_handle_code_lens_request (VlsServer* self,
                                     JsonrpcServer* _self_,
                                     JsonrpcClient* client,
                                     const gchar* method,
                                     GVariant* id,
                                     GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gchar* _tmp2_ = NULL;
	GVariant* _tmp3_;
	gchar* uri = NULL;
	gchar* _tmp9_;
	gboolean _tmp10_ = FALSE;
	GVariant* _tmp11_;
	GeeArrayList* results = NULL;
	GeeArrayList* _tmp13_;
	VlsProject* selected_project = NULL;
	GHashTable* _tmp14_;
	guint _tmp15_ = 0;
	gconstpointer* _tmp16_;
	VlsProject* _tmp25_;
	GeeArrayList* _tmp31_;
	gboolean _tmp32_;
	gboolean _tmp33_;
	VlsProject* _tmp40_;
	GeeArrayList* _tmp41_;
	gpointer _tmp42_;
	VlsPair* _tmp43_;
	gconstpointer _tmp44_;
	gconstpointer _tmp45_;
	GeeArrayList* _tmp46_;
	gpointer _tmp47_;
	VlsPair* _tmp48_;
	gconstpointer _tmp49_;
	gconstpointer _tmp50_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
	document = _tmp1_;
	_tmp3_ = document;
	if (_tmp3_ != NULL) {
		GVariant* _tmp4_;
		const GVariantType* _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		gchar* _tmp8_;
		_tmp4_ = document;
		_tmp5_ = G_VARIANT_TYPE_STRING;
		_tmp6_ = g_variant_lookup_value (_tmp4_, "uri", _tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = _variant_get10 (_tmp7_);
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp8_;
		_g_variant_unref0 (_tmp7_);
	} else {
		_g_free0 (_tmp2_);
		_tmp2_ = NULL;
	}
	_tmp9_ = g_strdup (_tmp2_);
	uri = _tmp9_;
	_tmp11_ = document;
	if (_tmp11_ == NULL) {
		_tmp10_ = TRUE;
	} else {
		const gchar* _tmp12_;
		_tmp12_ = uri;
		_tmp10_ = _tmp12_ == NULL;
	}
	if (_tmp10_) {
		g_warning ("server.vala:1922: [%s] `textDocument` or `uri` not provided as expecte" \
"d", method);
		vls_server_reply_null (id, client, method);
		_g_free0 (uri);
		_g_free0 (_tmp2_);
		_g_variant_unref0 (document);
		return;
	}
	_tmp13_ = gee_array_list_new (VLS_TYPE_PAIR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp13_) {
		g_object_set_data ((GObject *) _tmp13_, "vala-creation-function", "Vls.Server.handle_code_lens_request");
	}
	results = _tmp13_;
	selected_project = NULL;
	_tmp14_ = self->priv->projects;
	_tmp16_ = g_hash_table_get_keys_as_array (_tmp14_, &_tmp15_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp16_;
		project_collection_length1 = _tmp15_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				VlsProject* _tmp17_;
				const gchar* _tmp18_;
				GeeArrayList* _tmp19_;
				GeeArrayList* _tmp20_;
				gboolean _tmp21_;
				gboolean _tmp22_;
				_tmp17_ = project;
				_tmp18_ = uri;
				_tmp19_ = vls_project_lookup_compile_input_source_file (_tmp17_, _tmp18_);
				_g_object_unref0 (results);
				results = _tmp19_;
				_tmp20_ = results;
				_tmp21_ = gee_collection_get_is_empty ((GeeCollection*) _tmp20_);
				_tmp22_ = _tmp21_;
				if (!_tmp22_) {
					VlsProject* _tmp23_;
					VlsProject* _tmp24_;
					_tmp23_ = project;
					_tmp24_ = _g_object_ref0 (_tmp23_);
					_g_object_unref0 (selected_project);
					selected_project = _tmp24_;
					break;
				}
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp25_ = selected_project;
	if (_tmp25_ == NULL) {
		VlsDefaultProject* _tmp26_;
		const gchar* _tmp27_;
		GeeArrayList* _tmp28_;
		VlsDefaultProject* _tmp29_;
		VlsProject* _tmp30_;
		_tmp26_ = self->priv->default_project;
		_tmp27_ = uri;
		_tmp28_ = vls_project_lookup_compile_input_source_file ((VlsProject*) _tmp26_, _tmp27_);
		_g_object_unref0 (results);
		results = _tmp28_;
		_tmp29_ = self->priv->default_project;
		_tmp30_ = _g_object_ref0 ((VlsProject*) _tmp29_);
		_g_object_unref0 (selected_project);
		selected_project = _tmp30_;
	}
	_tmp31_ = results;
	_tmp32_ = gee_collection_get_is_empty ((GeeCollection*) _tmp31_);
	_tmp33_ = _tmp32_;
	if (_tmp33_) {
		const gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		_tmp34_ = uri;
		_tmp35_ = g_uri_unescape_string (_tmp34_, NULL);
		_tmp36_ = _tmp35_;
		_tmp37_ = string_to_string (_tmp36_);
		_tmp38_ = g_strconcat ("file `", _tmp37_, "' not found", NULL);
		_tmp39_ = _tmp38_;
		g_debug ("server.vala:1942: %s", _tmp39_);
		_g_free0 (_tmp39_);
		_g_free0 (_tmp36_);
		vls_server_reply_null (id, client, method);
		_g_object_unref0 (selected_project);
		_g_object_unref0 (results);
		_g_free0 (uri);
		_g_free0 (_tmp2_);
		_g_variant_unref0 (document);
		return;
	}
	_tmp40_ = selected_project;
	_tmp41_ = results;
	_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, 0);
	_tmp43_ = (VlsPair*) _tmp42_;
	_tmp44_ = vls_pair_get_first (_tmp43_);
	_tmp45_ = _tmp44_;
	_tmp46_ = results;
	_tmp47_ = gee_abstract_list_get ((GeeAbstractList*) _tmp46_, 0);
	_tmp48_ = (VlsPair*) _tmp47_;
	_tmp49_ = vls_pair_get_second (_tmp48_);
	_tmp50_ = _tmp49_;
	vls_code_lens_engine_begin_response (self, _tmp40_, client, id, method, (ValaSourceFile*) _tmp45_, (VlsCompilation*) _tmp50_);
	_g_object_unref0 (_tmp48_);
	_g_object_unref0 (_tmp43_);
	_g_object_unref0 (selected_project);
	_g_object_unref0 (results);
	_g_free0 (uri);
	_g_free0 (_tmp2_);
	_g_variant_unref0 (document);
}

static void
vls_server_shutdown (VlsServer* self,
                     JsonrpcServer* _self_,
                     JsonrpcClient* client,
                     const gchar* method,
                     GVariant* id,
                     GVariant* params)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (_self_ != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	vls_server_reply_null (id, client, "shutdown");
	vls_server_shutdown_real (self);
}

static void
vls_server_exit (VlsServer* self,
                 JsonrpcClient* client,
                 GVariant* params)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (params != NULL);
	vls_server_shutdown_real (self);
}

static void
vls_server_shutdown_real (VlsServer* self)
{
	GCancellable* _tmp0_;
	GHashTable* _tmp2_;
	guint _tmp3_ = 0;
	gconstpointer* _tmp4_;
	GMainLoop* _tmp9_;
	guint* _tmp10_;
	gint _tmp10__length1;
	g_return_if_fail (self != NULL);
	g_debug ("server.vala:1962: shutting down...");
	self->priv->shutting_down = TRUE;
	_tmp0_ = vls_server_cancellable;
	g_cancellable_cancel (_tmp0_);
	if (self->priv->client_closed_event_id != ((gulong) 0)) {
		JsonrpcServer* _tmp1_;
		_tmp1_ = self->priv->server;
		g_signal_handler_disconnect ((GObject*) _tmp1_, self->priv->client_closed_event_id);
	}
	_tmp2_ = self->priv->projects;
	_tmp4_ = g_hash_table_get_keys_as_array (_tmp2_, &_tmp3_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp4_;
		project_collection_length1 = _tmp3_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				VlsProject* _tmp5_;
				GHashTable* _tmp6_;
				VlsProject* _tmp7_;
				gconstpointer _tmp8_;
				_tmp5_ = project;
				_tmp6_ = self->priv->projects;
				_tmp7_ = project;
				_tmp8_ = g_hash_table_lookup (_tmp6_, _tmp7_);
				g_signal_handler_disconnect ((GObject*) _tmp5_, (gulong) ((guintptr) _tmp8_));
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp9_ = self->priv->loop;
	g_main_loop_quit (_tmp9_);
	_tmp10_ = self->priv->g_sources;
	_tmp10__length1 = self->priv->g_sources_length1;
	{
		guint* id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
		id_collection = _tmp10_;
		id_collection_length1 = _tmp10__length1;
		for (id_it = 0; id_it < id_collection_length1; id_it = id_it + 1) {
			guint id = 0U;
			id = id_collection[id_it];
			{
				g_source_remove (id);
			}
		}
	}
}

static void
_vls_server___lambda69_ (void)
{
	vls_server_received_signal = TRUE;
}

static void
__vls_server___lambda69__gsignal_handler_func (gint signum)
{
	_vls_server___lambda69_ ();
}

static void
_vls_server___lambda70_ (void)
{
	vls_server_received_signal = TRUE;
}

static void
__vls_server___lambda70__gsignal_handler_func (gint signum)
{
	_vls_server___lambda70_ ();
}

static void
vls_server_class_init (VlsServerClass * klass,
                       gpointer klass_data)
{
	GCancellable* _tmp0_;
	vls_server_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &VlsServer_private_offset);
	G_OBJECT_CLASS (klass)->finalize = vls_server_finalize;
	_tmp0_ = g_cancellable_new ();
	if (_tmp0_) {
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
	}
	vls_server_cancellable = _tmp0_;
	signal (SIGINT, __vls_server___lambda69__gsignal_handler_func);
	signal (SIGTERM, __vls_server___lambda70__gsignal_handler_func);
}

static void
vls_server_instance_init (VlsServer * self,
                          gpointer klass)
{
	guint* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeHashSet* _tmp2_;
	self->priv = vls_server_get_instance_private (self);
	self->priv->shutting_down = FALSE;
	_tmp0_ = g_new0 (guint, 0);
	self->priv->g_sources = _tmp0_;
	self->priv->g_sources_length1 = 0;
	self->priv->_g_sources_size_ = self->priv->g_sources_length1;
	_tmp1_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp1_) {
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "");
	}
	self->priv->discarded_files = _tmp1_;
	_tmp2_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp2_) {
		g_object_set_data ((GObject *) _tmp2_, "vala-creation-function", "");
	}
	self->priv->open_files = _tmp2_;
	self->priv->update_context_client = NULL;
	self->priv->update_context_requests = (gint64) 0;
	self->priv->update_context_time_us = (gint64) 0;
}

static void
vls_server_finalize (GObject * obj)
{
	VlsServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VLS_TYPE_SERVER, VlsServer);
	_g_object_unref0 (self->priv->server);
	_g_main_loop_unref0 (self->priv->loop);
	_g_hash_table_unref0 (self->priv->notif_handlers);
	_g_hash_table_unref0 (self->priv->call_handlers);
	_g_object_unref0 (self->priv->init_params);
	_vls_gir_documentation_unref0 (self->priv->documentation);
	_g_object_unref0 (self->priv->pending_requests);
	self->priv->g_sources = (g_free (self->priv->g_sources), NULL);
	_g_hash_table_unref0 (self->priv->projects);
	_g_object_unref0 (self->priv->default_project);
	_g_object_unref0 (self->priv->discarded_files);
	_g_object_unref0 (self->priv->open_files);
	_g_object_unref0 (self->priv->update_context_client);
	G_OBJECT_CLASS (vls_server_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
vls_server_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VlsServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vls_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VlsServer), 0, (GInstanceInitFunc) vls_server_instance_init, NULL };
	GType vls_server_type_id;
	vls_server_type_id = g_type_register_static (G_TYPE_OBJECT, "VlsServer", &g_define_type_info, 0);
	VlsServer_private_offset = g_type_add_instance_private (vls_server_type_id, sizeof (VlsServerPrivate));
	return vls_server_type_id;
}

GType
vls_server_get_type (void)
{
	static gsize vls_server_type_id__once = 0;
	if (g_once_init_enter (&vls_server_type_id__once)) {
		GType vls_server_type_id;
		vls_server_type_id = vls_server_get_type_once ();
		g_once_init_leave (&vls_server_type_id__once, vls_server_type_id);
	}
	return vls_server_type_id__once;
}

static gint
_vala_main (gchar** args,
            gint args_length1)
{
	GOptionContext* ocontext = NULL;
	GOptionContext* _tmp0_;
	GOptionContext* _tmp1_;
	GOptionContext* _tmp2_;
	GOptionContext* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GMainLoop* loop = NULL;
	GMainLoop* _tmp15_;
	GMainLoop* _tmp16_;
	VlsServer* _tmp17_;
	VlsServer* _tmp18_;
	GMainLoop* _tmp19_;
	GError* _inner_error0_ = NULL;
	gint result;
	g_set_prgname ("vala-language-server");
	_tmp0_ = g_option_context_new ("- vala-language-server");
	ocontext = _tmp0_;
	_tmp1_ = ocontext;
	g_option_context_add_main_entries (_tmp1_, entries, NULL);
	_tmp2_ = ocontext;
	g_option_context_set_summary (_tmp2_, "A language server for Vala");
	_tmp3_ = ocontext;
	_tmp4_ = string_to_string (CONFIG_PROJECT_BUGSITE);
	_tmp5_ = g_strconcat ("Report bugs to ", _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	g_option_context_set_description (_tmp3_, _tmp6_);
	_g_free0 (_tmp6_);
	{
		GOptionContext* _tmp7_;
		_tmp7_ = ocontext;
		g_option_context_parse (_tmp7_, (gint*) (&args_length1), &args, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		FILE* _tmp11_;
		const gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = stderr;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		fprintf (_tmp8_, "%s\n", _tmp10_);
		_tmp11_ = stderr;
		_tmp12_ = args[0];
		fprintf (_tmp11_, "Run '%s --version' to print version, or no arguments to run the langua" \
"ge server.\n", _tmp12_);
		result = 1;
		_g_error_free0 (e);
		_g_option_context_free0 (ocontext);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp13_ = -1;
		_g_option_context_free0 (ocontext);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp13_;
	}
	if (opt_version) {
		FILE* _tmp14_;
		_tmp14_ = stdout;
		fprintf (_tmp14_, "%s %s\n", CONFIG_PROJECT_NAME, CONFIG_PROJECT_VERSION);
		result = 1;
		_g_option_context_free0 (ocontext);
		return result;
	}
	_tmp15_ = g_main_loop_new (NULL, FALSE);
	loop = _tmp15_;
	_tmp16_ = loop;
	_tmp17_ = vls_server_new (_tmp16_);
	if (_tmp17_) {
		g_object_set_data ((GObject *) _tmp17_, "vala-creation-function", "main");
	}
	_tmp18_ = _tmp17_;
	_g_object_unref0 (_tmp18_);
	_tmp19_ = loop;
	g_main_loop_run (_tmp19_);
	result = 0;
	_g_main_loop_unref0 (loop);
	_g_option_context_free0 (ocontext);
	return result;
}

int
main (int argc,
      char ** argv)
{
	return _vala_main (argv, argc);
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

